var __defProp = Object.defineProperty;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var commonjsGlobal = typeof globalThis !== "undefined" ? globalThis : typeof window !== "undefined" ? window : typeof global !== "undefined" ? global : typeof self !== "undefined" ? self : {};
function getDefaultExportFromCjs(x) {
  return x && x.__esModule && Object.prototype.hasOwnProperty.call(x, "default") ? x["default"] : x;
}
function getAugmentedNamespace(n) {
  if (n.__esModule)
    return n;
  var a = Object.defineProperty({}, "__esModule", { value: true });
  Object.keys(n).forEach(function(k) {
    var d = Object.getOwnPropertyDescriptor(n, k);
    Object.defineProperty(a, k, d.get ? d : {
      enumerable: true,
      get: function() {
        return n[k];
      }
    });
  });
  return a;
}
var axios$2 = { exports: {} };
var bind$2 = function bind(fn, thisArg) {
  return function wrap() {
    var args = new Array(arguments.length);
    for (var i = 0; i < args.length; i++) {
      args[i] = arguments[i];
    }
    return fn.apply(thisArg, args);
  };
};
var bind$1 = bind$2;
var toString$3 = Object.prototype.toString;
function isArray$d(val) {
  return Array.isArray(val);
}
function isUndefined(val) {
  return typeof val === "undefined";
}
function isBuffer$3(val) {
  return val !== null && !isUndefined(val) && val.constructor !== null && !isUndefined(val.constructor) && typeof val.constructor.isBuffer === "function" && val.constructor.isBuffer(val);
}
function isArrayBuffer(val) {
  return toString$3.call(val) === "[object ArrayBuffer]";
}
function isFormData(val) {
  return toString$3.call(val) === "[object FormData]";
}
function isArrayBufferView(val) {
  var result;
  if (typeof ArrayBuffer !== "undefined" && ArrayBuffer.isView) {
    result = ArrayBuffer.isView(val);
  } else {
    result = val && val.buffer && isArrayBuffer(val.buffer);
  }
  return result;
}
function isString$1(val) {
  return typeof val === "string";
}
function isNumber$1(val) {
  return typeof val === "number";
}
function isObject$8(val) {
  return val !== null && typeof val === "object";
}
function isPlainObject(val) {
  if (toString$3.call(val) !== "[object Object]") {
    return false;
  }
  var prototype = Object.getPrototypeOf(val);
  return prototype === null || prototype === Object.prototype;
}
function isDate(val) {
  return toString$3.call(val) === "[object Date]";
}
function isFile(val) {
  return toString$3.call(val) === "[object File]";
}
function isBlob(val) {
  return toString$3.call(val) === "[object Blob]";
}
function isFunction$4(val) {
  return toString$3.call(val) === "[object Function]";
}
function isStream(val) {
  return isObject$8(val) && isFunction$4(val.pipe);
}
function isURLSearchParams(val) {
  return toString$3.call(val) === "[object URLSearchParams]";
}
function trim(str) {
  return str.trim ? str.trim() : str.replace(/^\s+|\s+$/g, "");
}
function isStandardBrowserEnv() {
  if (typeof navigator !== "undefined" && (navigator.product === "ReactNative" || navigator.product === "NativeScript" || navigator.product === "NS")) {
    return false;
  }
  return typeof window !== "undefined" && typeof document !== "undefined";
}
function forEach$1(obj, fn) {
  if (obj === null || typeof obj === "undefined") {
    return;
  }
  if (typeof obj !== "object") {
    obj = [obj];
  }
  if (isArray$d(obj)) {
    for (var i = 0, l = obj.length; i < l; i++) {
      fn.call(null, obj[i], i, obj);
    }
  } else {
    for (var key in obj) {
      if (Object.prototype.hasOwnProperty.call(obj, key)) {
        fn.call(null, obj[key], key, obj);
      }
    }
  }
}
function merge() {
  var result = {};
  function assignValue2(val, key) {
    if (isPlainObject(result[key]) && isPlainObject(val)) {
      result[key] = merge(result[key], val);
    } else if (isPlainObject(val)) {
      result[key] = merge({}, val);
    } else if (isArray$d(val)) {
      result[key] = val.slice();
    } else {
      result[key] = val;
    }
  }
  for (var i = 0, l = arguments.length; i < l; i++) {
    forEach$1(arguments[i], assignValue2);
  }
  return result;
}
function extend(a, b, thisArg) {
  forEach$1(b, function assignValue2(val, key) {
    if (thisArg && typeof val === "function") {
      a[key] = bind$1(val, thisArg);
    } else {
      a[key] = val;
    }
  });
  return a;
}
function stripBOM(content) {
  if (content.charCodeAt(0) === 65279) {
    content = content.slice(1);
  }
  return content;
}
var utils$e = {
  isArray: isArray$d,
  isArrayBuffer,
  isBuffer: isBuffer$3,
  isFormData,
  isArrayBufferView,
  isString: isString$1,
  isNumber: isNumber$1,
  isObject: isObject$8,
  isPlainObject,
  isUndefined,
  isDate,
  isFile,
  isBlob,
  isFunction: isFunction$4,
  isStream,
  isURLSearchParams,
  isStandardBrowserEnv,
  forEach: forEach$1,
  merge,
  extend,
  trim,
  stripBOM
};
var utils$d = utils$e;
function encode(val) {
  return encodeURIComponent(val).replace(/%3A/gi, ":").replace(/%24/g, "$").replace(/%2C/gi, ",").replace(/%20/g, "+").replace(/%5B/gi, "[").replace(/%5D/gi, "]");
}
var buildURL$2 = function buildURL(url, params, paramsSerializer) {
  if (!params) {
    return url;
  }
  var serializedParams;
  if (paramsSerializer) {
    serializedParams = paramsSerializer(params);
  } else if (utils$d.isURLSearchParams(params)) {
    serializedParams = params.toString();
  } else {
    var parts = [];
    utils$d.forEach(params, function serialize(val, key) {
      if (val === null || typeof val === "undefined") {
        return;
      }
      if (utils$d.isArray(val)) {
        key = key + "[]";
      } else {
        val = [val];
      }
      utils$d.forEach(val, function parseValue(v) {
        if (utils$d.isDate(v)) {
          v = v.toISOString();
        } else if (utils$d.isObject(v)) {
          v = JSON.stringify(v);
        }
        parts.push(encode(key) + "=" + encode(v));
      });
    });
    serializedParams = parts.join("&");
  }
  if (serializedParams) {
    var hashmarkIndex = url.indexOf("#");
    if (hashmarkIndex !== -1) {
      url = url.slice(0, hashmarkIndex);
    }
    url += (url.indexOf("?") === -1 ? "?" : "&") + serializedParams;
  }
  return url;
};
var utils$c = utils$e;
function InterceptorManager$1() {
  this.handlers = [];
}
InterceptorManager$1.prototype.use = function use(fulfilled, rejected, options) {
  this.handlers.push({
    fulfilled,
    rejected,
    synchronous: options ? options.synchronous : false,
    runWhen: options ? options.runWhen : null
  });
  return this.handlers.length - 1;
};
InterceptorManager$1.prototype.eject = function eject(id) {
  if (this.handlers[id]) {
    this.handlers[id] = null;
  }
};
InterceptorManager$1.prototype.forEach = function forEach(fn) {
  utils$c.forEach(this.handlers, function forEachHandler(h) {
    if (h !== null) {
      fn(h);
    }
  });
};
var InterceptorManager_1 = InterceptorManager$1;
var utils$b = utils$e;
var normalizeHeaderName$1 = function normalizeHeaderName(headers, normalizedName) {
  utils$b.forEach(headers, function processHeader(value, name) {
    if (name !== normalizedName && name.toUpperCase() === normalizedName.toUpperCase()) {
      headers[normalizedName] = value;
      delete headers[name];
    }
  });
};
var enhanceError$2 = function enhanceError(error, config2, code, request2, response) {
  error.config = config2;
  if (code) {
    error.code = code;
  }
  error.request = request2;
  error.response = response;
  error.isAxiosError = true;
  error.toJSON = function toJSON() {
    return {
      message: this.message,
      name: this.name,
      description: this.description,
      number: this.number,
      fileName: this.fileName,
      lineNumber: this.lineNumber,
      columnNumber: this.columnNumber,
      stack: this.stack,
      config: this.config,
      code: this.code,
      status: this.response && this.response.status ? this.response.status : null
    };
  };
  return error;
};
var transitional = {
  silentJSONParsing: true,
  forcedJSONParsing: true,
  clarifyTimeoutError: false
};
var enhanceError$1 = enhanceError$2;
var createError$2 = function createError(message, config2, code, request2, response) {
  var error = new Error(message);
  return enhanceError$1(error, config2, code, request2, response);
};
var createError$1 = createError$2;
var settle$1 = function settle(resolve, reject, response) {
  var validateStatus2 = response.config.validateStatus;
  if (!response.status || !validateStatus2 || validateStatus2(response.status)) {
    resolve(response);
  } else {
    reject(createError$1("Request failed with status code " + response.status, response.config, null, response.request, response));
  }
};
var utils$a = utils$e;
var cookies$1 = utils$a.isStandardBrowserEnv() ? function standardBrowserEnv() {
  return {
    write: function write(name, value, expires, path, domain, secure) {
      var cookie = [];
      cookie.push(name + "=" + encodeURIComponent(value));
      if (utils$a.isNumber(expires)) {
        cookie.push("expires=" + new Date(expires).toGMTString());
      }
      if (utils$a.isString(path)) {
        cookie.push("path=" + path);
      }
      if (utils$a.isString(domain)) {
        cookie.push("domain=" + domain);
      }
      if (secure === true) {
        cookie.push("secure");
      }
      document.cookie = cookie.join("; ");
    },
    read: function read(name) {
      var match = document.cookie.match(new RegExp("(^|;\\s*)(" + name + ")=([^;]*)"));
      return match ? decodeURIComponent(match[3]) : null;
    },
    remove: function remove(name) {
      this.write(name, "", Date.now() - 864e5);
    }
  };
}() : function nonStandardBrowserEnv() {
  return {
    write: function write() {
    },
    read: function read() {
      return null;
    },
    remove: function remove() {
    }
  };
}();
var isAbsoluteURL$1 = function isAbsoluteURL(url) {
  return /^([a-z][a-z\d+\-.]*:)?\/\//i.test(url);
};
var combineURLs$1 = function combineURLs(baseURL, relativeURL) {
  return relativeURL ? baseURL.replace(/\/+$/, "") + "/" + relativeURL.replace(/^\/+/, "") : baseURL;
};
var isAbsoluteURL2 = isAbsoluteURL$1;
var combineURLs2 = combineURLs$1;
var buildFullPath$1 = function buildFullPath(baseURL, requestedURL) {
  if (baseURL && !isAbsoluteURL2(requestedURL)) {
    return combineURLs2(baseURL, requestedURL);
  }
  return requestedURL;
};
var utils$9 = utils$e;
var ignoreDuplicateOf = [
  "age",
  "authorization",
  "content-length",
  "content-type",
  "etag",
  "expires",
  "from",
  "host",
  "if-modified-since",
  "if-unmodified-since",
  "last-modified",
  "location",
  "max-forwards",
  "proxy-authorization",
  "referer",
  "retry-after",
  "user-agent"
];
var parseHeaders$1 = function parseHeaders(headers) {
  var parsed = {};
  var key;
  var val;
  var i;
  if (!headers) {
    return parsed;
  }
  utils$9.forEach(headers.split("\n"), function parser(line) {
    i = line.indexOf(":");
    key = utils$9.trim(line.substr(0, i)).toLowerCase();
    val = utils$9.trim(line.substr(i + 1));
    if (key) {
      if (parsed[key] && ignoreDuplicateOf.indexOf(key) >= 0) {
        return;
      }
      if (key === "set-cookie") {
        parsed[key] = (parsed[key] ? parsed[key] : []).concat([val]);
      } else {
        parsed[key] = parsed[key] ? parsed[key] + ", " + val : val;
      }
    }
  });
  return parsed;
};
var utils$8 = utils$e;
var isURLSameOrigin$1 = utils$8.isStandardBrowserEnv() ? function standardBrowserEnv2() {
  var msie = /(msie|trident)/i.test(navigator.userAgent);
  var urlParsingNode = document.createElement("a");
  var originURL;
  function resolveURL(url) {
    var href = url;
    if (msie) {
      urlParsingNode.setAttribute("href", href);
      href = urlParsingNode.href;
    }
    urlParsingNode.setAttribute("href", href);
    return {
      href: urlParsingNode.href,
      protocol: urlParsingNode.protocol ? urlParsingNode.protocol.replace(/:$/, "") : "",
      host: urlParsingNode.host,
      search: urlParsingNode.search ? urlParsingNode.search.replace(/^\?/, "") : "",
      hash: urlParsingNode.hash ? urlParsingNode.hash.replace(/^#/, "") : "",
      hostname: urlParsingNode.hostname,
      port: urlParsingNode.port,
      pathname: urlParsingNode.pathname.charAt(0) === "/" ? urlParsingNode.pathname : "/" + urlParsingNode.pathname
    };
  }
  originURL = resolveURL(window.location.href);
  return function isURLSameOrigin2(requestURL) {
    var parsed = utils$8.isString(requestURL) ? resolveURL(requestURL) : requestURL;
    return parsed.protocol === originURL.protocol && parsed.host === originURL.host;
  };
}() : function nonStandardBrowserEnv2() {
  return function isURLSameOrigin2() {
    return true;
  };
}();
function Cancel$3(message) {
  this.message = message;
}
Cancel$3.prototype.toString = function toString() {
  return "Cancel" + (this.message ? ": " + this.message : "");
};
Cancel$3.prototype.__CANCEL__ = true;
var Cancel_1 = Cancel$3;
var utils$7 = utils$e;
var settle2 = settle$1;
var cookies = cookies$1;
var buildURL$1 = buildURL$2;
var buildFullPath2 = buildFullPath$1;
var parseHeaders2 = parseHeaders$1;
var isURLSameOrigin = isURLSameOrigin$1;
var createError2 = createError$2;
var transitionalDefaults$1 = transitional;
var Cancel$2 = Cancel_1;
var xhr = function xhrAdapter(config2) {
  return new Promise(function dispatchXhrRequest(resolve, reject) {
    var requestData = config2.data;
    var requestHeaders = config2.headers;
    var responseType = config2.responseType;
    var onCanceled;
    function done() {
      if (config2.cancelToken) {
        config2.cancelToken.unsubscribe(onCanceled);
      }
      if (config2.signal) {
        config2.signal.removeEventListener("abort", onCanceled);
      }
    }
    if (utils$7.isFormData(requestData)) {
      delete requestHeaders["Content-Type"];
    }
    var request2 = new XMLHttpRequest();
    if (config2.auth) {
      var username = config2.auth.username || "";
      var password = config2.auth.password ? unescape(encodeURIComponent(config2.auth.password)) : "";
      requestHeaders.Authorization = "Basic " + btoa(username + ":" + password);
    }
    var fullPath = buildFullPath2(config2.baseURL, config2.url);
    request2.open(config2.method.toUpperCase(), buildURL$1(fullPath, config2.params, config2.paramsSerializer), true);
    request2.timeout = config2.timeout;
    function onloadend() {
      if (!request2) {
        return;
      }
      var responseHeaders = "getAllResponseHeaders" in request2 ? parseHeaders2(request2.getAllResponseHeaders()) : null;
      var responseData = !responseType || responseType === "text" || responseType === "json" ? request2.responseText : request2.response;
      var response = {
        data: responseData,
        status: request2.status,
        statusText: request2.statusText,
        headers: responseHeaders,
        config: config2,
        request: request2
      };
      settle2(function _resolve(value) {
        resolve(value);
        done();
      }, function _reject(err) {
        reject(err);
        done();
      }, response);
      request2 = null;
    }
    if ("onloadend" in request2) {
      request2.onloadend = onloadend;
    } else {
      request2.onreadystatechange = function handleLoad() {
        if (!request2 || request2.readyState !== 4) {
          return;
        }
        if (request2.status === 0 && !(request2.responseURL && request2.responseURL.indexOf("file:") === 0)) {
          return;
        }
        setTimeout(onloadend);
      };
    }
    request2.onabort = function handleAbort() {
      if (!request2) {
        return;
      }
      reject(createError2("Request aborted", config2, "ECONNABORTED", request2));
      request2 = null;
    };
    request2.onerror = function handleError() {
      reject(createError2("Network Error", config2, null, request2));
      request2 = null;
    };
    request2.ontimeout = function handleTimeout() {
      var timeoutErrorMessage = config2.timeout ? "timeout of " + config2.timeout + "ms exceeded" : "timeout exceeded";
      var transitional3 = config2.transitional || transitionalDefaults$1;
      if (config2.timeoutErrorMessage) {
        timeoutErrorMessage = config2.timeoutErrorMessage;
      }
      reject(createError2(timeoutErrorMessage, config2, transitional3.clarifyTimeoutError ? "ETIMEDOUT" : "ECONNABORTED", request2));
      request2 = null;
    };
    if (utils$7.isStandardBrowserEnv()) {
      var xsrfValue = (config2.withCredentials || isURLSameOrigin(fullPath)) && config2.xsrfCookieName ? cookies.read(config2.xsrfCookieName) : void 0;
      if (xsrfValue) {
        requestHeaders[config2.xsrfHeaderName] = xsrfValue;
      }
    }
    if ("setRequestHeader" in request2) {
      utils$7.forEach(requestHeaders, function setRequestHeader(val, key) {
        if (typeof requestData === "undefined" && key.toLowerCase() === "content-type") {
          delete requestHeaders[key];
        } else {
          request2.setRequestHeader(key, val);
        }
      });
    }
    if (!utils$7.isUndefined(config2.withCredentials)) {
      request2.withCredentials = !!config2.withCredentials;
    }
    if (responseType && responseType !== "json") {
      request2.responseType = config2.responseType;
    }
    if (typeof config2.onDownloadProgress === "function") {
      request2.addEventListener("progress", config2.onDownloadProgress);
    }
    if (typeof config2.onUploadProgress === "function" && request2.upload) {
      request2.upload.addEventListener("progress", config2.onUploadProgress);
    }
    if (config2.cancelToken || config2.signal) {
      onCanceled = function(cancel) {
        if (!request2) {
          return;
        }
        reject(!cancel || cancel && cancel.type ? new Cancel$2("canceled") : cancel);
        request2.abort();
        request2 = null;
      };
      config2.cancelToken && config2.cancelToken.subscribe(onCanceled);
      if (config2.signal) {
        config2.signal.aborted ? onCanceled() : config2.signal.addEventListener("abort", onCanceled);
      }
    }
    if (!requestData) {
      requestData = null;
    }
    request2.send(requestData);
  });
};
var utils$6 = utils$e;
var normalizeHeaderName2 = normalizeHeaderName$1;
var enhanceError2 = enhanceError$2;
var transitionalDefaults = transitional;
var DEFAULT_CONTENT_TYPE = {
  "Content-Type": "application/x-www-form-urlencoded"
};
function setContentTypeIfUnset(headers, value) {
  if (!utils$6.isUndefined(headers) && utils$6.isUndefined(headers["Content-Type"])) {
    headers["Content-Type"] = value;
  }
}
function getDefaultAdapter() {
  var adapter;
  if (typeof XMLHttpRequest !== "undefined") {
    adapter = xhr;
  } else if (typeof process !== "undefined" && Object.prototype.toString.call(process) === "[object process]") {
    adapter = xhr;
  }
  return adapter;
}
function stringifySafely(rawValue, parser, encoder) {
  if (utils$6.isString(rawValue)) {
    try {
      (parser || JSON.parse)(rawValue);
      return utils$6.trim(rawValue);
    } catch (e) {
      if (e.name !== "SyntaxError") {
        throw e;
      }
    }
  }
  return (encoder || JSON.stringify)(rawValue);
}
var defaults$4 = {
  transitional: transitionalDefaults,
  adapter: getDefaultAdapter(),
  transformRequest: [function transformRequest(data2, headers) {
    normalizeHeaderName2(headers, "Accept");
    normalizeHeaderName2(headers, "Content-Type");
    if (utils$6.isFormData(data2) || utils$6.isArrayBuffer(data2) || utils$6.isBuffer(data2) || utils$6.isStream(data2) || utils$6.isFile(data2) || utils$6.isBlob(data2)) {
      return data2;
    }
    if (utils$6.isArrayBufferView(data2)) {
      return data2.buffer;
    }
    if (utils$6.isURLSearchParams(data2)) {
      setContentTypeIfUnset(headers, "application/x-www-form-urlencoded;charset=utf-8");
      return data2.toString();
    }
    if (utils$6.isObject(data2) || headers && headers["Content-Type"] === "application/json") {
      setContentTypeIfUnset(headers, "application/json");
      return stringifySafely(data2);
    }
    return data2;
  }],
  transformResponse: [function transformResponse(data2) {
    var transitional3 = this.transitional || defaults$4.transitional;
    var silentJSONParsing = transitional3 && transitional3.silentJSONParsing;
    var forcedJSONParsing = transitional3 && transitional3.forcedJSONParsing;
    var strictJSONParsing = !silentJSONParsing && this.responseType === "json";
    if (strictJSONParsing || forcedJSONParsing && utils$6.isString(data2) && data2.length) {
      try {
        return JSON.parse(data2);
      } catch (e) {
        if (strictJSONParsing) {
          if (e.name === "SyntaxError") {
            throw enhanceError2(e, this, "E_JSON_PARSE");
          }
          throw e;
        }
      }
    }
    return data2;
  }],
  timeout: 0,
  xsrfCookieName: "XSRF-TOKEN",
  xsrfHeaderName: "X-XSRF-TOKEN",
  maxContentLength: -1,
  maxBodyLength: -1,
  validateStatus: function validateStatus(status) {
    return status >= 200 && status < 300;
  },
  headers: {
    common: {
      "Accept": "application/json, text/plain, */*"
    }
  }
};
utils$6.forEach(["delete", "get", "head"], function forEachMethodNoData(method) {
  defaults$4.headers[method] = {};
});
utils$6.forEach(["post", "put", "patch"], function forEachMethodWithData(method) {
  defaults$4.headers[method] = utils$6.merge(DEFAULT_CONTENT_TYPE);
});
var defaults_1 = defaults$4;
var utils$5 = utils$e;
var defaults$3 = defaults_1;
var transformData$1 = function transformData(data2, headers, fns) {
  var context = this || defaults$3;
  utils$5.forEach(fns, function transform(fn) {
    data2 = fn.call(context, data2, headers);
  });
  return data2;
};
var isCancel$1 = function isCancel(value) {
  return !!(value && value.__CANCEL__);
};
var utils$4 = utils$e;
var transformData2 = transformData$1;
var isCancel2 = isCancel$1;
var defaults$2 = defaults_1;
var Cancel$1 = Cancel_1;
function throwIfCancellationRequested(config2) {
  if (config2.cancelToken) {
    config2.cancelToken.throwIfRequested();
  }
  if (config2.signal && config2.signal.aborted) {
    throw new Cancel$1("canceled");
  }
}
var dispatchRequest$1 = function dispatchRequest(config2) {
  throwIfCancellationRequested(config2);
  config2.headers = config2.headers || {};
  config2.data = transformData2.call(config2, config2.data, config2.headers, config2.transformRequest);
  config2.headers = utils$4.merge(config2.headers.common || {}, config2.headers[config2.method] || {}, config2.headers);
  utils$4.forEach(["delete", "get", "head", "post", "put", "patch", "common"], function cleanHeaderConfig(method) {
    delete config2.headers[method];
  });
  var adapter = config2.adapter || defaults$2.adapter;
  return adapter(config2).then(function onAdapterResolution(response) {
    throwIfCancellationRequested(config2);
    response.data = transformData2.call(config2, response.data, response.headers, config2.transformResponse);
    return response;
  }, function onAdapterRejection(reason) {
    if (!isCancel2(reason)) {
      throwIfCancellationRequested(config2);
      if (reason && reason.response) {
        reason.response.data = transformData2.call(config2, reason.response.data, reason.response.headers, config2.transformResponse);
      }
    }
    return Promise.reject(reason);
  });
};
var utils$3 = utils$e;
var mergeConfig$2 = function mergeConfig(config1, config2) {
  config2 = config2 || {};
  var config3 = {};
  function getMergedValue(target, source2) {
    if (utils$3.isPlainObject(target) && utils$3.isPlainObject(source2)) {
      return utils$3.merge(target, source2);
    } else if (utils$3.isPlainObject(source2)) {
      return utils$3.merge({}, source2);
    } else if (utils$3.isArray(source2)) {
      return source2.slice();
    }
    return source2;
  }
  function mergeDeepProperties(prop) {
    if (!utils$3.isUndefined(config2[prop])) {
      return getMergedValue(config1[prop], config2[prop]);
    } else if (!utils$3.isUndefined(config1[prop])) {
      return getMergedValue(void 0, config1[prop]);
    }
  }
  function valueFromConfig2(prop) {
    if (!utils$3.isUndefined(config2[prop])) {
      return getMergedValue(void 0, config2[prop]);
    }
  }
  function defaultToConfig2(prop) {
    if (!utils$3.isUndefined(config2[prop])) {
      return getMergedValue(void 0, config2[prop]);
    } else if (!utils$3.isUndefined(config1[prop])) {
      return getMergedValue(void 0, config1[prop]);
    }
  }
  function mergeDirectKeys(prop) {
    if (prop in config2) {
      return getMergedValue(config1[prop], config2[prop]);
    } else if (prop in config1) {
      return getMergedValue(void 0, config1[prop]);
    }
  }
  var mergeMap = {
    "url": valueFromConfig2,
    "method": valueFromConfig2,
    "data": valueFromConfig2,
    "baseURL": defaultToConfig2,
    "transformRequest": defaultToConfig2,
    "transformResponse": defaultToConfig2,
    "paramsSerializer": defaultToConfig2,
    "timeout": defaultToConfig2,
    "timeoutMessage": defaultToConfig2,
    "withCredentials": defaultToConfig2,
    "adapter": defaultToConfig2,
    "responseType": defaultToConfig2,
    "xsrfCookieName": defaultToConfig2,
    "xsrfHeaderName": defaultToConfig2,
    "onUploadProgress": defaultToConfig2,
    "onDownloadProgress": defaultToConfig2,
    "decompress": defaultToConfig2,
    "maxContentLength": defaultToConfig2,
    "maxBodyLength": defaultToConfig2,
    "transport": defaultToConfig2,
    "httpAgent": defaultToConfig2,
    "httpsAgent": defaultToConfig2,
    "cancelToken": defaultToConfig2,
    "socketPath": defaultToConfig2,
    "responseEncoding": defaultToConfig2,
    "validateStatus": mergeDirectKeys
  };
  utils$3.forEach(Object.keys(config1).concat(Object.keys(config2)), function computeConfigValue(prop) {
    var merge2 = mergeMap[prop] || mergeDeepProperties;
    var configValue = merge2(prop);
    utils$3.isUndefined(configValue) && merge2 !== mergeDirectKeys || (config3[prop] = configValue);
  });
  return config3;
};
var data = {
  "version": "0.26.1"
};
var VERSION = data.version;
var validators$1 = {};
["object", "boolean", "number", "function", "string", "symbol"].forEach(function(type, i) {
  validators$1[type] = function validator2(thing) {
    return typeof thing === type || "a" + (i < 1 ? "n " : " ") + type;
  };
});
var deprecatedWarnings = {};
validators$1.transitional = function transitional2(validator2, version, message) {
  function formatMessage(opt, desc) {
    return "[Axios v" + VERSION + "] Transitional option '" + opt + "'" + desc + (message ? ". " + message : "");
  }
  return function(value, opt, opts) {
    if (validator2 === false) {
      throw new Error(formatMessage(opt, " has been removed" + (version ? " in " + version : "")));
    }
    if (version && !deprecatedWarnings[opt]) {
      deprecatedWarnings[opt] = true;
      console.warn(formatMessage(opt, " has been deprecated since v" + version + " and will be removed in the near future"));
    }
    return validator2 ? validator2(value, opt, opts) : true;
  };
};
function assertOptions(options, schema, allowUnknown) {
  if (typeof options !== "object") {
    throw new TypeError("options must be an object");
  }
  var keys2 = Object.keys(options);
  var i = keys2.length;
  while (i-- > 0) {
    var opt = keys2[i];
    var validator2 = schema[opt];
    if (validator2) {
      var value = options[opt];
      var result = value === void 0 || validator2(value, opt, options);
      if (result !== true) {
        throw new TypeError("option " + opt + " must be " + result);
      }
      continue;
    }
    if (allowUnknown !== true) {
      throw Error("Unknown option " + opt);
    }
  }
}
var validator$1 = {
  assertOptions,
  validators: validators$1
};
var utils$2 = utils$e;
var buildURL2 = buildURL$2;
var InterceptorManager = InterceptorManager_1;
var dispatchRequest2 = dispatchRequest$1;
var mergeConfig$1 = mergeConfig$2;
var validator = validator$1;
var validators = validator.validators;
function Axios$1(instanceConfig) {
  this.defaults = instanceConfig;
  this.interceptors = {
    request: new InterceptorManager(),
    response: new InterceptorManager()
  };
}
Axios$1.prototype.request = function request(configOrUrl, config2) {
  if (typeof configOrUrl === "string") {
    config2 = config2 || {};
    config2.url = configOrUrl;
  } else {
    config2 = configOrUrl || {};
  }
  config2 = mergeConfig$1(this.defaults, config2);
  if (config2.method) {
    config2.method = config2.method.toLowerCase();
  } else if (this.defaults.method) {
    config2.method = this.defaults.method.toLowerCase();
  } else {
    config2.method = "get";
  }
  var transitional3 = config2.transitional;
  if (transitional3 !== void 0) {
    validator.assertOptions(transitional3, {
      silentJSONParsing: validators.transitional(validators.boolean),
      forcedJSONParsing: validators.transitional(validators.boolean),
      clarifyTimeoutError: validators.transitional(validators.boolean)
    }, false);
  }
  var requestInterceptorChain = [];
  var synchronousRequestInterceptors = true;
  this.interceptors.request.forEach(function unshiftRequestInterceptors(interceptor) {
    if (typeof interceptor.runWhen === "function" && interceptor.runWhen(config2) === false) {
      return;
    }
    synchronousRequestInterceptors = synchronousRequestInterceptors && interceptor.synchronous;
    requestInterceptorChain.unshift(interceptor.fulfilled, interceptor.rejected);
  });
  var responseInterceptorChain = [];
  this.interceptors.response.forEach(function pushResponseInterceptors(interceptor) {
    responseInterceptorChain.push(interceptor.fulfilled, interceptor.rejected);
  });
  var promise;
  if (!synchronousRequestInterceptors) {
    var chain = [dispatchRequest2, void 0];
    Array.prototype.unshift.apply(chain, requestInterceptorChain);
    chain = chain.concat(responseInterceptorChain);
    promise = Promise.resolve(config2);
    while (chain.length) {
      promise = promise.then(chain.shift(), chain.shift());
    }
    return promise;
  }
  var newConfig = config2;
  while (requestInterceptorChain.length) {
    var onFulfilled = requestInterceptorChain.shift();
    var onRejected = requestInterceptorChain.shift();
    try {
      newConfig = onFulfilled(newConfig);
    } catch (error) {
      onRejected(error);
      break;
    }
  }
  try {
    promise = dispatchRequest2(newConfig);
  } catch (error) {
    return Promise.reject(error);
  }
  while (responseInterceptorChain.length) {
    promise = promise.then(responseInterceptorChain.shift(), responseInterceptorChain.shift());
  }
  return promise;
};
Axios$1.prototype.getUri = function getUri(config2) {
  config2 = mergeConfig$1(this.defaults, config2);
  return buildURL2(config2.url, config2.params, config2.paramsSerializer).replace(/^\?/, "");
};
utils$2.forEach(["delete", "get", "head", "options"], function forEachMethodNoData2(method) {
  Axios$1.prototype[method] = function(url, config2) {
    return this.request(mergeConfig$1(config2 || {}, {
      method,
      url,
      data: (config2 || {}).data
    }));
  };
});
utils$2.forEach(["post", "put", "patch"], function forEachMethodWithData2(method) {
  Axios$1.prototype[method] = function(url, data2, config2) {
    return this.request(mergeConfig$1(config2 || {}, {
      method,
      url,
      data: data2
    }));
  };
});
var Axios_1 = Axios$1;
var Cancel = Cancel_1;
function CancelToken(executor) {
  if (typeof executor !== "function") {
    throw new TypeError("executor must be a function.");
  }
  var resolvePromise;
  this.promise = new Promise(function promiseExecutor(resolve) {
    resolvePromise = resolve;
  });
  var token = this;
  this.promise.then(function(cancel) {
    if (!token._listeners)
      return;
    var i;
    var l = token._listeners.length;
    for (i = 0; i < l; i++) {
      token._listeners[i](cancel);
    }
    token._listeners = null;
  });
  this.promise.then = function(onfulfilled) {
    var _resolve;
    var promise = new Promise(function(resolve) {
      token.subscribe(resolve);
      _resolve = resolve;
    }).then(onfulfilled);
    promise.cancel = function reject() {
      token.unsubscribe(_resolve);
    };
    return promise;
  };
  executor(function cancel(message) {
    if (token.reason) {
      return;
    }
    token.reason = new Cancel(message);
    resolvePromise(token.reason);
  });
}
CancelToken.prototype.throwIfRequested = function throwIfRequested() {
  if (this.reason) {
    throw this.reason;
  }
};
CancelToken.prototype.subscribe = function subscribe(listener) {
  if (this.reason) {
    listener(this.reason);
    return;
  }
  if (this._listeners) {
    this._listeners.push(listener);
  } else {
    this._listeners = [listener];
  }
};
CancelToken.prototype.unsubscribe = function unsubscribe(listener) {
  if (!this._listeners) {
    return;
  }
  var index = this._listeners.indexOf(listener);
  if (index !== -1) {
    this._listeners.splice(index, 1);
  }
};
CancelToken.source = function source() {
  var cancel;
  var token = new CancelToken(function executor(c) {
    cancel = c;
  });
  return {
    token,
    cancel
  };
};
var CancelToken_1 = CancelToken;
var spread = function spread2(callback) {
  return function wrap(arr) {
    return callback.apply(null, arr);
  };
};
var utils$1 = utils$e;
var isAxiosError = function isAxiosError2(payload) {
  return utils$1.isObject(payload) && payload.isAxiosError === true;
};
var utils = utils$e;
var bind2 = bind$2;
var Axios = Axios_1;
var mergeConfig2 = mergeConfig$2;
var defaults$1 = defaults_1;
function createInstance(defaultConfig) {
  var context = new Axios(defaultConfig);
  var instance = bind2(Axios.prototype.request, context);
  utils.extend(instance, Axios.prototype, context);
  utils.extend(instance, context);
  instance.create = function create(instanceConfig) {
    return createInstance(mergeConfig2(defaultConfig, instanceConfig));
  };
  return instance;
}
var axios$1 = createInstance(defaults$1);
axios$1.Axios = Axios;
axios$1.Cancel = Cancel_1;
axios$1.CancelToken = CancelToken_1;
axios$1.isCancel = isCancel$1;
axios$1.VERSION = data.version;
axios$1.all = function all(promises) {
  return Promise.all(promises);
};
axios$1.spread = spread;
axios$1.isAxiosError = isAxiosError;
axios$2.exports = axios$1;
axios$2.exports.default = axios$1;
var axios = axios$2.exports;
var freeGlobal$1 = typeof commonjsGlobal == "object" && commonjsGlobal && commonjsGlobal.Object === Object && commonjsGlobal;
var _freeGlobal = freeGlobal$1;
var freeGlobal = _freeGlobal;
var freeSelf = typeof self == "object" && self && self.Object === Object && self;
var root$8 = freeGlobal || freeSelf || Function("return this")();
var _root = root$8;
var root$7 = _root;
var Symbol$5 = root$7.Symbol;
var _Symbol = Symbol$5;
var Symbol$4 = _Symbol;
var objectProto$d = Object.prototype;
var hasOwnProperty$a = objectProto$d.hasOwnProperty;
var nativeObjectToString$1 = objectProto$d.toString;
var symToStringTag$1 = Symbol$4 ? Symbol$4.toStringTag : void 0;
function getRawTag$1(value) {
  var isOwn = hasOwnProperty$a.call(value, symToStringTag$1), tag = value[symToStringTag$1];
  try {
    value[symToStringTag$1] = void 0;
    var unmasked = true;
  } catch (e) {
  }
  var result = nativeObjectToString$1.call(value);
  if (unmasked) {
    if (isOwn) {
      value[symToStringTag$1] = tag;
    } else {
      delete value[symToStringTag$1];
    }
  }
  return result;
}
var _getRawTag = getRawTag$1;
var objectProto$c = Object.prototype;
var nativeObjectToString = objectProto$c.toString;
function objectToString$1(value) {
  return nativeObjectToString.call(value);
}
var _objectToString = objectToString$1;
var Symbol$3 = _Symbol, getRawTag = _getRawTag, objectToString = _objectToString;
var nullTag = "[object Null]", undefinedTag = "[object Undefined]";
var symToStringTag = Symbol$3 ? Symbol$3.toStringTag : void 0;
function baseGetTag$5(value) {
  if (value == null) {
    return value === void 0 ? undefinedTag : nullTag;
  }
  return symToStringTag && symToStringTag in Object(value) ? getRawTag(value) : objectToString(value);
}
var _baseGetTag = baseGetTag$5;
function isObject$7(value) {
  var type = typeof value;
  return value != null && (type == "object" || type == "function");
}
var isObject_1 = isObject$7;
var baseGetTag$4 = _baseGetTag, isObject$6 = isObject_1;
var asyncTag = "[object AsyncFunction]", funcTag$1 = "[object Function]", genTag = "[object GeneratorFunction]", proxyTag = "[object Proxy]";
function isFunction$3(value) {
  if (!isObject$6(value)) {
    return false;
  }
  var tag = baseGetTag$4(value);
  return tag == funcTag$1 || tag == genTag || tag == asyncTag || tag == proxyTag;
}
var isFunction_1 = isFunction$3;
var root$6 = _root;
var coreJsData$1 = root$6["__core-js_shared__"];
var _coreJsData = coreJsData$1;
var coreJsData = _coreJsData;
var maskSrcKey = function() {
  var uid = /[^.]+$/.exec(coreJsData && coreJsData.keys && coreJsData.keys.IE_PROTO || "");
  return uid ? "Symbol(src)_1." + uid : "";
}();
function isMasked$1(func) {
  return !!maskSrcKey && maskSrcKey in func;
}
var _isMasked = isMasked$1;
var funcProto$1 = Function.prototype;
var funcToString$1 = funcProto$1.toString;
function toSource$2(func) {
  if (func != null) {
    try {
      return funcToString$1.call(func);
    } catch (e) {
    }
    try {
      return func + "";
    } catch (e) {
    }
  }
  return "";
}
var _toSource = toSource$2;
var isFunction$2 = isFunction_1, isMasked = _isMasked, isObject$5 = isObject_1, toSource$1 = _toSource;
var reRegExpChar = /[\\^$.*+?()[\]{}|]/g;
var reIsHostCtor = /^\[object .+?Constructor\]$/;
var funcProto = Function.prototype, objectProto$b = Object.prototype;
var funcToString = funcProto.toString;
var hasOwnProperty$9 = objectProto$b.hasOwnProperty;
var reIsNative = RegExp("^" + funcToString.call(hasOwnProperty$9).replace(reRegExpChar, "\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, "$1.*?") + "$");
function baseIsNative$1(value) {
  if (!isObject$5(value) || isMasked(value)) {
    return false;
  }
  var pattern = isFunction$2(value) ? reIsNative : reIsHostCtor;
  return pattern.test(toSource$1(value));
}
var _baseIsNative = baseIsNative$1;
function getValue$1(object, key) {
  return object == null ? void 0 : object[key];
}
var _getValue = getValue$1;
var baseIsNative = _baseIsNative, getValue = _getValue;
function getNative$7(object, key) {
  var value = getValue(object, key);
  return baseIsNative(value) ? value : void 0;
}
var _getNative = getNative$7;
var getNative$6 = _getNative;
var defineProperty$3 = function() {
  try {
    var func = getNative$6(Object, "defineProperty");
    func({}, "", {});
    return func;
  } catch (e) {
  }
}();
var _defineProperty = defineProperty$3;
var defineProperty$2 = _defineProperty;
function baseAssignValue$2(object, key, value) {
  if (key == "__proto__" && defineProperty$2) {
    defineProperty$2(object, key, {
      "configurable": true,
      "enumerable": true,
      "value": value,
      "writable": true
    });
  } else {
    object[key] = value;
  }
}
var _baseAssignValue = baseAssignValue$2;
function eq$4(value, other) {
  return value === other || value !== value && other !== other;
}
var eq_1 = eq$4;
var baseAssignValue$1 = _baseAssignValue, eq$3 = eq_1;
var objectProto$a = Object.prototype;
var hasOwnProperty$8 = objectProto$a.hasOwnProperty;
function assignValue$1(object, key, value) {
  var objValue = object[key];
  if (!(hasOwnProperty$8.call(object, key) && eq$3(objValue, value)) || value === void 0 && !(key in object)) {
    baseAssignValue$1(object, key, value);
  }
}
var _assignValue = assignValue$1;
var assignValue = _assignValue, baseAssignValue = _baseAssignValue;
function copyObject$1(source2, props, object, customizer) {
  var isNew = !object;
  object || (object = {});
  var index = -1, length = props.length;
  while (++index < length) {
    var key = props[index];
    var newValue = customizer ? customizer(object[key], source2[key], key, object, source2) : void 0;
    if (newValue === void 0) {
      newValue = source2[key];
    }
    if (isNew) {
      baseAssignValue(object, key, newValue);
    } else {
      assignValue(object, key, newValue);
    }
  }
  return object;
}
var _copyObject = copyObject$1;
function identity$4(value) {
  return value;
}
var identity_1 = identity$4;
function apply$1(func, thisArg, args) {
  switch (args.length) {
    case 0:
      return func.call(thisArg);
    case 1:
      return func.call(thisArg, args[0]);
    case 2:
      return func.call(thisArg, args[0], args[1]);
    case 3:
      return func.call(thisArg, args[0], args[1], args[2]);
  }
  return func.apply(thisArg, args);
}
var _apply = apply$1;
var apply = _apply;
var nativeMax$1 = Math.max;
function overRest$1(func, start, transform) {
  start = nativeMax$1(start === void 0 ? func.length - 1 : start, 0);
  return function() {
    var args = arguments, index = -1, length = nativeMax$1(args.length - start, 0), array = Array(length);
    while (++index < length) {
      array[index] = args[start + index];
    }
    index = -1;
    var otherArgs = Array(start + 1);
    while (++index < start) {
      otherArgs[index] = args[index];
    }
    otherArgs[start] = transform(array);
    return apply(func, this, otherArgs);
  };
}
var _overRest = overRest$1;
function constant$1(value) {
  return function() {
    return value;
  };
}
var constant_1 = constant$1;
var constant = constant_1, defineProperty$1 = _defineProperty, identity$3 = identity_1;
var baseSetToString$1 = !defineProperty$1 ? identity$3 : function(func, string) {
  return defineProperty$1(func, "toString", {
    "configurable": true,
    "enumerable": false,
    "value": constant(string),
    "writable": true
  });
};
var _baseSetToString = baseSetToString$1;
var HOT_COUNT = 800, HOT_SPAN = 16;
var nativeNow = Date.now;
function shortOut$1(func) {
  var count = 0, lastCalled = 0;
  return function() {
    var stamp = nativeNow(), remaining = HOT_SPAN - (stamp - lastCalled);
    lastCalled = stamp;
    if (remaining > 0) {
      if (++count >= HOT_COUNT) {
        return arguments[0];
      }
    } else {
      count = 0;
    }
    return func.apply(void 0, arguments);
  };
}
var _shortOut = shortOut$1;
var baseSetToString = _baseSetToString, shortOut = _shortOut;
var setToString$1 = shortOut(baseSetToString);
var _setToString = setToString$1;
var identity$2 = identity_1, overRest = _overRest, setToString = _setToString;
function baseRest$1(func, start) {
  return setToString(overRest(func, start, identity$2), func + "");
}
var _baseRest = baseRest$1;
var MAX_SAFE_INTEGER$1 = 9007199254740991;
function isLength$3(value) {
  return typeof value == "number" && value > -1 && value % 1 == 0 && value <= MAX_SAFE_INTEGER$1;
}
var isLength_1 = isLength$3;
var isFunction$1 = isFunction_1, isLength$2 = isLength_1;
function isArrayLike$5(value) {
  return value != null && isLength$2(value.length) && !isFunction$1(value);
}
var isArrayLike_1 = isArrayLike$5;
var MAX_SAFE_INTEGER = 9007199254740991;
var reIsUint = /^(?:0|[1-9]\d*)$/;
function isIndex$3(value, length) {
  var type = typeof value;
  length = length == null ? MAX_SAFE_INTEGER : length;
  return !!length && (type == "number" || type != "symbol" && reIsUint.test(value)) && (value > -1 && value % 1 == 0 && value < length);
}
var _isIndex = isIndex$3;
var eq$2 = eq_1, isArrayLike$4 = isArrayLike_1, isIndex$2 = _isIndex, isObject$4 = isObject_1;
function isIterateeCall$2(value, index, object) {
  if (!isObject$4(object)) {
    return false;
  }
  var type = typeof index;
  if (type == "number" ? isArrayLike$4(object) && isIndex$2(index, object.length) : type == "string" && index in object) {
    return eq$2(object[index], value);
  }
  return false;
}
var _isIterateeCall = isIterateeCall$2;
var baseRest = _baseRest, isIterateeCall$1 = _isIterateeCall;
function createAssigner$1(assigner) {
  return baseRest(function(object, sources) {
    var index = -1, length = sources.length, customizer = length > 1 ? sources[length - 1] : void 0, guard = length > 2 ? sources[2] : void 0;
    customizer = assigner.length > 3 && typeof customizer == "function" ? (length--, customizer) : void 0;
    if (guard && isIterateeCall$1(sources[0], sources[1], guard)) {
      customizer = length < 3 ? void 0 : customizer;
      length = 1;
    }
    object = Object(object);
    while (++index < length) {
      var source2 = sources[index];
      if (source2) {
        assigner(object, source2, index, customizer);
      }
    }
    return object;
  });
}
var _createAssigner = createAssigner$1;
function baseTimes$1(n, iteratee) {
  var index = -1, result = Array(n);
  while (++index < n) {
    result[index] = iteratee(index);
  }
  return result;
}
var _baseTimes = baseTimes$1;
function isObjectLike$6(value) {
  return value != null && typeof value == "object";
}
var isObjectLike_1 = isObjectLike$6;
var baseGetTag$3 = _baseGetTag, isObjectLike$5 = isObjectLike_1;
var argsTag$2 = "[object Arguments]";
function baseIsArguments$1(value) {
  return isObjectLike$5(value) && baseGetTag$3(value) == argsTag$2;
}
var _baseIsArguments = baseIsArguments$1;
var baseIsArguments = _baseIsArguments, isObjectLike$4 = isObjectLike_1;
var objectProto$9 = Object.prototype;
var hasOwnProperty$7 = objectProto$9.hasOwnProperty;
var propertyIsEnumerable$1 = objectProto$9.propertyIsEnumerable;
var isArguments$2 = baseIsArguments(function() {
  return arguments;
}()) ? baseIsArguments : function(value) {
  return isObjectLike$4(value) && hasOwnProperty$7.call(value, "callee") && !propertyIsEnumerable$1.call(value, "callee");
};
var isArguments_1 = isArguments$2;
var isArray$c = Array.isArray;
var isArray_1 = isArray$c;
var isBuffer$2 = { exports: {} };
function stubFalse() {
  return false;
}
var stubFalse_1 = stubFalse;
(function(module, exports) {
  var root2 = _root, stubFalse2 = stubFalse_1;
  var freeExports = exports && !exports.nodeType && exports;
  var freeModule = freeExports && true && module && !module.nodeType && module;
  var moduleExports = freeModule && freeModule.exports === freeExports;
  var Buffer2 = moduleExports ? root2.Buffer : void 0;
  var nativeIsBuffer = Buffer2 ? Buffer2.isBuffer : void 0;
  var isBuffer2 = nativeIsBuffer || stubFalse2;
  module.exports = isBuffer2;
})(isBuffer$2, isBuffer$2.exports);
var baseGetTag$2 = _baseGetTag, isLength$1 = isLength_1, isObjectLike$3 = isObjectLike_1;
var argsTag$1 = "[object Arguments]", arrayTag$1 = "[object Array]", boolTag$1 = "[object Boolean]", dateTag$1 = "[object Date]", errorTag$1 = "[object Error]", funcTag = "[object Function]", mapTag$2 = "[object Map]", numberTag$1 = "[object Number]", objectTag$2 = "[object Object]", regexpTag$1 = "[object RegExp]", setTag$2 = "[object Set]", stringTag$1 = "[object String]", weakMapTag$1 = "[object WeakMap]";
var arrayBufferTag$1 = "[object ArrayBuffer]", dataViewTag$2 = "[object DataView]", float32Tag = "[object Float32Array]", float64Tag = "[object Float64Array]", int8Tag = "[object Int8Array]", int16Tag = "[object Int16Array]", int32Tag = "[object Int32Array]", uint8Tag = "[object Uint8Array]", uint8ClampedTag = "[object Uint8ClampedArray]", uint16Tag = "[object Uint16Array]", uint32Tag = "[object Uint32Array]";
var typedArrayTags = {};
typedArrayTags[float32Tag] = typedArrayTags[float64Tag] = typedArrayTags[int8Tag] = typedArrayTags[int16Tag] = typedArrayTags[int32Tag] = typedArrayTags[uint8Tag] = typedArrayTags[uint8ClampedTag] = typedArrayTags[uint16Tag] = typedArrayTags[uint32Tag] = true;
typedArrayTags[argsTag$1] = typedArrayTags[arrayTag$1] = typedArrayTags[arrayBufferTag$1] = typedArrayTags[boolTag$1] = typedArrayTags[dataViewTag$2] = typedArrayTags[dateTag$1] = typedArrayTags[errorTag$1] = typedArrayTags[funcTag] = typedArrayTags[mapTag$2] = typedArrayTags[numberTag$1] = typedArrayTags[objectTag$2] = typedArrayTags[regexpTag$1] = typedArrayTags[setTag$2] = typedArrayTags[stringTag$1] = typedArrayTags[weakMapTag$1] = false;
function baseIsTypedArray$1(value) {
  return isObjectLike$3(value) && isLength$1(value.length) && !!typedArrayTags[baseGetTag$2(value)];
}
var _baseIsTypedArray = baseIsTypedArray$1;
function baseUnary$1(func) {
  return function(value) {
    return func(value);
  };
}
var _baseUnary = baseUnary$1;
var _nodeUtil = { exports: {} };
(function(module, exports) {
  var freeGlobal2 = _freeGlobal;
  var freeExports = exports && !exports.nodeType && exports;
  var freeModule = freeExports && true && module && !module.nodeType && module;
  var moduleExports = freeModule && freeModule.exports === freeExports;
  var freeProcess = moduleExports && freeGlobal2.process;
  var nodeUtil2 = function() {
    try {
      var types = freeModule && freeModule.require && freeModule.require("util").types;
      if (types) {
        return types;
      }
      return freeProcess && freeProcess.binding && freeProcess.binding("util");
    } catch (e) {
    }
  }();
  module.exports = nodeUtil2;
})(_nodeUtil, _nodeUtil.exports);
var baseIsTypedArray = _baseIsTypedArray, baseUnary = _baseUnary, nodeUtil = _nodeUtil.exports;
var nodeIsTypedArray = nodeUtil && nodeUtil.isTypedArray;
var isTypedArray$2 = nodeIsTypedArray ? baseUnary(nodeIsTypedArray) : baseIsTypedArray;
var isTypedArray_1 = isTypedArray$2;
var baseTimes = _baseTimes, isArguments$1 = isArguments_1, isArray$b = isArray_1, isBuffer$1 = isBuffer$2.exports, isIndex$1 = _isIndex, isTypedArray$1 = isTypedArray_1;
var objectProto$8 = Object.prototype;
var hasOwnProperty$6 = objectProto$8.hasOwnProperty;
function arrayLikeKeys$2(value, inherited) {
  var isArr = isArray$b(value), isArg = !isArr && isArguments$1(value), isBuff = !isArr && !isArg && isBuffer$1(value), isType = !isArr && !isArg && !isBuff && isTypedArray$1(value), skipIndexes = isArr || isArg || isBuff || isType, result = skipIndexes ? baseTimes(value.length, String) : [], length = result.length;
  for (var key in value) {
    if ((inherited || hasOwnProperty$6.call(value, key)) && !(skipIndexes && (key == "length" || isBuff && (key == "offset" || key == "parent") || isType && (key == "buffer" || key == "byteLength" || key == "byteOffset") || isIndex$1(key, length)))) {
      result.push(key);
    }
  }
  return result;
}
var _arrayLikeKeys = arrayLikeKeys$2;
var objectProto$7 = Object.prototype;
function isPrototype$2(value) {
  var Ctor = value && value.constructor, proto = typeof Ctor == "function" && Ctor.prototype || objectProto$7;
  return value === proto;
}
var _isPrototype = isPrototype$2;
function nativeKeysIn$1(object) {
  var result = [];
  if (object != null) {
    for (var key in Object(object)) {
      result.push(key);
    }
  }
  return result;
}
var _nativeKeysIn = nativeKeysIn$1;
var isObject$3 = isObject_1, isPrototype$1 = _isPrototype, nativeKeysIn = _nativeKeysIn;
var objectProto$6 = Object.prototype;
var hasOwnProperty$5 = objectProto$6.hasOwnProperty;
function baseKeysIn$1(object) {
  if (!isObject$3(object)) {
    return nativeKeysIn(object);
  }
  var isProto = isPrototype$1(object), result = [];
  for (var key in object) {
    if (!(key == "constructor" && (isProto || !hasOwnProperty$5.call(object, key)))) {
      result.push(key);
    }
  }
  return result;
}
var _baseKeysIn = baseKeysIn$1;
var arrayLikeKeys$1 = _arrayLikeKeys, baseKeysIn = _baseKeysIn, isArrayLike$3 = isArrayLike_1;
function keysIn$1(object) {
  return isArrayLike$3(object) ? arrayLikeKeys$1(object, true) : baseKeysIn(object);
}
var keysIn_1 = keysIn$1;
var copyObject = _copyObject, createAssigner = _createAssigner, keysIn = keysIn_1;
var assignIn = createAssigner(function(object, source2) {
  copyObject(source2, keysIn(source2), object);
});
var assignIn_1 = assignIn;
const config = {
  methods: {
    getConfig(key, defaultValue) {
      return this.$formvuelar && this.$formvuelar[key] ? this.$formvuelar[key] : defaultValue;
    }
  }
};
var render$k = function() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("form", { class: { "fvl-form-drag-over": _vm.isDragging }, on: { "submit": function($event) {
    $event.preventDefault();
    return _vm.submit();
  }, "dragover": function($event) {
    _vm.isDragging = true;
  }, "dragend": function($event) {
    _vm.isDragging = false;
  }, "dragleave": function($event) {
    _vm.isDragging = false;
  }, "dragexit": function($event) {
    _vm.isDragging = false;
  }, "drop": function($event) {
    _vm.isDragging = false;
  } } }, [_vm._t("default")], 2);
};
var staticRenderFns$k = [];
var FvlForm_vue_vue_type_style_index_0_lang = "";
function normalizeComponent(scriptExports, render2, staticRenderFns2, functionalTemplate, injectStyles, scopeId, moduleIdentifier, shadowMode) {
  var options = typeof scriptExports === "function" ? scriptExports.options : scriptExports;
  if (render2) {
    options.render = render2;
    options.staticRenderFns = staticRenderFns2;
    options._compiled = true;
  }
  if (functionalTemplate) {
    options.functional = true;
  }
  if (scopeId) {
    options._scopeId = "data-v-" + scopeId;
  }
  var hook;
  if (moduleIdentifier) {
    hook = function(context) {
      context = context || this.$vnode && this.$vnode.ssrContext || this.parent && this.parent.$vnode && this.parent.$vnode.ssrContext;
      if (!context && typeof __VUE_SSR_CONTEXT__ !== "undefined") {
        context = __VUE_SSR_CONTEXT__;
      }
      if (injectStyles) {
        injectStyles.call(this, context);
      }
      if (context && context._registeredComponents) {
        context._registeredComponents.add(moduleIdentifier);
      }
    };
    options._ssrRegister = hook;
  } else if (injectStyles) {
    hook = shadowMode ? function() {
      injectStyles.call(this, (options.functional ? this.parent : this).$root.$options.shadowRoot);
    } : injectStyles;
  }
  if (hook) {
    if (options.functional) {
      options._injectStyles = hook;
      var originalRender = options.render;
      options.render = function renderWithStyleInjection(h, context) {
        hook.call(context);
        return originalRender(h, context);
      };
    } else {
      var existing = options.beforeCreate;
      options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
    }
  }
  return {
    exports: scriptExports,
    options
  };
}
const __vue2_script$l = {
  mixins: [config],
  props: {
    method: {
      type: String,
      default: "post",
      validator: function(value) {
        return ["get", "post", "put", "patch", "delete"].indexOf(value) !== -1;
      }
    },
    url: {
      type: String,
      required: true
    },
    multipart: {
      type: Boolean,
      default: false
    },
    headers: {
      type: Object,
      default: () => {
      }
    },
    data: {
      type: Object,
      default: () => {
        return {};
      }
    }
  },
  data() {
    return {
      errors: {},
      uploadPercentage: 0,
      isLoading: false,
      isDragging: false
    };
  },
  computed: {
    additionalHeaders() {
      let multipart = this.multipart ? {
        "Content-Type": "multipart/form-data"
      } : {};
      let globalHeaders = this.getConfig("headers", {});
      return assignIn_1(globalHeaders, this.headers, multipart);
    }
  },
  created() {
    this.axios = axios.create();
    this.loadInterceptors();
  },
  beforeDestroy() {
    this.unloadInterceptors();
  },
  methods: {
    prepareData() {
      let rawData = this.data;
      let formData = new FormData();
      Object.keys(rawData).forEach((e) => {
        if (rawData[e] instanceof Array) {
          Object.keys(rawData[e]).forEach((f) => {
            if (rawData[e][f] instanceof File) {
              formData.append(e + "[]", rawData[e][f]);
            } else if (rawData[e][f] instanceof Object) {
              formData.append(e + "[]", JSON.stringify(this.replaceNullOnMultipart(rawData[e][f])));
            } else {
              formData.append(e, this.replaceNullOnMultipart(rawData[e]));
            }
          });
        } else {
          if (rawData[e] instanceof Object && !(rawData[e] instanceof File)) {
            formData.append(e, JSON.stringify(this.replaceNullOnMultipart(rawData[e])));
          } else if (this.multipart && typeof rawData[e] === "boolean") {
            formData.append(e, rawData[e] ? 1 : 0);
          } else {
            formData.append(e, this.replaceNullOnMultipart(rawData[e]));
          }
        }
      });
      if (this.method == "patch" || this.method == "put") {
        formData.append("_method", this.method);
      }
      return formData;
    },
    replaceNullOnMultipart(val) {
      return this.multipart && val === null ? "" : val;
    },
    submit() {
      let $this = this;
      this.isLoading = true;
      this.$emit("requeststarted");
      let method = this.multipart && (this.method == "patch" || this.method == "put") ? "post" : this.method;
      this.axios({
        method,
        url: this.url,
        data: this.multipart ? this.prepareData() : this.data,
        params: this.method == "get" || this.method == "delete" ? this.data : {},
        headers: this.additionalHeaders,
        onUploadProgress: function(progressEvent) {
          let percentage = Math.round(progressEvent.loaded * 100 / progressEvent.total);
          $this.uploadPercentage = percentage;
          $this.$emit("uploadProgress", percentage);
        }
      }).then(function(response) {
        $this.$emit("success", response);
      }).catch(function(error) {
        if (error.response && error.response.status === 422) {
          $this.errors = error.response.data.errors;
          $this.$nextTick(() => {
            var _a;
            (_a = document.getElementsByClassName("fvl-has-error")[0]) == null ? void 0 : _a.scrollIntoView({ behavior: "smooth", block: "nearest", inline: "nearest" });
          });
        }
        if (error.response && error.response.status === 419) {
          $this.$emit("error", { response: { status: 419 } });
          return;
        }
        if (error.response && error.response.status === 401) {
          $this.$emit("error", { response: { status: 401 } });
          return;
        }
        $this.$emit("error", error.response);
      }).then(function() {
        $this.isLoading = false;
        $this.uploadPercentage = 0;
        $this.$emit("uploadProgress", 0);
        $this.$emit("requestfinished");
      });
    },
    dirty(name) {
      let subKeys = Object.keys(this.errors).filter((e) => e.startsWith(name + "."));
      subKeys.forEach((e) => {
        this.errors[e] = false;
      });
      this.errors[name] = false;
      this.$emit("changed", { fieldName: name });
    },
    getErrors(name) {
      return this.errors[name] ? this.errors[name] : [];
    },
    hasErrors(name) {
      return this.errors[name] && this.errors[name] !== [] ? true : false;
    },
    loadInterceptors() {
      let interceptors = this.getConfig("interceptors", false);
      if (!interceptors)
        return;
      if (interceptors.request) {
        this.requestInterceptor = this.axios.interceptors.request.use(interceptors.request.before, interceptors.request.error);
      }
      if (interceptors.response) {
        this.responseInterceptor = this.axios.interceptors.response.use(interceptors.response.success, interceptors.response.error);
      }
    },
    unloadInterceptors() {
      if (this.requestInterceptor) {
        this.axios.interceptors.request.eject(this.requestInterceptor);
      }
      if (this.responseInterceptor) {
        this.axios.interceptors.response.eject(this.responseInterceptor);
      }
    }
  }
};
const __cssModules$l = {};
var __component__$l = /* @__PURE__ */ normalizeComponent(__vue2_script$l, render$k, staticRenderFns$k, false, __vue2_injectStyles$l, null, null, null);
function __vue2_injectStyles$l(context) {
  for (let o in __cssModules$l) {
    this[o] = __cssModules$l[o];
  }
}
var FvlForm = /* @__PURE__ */ function() {
  return __component__$l.exports;
}();
var render$j = function() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("transition-group", { attrs: { "name": "slide-down", "appear": "" } }, _vm._l(_vm.errors, function(error, index) {
    return _c("div", { key: "error" + index, staticClass: "fvl-checkbox-error-message", domProps: { "innerHTML": _vm._s(_vm.multible + error) } });
  }), 0);
};
var staticRenderFns$j = [];
const __vue2_script$k = {
  props: {
    errors: {
      type: Array,
      default: () => []
    }
  },
  computed: {
    multible() {
      return this.errors.length > 1 ? "- " : "";
    }
  }
};
const __cssModules$k = {};
var __component__$k = /* @__PURE__ */ normalizeComponent(__vue2_script$k, render$j, staticRenderFns$j, false, __vue2_injectStyles$k, null, null, null);
function __vue2_injectStyles$k(context) {
  for (let o in __cssModules$k) {
    this[o] = __cssModules$k[o];
  }
}
var ValidationErrors = /* @__PURE__ */ function() {
  return __component__$k.exports;
}();
var render$i = function() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", { staticClass: "fvl-input-wrapper", class: { "fvl-has-error": _vm.$parent.hasErrors(_vm.name) } }, [_vm.label ? _c("label", { staticClass: "fvl-input-label", class: _vm.labelClass, attrs: { "for": _vm.name } }, [_c("span", { domProps: { "innerHTML": _vm._s(_vm.label) } }), _vm._t("label_suffix")], 2) : _vm._e(), _c("div", { staticClass: "fvl-input-group" }, [_vm._t("prefix"), _c("input", { staticClass: "fvl-input", class: _vm.fieldClass, attrs: { "id": _vm.id, "name": _vm.name, "type": _vm.type, "placeholder": _vm.placeholder, "autocomplete": _vm.autocomplete, "min": _vm.min, "max": _vm.max, "size": _vm.size, "step": _vm.step, "maxlength": _vm.maxlength, "required": _vm.required, "readonly": _vm.readonly, "disabled": _vm.disabled, "pattern": _vm.pattern }, domProps: { "value": _vm.value }, on: { "change": function($event) {
    _vm.$parent.dirty(_vm.name), _vm.$emit("changed");
  }, "input": function($event) {
    _vm.$parent.dirty(_vm.name), _vm.$emit("update:value", $event.target.value), _vm.$emit("input", $event);
  } } }), _vm._t("suffix")], 2), _vm._t("hint"), _vm._t("errors", function() {
    return [_c("validation-errors", { attrs: { "errors": _vm.$parent.getErrors(_vm.name) } })];
  }, { "errors": _vm.$parent.getErrors(_vm.name) })], 2);
};
var staticRenderFns$i = [];
const __vue2_script$j = {
  components: {
    ValidationErrors
  },
  props: {
    label: {
      type: String,
      required: false,
      default: null
    },
    name: {
      type: String,
      required: true
    },
    id: {
      type: String,
      default: null
    },
    value: {
      validator: (prop) => typeof prop === "string" || prop === "number" || prop === null,
      default: ""
    },
    type: {
      type: String,
      default: "text"
    },
    min: {
      type: Number,
      required: false,
      default: null
    },
    max: {
      type: Number,
      required: false,
      default: null
    },
    maxlength: {
      type: Number,
      required: false,
      default: null
    },
    size: {
      type: Number,
      required: false,
      default: null
    },
    step: {
      type: Number,
      required: false,
      default: null
    },
    pattern: {
      type: String,
      required: false,
      default: null
    },
    placeholder: {
      type: String,
      required: false,
      default: null
    },
    autocomplete: {
      type: String,
      required: false,
      default: null
    },
    fieldClass: {
      type: String,
      required: false,
      default: null
    },
    labelClass: {
      type: String,
      required: false,
      default: null
    },
    readonly: {
      type: Boolean,
      required: false,
      default: false
    },
    required: {
      type: Boolean,
      required: false,
      default: false
    },
    disabled: {
      type: Boolean,
      required: false,
      default: false
    }
  }
};
const __cssModules$j = {};
var __component__$j = /* @__PURE__ */ normalizeComponent(__vue2_script$j, render$i, staticRenderFns$i, false, __vue2_injectStyles$j, null, null, null);
function __vue2_injectStyles$j(context) {
  for (let o in __cssModules$j) {
    this[o] = __cssModules$j[o];
  }
}
var FvlInput = /* @__PURE__ */ function() {
  return __component__$j.exports;
}();
var render$h = function() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", { staticClass: "fvl-textarea-wrapper", class: { "fvl-has-error": _vm.$parent.hasErrors(_vm.name) } }, [_vm.label ? _c("label", { staticClass: "fvl-textarea-label", class: _vm.labelClass, attrs: { "for": _vm.name } }, [_c("span", { domProps: { "innerHTML": _vm._s(_vm.label) } }), _vm._t("label_suffix")], 2) : _vm._e(), _c("div", { staticClass: "fvl-input-group" }, [_c("textarea", { staticClass: "fvl-textarea", class: _vm.fieldClass, attrs: { "id": _vm.id, "name": _vm.name, "placeholder": _vm.placeholder, "autocomplete": _vm.autocomplete, "cols": _vm.cols, "maxlength": _vm.maxlength, "rows": _vm.rows, "wrap": _vm.wrap, "required": _vm.required, "readonly": _vm.readonly, "disabled": _vm.disabled }, domProps: { "value": _vm.value }, on: { "change": function($event) {
    _vm.$parent.dirty(_vm.name), _vm.$emit("changed");
  }, "input": function($event) {
    _vm.$parent.dirty(_vm.name), _vm.$emit("update:value", $event.target.value), _vm.$emit("input", $event);
  } } })]), _vm._t("hint"), _vm._t("errors", function() {
    return [_c("validation-errors", { attrs: { "errors": _vm.$parent.getErrors(_vm.name) } })];
  }, { "errors": _vm.$parent.getErrors(_vm.name) })], 2);
};
var staticRenderFns$h = [];
const __vue2_script$i = {
  components: {
    ValidationErrors
  },
  props: {
    label: {
      type: String,
      required: false,
      default: null
    },
    name: {
      type: String,
      required: true
    },
    id: {
      type: String,
      default: null
    },
    value: {
      validator: (prop) => typeof prop === "string" || prop === null,
      default: ""
    },
    placeholder: {
      type: String,
      required: false,
      default: null
    },
    autocomplete: {
      type: String,
      required: false,
      default: null
    },
    fieldClass: {
      type: String,
      required: false,
      default: null
    },
    labelClass: {
      type: String,
      required: false,
      default: null
    },
    cols: {
      type: Number,
      required: false,
      default: null
    },
    maxlength: {
      type: Number,
      required: false,
      default: null
    },
    rows: {
      type: Number,
      required: false,
      default: null
    },
    wrap: {
      type: String,
      required: false,
      default: null
    },
    required: {
      type: Boolean,
      required: false,
      default: false
    },
    readonly: {
      type: Boolean,
      required: false,
      default: false
    },
    disabled: {
      type: Boolean,
      required: false,
      default: false
    }
  }
};
const __cssModules$i = {};
var __component__$i = /* @__PURE__ */ normalizeComponent(__vue2_script$i, render$h, staticRenderFns$h, false, __vue2_injectStyles$i, null, null, null);
function __vue2_injectStyles$i(context) {
  for (let o in __cssModules$i) {
    this[o] = __cssModules$i[o];
  }
}
var FvlTextarea = /* @__PURE__ */ function() {
  return __component__$i.exports;
}();
var render$g = function() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", { staticClass: "fvl-select-wrapper", class: { "fvl-has-error": _vm.$parent.hasErrors(_vm.name) } }, [_vm.label ? _c("label", { staticClass: "fvl-select-label", class: _vm.labelClass, attrs: { "for": _vm.id } }, [_c("span", { domProps: { "innerHTML": _vm._s(_vm.label) } }), _vm._t("label_suffix")], 2) : _vm._e(), _c("div", { staticClass: "fvl-select" }, [_c("select", { ref: _vm._uid, class: _vm.fieldClass, attrs: { "id": _vm.id, "name": _vm.name, "placeholder": _vm.placeholder, "autocomplete": _vm.autocomplete, "required": _vm.required, "readonly": _vm.readonly, "disabled": _vm.disabled }, on: { "change": function($event) {
    _vm.$emit("update:selected", $event.target.value), _vm.$emit("changed"), _vm.$parent.dirty(_vm.name);
  } } }, [_vm.allowEmpty ? _c("option", { attrs: { "disabled": "", "selected": "", "value": "" }, domProps: { "textContent": _vm._s(_vm.placeholder) } }) : _vm._e(), _vm._l(_vm.options, function(option, key) {
    return _c("option", { key, domProps: { "value": key, "selected": _vm.selected == key, "textContent": _vm._s(option) } });
  })], 2), _c("div", { staticClass: "pointer-events-none absolute h-full inset-y-0 right-0 flex items-center px-2 text-gray-700", on: { "click": function($event) {
    return _vm.$refs[_vm._uid].click();
  } } }, [_c("svg", { staticClass: "fill-current h-4 w-4", attrs: { "xmlns": "http://www.w3.org/2000/svg", "viewBox": "0 0 20 20" } }, [_c("path", { attrs: { "d": "M9.293 12.95l.707.707L15.657 8l-1.414-1.414L10 10.828 5.757 6.586 4.343 8z" } })])])]), _vm._t("hint"), _vm._t("errors", function() {
    return [_c("validation-errors", { attrs: { "errors": _vm.$parent.getErrors(_vm.name) } })];
  }, { "errors": _vm.$parent.getErrors(_vm.name) })], 2);
};
var staticRenderFns$g = [];
const __vue2_script$h = {
  components: {
    ValidationErrors
  },
  props: {
    selected: {
      type: String | Number,
      default: ""
    },
    name: {
      type: String,
      required: true
    },
    id: {
      type: String,
      default: null
    },
    label: {
      type: String,
      default: null
    },
    options: {
      type: Object,
      required: true,
      default: () => {
      }
    },
    allowEmpty: {
      type: Boolean,
      default: true
    },
    placeholder: {
      type: String,
      required: false,
      default: null
    },
    autocomplete: {
      type: String,
      required: false,
      default: null
    },
    fieldClass: {
      type: String,
      required: false,
      default: null
    },
    labelClass: {
      type: String,
      required: false,
      default: ""
    },
    required: {
      type: Boolean,
      required: false,
      default: false
    },
    readonly: {
      type: Boolean,
      required: false,
      default: false
    },
    disabled: {
      type: Boolean,
      required: false,
      default: false
    }
  }
};
const __cssModules$h = {};
var __component__$h = /* @__PURE__ */ normalizeComponent(__vue2_script$h, render$g, staticRenderFns$g, false, __vue2_injectStyles$h, null, null, null);
function __vue2_injectStyles$h(context) {
  for (let o in __cssModules$h) {
    this[o] = __cssModules$h[o];
  }
}
var FvlSelect = /* @__PURE__ */ function() {
  return __component__$h.exports;
}();
function isArray$a(value) {
  return !Array.isArray ? getTag$2(value) === "[object Array]" : Array.isArray(value);
}
const INFINITY$3 = 1 / 0;
function baseToString$2(value) {
  if (typeof value == "string") {
    return value;
  }
  let result = value + "";
  return result == "0" && 1 / value == -INFINITY$3 ? "-0" : result;
}
function toString$2(value) {
  return value == null ? "" : baseToString$2(value);
}
function isString(value) {
  return typeof value === "string";
}
function isNumber(value) {
  return typeof value === "number";
}
function isBoolean(value) {
  return value === true || value === false || isObjectLike$2(value) && getTag$2(value) == "[object Boolean]";
}
function isObject$2(value) {
  return typeof value === "object";
}
function isObjectLike$2(value) {
  return isObject$2(value) && value !== null;
}
function isDefined(value) {
  return value !== void 0 && value !== null;
}
function isBlank(value) {
  return !value.trim().length;
}
function getTag$2(value) {
  return value == null ? value === void 0 ? "[object Undefined]" : "[object Null]" : Object.prototype.toString.call(value);
}
const EXTENDED_SEARCH_UNAVAILABLE = "Extended search is not available";
const INCORRECT_INDEX_TYPE = "Incorrect 'index' type";
const LOGICAL_SEARCH_INVALID_QUERY_FOR_KEY = (key) => `Invalid value for key ${key}`;
const PATTERN_LENGTH_TOO_LARGE = (max) => `Pattern length exceeds max of ${max}.`;
const MISSING_KEY_PROPERTY = (name) => `Missing ${name} property in key`;
const INVALID_KEY_WEIGHT_VALUE = (key) => `Property 'weight' in key '${key}' must be a positive integer`;
const hasOwn = Object.prototype.hasOwnProperty;
class KeyStore {
  constructor(keys2) {
    this._keys = [];
    this._keyMap = {};
    let totalWeight = 0;
    keys2.forEach((key) => {
      let obj = createKey(key);
      totalWeight += obj.weight;
      this._keys.push(obj);
      this._keyMap[obj.id] = obj;
      totalWeight += obj.weight;
    });
    this._keys.forEach((key) => {
      key.weight /= totalWeight;
    });
  }
  get(keyId) {
    return this._keyMap[keyId];
  }
  keys() {
    return this._keys;
  }
  toJSON() {
    return JSON.stringify(this._keys);
  }
}
function createKey(key) {
  let path = null;
  let id = null;
  let src = null;
  let weight = 1;
  let getFn = null;
  if (isString(key) || isArray$a(key)) {
    src = key;
    path = createKeyPath(key);
    id = createKeyId(key);
  } else {
    if (!hasOwn.call(key, "name")) {
      throw new Error(MISSING_KEY_PROPERTY("name"));
    }
    const name = key.name;
    src = name;
    if (hasOwn.call(key, "weight")) {
      weight = key.weight;
      if (weight <= 0) {
        throw new Error(INVALID_KEY_WEIGHT_VALUE(name));
      }
    }
    path = createKeyPath(name);
    id = createKeyId(name);
    getFn = key.getFn;
  }
  return { path, id, weight, src, getFn };
}
function createKeyPath(key) {
  return isArray$a(key) ? key : key.split(".");
}
function createKeyId(key) {
  return isArray$a(key) ? key.join(".") : key;
}
function get$2(obj, path) {
  let list = [];
  let arr = false;
  const deepGet = (obj2, path2, index) => {
    if (!isDefined(obj2)) {
      return;
    }
    if (!path2[index]) {
      list.push(obj2);
    } else {
      let key = path2[index];
      const value = obj2[key];
      if (!isDefined(value)) {
        return;
      }
      if (index === path2.length - 1 && (isString(value) || isNumber(value) || isBoolean(value))) {
        list.push(toString$2(value));
      } else if (isArray$a(value)) {
        arr = true;
        for (let i = 0, len = value.length; i < len; i += 1) {
          deepGet(value[i], path2, index + 1);
        }
      } else if (path2.length) {
        deepGet(value, path2, index + 1);
      }
    }
  };
  deepGet(obj, isString(path) ? path.split(".") : path, 0);
  return arr ? list : list[0];
}
const MatchOptions = {
  includeMatches: false,
  findAllMatches: false,
  minMatchCharLength: 1
};
const BasicOptions = {
  isCaseSensitive: false,
  includeScore: false,
  keys: [],
  shouldSort: true,
  sortFn: (a, b) => a.score === b.score ? a.idx < b.idx ? -1 : 1 : a.score < b.score ? -1 : 1
};
const FuzzyOptions = {
  location: 0,
  threshold: 0.6,
  distance: 100
};
const AdvancedOptions = {
  useExtendedSearch: false,
  getFn: get$2,
  ignoreLocation: false,
  ignoreFieldNorm: false,
  fieldNormWeight: 1
};
var Config = __spreadValues(__spreadValues(__spreadValues(__spreadValues({}, BasicOptions), MatchOptions), FuzzyOptions), AdvancedOptions);
const SPACE = /[^ ]+/g;
function norm(weight = 1, mantissa = 3) {
  const cache = /* @__PURE__ */ new Map();
  const m = Math.pow(10, mantissa);
  return {
    get(value) {
      const numTokens = value.match(SPACE).length;
      if (cache.has(numTokens)) {
        return cache.get(numTokens);
      }
      const norm2 = 1 / Math.pow(numTokens, 0.5 * weight);
      const n = parseFloat(Math.round(norm2 * m) / m);
      cache.set(numTokens, n);
      return n;
    },
    clear() {
      cache.clear();
    }
  };
}
class FuseIndex {
  constructor({
    getFn = Config.getFn,
    fieldNormWeight = Config.fieldNormWeight
  } = {}) {
    this.norm = norm(fieldNormWeight, 3);
    this.getFn = getFn;
    this.isCreated = false;
    this.setIndexRecords();
  }
  setSources(docs = []) {
    this.docs = docs;
  }
  setIndexRecords(records = []) {
    this.records = records;
  }
  setKeys(keys2 = []) {
    this.keys = keys2;
    this._keysMap = {};
    keys2.forEach((key, idx) => {
      this._keysMap[key.id] = idx;
    });
  }
  create() {
    if (this.isCreated || !this.docs.length) {
      return;
    }
    this.isCreated = true;
    if (isString(this.docs[0])) {
      this.docs.forEach((doc, docIndex) => {
        this._addString(doc, docIndex);
      });
    } else {
      this.docs.forEach((doc, docIndex) => {
        this._addObject(doc, docIndex);
      });
    }
    this.norm.clear();
  }
  add(doc) {
    const idx = this.size();
    if (isString(doc)) {
      this._addString(doc, idx);
    } else {
      this._addObject(doc, idx);
    }
  }
  removeAt(idx) {
    this.records.splice(idx, 1);
    for (let i = idx, len = this.size(); i < len; i += 1) {
      this.records[i].i -= 1;
    }
  }
  getValueForItemAtKeyId(item, keyId) {
    return item[this._keysMap[keyId]];
  }
  size() {
    return this.records.length;
  }
  _addString(doc, docIndex) {
    if (!isDefined(doc) || isBlank(doc)) {
      return;
    }
    let record = {
      v: doc,
      i: docIndex,
      n: this.norm.get(doc)
    };
    this.records.push(record);
  }
  _addObject(doc, docIndex) {
    let record = { i: docIndex, $: {} };
    this.keys.forEach((key, keyIndex) => {
      let value = key.getFn ? key.getFn(doc) : this.getFn(doc, key.path);
      if (!isDefined(value)) {
        return;
      }
      if (isArray$a(value)) {
        let subRecords = [];
        const stack = [{ nestedArrIndex: -1, value }];
        while (stack.length) {
          const { nestedArrIndex, value: value2 } = stack.pop();
          if (!isDefined(value2)) {
            continue;
          }
          if (isString(value2) && !isBlank(value2)) {
            let subRecord = {
              v: value2,
              i: nestedArrIndex,
              n: this.norm.get(value2)
            };
            subRecords.push(subRecord);
          } else if (isArray$a(value2)) {
            value2.forEach((item, k) => {
              stack.push({
                nestedArrIndex: k,
                value: item
              });
            });
          } else
            ;
        }
        record.$[keyIndex] = subRecords;
      } else if (isString(value) && !isBlank(value)) {
        let subRecord = {
          v: value,
          n: this.norm.get(value)
        };
        record.$[keyIndex] = subRecord;
      }
    });
    this.records.push(record);
  }
  toJSON() {
    return {
      keys: this.keys,
      records: this.records
    };
  }
}
function createIndex(keys2, docs, { getFn = Config.getFn, fieldNormWeight = Config.fieldNormWeight } = {}) {
  const myIndex = new FuseIndex({ getFn, fieldNormWeight });
  myIndex.setKeys(keys2.map(createKey));
  myIndex.setSources(docs);
  myIndex.create();
  return myIndex;
}
function parseIndex(data2, { getFn = Config.getFn, fieldNormWeight = Config.fieldNormWeight } = {}) {
  const { keys: keys2, records } = data2;
  const myIndex = new FuseIndex({ getFn, fieldNormWeight });
  myIndex.setKeys(keys2);
  myIndex.setIndexRecords(records);
  return myIndex;
}
function computeScore$1(pattern, {
  errors = 0,
  currentLocation = 0,
  expectedLocation = 0,
  distance = Config.distance,
  ignoreLocation = Config.ignoreLocation
} = {}) {
  const accuracy = errors / pattern.length;
  if (ignoreLocation) {
    return accuracy;
  }
  const proximity = Math.abs(expectedLocation - currentLocation);
  if (!distance) {
    return proximity ? 1 : accuracy;
  }
  return accuracy + proximity / distance;
}
function convertMaskToIndices(matchmask = [], minMatchCharLength = Config.minMatchCharLength) {
  let indices = [];
  let start = -1;
  let end = -1;
  let i = 0;
  for (let len = matchmask.length; i < len; i += 1) {
    let match = matchmask[i];
    if (match && start === -1) {
      start = i;
    } else if (!match && start !== -1) {
      end = i - 1;
      if (end - start + 1 >= minMatchCharLength) {
        indices.push([start, end]);
      }
      start = -1;
    }
  }
  if (matchmask[i - 1] && i - start >= minMatchCharLength) {
    indices.push([start, i - 1]);
  }
  return indices;
}
const MAX_BITS = 32;
function search(text, pattern, patternAlphabet, {
  location = Config.location,
  distance = Config.distance,
  threshold = Config.threshold,
  findAllMatches = Config.findAllMatches,
  minMatchCharLength = Config.minMatchCharLength,
  includeMatches = Config.includeMatches,
  ignoreLocation = Config.ignoreLocation
} = {}) {
  if (pattern.length > MAX_BITS) {
    throw new Error(PATTERN_LENGTH_TOO_LARGE(MAX_BITS));
  }
  const patternLen = pattern.length;
  const textLen = text.length;
  const expectedLocation = Math.max(0, Math.min(location, textLen));
  let currentThreshold = threshold;
  let bestLocation = expectedLocation;
  const computeMatches = minMatchCharLength > 1 || includeMatches;
  const matchMask = computeMatches ? Array(textLen) : [];
  let index;
  while ((index = text.indexOf(pattern, bestLocation)) > -1) {
    let score = computeScore$1(pattern, {
      currentLocation: index,
      expectedLocation,
      distance,
      ignoreLocation
    });
    currentThreshold = Math.min(score, currentThreshold);
    bestLocation = index + patternLen;
    if (computeMatches) {
      let i = 0;
      while (i < patternLen) {
        matchMask[index + i] = 1;
        i += 1;
      }
    }
  }
  bestLocation = -1;
  let lastBitArr = [];
  let finalScore = 1;
  let binMax = patternLen + textLen;
  const mask = 1 << patternLen - 1;
  for (let i = 0; i < patternLen; i += 1) {
    let binMin = 0;
    let binMid = binMax;
    while (binMin < binMid) {
      const score2 = computeScore$1(pattern, {
        errors: i,
        currentLocation: expectedLocation + binMid,
        expectedLocation,
        distance,
        ignoreLocation
      });
      if (score2 <= currentThreshold) {
        binMin = binMid;
      } else {
        binMax = binMid;
      }
      binMid = Math.floor((binMax - binMin) / 2 + binMin);
    }
    binMax = binMid;
    let start = Math.max(1, expectedLocation - binMid + 1);
    let finish = findAllMatches ? textLen : Math.min(expectedLocation + binMid, textLen) + patternLen;
    let bitArr = Array(finish + 2);
    bitArr[finish + 1] = (1 << i) - 1;
    for (let j = finish; j >= start; j -= 1) {
      let currentLocation = j - 1;
      let charMatch = patternAlphabet[text.charAt(currentLocation)];
      if (computeMatches) {
        matchMask[currentLocation] = +!!charMatch;
      }
      bitArr[j] = (bitArr[j + 1] << 1 | 1) & charMatch;
      if (i) {
        bitArr[j] |= (lastBitArr[j + 1] | lastBitArr[j]) << 1 | 1 | lastBitArr[j + 1];
      }
      if (bitArr[j] & mask) {
        finalScore = computeScore$1(pattern, {
          errors: i,
          currentLocation,
          expectedLocation,
          distance,
          ignoreLocation
        });
        if (finalScore <= currentThreshold) {
          currentThreshold = finalScore;
          bestLocation = currentLocation;
          if (bestLocation <= expectedLocation) {
            break;
          }
          start = Math.max(1, 2 * expectedLocation - bestLocation);
        }
      }
    }
    const score = computeScore$1(pattern, {
      errors: i + 1,
      currentLocation: expectedLocation,
      expectedLocation,
      distance,
      ignoreLocation
    });
    if (score > currentThreshold) {
      break;
    }
    lastBitArr = bitArr;
  }
  const result = {
    isMatch: bestLocation >= 0,
    score: Math.max(1e-3, finalScore)
  };
  if (computeMatches) {
    const indices = convertMaskToIndices(matchMask, minMatchCharLength);
    if (!indices.length) {
      result.isMatch = false;
    } else if (includeMatches) {
      result.indices = indices;
    }
  }
  return result;
}
function createPatternAlphabet(pattern) {
  let mask = {};
  for (let i = 0, len = pattern.length; i < len; i += 1) {
    const char = pattern.charAt(i);
    mask[char] = (mask[char] || 0) | 1 << len - i - 1;
  }
  return mask;
}
class BitapSearch {
  constructor(pattern, {
    location = Config.location,
    threshold = Config.threshold,
    distance = Config.distance,
    includeMatches = Config.includeMatches,
    findAllMatches = Config.findAllMatches,
    minMatchCharLength = Config.minMatchCharLength,
    isCaseSensitive = Config.isCaseSensitive,
    ignoreLocation = Config.ignoreLocation
  } = {}) {
    this.options = {
      location,
      threshold,
      distance,
      includeMatches,
      findAllMatches,
      minMatchCharLength,
      isCaseSensitive,
      ignoreLocation
    };
    this.pattern = isCaseSensitive ? pattern : pattern.toLowerCase();
    this.chunks = [];
    if (!this.pattern.length) {
      return;
    }
    const addChunk = (pattern2, startIndex) => {
      this.chunks.push({
        pattern: pattern2,
        alphabet: createPatternAlphabet(pattern2),
        startIndex
      });
    };
    const len = this.pattern.length;
    if (len > MAX_BITS) {
      let i = 0;
      const remainder = len % MAX_BITS;
      const end = len - remainder;
      while (i < end) {
        addChunk(this.pattern.substr(i, MAX_BITS), i);
        i += MAX_BITS;
      }
      if (remainder) {
        const startIndex = len - MAX_BITS;
        addChunk(this.pattern.substr(startIndex), startIndex);
      }
    } else {
      addChunk(this.pattern, 0);
    }
  }
  searchIn(text) {
    const { isCaseSensitive, includeMatches } = this.options;
    if (!isCaseSensitive) {
      text = text.toLowerCase();
    }
    if (this.pattern === text) {
      let result2 = {
        isMatch: true,
        score: 0
      };
      if (includeMatches) {
        result2.indices = [[0, text.length - 1]];
      }
      return result2;
    }
    const {
      location,
      distance,
      threshold,
      findAllMatches,
      minMatchCharLength,
      ignoreLocation
    } = this.options;
    let allIndices = [];
    let totalScore = 0;
    let hasMatches = false;
    this.chunks.forEach(({ pattern, alphabet, startIndex }) => {
      const { isMatch, score, indices } = search(text, pattern, alphabet, {
        location: location + startIndex,
        distance,
        threshold,
        findAllMatches,
        minMatchCharLength,
        includeMatches,
        ignoreLocation
      });
      if (isMatch) {
        hasMatches = true;
      }
      totalScore += score;
      if (isMatch && indices) {
        allIndices = [...allIndices, ...indices];
      }
    });
    let result = {
      isMatch: hasMatches,
      score: hasMatches ? totalScore / this.chunks.length : 1
    };
    if (hasMatches && includeMatches) {
      result.indices = allIndices;
    }
    return result;
  }
}
class BaseMatch {
  constructor(pattern) {
    this.pattern = pattern;
  }
  static isMultiMatch(pattern) {
    return getMatch(pattern, this.multiRegex);
  }
  static isSingleMatch(pattern) {
    return getMatch(pattern, this.singleRegex);
  }
  search() {
  }
}
function getMatch(pattern, exp) {
  const matches = pattern.match(exp);
  return matches ? matches[1] : null;
}
class ExactMatch extends BaseMatch {
  constructor(pattern) {
    super(pattern);
  }
  static get type() {
    return "exact";
  }
  static get multiRegex() {
    return /^="(.*)"$/;
  }
  static get singleRegex() {
    return /^=(.*)$/;
  }
  search(text) {
    const isMatch = text === this.pattern;
    return {
      isMatch,
      score: isMatch ? 0 : 1,
      indices: [0, this.pattern.length - 1]
    };
  }
}
class InverseExactMatch extends BaseMatch {
  constructor(pattern) {
    super(pattern);
  }
  static get type() {
    return "inverse-exact";
  }
  static get multiRegex() {
    return /^!"(.*)"$/;
  }
  static get singleRegex() {
    return /^!(.*)$/;
  }
  search(text) {
    const index = text.indexOf(this.pattern);
    const isMatch = index === -1;
    return {
      isMatch,
      score: isMatch ? 0 : 1,
      indices: [0, text.length - 1]
    };
  }
}
class PrefixExactMatch extends BaseMatch {
  constructor(pattern) {
    super(pattern);
  }
  static get type() {
    return "prefix-exact";
  }
  static get multiRegex() {
    return /^\^"(.*)"$/;
  }
  static get singleRegex() {
    return /^\^(.*)$/;
  }
  search(text) {
    const isMatch = text.startsWith(this.pattern);
    return {
      isMatch,
      score: isMatch ? 0 : 1,
      indices: [0, this.pattern.length - 1]
    };
  }
}
class InversePrefixExactMatch extends BaseMatch {
  constructor(pattern) {
    super(pattern);
  }
  static get type() {
    return "inverse-prefix-exact";
  }
  static get multiRegex() {
    return /^!\^"(.*)"$/;
  }
  static get singleRegex() {
    return /^!\^(.*)$/;
  }
  search(text) {
    const isMatch = !text.startsWith(this.pattern);
    return {
      isMatch,
      score: isMatch ? 0 : 1,
      indices: [0, text.length - 1]
    };
  }
}
class SuffixExactMatch extends BaseMatch {
  constructor(pattern) {
    super(pattern);
  }
  static get type() {
    return "suffix-exact";
  }
  static get multiRegex() {
    return /^"(.*)"\$$/;
  }
  static get singleRegex() {
    return /^(.*)\$$/;
  }
  search(text) {
    const isMatch = text.endsWith(this.pattern);
    return {
      isMatch,
      score: isMatch ? 0 : 1,
      indices: [text.length - this.pattern.length, text.length - 1]
    };
  }
}
class InverseSuffixExactMatch extends BaseMatch {
  constructor(pattern) {
    super(pattern);
  }
  static get type() {
    return "inverse-suffix-exact";
  }
  static get multiRegex() {
    return /^!"(.*)"\$$/;
  }
  static get singleRegex() {
    return /^!(.*)\$$/;
  }
  search(text) {
    const isMatch = !text.endsWith(this.pattern);
    return {
      isMatch,
      score: isMatch ? 0 : 1,
      indices: [0, text.length - 1]
    };
  }
}
class FuzzyMatch extends BaseMatch {
  constructor(pattern, {
    location = Config.location,
    threshold = Config.threshold,
    distance = Config.distance,
    includeMatches = Config.includeMatches,
    findAllMatches = Config.findAllMatches,
    minMatchCharLength = Config.minMatchCharLength,
    isCaseSensitive = Config.isCaseSensitive,
    ignoreLocation = Config.ignoreLocation
  } = {}) {
    super(pattern);
    this._bitapSearch = new BitapSearch(pattern, {
      location,
      threshold,
      distance,
      includeMatches,
      findAllMatches,
      minMatchCharLength,
      isCaseSensitive,
      ignoreLocation
    });
  }
  static get type() {
    return "fuzzy";
  }
  static get multiRegex() {
    return /^"(.*)"$/;
  }
  static get singleRegex() {
    return /^(.*)$/;
  }
  search(text) {
    return this._bitapSearch.searchIn(text);
  }
}
class IncludeMatch extends BaseMatch {
  constructor(pattern) {
    super(pattern);
  }
  static get type() {
    return "include";
  }
  static get multiRegex() {
    return /^'"(.*)"$/;
  }
  static get singleRegex() {
    return /^'(.*)$/;
  }
  search(text) {
    let location = 0;
    let index;
    const indices = [];
    const patternLen = this.pattern.length;
    while ((index = text.indexOf(this.pattern, location)) > -1) {
      location = index + patternLen;
      indices.push([index, location - 1]);
    }
    const isMatch = !!indices.length;
    return {
      isMatch,
      score: isMatch ? 0 : 1,
      indices
    };
  }
}
const searchers = [
  ExactMatch,
  IncludeMatch,
  PrefixExactMatch,
  InversePrefixExactMatch,
  InverseSuffixExactMatch,
  SuffixExactMatch,
  InverseExactMatch,
  FuzzyMatch
];
const searchersLen = searchers.length;
const SPACE_RE = / +(?=(?:[^\"]*\"[^\"]*\")*[^\"]*$)/;
const OR_TOKEN = "|";
function parseQuery(pattern, options = {}) {
  return pattern.split(OR_TOKEN).map((item) => {
    let query = item.trim().split(SPACE_RE).filter((item2) => item2 && !!item2.trim());
    let results = [];
    for (let i = 0, len = query.length; i < len; i += 1) {
      const queryItem = query[i];
      let found = false;
      let idx = -1;
      while (!found && ++idx < searchersLen) {
        const searcher = searchers[idx];
        let token = searcher.isMultiMatch(queryItem);
        if (token) {
          results.push(new searcher(token, options));
          found = true;
        }
      }
      if (found) {
        continue;
      }
      idx = -1;
      while (++idx < searchersLen) {
        const searcher = searchers[idx];
        let token = searcher.isSingleMatch(queryItem);
        if (token) {
          results.push(new searcher(token, options));
          break;
        }
      }
    }
    return results;
  });
}
const MultiMatchSet = /* @__PURE__ */ new Set([FuzzyMatch.type, IncludeMatch.type]);
class ExtendedSearch {
  constructor(pattern, {
    isCaseSensitive = Config.isCaseSensitive,
    includeMatches = Config.includeMatches,
    minMatchCharLength = Config.minMatchCharLength,
    ignoreLocation = Config.ignoreLocation,
    findAllMatches = Config.findAllMatches,
    location = Config.location,
    threshold = Config.threshold,
    distance = Config.distance
  } = {}) {
    this.query = null;
    this.options = {
      isCaseSensitive,
      includeMatches,
      minMatchCharLength,
      findAllMatches,
      ignoreLocation,
      location,
      threshold,
      distance
    };
    this.pattern = isCaseSensitive ? pattern : pattern.toLowerCase();
    this.query = parseQuery(this.pattern, this.options);
  }
  static condition(_, options) {
    return options.useExtendedSearch;
  }
  searchIn(text) {
    const query = this.query;
    if (!query) {
      return {
        isMatch: false,
        score: 1
      };
    }
    const { includeMatches, isCaseSensitive } = this.options;
    text = isCaseSensitive ? text : text.toLowerCase();
    let numMatches = 0;
    let allIndices = [];
    let totalScore = 0;
    for (let i = 0, qLen = query.length; i < qLen; i += 1) {
      const searchers2 = query[i];
      allIndices.length = 0;
      numMatches = 0;
      for (let j = 0, pLen = searchers2.length; j < pLen; j += 1) {
        const searcher = searchers2[j];
        const { isMatch, indices, score } = searcher.search(text);
        if (isMatch) {
          numMatches += 1;
          totalScore += score;
          if (includeMatches) {
            const type = searcher.constructor.type;
            if (MultiMatchSet.has(type)) {
              allIndices = [...allIndices, ...indices];
            } else {
              allIndices.push(indices);
            }
          }
        } else {
          totalScore = 0;
          numMatches = 0;
          allIndices.length = 0;
          break;
        }
      }
      if (numMatches) {
        let result = {
          isMatch: true,
          score: totalScore / numMatches
        };
        if (includeMatches) {
          result.indices = allIndices;
        }
        return result;
      }
    }
    return {
      isMatch: false,
      score: 1
    };
  }
}
const registeredSearchers = [];
function register(...args) {
  registeredSearchers.push(...args);
}
function createSearcher(pattern, options) {
  for (let i = 0, len = registeredSearchers.length; i < len; i += 1) {
    let searcherClass = registeredSearchers[i];
    if (searcherClass.condition(pattern, options)) {
      return new searcherClass(pattern, options);
    }
  }
  return new BitapSearch(pattern, options);
}
const LogicalOperator = {
  AND: "$and",
  OR: "$or"
};
const KeyType = {
  PATH: "$path",
  PATTERN: "$val"
};
const isExpression = (query) => !!(query[LogicalOperator.AND] || query[LogicalOperator.OR]);
const isPath = (query) => !!query[KeyType.PATH];
const isLeaf = (query) => !isArray$a(query) && isObject$2(query) && !isExpression(query);
const convertToExplicit = (query) => ({
  [LogicalOperator.AND]: Object.keys(query).map((key) => ({
    [key]: query[key]
  }))
});
function parse(query, options, { auto = true } = {}) {
  const next = (query2) => {
    let keys2 = Object.keys(query2);
    const isQueryPath = isPath(query2);
    if (!isQueryPath && keys2.length > 1 && !isExpression(query2)) {
      return next(convertToExplicit(query2));
    }
    if (isLeaf(query2)) {
      const key = isQueryPath ? query2[KeyType.PATH] : keys2[0];
      const pattern = isQueryPath ? query2[KeyType.PATTERN] : query2[key];
      if (!isString(pattern)) {
        throw new Error(LOGICAL_SEARCH_INVALID_QUERY_FOR_KEY(key));
      }
      const obj = {
        keyId: createKeyId(key),
        pattern
      };
      if (auto) {
        obj.searcher = createSearcher(pattern, options);
      }
      return obj;
    }
    let node = {
      children: [],
      operator: keys2[0]
    };
    keys2.forEach((key) => {
      const value = query2[key];
      if (isArray$a(value)) {
        value.forEach((item) => {
          node.children.push(next(item));
        });
      }
    });
    return node;
  };
  if (!isExpression(query)) {
    query = convertToExplicit(query);
  }
  return next(query);
}
function computeScore(results, { ignoreFieldNorm = Config.ignoreFieldNorm }) {
  results.forEach((result) => {
    let totalScore = 1;
    result.matches.forEach(({ key, norm: norm2, score }) => {
      const weight = key ? key.weight : null;
      totalScore *= Math.pow(score === 0 && weight ? Number.EPSILON : score, (weight || 1) * (ignoreFieldNorm ? 1 : norm2));
    });
    result.score = totalScore;
  });
}
function transformMatches(result, data2) {
  const matches = result.matches;
  data2.matches = [];
  if (!isDefined(matches)) {
    return;
  }
  matches.forEach((match) => {
    if (!isDefined(match.indices) || !match.indices.length) {
      return;
    }
    const { indices, value } = match;
    let obj = {
      indices,
      value
    };
    if (match.key) {
      obj.key = match.key.src;
    }
    if (match.idx > -1) {
      obj.refIndex = match.idx;
    }
    data2.matches.push(obj);
  });
}
function transformScore(result, data2) {
  data2.score = result.score;
}
function format(results, docs, {
  includeMatches = Config.includeMatches,
  includeScore = Config.includeScore
} = {}) {
  const transformers = [];
  if (includeMatches)
    transformers.push(transformMatches);
  if (includeScore)
    transformers.push(transformScore);
  return results.map((result) => {
    const { idx } = result;
    const data2 = {
      item: docs[idx],
      refIndex: idx
    };
    if (transformers.length) {
      transformers.forEach((transformer) => {
        transformer(result, data2);
      });
    }
    return data2;
  });
}
class Fuse {
  constructor(docs, options = {}, index) {
    this.options = __spreadValues(__spreadValues({}, Config), options);
    if (this.options.useExtendedSearch && false) {
      throw new Error(EXTENDED_SEARCH_UNAVAILABLE);
    }
    this._keyStore = new KeyStore(this.options.keys);
    this.setCollection(docs, index);
  }
  setCollection(docs, index) {
    this._docs = docs;
    if (index && !(index instanceof FuseIndex)) {
      throw new Error(INCORRECT_INDEX_TYPE);
    }
    this._myIndex = index || createIndex(this.options.keys, this._docs, {
      getFn: this.options.getFn,
      fieldNormWeight: this.options.fieldNormWeight
    });
  }
  add(doc) {
    if (!isDefined(doc)) {
      return;
    }
    this._docs.push(doc);
    this._myIndex.add(doc);
  }
  remove(predicate = () => false) {
    const results = [];
    for (let i = 0, len = this._docs.length; i < len; i += 1) {
      const doc = this._docs[i];
      if (predicate(doc, i)) {
        this.removeAt(i);
        i -= 1;
        len -= 1;
        results.push(doc);
      }
    }
    return results;
  }
  removeAt(idx) {
    this._docs.splice(idx, 1);
    this._myIndex.removeAt(idx);
  }
  getIndex() {
    return this._myIndex;
  }
  search(query, { limit = -1 } = {}) {
    const {
      includeMatches,
      includeScore,
      shouldSort,
      sortFn,
      ignoreFieldNorm
    } = this.options;
    let results = isString(query) ? isString(this._docs[0]) ? this._searchStringList(query) : this._searchObjectList(query) : this._searchLogical(query);
    computeScore(results, { ignoreFieldNorm });
    if (shouldSort) {
      results.sort(sortFn);
    }
    if (isNumber(limit) && limit > -1) {
      results = results.slice(0, limit);
    }
    return format(results, this._docs, {
      includeMatches,
      includeScore
    });
  }
  _searchStringList(query) {
    const searcher = createSearcher(query, this.options);
    const { records } = this._myIndex;
    const results = [];
    records.forEach(({ v: text, i: idx, n: norm2 }) => {
      if (!isDefined(text)) {
        return;
      }
      const { isMatch, score, indices } = searcher.searchIn(text);
      if (isMatch) {
        results.push({
          item: text,
          idx,
          matches: [{ score, value: text, norm: norm2, indices }]
        });
      }
    });
    return results;
  }
  _searchLogical(query) {
    const expression = parse(query, this.options);
    const evaluate = (node, item, idx) => {
      if (!node.children) {
        const { keyId, searcher } = node;
        const matches = this._findMatches({
          key: this._keyStore.get(keyId),
          value: this._myIndex.getValueForItemAtKeyId(item, keyId),
          searcher
        });
        if (matches && matches.length) {
          return [
            {
              idx,
              item,
              matches
            }
          ];
        }
        return [];
      }
      const res = [];
      for (let i = 0, len = node.children.length; i < len; i += 1) {
        const child = node.children[i];
        const result = evaluate(child, item, idx);
        if (result.length) {
          res.push(...result);
        } else if (node.operator === LogicalOperator.AND) {
          return [];
        }
      }
      return res;
    };
    const records = this._myIndex.records;
    const resultMap = {};
    const results = [];
    records.forEach(({ $: item, i: idx }) => {
      if (isDefined(item)) {
        let expResults = evaluate(expression, item, idx);
        if (expResults.length) {
          if (!resultMap[idx]) {
            resultMap[idx] = { idx, item, matches: [] };
            results.push(resultMap[idx]);
          }
          expResults.forEach(({ matches }) => {
            resultMap[idx].matches.push(...matches);
          });
        }
      }
    });
    return results;
  }
  _searchObjectList(query) {
    const searcher = createSearcher(query, this.options);
    const { keys: keys2, records } = this._myIndex;
    const results = [];
    records.forEach(({ $: item, i: idx }) => {
      if (!isDefined(item)) {
        return;
      }
      let matches = [];
      keys2.forEach((key, keyIndex) => {
        matches.push(...this._findMatches({
          key,
          value: item[keyIndex],
          searcher
        }));
      });
      if (matches.length) {
        results.push({
          idx,
          item,
          matches
        });
      }
    });
    return results;
  }
  _findMatches({ key, value, searcher }) {
    if (!isDefined(value)) {
      return [];
    }
    let matches = [];
    if (isArray$a(value)) {
      value.forEach(({ v: text, i: idx, n: norm2 }) => {
        if (!isDefined(text)) {
          return;
        }
        const { isMatch, score, indices } = searcher.searchIn(text);
        if (isMatch) {
          matches.push({
            score,
            key,
            value: text,
            idx,
            norm: norm2,
            indices
          });
        }
      });
    } else {
      const { v: text, n: norm2 } = value;
      const { isMatch, score, indices } = searcher.searchIn(text);
      if (isMatch) {
        matches.push({ score, key, value: text, norm: norm2, indices });
      }
    }
    return matches;
  }
}
Fuse.version = "6.6.2";
Fuse.createIndex = createIndex;
Fuse.parseIndex = parseIndex;
Fuse.config = Config;
{
  Fuse.parseQuery = parse;
}
{
  register(ExtendedSearch);
}
/**!
 * @fileOverview Kickass library to create and place poppers near their reference elements.
 * @version 1.16.1
 * @license
 * Copyright (c) 2016 Federico Zivolo and contributors
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */
var isBrowser = typeof window !== "undefined" && typeof document !== "undefined" && typeof navigator !== "undefined";
var timeoutDuration = function() {
  var longerTimeoutBrowsers = ["Edge", "Trident", "Firefox"];
  for (var i = 0; i < longerTimeoutBrowsers.length; i += 1) {
    if (isBrowser && navigator.userAgent.indexOf(longerTimeoutBrowsers[i]) >= 0) {
      return 1;
    }
  }
  return 0;
}();
function microtaskDebounce(fn) {
  var called = false;
  return function() {
    if (called) {
      return;
    }
    called = true;
    window.Promise.resolve().then(function() {
      called = false;
      fn();
    });
  };
}
function taskDebounce(fn) {
  var scheduled = false;
  return function() {
    if (!scheduled) {
      scheduled = true;
      setTimeout(function() {
        scheduled = false;
        fn();
      }, timeoutDuration);
    }
  };
}
var supportsMicroTasks = isBrowser && window.Promise;
var debounce$1 = supportsMicroTasks ? microtaskDebounce : taskDebounce;
function isFunction(functionToCheck) {
  var getType = {};
  return functionToCheck && getType.toString.call(functionToCheck) === "[object Function]";
}
function getStyleComputedProperty(element, property2) {
  if (element.nodeType !== 1) {
    return [];
  }
  var window2 = element.ownerDocument.defaultView;
  var css = window2.getComputedStyle(element, null);
  return property2 ? css[property2] : css;
}
function getParentNode(element) {
  if (element.nodeName === "HTML") {
    return element;
  }
  return element.parentNode || element.host;
}
function getScrollParent(element) {
  if (!element) {
    return document.body;
  }
  switch (element.nodeName) {
    case "HTML":
    case "BODY":
      return element.ownerDocument.body;
    case "#document":
      return element.body;
  }
  var _getStyleComputedProp = getStyleComputedProperty(element), overflow = _getStyleComputedProp.overflow, overflowX = _getStyleComputedProp.overflowX, overflowY = _getStyleComputedProp.overflowY;
  if (/(auto|scroll|overlay)/.test(overflow + overflowY + overflowX)) {
    return element;
  }
  return getScrollParent(getParentNode(element));
}
function getReferenceNode(reference) {
  return reference && reference.referenceNode ? reference.referenceNode : reference;
}
var isIE11 = isBrowser && !!(window.MSInputMethodContext && document.documentMode);
var isIE10 = isBrowser && /MSIE 10/.test(navigator.userAgent);
function isIE(version) {
  if (version === 11) {
    return isIE11;
  }
  if (version === 10) {
    return isIE10;
  }
  return isIE11 || isIE10;
}
function getOffsetParent(element) {
  if (!element) {
    return document.documentElement;
  }
  var noOffsetParent = isIE(10) ? document.body : null;
  var offsetParent = element.offsetParent || null;
  while (offsetParent === noOffsetParent && element.nextElementSibling) {
    offsetParent = (element = element.nextElementSibling).offsetParent;
  }
  var nodeName = offsetParent && offsetParent.nodeName;
  if (!nodeName || nodeName === "BODY" || nodeName === "HTML") {
    return element ? element.ownerDocument.documentElement : document.documentElement;
  }
  if (["TH", "TD", "TABLE"].indexOf(offsetParent.nodeName) !== -1 && getStyleComputedProperty(offsetParent, "position") === "static") {
    return getOffsetParent(offsetParent);
  }
  return offsetParent;
}
function isOffsetContainer(element) {
  var nodeName = element.nodeName;
  if (nodeName === "BODY") {
    return false;
  }
  return nodeName === "HTML" || getOffsetParent(element.firstElementChild) === element;
}
function getRoot(node) {
  if (node.parentNode !== null) {
    return getRoot(node.parentNode);
  }
  return node;
}
function findCommonOffsetParent(element1, element2) {
  if (!element1 || !element1.nodeType || !element2 || !element2.nodeType) {
    return document.documentElement;
  }
  var order = element1.compareDocumentPosition(element2) & Node.DOCUMENT_POSITION_FOLLOWING;
  var start = order ? element1 : element2;
  var end = order ? element2 : element1;
  var range = document.createRange();
  range.setStart(start, 0);
  range.setEnd(end, 0);
  var commonAncestorContainer = range.commonAncestorContainer;
  if (element1 !== commonAncestorContainer && element2 !== commonAncestorContainer || start.contains(end)) {
    if (isOffsetContainer(commonAncestorContainer)) {
      return commonAncestorContainer;
    }
    return getOffsetParent(commonAncestorContainer);
  }
  var element1root = getRoot(element1);
  if (element1root.host) {
    return findCommonOffsetParent(element1root.host, element2);
  } else {
    return findCommonOffsetParent(element1, getRoot(element2).host);
  }
}
function getScroll(element) {
  var side = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : "top";
  var upperSide = side === "top" ? "scrollTop" : "scrollLeft";
  var nodeName = element.nodeName;
  if (nodeName === "BODY" || nodeName === "HTML") {
    var html = element.ownerDocument.documentElement;
    var scrollingElement = element.ownerDocument.scrollingElement || html;
    return scrollingElement[upperSide];
  }
  return element[upperSide];
}
function includeScroll(rect, element) {
  var subtract = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : false;
  var scrollTop = getScroll(element, "top");
  var scrollLeft = getScroll(element, "left");
  var modifier = subtract ? -1 : 1;
  rect.top += scrollTop * modifier;
  rect.bottom += scrollTop * modifier;
  rect.left += scrollLeft * modifier;
  rect.right += scrollLeft * modifier;
  return rect;
}
function getBordersSize(styles, axis) {
  var sideA = axis === "x" ? "Left" : "Top";
  var sideB = sideA === "Left" ? "Right" : "Bottom";
  return parseFloat(styles["border" + sideA + "Width"]) + parseFloat(styles["border" + sideB + "Width"]);
}
function getSize(axis, body, html, computedStyle) {
  return Math.max(body["offset" + axis], body["scroll" + axis], html["client" + axis], html["offset" + axis], html["scroll" + axis], isIE(10) ? parseInt(html["offset" + axis]) + parseInt(computedStyle["margin" + (axis === "Height" ? "Top" : "Left")]) + parseInt(computedStyle["margin" + (axis === "Height" ? "Bottom" : "Right")]) : 0);
}
function getWindowSizes(document2) {
  var body = document2.body;
  var html = document2.documentElement;
  var computedStyle = isIE(10) && getComputedStyle(html);
  return {
    height: getSize("Height", body, html, computedStyle),
    width: getSize("Width", body, html, computedStyle)
  };
}
var classCallCheck = function(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
};
var createClass = function() {
  function defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];
      descriptor.enumerable = descriptor.enumerable || false;
      descriptor.configurable = true;
      if ("value" in descriptor)
        descriptor.writable = true;
      Object.defineProperty(target, descriptor.key, descriptor);
    }
  }
  return function(Constructor, protoProps, staticProps) {
    if (protoProps)
      defineProperties(Constructor.prototype, protoProps);
    if (staticProps)
      defineProperties(Constructor, staticProps);
    return Constructor;
  };
}();
var defineProperty = function(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }
  return obj;
};
var _extends = Object.assign || function(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source2 = arguments[i];
    for (var key in source2) {
      if (Object.prototype.hasOwnProperty.call(source2, key)) {
        target[key] = source2[key];
      }
    }
  }
  return target;
};
function getClientRect(offsets) {
  return _extends({}, offsets, {
    right: offsets.left + offsets.width,
    bottom: offsets.top + offsets.height
  });
}
function getBoundingClientRect(element) {
  var rect = {};
  try {
    if (isIE(10)) {
      rect = element.getBoundingClientRect();
      var scrollTop = getScroll(element, "top");
      var scrollLeft = getScroll(element, "left");
      rect.top += scrollTop;
      rect.left += scrollLeft;
      rect.bottom += scrollTop;
      rect.right += scrollLeft;
    } else {
      rect = element.getBoundingClientRect();
    }
  } catch (e) {
  }
  var result = {
    left: rect.left,
    top: rect.top,
    width: rect.right - rect.left,
    height: rect.bottom - rect.top
  };
  var sizes = element.nodeName === "HTML" ? getWindowSizes(element.ownerDocument) : {};
  var width = sizes.width || element.clientWidth || result.width;
  var height = sizes.height || element.clientHeight || result.height;
  var horizScrollbar = element.offsetWidth - width;
  var vertScrollbar = element.offsetHeight - height;
  if (horizScrollbar || vertScrollbar) {
    var styles = getStyleComputedProperty(element);
    horizScrollbar -= getBordersSize(styles, "x");
    vertScrollbar -= getBordersSize(styles, "y");
    result.width -= horizScrollbar;
    result.height -= vertScrollbar;
  }
  return getClientRect(result);
}
function getOffsetRectRelativeToArbitraryNode(children, parent) {
  var fixedPosition = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : false;
  var isIE102 = isIE(10);
  var isHTML = parent.nodeName === "HTML";
  var childrenRect = getBoundingClientRect(children);
  var parentRect = getBoundingClientRect(parent);
  var scrollParent = getScrollParent(children);
  var styles = getStyleComputedProperty(parent);
  var borderTopWidth = parseFloat(styles.borderTopWidth);
  var borderLeftWidth = parseFloat(styles.borderLeftWidth);
  if (fixedPosition && isHTML) {
    parentRect.top = Math.max(parentRect.top, 0);
    parentRect.left = Math.max(parentRect.left, 0);
  }
  var offsets = getClientRect({
    top: childrenRect.top - parentRect.top - borderTopWidth,
    left: childrenRect.left - parentRect.left - borderLeftWidth,
    width: childrenRect.width,
    height: childrenRect.height
  });
  offsets.marginTop = 0;
  offsets.marginLeft = 0;
  if (!isIE102 && isHTML) {
    var marginTop = parseFloat(styles.marginTop);
    var marginLeft = parseFloat(styles.marginLeft);
    offsets.top -= borderTopWidth - marginTop;
    offsets.bottom -= borderTopWidth - marginTop;
    offsets.left -= borderLeftWidth - marginLeft;
    offsets.right -= borderLeftWidth - marginLeft;
    offsets.marginTop = marginTop;
    offsets.marginLeft = marginLeft;
  }
  if (isIE102 && !fixedPosition ? parent.contains(scrollParent) : parent === scrollParent && scrollParent.nodeName !== "BODY") {
    offsets = includeScroll(offsets, parent);
  }
  return offsets;
}
function getViewportOffsetRectRelativeToArtbitraryNode(element) {
  var excludeScroll = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : false;
  var html = element.ownerDocument.documentElement;
  var relativeOffset = getOffsetRectRelativeToArbitraryNode(element, html);
  var width = Math.max(html.clientWidth, window.innerWidth || 0);
  var height = Math.max(html.clientHeight, window.innerHeight || 0);
  var scrollTop = !excludeScroll ? getScroll(html) : 0;
  var scrollLeft = !excludeScroll ? getScroll(html, "left") : 0;
  var offset2 = {
    top: scrollTop - relativeOffset.top + relativeOffset.marginTop,
    left: scrollLeft - relativeOffset.left + relativeOffset.marginLeft,
    width,
    height
  };
  return getClientRect(offset2);
}
function isFixed(element) {
  var nodeName = element.nodeName;
  if (nodeName === "BODY" || nodeName === "HTML") {
    return false;
  }
  if (getStyleComputedProperty(element, "position") === "fixed") {
    return true;
  }
  var parentNode = getParentNode(element);
  if (!parentNode) {
    return false;
  }
  return isFixed(parentNode);
}
function getFixedPositionOffsetParent(element) {
  if (!element || !element.parentElement || isIE()) {
    return document.documentElement;
  }
  var el = element.parentElement;
  while (el && getStyleComputedProperty(el, "transform") === "none") {
    el = el.parentElement;
  }
  return el || document.documentElement;
}
function getBoundaries(popper, reference, padding, boundariesElement) {
  var fixedPosition = arguments.length > 4 && arguments[4] !== void 0 ? arguments[4] : false;
  var boundaries = { top: 0, left: 0 };
  var offsetParent = fixedPosition ? getFixedPositionOffsetParent(popper) : findCommonOffsetParent(popper, getReferenceNode(reference));
  if (boundariesElement === "viewport") {
    boundaries = getViewportOffsetRectRelativeToArtbitraryNode(offsetParent, fixedPosition);
  } else {
    var boundariesNode = void 0;
    if (boundariesElement === "scrollParent") {
      boundariesNode = getScrollParent(getParentNode(reference));
      if (boundariesNode.nodeName === "BODY") {
        boundariesNode = popper.ownerDocument.documentElement;
      }
    } else if (boundariesElement === "window") {
      boundariesNode = popper.ownerDocument.documentElement;
    } else {
      boundariesNode = boundariesElement;
    }
    var offsets = getOffsetRectRelativeToArbitraryNode(boundariesNode, offsetParent, fixedPosition);
    if (boundariesNode.nodeName === "HTML" && !isFixed(offsetParent)) {
      var _getWindowSizes = getWindowSizes(popper.ownerDocument), height = _getWindowSizes.height, width = _getWindowSizes.width;
      boundaries.top += offsets.top - offsets.marginTop;
      boundaries.bottom = height + offsets.top;
      boundaries.left += offsets.left - offsets.marginLeft;
      boundaries.right = width + offsets.left;
    } else {
      boundaries = offsets;
    }
  }
  padding = padding || 0;
  var isPaddingNumber = typeof padding === "number";
  boundaries.left += isPaddingNumber ? padding : padding.left || 0;
  boundaries.top += isPaddingNumber ? padding : padding.top || 0;
  boundaries.right -= isPaddingNumber ? padding : padding.right || 0;
  boundaries.bottom -= isPaddingNumber ? padding : padding.bottom || 0;
  return boundaries;
}
function getArea(_ref) {
  var width = _ref.width, height = _ref.height;
  return width * height;
}
function computeAutoPlacement(placement, refRect, popper, reference, boundariesElement) {
  var padding = arguments.length > 5 && arguments[5] !== void 0 ? arguments[5] : 0;
  if (placement.indexOf("auto") === -1) {
    return placement;
  }
  var boundaries = getBoundaries(popper, reference, padding, boundariesElement);
  var rects = {
    top: {
      width: boundaries.width,
      height: refRect.top - boundaries.top
    },
    right: {
      width: boundaries.right - refRect.right,
      height: boundaries.height
    },
    bottom: {
      width: boundaries.width,
      height: boundaries.bottom - refRect.bottom
    },
    left: {
      width: refRect.left - boundaries.left,
      height: boundaries.height
    }
  };
  var sortedAreas = Object.keys(rects).map(function(key) {
    return _extends({
      key
    }, rects[key], {
      area: getArea(rects[key])
    });
  }).sort(function(a, b) {
    return b.area - a.area;
  });
  var filteredAreas = sortedAreas.filter(function(_ref2) {
    var width = _ref2.width, height = _ref2.height;
    return width >= popper.clientWidth && height >= popper.clientHeight;
  });
  var computedPlacement = filteredAreas.length > 0 ? filteredAreas[0].key : sortedAreas[0].key;
  var variation = placement.split("-")[1];
  return computedPlacement + (variation ? "-" + variation : "");
}
function getReferenceOffsets(state, popper, reference) {
  var fixedPosition = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : null;
  var commonOffsetParent = fixedPosition ? getFixedPositionOffsetParent(popper) : findCommonOffsetParent(popper, getReferenceNode(reference));
  return getOffsetRectRelativeToArbitraryNode(reference, commonOffsetParent, fixedPosition);
}
function getOuterSizes(element) {
  var window2 = element.ownerDocument.defaultView;
  var styles = window2.getComputedStyle(element);
  var x = parseFloat(styles.marginTop || 0) + parseFloat(styles.marginBottom || 0);
  var y = parseFloat(styles.marginLeft || 0) + parseFloat(styles.marginRight || 0);
  var result = {
    width: element.offsetWidth + y,
    height: element.offsetHeight + x
  };
  return result;
}
function getOppositePlacement(placement) {
  var hash = { left: "right", right: "left", bottom: "top", top: "bottom" };
  return placement.replace(/left|right|bottom|top/g, function(matched) {
    return hash[matched];
  });
}
function getPopperOffsets(popper, referenceOffsets, placement) {
  placement = placement.split("-")[0];
  var popperRect = getOuterSizes(popper);
  var popperOffsets = {
    width: popperRect.width,
    height: popperRect.height
  };
  var isHoriz = ["right", "left"].indexOf(placement) !== -1;
  var mainSide = isHoriz ? "top" : "left";
  var secondarySide = isHoriz ? "left" : "top";
  var measurement = isHoriz ? "height" : "width";
  var secondaryMeasurement = !isHoriz ? "height" : "width";
  popperOffsets[mainSide] = referenceOffsets[mainSide] + referenceOffsets[measurement] / 2 - popperRect[measurement] / 2;
  if (placement === secondarySide) {
    popperOffsets[secondarySide] = referenceOffsets[secondarySide] - popperRect[secondaryMeasurement];
  } else {
    popperOffsets[secondarySide] = referenceOffsets[getOppositePlacement(secondarySide)];
  }
  return popperOffsets;
}
function find$1(arr, check) {
  if (Array.prototype.find) {
    return arr.find(check);
  }
  return arr.filter(check)[0];
}
function findIndex$2(arr, prop, value) {
  if (Array.prototype.findIndex) {
    return arr.findIndex(function(cur) {
      return cur[prop] === value;
    });
  }
  var match = find$1(arr, function(obj) {
    return obj[prop] === value;
  });
  return arr.indexOf(match);
}
function runModifiers(modifiers2, data2, ends) {
  var modifiersToRun = ends === void 0 ? modifiers2 : modifiers2.slice(0, findIndex$2(modifiers2, "name", ends));
  modifiersToRun.forEach(function(modifier) {
    if (modifier["function"]) {
      console.warn("`modifier.function` is deprecated, use `modifier.fn`!");
    }
    var fn = modifier["function"] || modifier.fn;
    if (modifier.enabled && isFunction(fn)) {
      data2.offsets.popper = getClientRect(data2.offsets.popper);
      data2.offsets.reference = getClientRect(data2.offsets.reference);
      data2 = fn(data2, modifier);
    }
  });
  return data2;
}
function update() {
  if (this.state.isDestroyed) {
    return;
  }
  var data2 = {
    instance: this,
    styles: {},
    arrowStyles: {},
    attributes: {},
    flipped: false,
    offsets: {}
  };
  data2.offsets.reference = getReferenceOffsets(this.state, this.popper, this.reference, this.options.positionFixed);
  data2.placement = computeAutoPlacement(this.options.placement, data2.offsets.reference, this.popper, this.reference, this.options.modifiers.flip.boundariesElement, this.options.modifiers.flip.padding);
  data2.originalPlacement = data2.placement;
  data2.positionFixed = this.options.positionFixed;
  data2.offsets.popper = getPopperOffsets(this.popper, data2.offsets.reference, data2.placement);
  data2.offsets.popper.position = this.options.positionFixed ? "fixed" : "absolute";
  data2 = runModifiers(this.modifiers, data2);
  if (!this.state.isCreated) {
    this.state.isCreated = true;
    this.options.onCreate(data2);
  } else {
    this.options.onUpdate(data2);
  }
}
function isModifierEnabled(modifiers2, modifierName) {
  return modifiers2.some(function(_ref) {
    var name = _ref.name, enabled = _ref.enabled;
    return enabled && name === modifierName;
  });
}
function getSupportedPropertyName(property2) {
  var prefixes = [false, "ms", "Webkit", "Moz", "O"];
  var upperProp = property2.charAt(0).toUpperCase() + property2.slice(1);
  for (var i = 0; i < prefixes.length; i++) {
    var prefix = prefixes[i];
    var toCheck = prefix ? "" + prefix + upperProp : property2;
    if (typeof document.body.style[toCheck] !== "undefined") {
      return toCheck;
    }
  }
  return null;
}
function destroy() {
  this.state.isDestroyed = true;
  if (isModifierEnabled(this.modifiers, "applyStyle")) {
    this.popper.removeAttribute("x-placement");
    this.popper.style.position = "";
    this.popper.style.top = "";
    this.popper.style.left = "";
    this.popper.style.right = "";
    this.popper.style.bottom = "";
    this.popper.style.willChange = "";
    this.popper.style[getSupportedPropertyName("transform")] = "";
  }
  this.disableEventListeners();
  if (this.options.removeOnDestroy) {
    this.popper.parentNode.removeChild(this.popper);
  }
  return this;
}
function getWindow(element) {
  var ownerDocument = element.ownerDocument;
  return ownerDocument ? ownerDocument.defaultView : window;
}
function attachToScrollParents(scrollParent, event, callback, scrollParents) {
  var isBody = scrollParent.nodeName === "BODY";
  var target = isBody ? scrollParent.ownerDocument.defaultView : scrollParent;
  target.addEventListener(event, callback, { passive: true });
  if (!isBody) {
    attachToScrollParents(getScrollParent(target.parentNode), event, callback, scrollParents);
  }
  scrollParents.push(target);
}
function setupEventListeners(reference, options, state, updateBound) {
  state.updateBound = updateBound;
  getWindow(reference).addEventListener("resize", state.updateBound, { passive: true });
  var scrollElement = getScrollParent(reference);
  attachToScrollParents(scrollElement, "scroll", state.updateBound, state.scrollParents);
  state.scrollElement = scrollElement;
  state.eventsEnabled = true;
  return state;
}
function enableEventListeners() {
  if (!this.state.eventsEnabled) {
    this.state = setupEventListeners(this.reference, this.options, this.state, this.scheduleUpdate);
  }
}
function removeEventListeners(reference, state) {
  getWindow(reference).removeEventListener("resize", state.updateBound);
  state.scrollParents.forEach(function(target) {
    target.removeEventListener("scroll", state.updateBound);
  });
  state.updateBound = null;
  state.scrollParents = [];
  state.scrollElement = null;
  state.eventsEnabled = false;
  return state;
}
function disableEventListeners() {
  if (this.state.eventsEnabled) {
    cancelAnimationFrame(this.scheduleUpdate);
    this.state = removeEventListeners(this.reference, this.state);
  }
}
function isNumeric(n) {
  return n !== "" && !isNaN(parseFloat(n)) && isFinite(n);
}
function setStyles(element, styles) {
  Object.keys(styles).forEach(function(prop) {
    var unit = "";
    if (["width", "height", "top", "right", "bottom", "left"].indexOf(prop) !== -1 && isNumeric(styles[prop])) {
      unit = "px";
    }
    element.style[prop] = styles[prop] + unit;
  });
}
function setAttributes(element, attributes) {
  Object.keys(attributes).forEach(function(prop) {
    var value = attributes[prop];
    if (value !== false) {
      element.setAttribute(prop, attributes[prop]);
    } else {
      element.removeAttribute(prop);
    }
  });
}
function applyStyle(data2) {
  setStyles(data2.instance.popper, data2.styles);
  setAttributes(data2.instance.popper, data2.attributes);
  if (data2.arrowElement && Object.keys(data2.arrowStyles).length) {
    setStyles(data2.arrowElement, data2.arrowStyles);
  }
  return data2;
}
function applyStyleOnLoad(reference, popper, options, modifierOptions, state) {
  var referenceOffsets = getReferenceOffsets(state, popper, reference, options.positionFixed);
  var placement = computeAutoPlacement(options.placement, referenceOffsets, popper, reference, options.modifiers.flip.boundariesElement, options.modifiers.flip.padding);
  popper.setAttribute("x-placement", placement);
  setStyles(popper, { position: options.positionFixed ? "fixed" : "absolute" });
  return options;
}
function getRoundedOffsets(data2, shouldRound) {
  var _data$offsets = data2.offsets, popper = _data$offsets.popper, reference = _data$offsets.reference;
  var round = Math.round, floor = Math.floor;
  var noRound = function noRound2(v) {
    return v;
  };
  var referenceWidth = round(reference.width);
  var popperWidth = round(popper.width);
  var isVertical = ["left", "right"].indexOf(data2.placement) !== -1;
  var isVariation = data2.placement.indexOf("-") !== -1;
  var sameWidthParity = referenceWidth % 2 === popperWidth % 2;
  var bothOddWidth = referenceWidth % 2 === 1 && popperWidth % 2 === 1;
  var horizontalToInteger = !shouldRound ? noRound : isVertical || isVariation || sameWidthParity ? round : floor;
  var verticalToInteger = !shouldRound ? noRound : round;
  return {
    left: horizontalToInteger(bothOddWidth && !isVariation && shouldRound ? popper.left - 1 : popper.left),
    top: verticalToInteger(popper.top),
    bottom: verticalToInteger(popper.bottom),
    right: horizontalToInteger(popper.right)
  };
}
var isFirefox = isBrowser && /Firefox/i.test(navigator.userAgent);
function computeStyle(data2, options) {
  var x = options.x, y = options.y;
  var popper = data2.offsets.popper;
  var legacyGpuAccelerationOption = find$1(data2.instance.modifiers, function(modifier) {
    return modifier.name === "applyStyle";
  }).gpuAcceleration;
  if (legacyGpuAccelerationOption !== void 0) {
    console.warn("WARNING: `gpuAcceleration` option moved to `computeStyle` modifier and will not be supported in future versions of Popper.js!");
  }
  var gpuAcceleration = legacyGpuAccelerationOption !== void 0 ? legacyGpuAccelerationOption : options.gpuAcceleration;
  var offsetParent = getOffsetParent(data2.instance.popper);
  var offsetParentRect = getBoundingClientRect(offsetParent);
  var styles = {
    position: popper.position
  };
  var offsets = getRoundedOffsets(data2, window.devicePixelRatio < 2 || !isFirefox);
  var sideA = x === "bottom" ? "top" : "bottom";
  var sideB = y === "right" ? "left" : "right";
  var prefixedProperty = getSupportedPropertyName("transform");
  var left = void 0, top = void 0;
  if (sideA === "bottom") {
    if (offsetParent.nodeName === "HTML") {
      top = -offsetParent.clientHeight + offsets.bottom;
    } else {
      top = -offsetParentRect.height + offsets.bottom;
    }
  } else {
    top = offsets.top;
  }
  if (sideB === "right") {
    if (offsetParent.nodeName === "HTML") {
      left = -offsetParent.clientWidth + offsets.right;
    } else {
      left = -offsetParentRect.width + offsets.right;
    }
  } else {
    left = offsets.left;
  }
  if (gpuAcceleration && prefixedProperty) {
    styles[prefixedProperty] = "translate3d(" + left + "px, " + top + "px, 0)";
    styles[sideA] = 0;
    styles[sideB] = 0;
    styles.willChange = "transform";
  } else {
    var invertTop = sideA === "bottom" ? -1 : 1;
    var invertLeft = sideB === "right" ? -1 : 1;
    styles[sideA] = top * invertTop;
    styles[sideB] = left * invertLeft;
    styles.willChange = sideA + ", " + sideB;
  }
  var attributes = {
    "x-placement": data2.placement
  };
  data2.attributes = _extends({}, attributes, data2.attributes);
  data2.styles = _extends({}, styles, data2.styles);
  data2.arrowStyles = _extends({}, data2.offsets.arrow, data2.arrowStyles);
  return data2;
}
function isModifierRequired(modifiers2, requestingName, requestedName) {
  var requesting = find$1(modifiers2, function(_ref) {
    var name = _ref.name;
    return name === requestingName;
  });
  var isRequired = !!requesting && modifiers2.some(function(modifier) {
    return modifier.name === requestedName && modifier.enabled && modifier.order < requesting.order;
  });
  if (!isRequired) {
    var _requesting = "`" + requestingName + "`";
    var requested = "`" + requestedName + "`";
    console.warn(requested + " modifier is required by " + _requesting + " modifier in order to work, be sure to include it before " + _requesting + "!");
  }
  return isRequired;
}
function arrow(data2, options) {
  var _data$offsets$arrow;
  if (!isModifierRequired(data2.instance.modifiers, "arrow", "keepTogether")) {
    return data2;
  }
  var arrowElement = options.element;
  if (typeof arrowElement === "string") {
    arrowElement = data2.instance.popper.querySelector(arrowElement);
    if (!arrowElement) {
      return data2;
    }
  } else {
    if (!data2.instance.popper.contains(arrowElement)) {
      console.warn("WARNING: `arrow.element` must be child of its popper element!");
      return data2;
    }
  }
  var placement = data2.placement.split("-")[0];
  var _data$offsets = data2.offsets, popper = _data$offsets.popper, reference = _data$offsets.reference;
  var isVertical = ["left", "right"].indexOf(placement) !== -1;
  var len = isVertical ? "height" : "width";
  var sideCapitalized = isVertical ? "Top" : "Left";
  var side = sideCapitalized.toLowerCase();
  var altSide = isVertical ? "left" : "top";
  var opSide = isVertical ? "bottom" : "right";
  var arrowElementSize = getOuterSizes(arrowElement)[len];
  if (reference[opSide] - arrowElementSize < popper[side]) {
    data2.offsets.popper[side] -= popper[side] - (reference[opSide] - arrowElementSize);
  }
  if (reference[side] + arrowElementSize > popper[opSide]) {
    data2.offsets.popper[side] += reference[side] + arrowElementSize - popper[opSide];
  }
  data2.offsets.popper = getClientRect(data2.offsets.popper);
  var center = reference[side] + reference[len] / 2 - arrowElementSize / 2;
  var css = getStyleComputedProperty(data2.instance.popper);
  var popperMarginSide = parseFloat(css["margin" + sideCapitalized]);
  var popperBorderSide = parseFloat(css["border" + sideCapitalized + "Width"]);
  var sideValue = center - data2.offsets.popper[side] - popperMarginSide - popperBorderSide;
  sideValue = Math.max(Math.min(popper[len] - arrowElementSize, sideValue), 0);
  data2.arrowElement = arrowElement;
  data2.offsets.arrow = (_data$offsets$arrow = {}, defineProperty(_data$offsets$arrow, side, Math.round(sideValue)), defineProperty(_data$offsets$arrow, altSide, ""), _data$offsets$arrow);
  return data2;
}
function getOppositeVariation(variation) {
  if (variation === "end") {
    return "start";
  } else if (variation === "start") {
    return "end";
  }
  return variation;
}
var placements = ["auto-start", "auto", "auto-end", "top-start", "top", "top-end", "right-start", "right", "right-end", "bottom-end", "bottom", "bottom-start", "left-end", "left", "left-start"];
var validPlacements = placements.slice(3);
function clockwise(placement) {
  var counter = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : false;
  var index = validPlacements.indexOf(placement);
  var arr = validPlacements.slice(index + 1).concat(validPlacements.slice(0, index));
  return counter ? arr.reverse() : arr;
}
var BEHAVIORS = {
  FLIP: "flip",
  CLOCKWISE: "clockwise",
  COUNTERCLOCKWISE: "counterclockwise"
};
function flip(data2, options) {
  if (isModifierEnabled(data2.instance.modifiers, "inner")) {
    return data2;
  }
  if (data2.flipped && data2.placement === data2.originalPlacement) {
    return data2;
  }
  var boundaries = getBoundaries(data2.instance.popper, data2.instance.reference, options.padding, options.boundariesElement, data2.positionFixed);
  var placement = data2.placement.split("-")[0];
  var placementOpposite = getOppositePlacement(placement);
  var variation = data2.placement.split("-")[1] || "";
  var flipOrder = [];
  switch (options.behavior) {
    case BEHAVIORS.FLIP:
      flipOrder = [placement, placementOpposite];
      break;
    case BEHAVIORS.CLOCKWISE:
      flipOrder = clockwise(placement);
      break;
    case BEHAVIORS.COUNTERCLOCKWISE:
      flipOrder = clockwise(placement, true);
      break;
    default:
      flipOrder = options.behavior;
  }
  flipOrder.forEach(function(step, index) {
    if (placement !== step || flipOrder.length === index + 1) {
      return data2;
    }
    placement = data2.placement.split("-")[0];
    placementOpposite = getOppositePlacement(placement);
    var popperOffsets = data2.offsets.popper;
    var refOffsets = data2.offsets.reference;
    var floor = Math.floor;
    var overlapsRef = placement === "left" && floor(popperOffsets.right) > floor(refOffsets.left) || placement === "right" && floor(popperOffsets.left) < floor(refOffsets.right) || placement === "top" && floor(popperOffsets.bottom) > floor(refOffsets.top) || placement === "bottom" && floor(popperOffsets.top) < floor(refOffsets.bottom);
    var overflowsLeft = floor(popperOffsets.left) < floor(boundaries.left);
    var overflowsRight = floor(popperOffsets.right) > floor(boundaries.right);
    var overflowsTop = floor(popperOffsets.top) < floor(boundaries.top);
    var overflowsBottom = floor(popperOffsets.bottom) > floor(boundaries.bottom);
    var overflowsBoundaries = placement === "left" && overflowsLeft || placement === "right" && overflowsRight || placement === "top" && overflowsTop || placement === "bottom" && overflowsBottom;
    var isVertical = ["top", "bottom"].indexOf(placement) !== -1;
    var flippedVariationByRef = !!options.flipVariations && (isVertical && variation === "start" && overflowsLeft || isVertical && variation === "end" && overflowsRight || !isVertical && variation === "start" && overflowsTop || !isVertical && variation === "end" && overflowsBottom);
    var flippedVariationByContent = !!options.flipVariationsByContent && (isVertical && variation === "start" && overflowsRight || isVertical && variation === "end" && overflowsLeft || !isVertical && variation === "start" && overflowsBottom || !isVertical && variation === "end" && overflowsTop);
    var flippedVariation = flippedVariationByRef || flippedVariationByContent;
    if (overlapsRef || overflowsBoundaries || flippedVariation) {
      data2.flipped = true;
      if (overlapsRef || overflowsBoundaries) {
        placement = flipOrder[index + 1];
      }
      if (flippedVariation) {
        variation = getOppositeVariation(variation);
      }
      data2.placement = placement + (variation ? "-" + variation : "");
      data2.offsets.popper = _extends({}, data2.offsets.popper, getPopperOffsets(data2.instance.popper, data2.offsets.reference, data2.placement));
      data2 = runModifiers(data2.instance.modifiers, data2, "flip");
    }
  });
  return data2;
}
function keepTogether(data2) {
  var _data$offsets = data2.offsets, popper = _data$offsets.popper, reference = _data$offsets.reference;
  var placement = data2.placement.split("-")[0];
  var floor = Math.floor;
  var isVertical = ["top", "bottom"].indexOf(placement) !== -1;
  var side = isVertical ? "right" : "bottom";
  var opSide = isVertical ? "left" : "top";
  var measurement = isVertical ? "width" : "height";
  if (popper[side] < floor(reference[opSide])) {
    data2.offsets.popper[opSide] = floor(reference[opSide]) - popper[measurement];
  }
  if (popper[opSide] > floor(reference[side])) {
    data2.offsets.popper[opSide] = floor(reference[side]);
  }
  return data2;
}
function toValue(str, measurement, popperOffsets, referenceOffsets) {
  var split = str.match(/((?:\-|\+)?\d*\.?\d*)(.*)/);
  var value = +split[1];
  var unit = split[2];
  if (!value) {
    return str;
  }
  if (unit.indexOf("%") === 0) {
    var element = void 0;
    switch (unit) {
      case "%p":
        element = popperOffsets;
        break;
      case "%":
      case "%r":
      default:
        element = referenceOffsets;
    }
    var rect = getClientRect(element);
    return rect[measurement] / 100 * value;
  } else if (unit === "vh" || unit === "vw") {
    var size = void 0;
    if (unit === "vh") {
      size = Math.max(document.documentElement.clientHeight, window.innerHeight || 0);
    } else {
      size = Math.max(document.documentElement.clientWidth, window.innerWidth || 0);
    }
    return size / 100 * value;
  } else {
    return value;
  }
}
function parseOffset(offset2, popperOffsets, referenceOffsets, basePlacement) {
  var offsets = [0, 0];
  var useHeight = ["right", "left"].indexOf(basePlacement) !== -1;
  var fragments = offset2.split(/(\+|\-)/).map(function(frag) {
    return frag.trim();
  });
  var divider = fragments.indexOf(find$1(fragments, function(frag) {
    return frag.search(/,|\s/) !== -1;
  }));
  if (fragments[divider] && fragments[divider].indexOf(",") === -1) {
    console.warn("Offsets separated by white space(s) are deprecated, use a comma (,) instead.");
  }
  var splitRegex = /\s*,\s*|\s+/;
  var ops = divider !== -1 ? [fragments.slice(0, divider).concat([fragments[divider].split(splitRegex)[0]]), [fragments[divider].split(splitRegex)[1]].concat(fragments.slice(divider + 1))] : [fragments];
  ops = ops.map(function(op, index) {
    var measurement = (index === 1 ? !useHeight : useHeight) ? "height" : "width";
    var mergeWithPrevious = false;
    return op.reduce(function(a, b) {
      if (a[a.length - 1] === "" && ["+", "-"].indexOf(b) !== -1) {
        a[a.length - 1] = b;
        mergeWithPrevious = true;
        return a;
      } else if (mergeWithPrevious) {
        a[a.length - 1] += b;
        mergeWithPrevious = false;
        return a;
      } else {
        return a.concat(b);
      }
    }, []).map(function(str) {
      return toValue(str, measurement, popperOffsets, referenceOffsets);
    });
  });
  ops.forEach(function(op, index) {
    op.forEach(function(frag, index2) {
      if (isNumeric(frag)) {
        offsets[index] += frag * (op[index2 - 1] === "-" ? -1 : 1);
      }
    });
  });
  return offsets;
}
function offset(data2, _ref) {
  var offset2 = _ref.offset;
  var placement = data2.placement, _data$offsets = data2.offsets, popper = _data$offsets.popper, reference = _data$offsets.reference;
  var basePlacement = placement.split("-")[0];
  var offsets = void 0;
  if (isNumeric(+offset2)) {
    offsets = [+offset2, 0];
  } else {
    offsets = parseOffset(offset2, popper, reference, basePlacement);
  }
  if (basePlacement === "left") {
    popper.top += offsets[0];
    popper.left -= offsets[1];
  } else if (basePlacement === "right") {
    popper.top += offsets[0];
    popper.left += offsets[1];
  } else if (basePlacement === "top") {
    popper.left += offsets[0];
    popper.top -= offsets[1];
  } else if (basePlacement === "bottom") {
    popper.left += offsets[0];
    popper.top += offsets[1];
  }
  data2.popper = popper;
  return data2;
}
function preventOverflow(data2, options) {
  var boundariesElement = options.boundariesElement || getOffsetParent(data2.instance.popper);
  if (data2.instance.reference === boundariesElement) {
    boundariesElement = getOffsetParent(boundariesElement);
  }
  var transformProp = getSupportedPropertyName("transform");
  var popperStyles = data2.instance.popper.style;
  var top = popperStyles.top, left = popperStyles.left, transform = popperStyles[transformProp];
  popperStyles.top = "";
  popperStyles.left = "";
  popperStyles[transformProp] = "";
  var boundaries = getBoundaries(data2.instance.popper, data2.instance.reference, options.padding, boundariesElement, data2.positionFixed);
  popperStyles.top = top;
  popperStyles.left = left;
  popperStyles[transformProp] = transform;
  options.boundaries = boundaries;
  var order = options.priority;
  var popper = data2.offsets.popper;
  var check = {
    primary: function primary(placement) {
      var value = popper[placement];
      if (popper[placement] < boundaries[placement] && !options.escapeWithReference) {
        value = Math.max(popper[placement], boundaries[placement]);
      }
      return defineProperty({}, placement, value);
    },
    secondary: function secondary(placement) {
      var mainSide = placement === "right" ? "left" : "top";
      var value = popper[mainSide];
      if (popper[placement] > boundaries[placement] && !options.escapeWithReference) {
        value = Math.min(popper[mainSide], boundaries[placement] - (placement === "right" ? popper.width : popper.height));
      }
      return defineProperty({}, mainSide, value);
    }
  };
  order.forEach(function(placement) {
    var side = ["left", "top"].indexOf(placement) !== -1 ? "primary" : "secondary";
    popper = _extends({}, popper, check[side](placement));
  });
  data2.offsets.popper = popper;
  return data2;
}
function shift(data2) {
  var placement = data2.placement;
  var basePlacement = placement.split("-")[0];
  var shiftvariation = placement.split("-")[1];
  if (shiftvariation) {
    var _data$offsets = data2.offsets, reference = _data$offsets.reference, popper = _data$offsets.popper;
    var isVertical = ["bottom", "top"].indexOf(basePlacement) !== -1;
    var side = isVertical ? "left" : "top";
    var measurement = isVertical ? "width" : "height";
    var shiftOffsets = {
      start: defineProperty({}, side, reference[side]),
      end: defineProperty({}, side, reference[side] + reference[measurement] - popper[measurement])
    };
    data2.offsets.popper = _extends({}, popper, shiftOffsets[shiftvariation]);
  }
  return data2;
}
function hide(data2) {
  if (!isModifierRequired(data2.instance.modifiers, "hide", "preventOverflow")) {
    return data2;
  }
  var refRect = data2.offsets.reference;
  var bound = find$1(data2.instance.modifiers, function(modifier) {
    return modifier.name === "preventOverflow";
  }).boundaries;
  if (refRect.bottom < bound.top || refRect.left > bound.right || refRect.top > bound.bottom || refRect.right < bound.left) {
    if (data2.hide === true) {
      return data2;
    }
    data2.hide = true;
    data2.attributes["x-out-of-boundaries"] = "";
  } else {
    if (data2.hide === false) {
      return data2;
    }
    data2.hide = false;
    data2.attributes["x-out-of-boundaries"] = false;
  }
  return data2;
}
function inner(data2) {
  var placement = data2.placement;
  var basePlacement = placement.split("-")[0];
  var _data$offsets = data2.offsets, popper = _data$offsets.popper, reference = _data$offsets.reference;
  var isHoriz = ["left", "right"].indexOf(basePlacement) !== -1;
  var subtractLength = ["top", "left"].indexOf(basePlacement) === -1;
  popper[isHoriz ? "left" : "top"] = reference[basePlacement] - (subtractLength ? popper[isHoriz ? "width" : "height"] : 0);
  data2.placement = getOppositePlacement(placement);
  data2.offsets.popper = getClientRect(popper);
  return data2;
}
var modifiers = {
  shift: {
    order: 100,
    enabled: true,
    fn: shift
  },
  offset: {
    order: 200,
    enabled: true,
    fn: offset,
    offset: 0
  },
  preventOverflow: {
    order: 300,
    enabled: true,
    fn: preventOverflow,
    priority: ["left", "right", "top", "bottom"],
    padding: 5,
    boundariesElement: "scrollParent"
  },
  keepTogether: {
    order: 400,
    enabled: true,
    fn: keepTogether
  },
  arrow: {
    order: 500,
    enabled: true,
    fn: arrow,
    element: "[x-arrow]"
  },
  flip: {
    order: 600,
    enabled: true,
    fn: flip,
    behavior: "flip",
    padding: 5,
    boundariesElement: "viewport",
    flipVariations: false,
    flipVariationsByContent: false
  },
  inner: {
    order: 700,
    enabled: false,
    fn: inner
  },
  hide: {
    order: 800,
    enabled: true,
    fn: hide
  },
  computeStyle: {
    order: 850,
    enabled: true,
    fn: computeStyle,
    gpuAcceleration: true,
    x: "bottom",
    y: "right"
  },
  applyStyle: {
    order: 900,
    enabled: true,
    fn: applyStyle,
    onLoad: applyStyleOnLoad,
    gpuAcceleration: void 0
  }
};
var Defaults = {
  placement: "bottom",
  positionFixed: false,
  eventsEnabled: true,
  removeOnDestroy: false,
  onCreate: function onCreate() {
  },
  onUpdate: function onUpdate() {
  },
  modifiers
};
var Popper = function() {
  function Popper2(reference, popper) {
    var _this = this;
    var options = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {};
    classCallCheck(this, Popper2);
    this.scheduleUpdate = function() {
      return requestAnimationFrame(_this.update);
    };
    this.update = debounce$1(this.update.bind(this));
    this.options = _extends({}, Popper2.Defaults, options);
    this.state = {
      isDestroyed: false,
      isCreated: false,
      scrollParents: []
    };
    this.reference = reference && reference.jquery ? reference[0] : reference;
    this.popper = popper && popper.jquery ? popper[0] : popper;
    this.options.modifiers = {};
    Object.keys(_extends({}, Popper2.Defaults.modifiers, options.modifiers)).forEach(function(name) {
      _this.options.modifiers[name] = _extends({}, Popper2.Defaults.modifiers[name] || {}, options.modifiers ? options.modifiers[name] : {});
    });
    this.modifiers = Object.keys(this.options.modifiers).map(function(name) {
      return _extends({
        name
      }, _this.options.modifiers[name]);
    }).sort(function(a, b) {
      return a.order - b.order;
    });
    this.modifiers.forEach(function(modifierOptions) {
      if (modifierOptions.enabled && isFunction(modifierOptions.onLoad)) {
        modifierOptions.onLoad(_this.reference, _this.popper, _this.options, modifierOptions, _this.state);
      }
    });
    this.update();
    var eventsEnabled = this.options.eventsEnabled;
    if (eventsEnabled) {
      this.enableEventListeners();
    }
    this.state.eventsEnabled = eventsEnabled;
  }
  createClass(Popper2, [{
    key: "update",
    value: function update$$1() {
      return update.call(this);
    }
  }, {
    key: "destroy",
    value: function destroy$$1() {
      return destroy.call(this);
    }
  }, {
    key: "enableEventListeners",
    value: function enableEventListeners$$1() {
      return enableEventListeners.call(this);
    }
  }, {
    key: "disableEventListeners",
    value: function disableEventListeners$$1() {
      return disableEventListeners.call(this);
    }
  }]);
  return Popper2;
}();
Popper.Utils = (typeof window !== "undefined" ? window : global).PopperUtils;
Popper.placements = placements;
Popper.Defaults = Defaults;
var Popper$1 = Popper;
function listCacheClear$1() {
  this.__data__ = [];
  this.size = 0;
}
var _listCacheClear = listCacheClear$1;
var eq$1 = eq_1;
function assocIndexOf$4(array, key) {
  var length = array.length;
  while (length--) {
    if (eq$1(array[length][0], key)) {
      return length;
    }
  }
  return -1;
}
var _assocIndexOf = assocIndexOf$4;
var assocIndexOf$3 = _assocIndexOf;
var arrayProto = Array.prototype;
var splice = arrayProto.splice;
function listCacheDelete$1(key) {
  var data2 = this.__data__, index = assocIndexOf$3(data2, key);
  if (index < 0) {
    return false;
  }
  var lastIndex = data2.length - 1;
  if (index == lastIndex) {
    data2.pop();
  } else {
    splice.call(data2, index, 1);
  }
  --this.size;
  return true;
}
var _listCacheDelete = listCacheDelete$1;
var assocIndexOf$2 = _assocIndexOf;
function listCacheGet$1(key) {
  var data2 = this.__data__, index = assocIndexOf$2(data2, key);
  return index < 0 ? void 0 : data2[index][1];
}
var _listCacheGet = listCacheGet$1;
var assocIndexOf$1 = _assocIndexOf;
function listCacheHas$1(key) {
  return assocIndexOf$1(this.__data__, key) > -1;
}
var _listCacheHas = listCacheHas$1;
var assocIndexOf = _assocIndexOf;
function listCacheSet$1(key, value) {
  var data2 = this.__data__, index = assocIndexOf(data2, key);
  if (index < 0) {
    ++this.size;
    data2.push([key, value]);
  } else {
    data2[index][1] = value;
  }
  return this;
}
var _listCacheSet = listCacheSet$1;
var listCacheClear = _listCacheClear, listCacheDelete = _listCacheDelete, listCacheGet = _listCacheGet, listCacheHas = _listCacheHas, listCacheSet = _listCacheSet;
function ListCache$4(entries) {
  var index = -1, length = entries == null ? 0 : entries.length;
  this.clear();
  while (++index < length) {
    var entry = entries[index];
    this.set(entry[0], entry[1]);
  }
}
ListCache$4.prototype.clear = listCacheClear;
ListCache$4.prototype["delete"] = listCacheDelete;
ListCache$4.prototype.get = listCacheGet;
ListCache$4.prototype.has = listCacheHas;
ListCache$4.prototype.set = listCacheSet;
var _ListCache = ListCache$4;
var ListCache$3 = _ListCache;
function stackClear$1() {
  this.__data__ = new ListCache$3();
  this.size = 0;
}
var _stackClear = stackClear$1;
function stackDelete$1(key) {
  var data2 = this.__data__, result = data2["delete"](key);
  this.size = data2.size;
  return result;
}
var _stackDelete = stackDelete$1;
function stackGet$1(key) {
  return this.__data__.get(key);
}
var _stackGet = stackGet$1;
function stackHas$1(key) {
  return this.__data__.has(key);
}
var _stackHas = stackHas$1;
var getNative$5 = _getNative, root$5 = _root;
var Map$4 = getNative$5(root$5, "Map");
var _Map = Map$4;
var getNative$4 = _getNative;
var nativeCreate$4 = getNative$4(Object, "create");
var _nativeCreate = nativeCreate$4;
var nativeCreate$3 = _nativeCreate;
function hashClear$1() {
  this.__data__ = nativeCreate$3 ? nativeCreate$3(null) : {};
  this.size = 0;
}
var _hashClear = hashClear$1;
function hashDelete$1(key) {
  var result = this.has(key) && delete this.__data__[key];
  this.size -= result ? 1 : 0;
  return result;
}
var _hashDelete = hashDelete$1;
var nativeCreate$2 = _nativeCreate;
var HASH_UNDEFINED$2 = "__lodash_hash_undefined__";
var objectProto$5 = Object.prototype;
var hasOwnProperty$4 = objectProto$5.hasOwnProperty;
function hashGet$1(key) {
  var data2 = this.__data__;
  if (nativeCreate$2) {
    var result = data2[key];
    return result === HASH_UNDEFINED$2 ? void 0 : result;
  }
  return hasOwnProperty$4.call(data2, key) ? data2[key] : void 0;
}
var _hashGet = hashGet$1;
var nativeCreate$1 = _nativeCreate;
var objectProto$4 = Object.prototype;
var hasOwnProperty$3 = objectProto$4.hasOwnProperty;
function hashHas$1(key) {
  var data2 = this.__data__;
  return nativeCreate$1 ? data2[key] !== void 0 : hasOwnProperty$3.call(data2, key);
}
var _hashHas = hashHas$1;
var nativeCreate = _nativeCreate;
var HASH_UNDEFINED$1 = "__lodash_hash_undefined__";
function hashSet$1(key, value) {
  var data2 = this.__data__;
  this.size += this.has(key) ? 0 : 1;
  data2[key] = nativeCreate && value === void 0 ? HASH_UNDEFINED$1 : value;
  return this;
}
var _hashSet = hashSet$1;
var hashClear = _hashClear, hashDelete = _hashDelete, hashGet = _hashGet, hashHas = _hashHas, hashSet = _hashSet;
function Hash$1(entries) {
  var index = -1, length = entries == null ? 0 : entries.length;
  this.clear();
  while (++index < length) {
    var entry = entries[index];
    this.set(entry[0], entry[1]);
  }
}
Hash$1.prototype.clear = hashClear;
Hash$1.prototype["delete"] = hashDelete;
Hash$1.prototype.get = hashGet;
Hash$1.prototype.has = hashHas;
Hash$1.prototype.set = hashSet;
var _Hash = Hash$1;
var Hash = _Hash, ListCache$2 = _ListCache, Map$3 = _Map;
function mapCacheClear$1() {
  this.size = 0;
  this.__data__ = {
    "hash": new Hash(),
    "map": new (Map$3 || ListCache$2)(),
    "string": new Hash()
  };
}
var _mapCacheClear = mapCacheClear$1;
function isKeyable$1(value) {
  var type = typeof value;
  return type == "string" || type == "number" || type == "symbol" || type == "boolean" ? value !== "__proto__" : value === null;
}
var _isKeyable = isKeyable$1;
var isKeyable = _isKeyable;
function getMapData$4(map, key) {
  var data2 = map.__data__;
  return isKeyable(key) ? data2[typeof key == "string" ? "string" : "hash"] : data2.map;
}
var _getMapData = getMapData$4;
var getMapData$3 = _getMapData;
function mapCacheDelete$1(key) {
  var result = getMapData$3(this, key)["delete"](key);
  this.size -= result ? 1 : 0;
  return result;
}
var _mapCacheDelete = mapCacheDelete$1;
var getMapData$2 = _getMapData;
function mapCacheGet$1(key) {
  return getMapData$2(this, key).get(key);
}
var _mapCacheGet = mapCacheGet$1;
var getMapData$1 = _getMapData;
function mapCacheHas$1(key) {
  return getMapData$1(this, key).has(key);
}
var _mapCacheHas = mapCacheHas$1;
var getMapData = _getMapData;
function mapCacheSet$1(key, value) {
  var data2 = getMapData(this, key), size = data2.size;
  data2.set(key, value);
  this.size += data2.size == size ? 0 : 1;
  return this;
}
var _mapCacheSet = mapCacheSet$1;
var mapCacheClear = _mapCacheClear, mapCacheDelete = _mapCacheDelete, mapCacheGet = _mapCacheGet, mapCacheHas = _mapCacheHas, mapCacheSet = _mapCacheSet;
function MapCache$3(entries) {
  var index = -1, length = entries == null ? 0 : entries.length;
  this.clear();
  while (++index < length) {
    var entry = entries[index];
    this.set(entry[0], entry[1]);
  }
}
MapCache$3.prototype.clear = mapCacheClear;
MapCache$3.prototype["delete"] = mapCacheDelete;
MapCache$3.prototype.get = mapCacheGet;
MapCache$3.prototype.has = mapCacheHas;
MapCache$3.prototype.set = mapCacheSet;
var _MapCache = MapCache$3;
var ListCache$1 = _ListCache, Map$2 = _Map, MapCache$2 = _MapCache;
var LARGE_ARRAY_SIZE = 200;
function stackSet$1(key, value) {
  var data2 = this.__data__;
  if (data2 instanceof ListCache$1) {
    var pairs = data2.__data__;
    if (!Map$2 || pairs.length < LARGE_ARRAY_SIZE - 1) {
      pairs.push([key, value]);
      this.size = ++data2.size;
      return this;
    }
    data2 = this.__data__ = new MapCache$2(pairs);
  }
  data2.set(key, value);
  this.size = data2.size;
  return this;
}
var _stackSet = stackSet$1;
var ListCache = _ListCache, stackClear = _stackClear, stackDelete = _stackDelete, stackGet = _stackGet, stackHas = _stackHas, stackSet = _stackSet;
function Stack$2(entries) {
  var data2 = this.__data__ = new ListCache(entries);
  this.size = data2.size;
}
Stack$2.prototype.clear = stackClear;
Stack$2.prototype["delete"] = stackDelete;
Stack$2.prototype.get = stackGet;
Stack$2.prototype.has = stackHas;
Stack$2.prototype.set = stackSet;
var _Stack = Stack$2;
var HASH_UNDEFINED = "__lodash_hash_undefined__";
function setCacheAdd$1(value) {
  this.__data__.set(value, HASH_UNDEFINED);
  return this;
}
var _setCacheAdd = setCacheAdd$1;
function setCacheHas$1(value) {
  return this.__data__.has(value);
}
var _setCacheHas = setCacheHas$1;
var MapCache$1 = _MapCache, setCacheAdd = _setCacheAdd, setCacheHas = _setCacheHas;
function SetCache$1(values) {
  var index = -1, length = values == null ? 0 : values.length;
  this.__data__ = new MapCache$1();
  while (++index < length) {
    this.add(values[index]);
  }
}
SetCache$1.prototype.add = SetCache$1.prototype.push = setCacheAdd;
SetCache$1.prototype.has = setCacheHas;
var _SetCache = SetCache$1;
function arraySome$1(array, predicate) {
  var index = -1, length = array == null ? 0 : array.length;
  while (++index < length) {
    if (predicate(array[index], index, array)) {
      return true;
    }
  }
  return false;
}
var _arraySome = arraySome$1;
function cacheHas$1(cache, key) {
  return cache.has(key);
}
var _cacheHas = cacheHas$1;
var SetCache = _SetCache, arraySome = _arraySome, cacheHas = _cacheHas;
var COMPARE_PARTIAL_FLAG$5 = 1, COMPARE_UNORDERED_FLAG$3 = 2;
function equalArrays$2(array, other, bitmask, customizer, equalFunc, stack) {
  var isPartial = bitmask & COMPARE_PARTIAL_FLAG$5, arrLength = array.length, othLength = other.length;
  if (arrLength != othLength && !(isPartial && othLength > arrLength)) {
    return false;
  }
  var arrStacked = stack.get(array);
  var othStacked = stack.get(other);
  if (arrStacked && othStacked) {
    return arrStacked == other && othStacked == array;
  }
  var index = -1, result = true, seen = bitmask & COMPARE_UNORDERED_FLAG$3 ? new SetCache() : void 0;
  stack.set(array, other);
  stack.set(other, array);
  while (++index < arrLength) {
    var arrValue = array[index], othValue = other[index];
    if (customizer) {
      var compared = isPartial ? customizer(othValue, arrValue, index, other, array, stack) : customizer(arrValue, othValue, index, array, other, stack);
    }
    if (compared !== void 0) {
      if (compared) {
        continue;
      }
      result = false;
      break;
    }
    if (seen) {
      if (!arraySome(other, function(othValue2, othIndex) {
        if (!cacheHas(seen, othIndex) && (arrValue === othValue2 || equalFunc(arrValue, othValue2, bitmask, customizer, stack))) {
          return seen.push(othIndex);
        }
      })) {
        result = false;
        break;
      }
    } else if (!(arrValue === othValue || equalFunc(arrValue, othValue, bitmask, customizer, stack))) {
      result = false;
      break;
    }
  }
  stack["delete"](array);
  stack["delete"](other);
  return result;
}
var _equalArrays = equalArrays$2;
var root$4 = _root;
var Uint8Array$1 = root$4.Uint8Array;
var _Uint8Array = Uint8Array$1;
function mapToArray$1(map) {
  var index = -1, result = Array(map.size);
  map.forEach(function(value, key) {
    result[++index] = [key, value];
  });
  return result;
}
var _mapToArray = mapToArray$1;
function setToArray$1(set) {
  var index = -1, result = Array(set.size);
  set.forEach(function(value) {
    result[++index] = value;
  });
  return result;
}
var _setToArray = setToArray$1;
var Symbol$2 = _Symbol, Uint8Array2 = _Uint8Array, eq = eq_1, equalArrays$1 = _equalArrays, mapToArray = _mapToArray, setToArray = _setToArray;
var COMPARE_PARTIAL_FLAG$4 = 1, COMPARE_UNORDERED_FLAG$2 = 2;
var boolTag = "[object Boolean]", dateTag = "[object Date]", errorTag = "[object Error]", mapTag$1 = "[object Map]", numberTag = "[object Number]", regexpTag = "[object RegExp]", setTag$1 = "[object Set]", stringTag = "[object String]", symbolTag$1 = "[object Symbol]";
var arrayBufferTag = "[object ArrayBuffer]", dataViewTag$1 = "[object DataView]";
var symbolProto$1 = Symbol$2 ? Symbol$2.prototype : void 0, symbolValueOf = symbolProto$1 ? symbolProto$1.valueOf : void 0;
function equalByTag$1(object, other, tag, bitmask, customizer, equalFunc, stack) {
  switch (tag) {
    case dataViewTag$1:
      if (object.byteLength != other.byteLength || object.byteOffset != other.byteOffset) {
        return false;
      }
      object = object.buffer;
      other = other.buffer;
    case arrayBufferTag:
      if (object.byteLength != other.byteLength || !equalFunc(new Uint8Array2(object), new Uint8Array2(other))) {
        return false;
      }
      return true;
    case boolTag:
    case dateTag:
    case numberTag:
      return eq(+object, +other);
    case errorTag:
      return object.name == other.name && object.message == other.message;
    case regexpTag:
    case stringTag:
      return object == other + "";
    case mapTag$1:
      var convert = mapToArray;
    case setTag$1:
      var isPartial = bitmask & COMPARE_PARTIAL_FLAG$4;
      convert || (convert = setToArray);
      if (object.size != other.size && !isPartial) {
        return false;
      }
      var stacked = stack.get(object);
      if (stacked) {
        return stacked == other;
      }
      bitmask |= COMPARE_UNORDERED_FLAG$2;
      stack.set(object, other);
      var result = equalArrays$1(convert(object), convert(other), bitmask, customizer, equalFunc, stack);
      stack["delete"](object);
      return result;
    case symbolTag$1:
      if (symbolValueOf) {
        return symbolValueOf.call(object) == symbolValueOf.call(other);
      }
  }
  return false;
}
var _equalByTag = equalByTag$1;
function arrayPush$1(array, values) {
  var index = -1, length = values.length, offset2 = array.length;
  while (++index < length) {
    array[offset2 + index] = values[index];
  }
  return array;
}
var _arrayPush = arrayPush$1;
var arrayPush = _arrayPush, isArray$9 = isArray_1;
function baseGetAllKeys$1(object, keysFunc, symbolsFunc) {
  var result = keysFunc(object);
  return isArray$9(object) ? result : arrayPush(result, symbolsFunc(object));
}
var _baseGetAllKeys = baseGetAllKeys$1;
function arrayFilter$2(array, predicate) {
  var index = -1, length = array == null ? 0 : array.length, resIndex = 0, result = [];
  while (++index < length) {
    var value = array[index];
    if (predicate(value, index, array)) {
      result[resIndex++] = value;
    }
  }
  return result;
}
var _arrayFilter = arrayFilter$2;
function stubArray$1() {
  return [];
}
var stubArray_1 = stubArray$1;
var arrayFilter$1 = _arrayFilter, stubArray = stubArray_1;
var objectProto$3 = Object.prototype;
var propertyIsEnumerable = objectProto$3.propertyIsEnumerable;
var nativeGetSymbols = Object.getOwnPropertySymbols;
var getSymbols$1 = !nativeGetSymbols ? stubArray : function(object) {
  if (object == null) {
    return [];
  }
  object = Object(object);
  return arrayFilter$1(nativeGetSymbols(object), function(symbol) {
    return propertyIsEnumerable.call(object, symbol);
  });
};
var _getSymbols = getSymbols$1;
function overArg$1(func, transform) {
  return function(arg) {
    return func(transform(arg));
  };
}
var _overArg = overArg$1;
var overArg = _overArg;
var nativeKeys$1 = overArg(Object.keys, Object);
var _nativeKeys = nativeKeys$1;
var isPrototype = _isPrototype, nativeKeys = _nativeKeys;
var objectProto$2 = Object.prototype;
var hasOwnProperty$2 = objectProto$2.hasOwnProperty;
function baseKeys$1(object) {
  if (!isPrototype(object)) {
    return nativeKeys(object);
  }
  var result = [];
  for (var key in Object(object)) {
    if (hasOwnProperty$2.call(object, key) && key != "constructor") {
      result.push(key);
    }
  }
  return result;
}
var _baseKeys = baseKeys$1;
var arrayLikeKeys = _arrayLikeKeys, baseKeys = _baseKeys, isArrayLike$2 = isArrayLike_1;
function keys$4(object) {
  return isArrayLike$2(object) ? arrayLikeKeys(object) : baseKeys(object);
}
var keys_1 = keys$4;
var baseGetAllKeys = _baseGetAllKeys, getSymbols = _getSymbols, keys$3 = keys_1;
function getAllKeys$1(object) {
  return baseGetAllKeys(object, keys$3, getSymbols);
}
var _getAllKeys = getAllKeys$1;
var getAllKeys = _getAllKeys;
var COMPARE_PARTIAL_FLAG$3 = 1;
var objectProto$1 = Object.prototype;
var hasOwnProperty$1 = objectProto$1.hasOwnProperty;
function equalObjects$1(object, other, bitmask, customizer, equalFunc, stack) {
  var isPartial = bitmask & COMPARE_PARTIAL_FLAG$3, objProps = getAllKeys(object), objLength = objProps.length, othProps = getAllKeys(other), othLength = othProps.length;
  if (objLength != othLength && !isPartial) {
    return false;
  }
  var index = objLength;
  while (index--) {
    var key = objProps[index];
    if (!(isPartial ? key in other : hasOwnProperty$1.call(other, key))) {
      return false;
    }
  }
  var objStacked = stack.get(object);
  var othStacked = stack.get(other);
  if (objStacked && othStacked) {
    return objStacked == other && othStacked == object;
  }
  var result = true;
  stack.set(object, other);
  stack.set(other, object);
  var skipCtor = isPartial;
  while (++index < objLength) {
    key = objProps[index];
    var objValue = object[key], othValue = other[key];
    if (customizer) {
      var compared = isPartial ? customizer(othValue, objValue, key, other, object, stack) : customizer(objValue, othValue, key, object, other, stack);
    }
    if (!(compared === void 0 ? objValue === othValue || equalFunc(objValue, othValue, bitmask, customizer, stack) : compared)) {
      result = false;
      break;
    }
    skipCtor || (skipCtor = key == "constructor");
  }
  if (result && !skipCtor) {
    var objCtor = object.constructor, othCtor = other.constructor;
    if (objCtor != othCtor && ("constructor" in object && "constructor" in other) && !(typeof objCtor == "function" && objCtor instanceof objCtor && typeof othCtor == "function" && othCtor instanceof othCtor)) {
      result = false;
    }
  }
  stack["delete"](object);
  stack["delete"](other);
  return result;
}
var _equalObjects = equalObjects$1;
var getNative$3 = _getNative, root$3 = _root;
var DataView$1 = getNative$3(root$3, "DataView");
var _DataView = DataView$1;
var getNative$2 = _getNative, root$2 = _root;
var Promise$2 = getNative$2(root$2, "Promise");
var _Promise = Promise$2;
var getNative$1 = _getNative, root$1 = _root;
var Set$2 = getNative$1(root$1, "Set");
var _Set = Set$2;
var getNative = _getNative, root = _root;
var WeakMap$1 = getNative(root, "WeakMap");
var _WeakMap = WeakMap$1;
var DataView = _DataView, Map$1 = _Map, Promise$1 = _Promise, Set$1 = _Set, WeakMap = _WeakMap, baseGetTag$1 = _baseGetTag, toSource = _toSource;
var mapTag = "[object Map]", objectTag$1 = "[object Object]", promiseTag = "[object Promise]", setTag = "[object Set]", weakMapTag = "[object WeakMap]";
var dataViewTag = "[object DataView]";
var dataViewCtorString = toSource(DataView), mapCtorString = toSource(Map$1), promiseCtorString = toSource(Promise$1), setCtorString = toSource(Set$1), weakMapCtorString = toSource(WeakMap);
var getTag$1 = baseGetTag$1;
if (DataView && getTag$1(new DataView(new ArrayBuffer(1))) != dataViewTag || Map$1 && getTag$1(new Map$1()) != mapTag || Promise$1 && getTag$1(Promise$1.resolve()) != promiseTag || Set$1 && getTag$1(new Set$1()) != setTag || WeakMap && getTag$1(new WeakMap()) != weakMapTag) {
  getTag$1 = function(value) {
    var result = baseGetTag$1(value), Ctor = result == objectTag$1 ? value.constructor : void 0, ctorString = Ctor ? toSource(Ctor) : "";
    if (ctorString) {
      switch (ctorString) {
        case dataViewCtorString:
          return dataViewTag;
        case mapCtorString:
          return mapTag;
        case promiseCtorString:
          return promiseTag;
        case setCtorString:
          return setTag;
        case weakMapCtorString:
          return weakMapTag;
      }
    }
    return result;
  };
}
var _getTag = getTag$1;
var Stack$1 = _Stack, equalArrays = _equalArrays, equalByTag = _equalByTag, equalObjects = _equalObjects, getTag = _getTag, isArray$8 = isArray_1, isBuffer = isBuffer$2.exports, isTypedArray = isTypedArray_1;
var COMPARE_PARTIAL_FLAG$2 = 1;
var argsTag = "[object Arguments]", arrayTag = "[object Array]", objectTag = "[object Object]";
var objectProto = Object.prototype;
var hasOwnProperty = objectProto.hasOwnProperty;
function baseIsEqualDeep$1(object, other, bitmask, customizer, equalFunc, stack) {
  var objIsArr = isArray$8(object), othIsArr = isArray$8(other), objTag = objIsArr ? arrayTag : getTag(object), othTag = othIsArr ? arrayTag : getTag(other);
  objTag = objTag == argsTag ? objectTag : objTag;
  othTag = othTag == argsTag ? objectTag : othTag;
  var objIsObj = objTag == objectTag, othIsObj = othTag == objectTag, isSameTag = objTag == othTag;
  if (isSameTag && isBuffer(object)) {
    if (!isBuffer(other)) {
      return false;
    }
    objIsArr = true;
    objIsObj = false;
  }
  if (isSameTag && !objIsObj) {
    stack || (stack = new Stack$1());
    return objIsArr || isTypedArray(object) ? equalArrays(object, other, bitmask, customizer, equalFunc, stack) : equalByTag(object, other, objTag, bitmask, customizer, equalFunc, stack);
  }
  if (!(bitmask & COMPARE_PARTIAL_FLAG$2)) {
    var objIsWrapped = objIsObj && hasOwnProperty.call(object, "__wrapped__"), othIsWrapped = othIsObj && hasOwnProperty.call(other, "__wrapped__");
    if (objIsWrapped || othIsWrapped) {
      var objUnwrapped = objIsWrapped ? object.value() : object, othUnwrapped = othIsWrapped ? other.value() : other;
      stack || (stack = new Stack$1());
      return equalFunc(objUnwrapped, othUnwrapped, bitmask, customizer, stack);
    }
  }
  if (!isSameTag) {
    return false;
  }
  stack || (stack = new Stack$1());
  return equalObjects(object, other, bitmask, customizer, equalFunc, stack);
}
var _baseIsEqualDeep = baseIsEqualDeep$1;
var baseIsEqualDeep = _baseIsEqualDeep, isObjectLike$1 = isObjectLike_1;
function baseIsEqual$2(value, other, bitmask, customizer, stack) {
  if (value === other) {
    return true;
  }
  if (value == null || other == null || !isObjectLike$1(value) && !isObjectLike$1(other)) {
    return value !== value && other !== other;
  }
  return baseIsEqualDeep(value, other, bitmask, customizer, baseIsEqual$2, stack);
}
var _baseIsEqual = baseIsEqual$2;
var Stack = _Stack, baseIsEqual$1 = _baseIsEqual;
var COMPARE_PARTIAL_FLAG$1 = 1, COMPARE_UNORDERED_FLAG$1 = 2;
function baseIsMatch$1(object, source2, matchData, customizer) {
  var index = matchData.length, length = index, noCustomizer = !customizer;
  if (object == null) {
    return !length;
  }
  object = Object(object);
  while (index--) {
    var data2 = matchData[index];
    if (noCustomizer && data2[2] ? data2[1] !== object[data2[0]] : !(data2[0] in object)) {
      return false;
    }
  }
  while (++index < length) {
    data2 = matchData[index];
    var key = data2[0], objValue = object[key], srcValue = data2[1];
    if (noCustomizer && data2[2]) {
      if (objValue === void 0 && !(key in object)) {
        return false;
      }
    } else {
      var stack = new Stack();
      if (customizer) {
        var result = customizer(objValue, srcValue, key, object, source2, stack);
      }
      if (!(result === void 0 ? baseIsEqual$1(srcValue, objValue, COMPARE_PARTIAL_FLAG$1 | COMPARE_UNORDERED_FLAG$1, customizer, stack) : result)) {
        return false;
      }
    }
  }
  return true;
}
var _baseIsMatch = baseIsMatch$1;
var isObject$1 = isObject_1;
function isStrictComparable$2(value) {
  return value === value && !isObject$1(value);
}
var _isStrictComparable = isStrictComparable$2;
var isStrictComparable$1 = _isStrictComparable, keys$2 = keys_1;
function getMatchData$1(object) {
  var result = keys$2(object), length = result.length;
  while (length--) {
    var key = result[length], value = object[key];
    result[length] = [key, value, isStrictComparable$1(value)];
  }
  return result;
}
var _getMatchData = getMatchData$1;
function matchesStrictComparable$2(key, srcValue) {
  return function(object) {
    if (object == null) {
      return false;
    }
    return object[key] === srcValue && (srcValue !== void 0 || key in Object(object));
  };
}
var _matchesStrictComparable = matchesStrictComparable$2;
var baseIsMatch = _baseIsMatch, getMatchData = _getMatchData, matchesStrictComparable$1 = _matchesStrictComparable;
function baseMatches$1(source2) {
  var matchData = getMatchData(source2);
  if (matchData.length == 1 && matchData[0][2]) {
    return matchesStrictComparable$1(matchData[0][0], matchData[0][1]);
  }
  return function(object) {
    return object === source2 || baseIsMatch(object, source2, matchData);
  };
}
var _baseMatches = baseMatches$1;
var baseGetTag = _baseGetTag, isObjectLike = isObjectLike_1;
var symbolTag = "[object Symbol]";
function isSymbol$4(value) {
  return typeof value == "symbol" || isObjectLike(value) && baseGetTag(value) == symbolTag;
}
var isSymbol_1 = isSymbol$4;
var isArray$7 = isArray_1, isSymbol$3 = isSymbol_1;
var reIsDeepProp = /\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\\]|\\.)*?\1)\]/, reIsPlainProp = /^\w*$/;
function isKey$3(value, object) {
  if (isArray$7(value)) {
    return false;
  }
  var type = typeof value;
  if (type == "number" || type == "symbol" || type == "boolean" || value == null || isSymbol$3(value)) {
    return true;
  }
  return reIsPlainProp.test(value) || !reIsDeepProp.test(value) || object != null && value in Object(object);
}
var _isKey = isKey$3;
var MapCache = _MapCache;
var FUNC_ERROR_TEXT = "Expected a function";
function memoize$1(func, resolver) {
  if (typeof func != "function" || resolver != null && typeof resolver != "function") {
    throw new TypeError(FUNC_ERROR_TEXT);
  }
  var memoized = function() {
    var args = arguments, key = resolver ? resolver.apply(this, args) : args[0], cache = memoized.cache;
    if (cache.has(key)) {
      return cache.get(key);
    }
    var result = func.apply(this, args);
    memoized.cache = cache.set(key, result) || cache;
    return result;
  };
  memoized.cache = new (memoize$1.Cache || MapCache)();
  return memoized;
}
memoize$1.Cache = MapCache;
var memoize_1 = memoize$1;
var memoize = memoize_1;
var MAX_MEMOIZE_SIZE = 500;
function memoizeCapped$1(func) {
  var result = memoize(func, function(key) {
    if (cache.size === MAX_MEMOIZE_SIZE) {
      cache.clear();
    }
    return key;
  });
  var cache = result.cache;
  return result;
}
var _memoizeCapped = memoizeCapped$1;
var memoizeCapped = _memoizeCapped;
var rePropName = /[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|$))/g;
var reEscapeChar = /\\(\\)?/g;
var stringToPath$1 = memoizeCapped(function(string) {
  var result = [];
  if (string.charCodeAt(0) === 46) {
    result.push("");
  }
  string.replace(rePropName, function(match, number, quote, subString) {
    result.push(quote ? subString.replace(reEscapeChar, "$1") : number || match);
  });
  return result;
});
var _stringToPath = stringToPath$1;
function arrayMap$1(array, iteratee) {
  var index = -1, length = array == null ? 0 : array.length, result = Array(length);
  while (++index < length) {
    result[index] = iteratee(array[index], index, array);
  }
  return result;
}
var _arrayMap = arrayMap$1;
var Symbol$1 = _Symbol, arrayMap = _arrayMap, isArray$6 = isArray_1, isSymbol$2 = isSymbol_1;
var INFINITY$2 = 1 / 0;
var symbolProto = Symbol$1 ? Symbol$1.prototype : void 0, symbolToString = symbolProto ? symbolProto.toString : void 0;
function baseToString$1(value) {
  if (typeof value == "string") {
    return value;
  }
  if (isArray$6(value)) {
    return arrayMap(value, baseToString$1) + "";
  }
  if (isSymbol$2(value)) {
    return symbolToString ? symbolToString.call(value) : "";
  }
  var result = value + "";
  return result == "0" && 1 / value == -INFINITY$2 ? "-0" : result;
}
var _baseToString = baseToString$1;
var baseToString = _baseToString;
function toString$1(value) {
  return value == null ? "" : baseToString(value);
}
var toString_1 = toString$1;
var isArray$5 = isArray_1, isKey$2 = _isKey, stringToPath = _stringToPath, toString2 = toString_1;
function castPath$2(value, object) {
  if (isArray$5(value)) {
    return value;
  }
  return isKey$2(value, object) ? [value] : stringToPath(toString2(value));
}
var _castPath = castPath$2;
var isSymbol$1 = isSymbol_1;
var INFINITY$1 = 1 / 0;
function toKey$4(value) {
  if (typeof value == "string" || isSymbol$1(value)) {
    return value;
  }
  var result = value + "";
  return result == "0" && 1 / value == -INFINITY$1 ? "-0" : result;
}
var _toKey = toKey$4;
var castPath$1 = _castPath, toKey$3 = _toKey;
function baseGet$2(object, path) {
  path = castPath$1(path, object);
  var index = 0, length = path.length;
  while (object != null && index < length) {
    object = object[toKey$3(path[index++])];
  }
  return index && index == length ? object : void 0;
}
var _baseGet = baseGet$2;
var baseGet$1 = _baseGet;
function get$1(object, path, defaultValue) {
  var result = object == null ? void 0 : baseGet$1(object, path);
  return result === void 0 ? defaultValue : result;
}
var get_1 = get$1;
function baseHasIn$1(object, key) {
  return object != null && key in Object(object);
}
var _baseHasIn = baseHasIn$1;
var castPath = _castPath, isArguments = isArguments_1, isArray$4 = isArray_1, isIndex = _isIndex, isLength = isLength_1, toKey$2 = _toKey;
function hasPath$1(object, path, hasFunc) {
  path = castPath(path, object);
  var index = -1, length = path.length, result = false;
  while (++index < length) {
    var key = toKey$2(path[index]);
    if (!(result = object != null && hasFunc(object, key))) {
      break;
    }
    object = object[key];
  }
  if (result || ++index != length) {
    return result;
  }
  length = object == null ? 0 : object.length;
  return !!length && isLength(length) && isIndex(key, length) && (isArray$4(object) || isArguments(object));
}
var _hasPath = hasPath$1;
var baseHasIn = _baseHasIn, hasPath = _hasPath;
function hasIn$1(object, path) {
  return object != null && hasPath(object, path, baseHasIn);
}
var hasIn_1 = hasIn$1;
var baseIsEqual = _baseIsEqual, get = get_1, hasIn = hasIn_1, isKey$1 = _isKey, isStrictComparable = _isStrictComparable, matchesStrictComparable = _matchesStrictComparable, toKey$1 = _toKey;
var COMPARE_PARTIAL_FLAG = 1, COMPARE_UNORDERED_FLAG = 2;
function baseMatchesProperty$1(path, srcValue) {
  if (isKey$1(path) && isStrictComparable(srcValue)) {
    return matchesStrictComparable(toKey$1(path), srcValue);
  }
  return function(object) {
    var objValue = get(object, path);
    return objValue === void 0 && objValue === srcValue ? hasIn(object, path) : baseIsEqual(srcValue, objValue, COMPARE_PARTIAL_FLAG | COMPARE_UNORDERED_FLAG);
  };
}
var _baseMatchesProperty = baseMatchesProperty$1;
function baseProperty$1(key) {
  return function(object) {
    return object == null ? void 0 : object[key];
  };
}
var _baseProperty = baseProperty$1;
var baseGet = _baseGet;
function basePropertyDeep$1(path) {
  return function(object) {
    return baseGet(object, path);
  };
}
var _basePropertyDeep = basePropertyDeep$1;
var baseProperty = _baseProperty, basePropertyDeep = _basePropertyDeep, isKey = _isKey, toKey = _toKey;
function property$1(path) {
  return isKey(path) ? baseProperty(toKey(path)) : basePropertyDeep(path);
}
var property_1 = property$1;
var baseMatches = _baseMatches, baseMatchesProperty = _baseMatchesProperty, identity$1 = identity_1, isArray$3 = isArray_1, property = property_1;
function baseIteratee$5(value) {
  if (typeof value == "function") {
    return value;
  }
  if (value == null) {
    return identity$1;
  }
  if (typeof value == "object") {
    return isArray$3(value) ? baseMatchesProperty(value[0], value[1]) : baseMatches(value);
  }
  return property(value);
}
var _baseIteratee = baseIteratee$5;
var baseIteratee$4 = _baseIteratee, isArrayLike$1 = isArrayLike_1, keys$1 = keys_1;
function createFind$1(findIndexFunc) {
  return function(collection, predicate, fromIndex) {
    var iterable = Object(collection);
    if (!isArrayLike$1(collection)) {
      var iteratee = baseIteratee$4(predicate);
      collection = keys$1(collection);
      predicate = function(key) {
        return iteratee(iterable[key], key, iterable);
      };
    }
    var index = findIndexFunc(collection, predicate, fromIndex);
    return index > -1 ? iterable[iteratee ? collection[index] : index] : void 0;
  };
}
var _createFind = createFind$1;
function baseFindIndex$1(array, predicate, fromIndex, fromRight) {
  var length = array.length, index = fromIndex + (fromRight ? 1 : -1);
  while (fromRight ? index-- : ++index < length) {
    if (predicate(array[index], index, array)) {
      return index;
    }
  }
  return -1;
}
var _baseFindIndex = baseFindIndex$1;
var reWhitespace = /\s/;
function trimmedEndIndex$1(string) {
  var index = string.length;
  while (index-- && reWhitespace.test(string.charAt(index))) {
  }
  return index;
}
var _trimmedEndIndex = trimmedEndIndex$1;
var trimmedEndIndex = _trimmedEndIndex;
var reTrimStart = /^\s+/;
function baseTrim$1(string) {
  return string ? string.slice(0, trimmedEndIndex(string) + 1).replace(reTrimStart, "") : string;
}
var _baseTrim = baseTrim$1;
var baseTrim = _baseTrim, isObject = isObject_1, isSymbol = isSymbol_1;
var NAN = 0 / 0;
var reIsBadHex = /^[-+]0x[0-9a-f]+$/i;
var reIsBinary = /^0b[01]+$/i;
var reIsOctal = /^0o[0-7]+$/i;
var freeParseInt = parseInt;
function toNumber$1(value) {
  if (typeof value == "number") {
    return value;
  }
  if (isSymbol(value)) {
    return NAN;
  }
  if (isObject(value)) {
    var other = typeof value.valueOf == "function" ? value.valueOf() : value;
    value = isObject(other) ? other + "" : other;
  }
  if (typeof value != "string") {
    return value === 0 ? value : +value;
  }
  value = baseTrim(value);
  var isBinary = reIsBinary.test(value);
  return isBinary || reIsOctal.test(value) ? freeParseInt(value.slice(2), isBinary ? 2 : 8) : reIsBadHex.test(value) ? NAN : +value;
}
var toNumber_1 = toNumber$1;
var toNumber = toNumber_1;
var INFINITY = 1 / 0, MAX_INTEGER = 17976931348623157e292;
function toFinite$1(value) {
  if (!value) {
    return value === 0 ? value : 0;
  }
  value = toNumber(value);
  if (value === INFINITY || value === -INFINITY) {
    var sign = value < 0 ? -1 : 1;
    return sign * MAX_INTEGER;
  }
  return value === value ? value : 0;
}
var toFinite_1 = toFinite$1;
var toFinite = toFinite_1;
function toInteger$1(value) {
  var result = toFinite(value), remainder = result % 1;
  return result === result ? remainder ? result - remainder : result : 0;
}
var toInteger_1 = toInteger$1;
var baseFindIndex = _baseFindIndex, baseIteratee$3 = _baseIteratee, toInteger = toInteger_1;
var nativeMax = Math.max;
function findIndex$1(array, predicate, fromIndex) {
  var length = array == null ? 0 : array.length;
  if (!length) {
    return -1;
  }
  var index = fromIndex == null ? 0 : toInteger(fromIndex);
  if (index < 0) {
    index = nativeMax(length + index, 0);
  }
  return baseFindIndex(array, baseIteratee$3(predicate), index);
}
var findIndex_1 = findIndex$1;
var createFind = _createFind, findIndex = findIndex_1;
var find = createFind(findIndex);
var find_1 = find;
function baseFindKey$1(collection, predicate, eachFunc) {
  var result;
  eachFunc(collection, function(value, key, collection2) {
    if (predicate(value, key, collection2)) {
      result = key;
      return false;
    }
  });
  return result;
}
var _baseFindKey = baseFindKey$1;
function createBaseFor$1(fromRight) {
  return function(object, iteratee, keysFunc) {
    var index = -1, iterable = Object(object), props = keysFunc(object), length = props.length;
    while (length--) {
      var key = props[fromRight ? length : ++index];
      if (iteratee(iterable[key], key, iterable) === false) {
        break;
      }
    }
    return object;
  };
}
var _createBaseFor = createBaseFor$1;
var createBaseFor = _createBaseFor;
var baseFor$1 = createBaseFor();
var _baseFor = baseFor$1;
var baseFor = _baseFor, keys = keys_1;
function baseForOwn$2(object, iteratee) {
  return object && baseFor(object, iteratee, keys);
}
var _baseForOwn = baseForOwn$2;
var baseFindKey = _baseFindKey, baseForOwn$1 = _baseForOwn, baseIteratee$2 = _baseIteratee;
function findKey(object, predicate) {
  return baseFindKey(object, baseIteratee$2(predicate), baseForOwn$1);
}
var findKey_1 = findKey;
const __vue2_script$g = {
  mounted() {
    const listener = (e) => {
      if (e.target === this.$el || this.$el.contains(e.target)) {
        return;
      }
      this.$emit("do");
    };
    document.addEventListener("click", listener);
    this.$once("hook:beforeDestroy", () => {
      document.removeEventListener("click", listener);
    });
  },
  render() {
    return this.$slots.default[0];
  }
};
let __vue2_render, __vue2_staticRenderFns;
const __cssModules$g = {};
var __component__$g = /* @__PURE__ */ normalizeComponent(__vue2_script$g, __vue2_render, __vue2_staticRenderFns, false, __vue2_injectStyles$g, null, null, null);
function __vue2_injectStyles$g(context) {
  for (let o in __cssModules$g) {
    this[o] = __cssModules$g[o];
  }
}
var OnClickOutside = /* @__PURE__ */ function() {
  return __component__$g.exports;
}();
var render$f = function() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("on-click-outside", { on: { "do": function($event) {
    return _vm.close();
  } } }, [_c("div", { staticClass: "fvl-search-select-wrapper", class: { "fvl-has-error": _vm.$parent.hasErrors(_vm.name), "fvl-dropdown-is-open": _vm.isOpen } }, [_vm.label ? _c("label", { staticClass: "fvl-select-label", class: _vm.labelClass, on: { "click": function($event) {
    return _vm.toggle();
  } } }, [_c("span", { domProps: { "innerHTML": _vm._s(_vm.label) } }), _vm._t("label_suffix")], 2) : _vm._e(), _c("div", { staticClass: "fvl-search-select-input-wrapper" }, [_c("button", { ref: "selectinput", staticClass: "fvl-search-select", class: [{ "fvl-search-select-placeholder": !_vm.selectedOptionValue }, _vm.fieldClass], attrs: { "disabled": _vm.disabled, "type": "button" }, domProps: { "innerHTML": _vm._s(_vm.selectedOptionValue ? _vm.selectedOptionValue : _vm.placeholder) }, on: { "click": function($event) {
    $event.preventDefault();
    return _vm.toggle();
  }, "keydown": [function($event) {
    if (!$event.type.indexOf("key") && _vm._k($event.keyCode, "space", 32, $event.key, [" ", "Spacebar"])) {
      return null;
    }
    return _vm.toggle();
  }, function($event) {
    if (!$event.type.indexOf("key") && _vm._k($event.keyCode, "esc", 27, $event.key, ["Esc", "Escape"])) {
      return null;
    }
    return _vm.close();
  }] } }), _c("div", { staticClass: "fvl-search-select-carret" }, [_c("svg", { attrs: { "xmlns": "http://www.w3.org/2000/svg", "viewBox": "0 0 20 20" } }, [_c("path", { attrs: { "d": "M9.293 12.95l.707.707L15.657 8l-1.414-1.414L10 10.828 5.757 6.586 4.343 8z" } })])]), _c("transition", { attrs: { "name": "fvl-dropdown-transition" } }, [_c("div", { directives: [{ name: "show", rawName: "v-show", value: _vm.isOpen, expression: "isOpen" }], ref: "selectdropdown", staticClass: "fvl-search-select-dropdown" }, [_c("input", { directives: [{ name: "model", rawName: "v-model", value: _vm.query, expression: "query" }], ref: "search", staticClass: "fvl-search-select-dropdown-input", attrs: { "autocapitalize": "off", "spellcheck": "false" }, domProps: { "value": _vm.query }, on: { "keydown": [function($event) {
    if (!$event.type.indexOf("key") && _vm._k($event.keyCode, "esc", 27, $event.key, ["Esc", "Escape"])) {
      return null;
    }
    return _vm.close();
  }, function($event) {
    if (!$event.type.indexOf("key") && _vm._k($event.keyCode, "down", 40, $event.key, ["Down", "ArrowDown"])) {
      return null;
    }
    return _vm.highlightNext();
  }, function($event) {
    if (!$event.type.indexOf("key") && _vm._k($event.keyCode, "up", 38, $event.key, ["Up", "ArrowUp"])) {
      return null;
    }
    return _vm.highlightPrevious();
  }, function($event) {
    if (!$event.type.indexOf("key") && _vm._k($event.keyCode, "enter", 13, $event.key, "Enter")) {
      return null;
    }
    $event.preventDefault();
    return _vm.selectHighlighted();
  }, function($event) {
    if (!$event.type.indexOf("key") && _vm._k($event.keyCode, "tab", 9, $event.key, "Tab")) {
      return null;
    }
    $event.preventDefault();
  }], "input": [function($event) {
    if ($event.target.composing) {
      return;
    }
    _vm.query = $event.target.value;
  }, function($event) {
    _vm.highlightedIndex = 0, _vm.getRemoteOptions();
  }] } }), !_vm.isLoading ? _c("ul", { ref: "options", staticClass: "fvl-search-select-dropdown-options" }, _vm._l(_vm.filteredOptionsList, function(option, index) {
    return _c("li", { key: option[_vm.optionKey], staticClass: "fvl-search-select-dropdown-option", class: {
      "fvl-search-select-dropdown-option-highlighted": index === _vm.highlightedIndex,
      "fvl-search-dropdown-option-disabled": _vm.optionIsDisabled(option)
    }, on: { "click": function($event) {
      return _vm.select(option);
    } } }, [_vm._t("option", function() {
      return [_vm._v(" " + _vm._s(option[_vm.optionValue]) + " ")];
    }, { "option": option, "disabled": _vm.optionIsDisabled(option) })], 2);
  }), 0) : _vm._e(), !_vm.filteredOptionsList.length && !_vm.isLoading ? _c("div", { staticClass: "search-select-empty" }, [_vm._t("no-results", function() {
    return [_c("span", { domProps: { "textContent": _vm._s(_vm.getConfig("noResultsText", "No results found!")) } })];
  })], 2) : _vm._e(), _vm.isLoading ? _c("div", { staticClass: "search-select-empty" }, [_vm._t("loading", function() {
    return [_c("span", { domProps: { "textContent": _vm._s(_vm.getConfig("pleaseWaitText", "Please wait...")) } })];
  })], 2) : _vm._e()])])], 1), _vm._t("hint"), _vm._t("errors", function() {
    return [_c("validation-errors", { attrs: { "errors": _vm.$parent.getErrors(_vm.name) } })];
  }, { "errors": _vm.$parent.getErrors(_vm.name) })], 2)]);
};
var staticRenderFns$f = [];
const __vue2_script$f = {
  components: {
    ValidationErrors,
    OnClickOutside
  },
  mixins: [config],
  props: {
    selected: {
      type: String | Number,
      default: null
    },
    name: {
      type: String,
      required: true
    },
    id: {
      type: String,
      default: null
    },
    label: {
      type: String,
      default: null
    },
    options: {
      type: Array,
      default: () => []
    },
    disabledOptions: {
      type: Array,
      default: () => []
    },
    optionsUrl: {
      type: String,
      default: null
    },
    responseDataPath: {
      type: String,
      default: null
    },
    lazyLoad: {
      type: Boolean,
      default: false
    },
    optionKey: {
      type: String,
      required: true
    },
    optionValue: {
      type: String,
      required: true
    },
    searchKeys: {
      type: Array,
      required: true,
      default: () => []
    },
    searchRemote: {
      type: Boolean,
      default: false
    },
    allowEmpty: {
      type: Boolean,
      default: true
    },
    placeholder: {
      type: String,
      required: false,
      default: "&nbsp;"
    },
    autocomplete: {
      type: String,
      required: false,
      default: null
    },
    fieldClass: {
      type: String,
      required: false,
      default: null
    },
    labelClass: {
      type: String,
      required: false,
      default: ""
    },
    required: {
      type: Boolean,
      required: false,
      default: false
    },
    readonly: {
      type: Boolean,
      required: false,
      default: false
    },
    disabled: {
      type: Boolean,
      required: false,
      default: false
    },
    selectFirst: {
      type: Boolean,
      required: false,
      default: false
    }
  },
  data() {
    return {
      isOpen: false,
      query: null,
      highlightedIndex: 0,
      remoteOptions: [],
      isLoading: false
    };
  },
  computed: {
    optionsList() {
      return this.remoteOptions.length ? this.remoteOptions : this.options;
    },
    filteredOptionsList() {
      if (!this.query) {
        return this.optionsList;
      }
      if (this.searchRemote) {
        return this.remoteOptions;
      }
      let fuse = new Fuse(this.optionsList, {
        threshold: 0.2,
        keys: this.searchKeys
      });
      return fuse.search(this.query).map((a) => a.item);
    },
    selectedOptionValue() {
      let $this = this;
      let option = find_1(this.optionsList, function(o) {
        return o[$this.optionKey] == $this.selected;
      });
      return option ? option[this.optionValue] : "";
    },
    selectedOptionIndex() {
      let $this = this;
      return findKey_1(this.optionsList, function(o) {
        return o[$this.optionKey] == $this.selected;
      });
    }
  },
  watch: {
    filteredOptionsList() {
      if (this.popper !== void 0) {
        this.popper.scheduleUpdate();
      }
    },
    optionsUrl() {
      this.getRemoteOptions(true);
    },
    disabledOptions() {
      this.getRemoteOptions(true);
    }
  },
  mounted() {
    if (!this.optionsUrl)
      return;
    if (!this.lazyLoad)
      this.getRemoteOptions();
  },
  beforeDestroy() {
    if (this.popper !== void 0) {
      this.popper.destroy();
    }
  },
  methods: {
    select(option) {
      if (this.optionIsDisabled(option))
        return;
      this.$emit("update:selected", String(option[this.optionKey]));
      this.$emit("changed");
      this.$parent.dirty(this.name);
      this.close();
    },
    reset() {
      this.query = "";
    },
    selectHighlighted() {
      if (!this.filteredOptionsList.length) {
        return;
      }
      this.select(this.filteredOptionsList[this.highlightedIndex]);
    },
    setupPopper() {
      if (this.popper === void 0) {
        this.popper = new Popper$1(this.$refs.selectinput, this.$refs.selectdropdown, {
          placement: "bottom"
        });
      } else {
        this.popper.scheduleUpdate();
      }
    },
    open() {
      if (this.isOpen)
        return;
      if (this.lazyLoad)
        this.getRemoteOptions();
      this.isOpen = true;
      this.$nextTick(() => {
        this.setupPopper();
        this.$refs.search.focus();
        this.highlightedIndex = this.selectedOptionIndex ? Number(this.selectedOptionIndex) : 0;
        this.scrollToIndex(this.highlightedIndex);
      });
    },
    close() {
      if (!this.isOpen)
        return;
      this.isOpen = false;
      this.$nextTick(() => {
        this.$refs.selectinput.focus();
        this.reset();
      });
    },
    toggle() {
      if (this.disabled || this.readonly)
        return;
      this.isOpen ? this.close() : this.open();
    },
    scrollToIndex(index) {
      if (typeof this.$refs.options == "undefined" || typeof this.$refs.options.children[index] == "undefined")
        return;
      this.$refs.options.children[index].scrollIntoView({ block: "nearest", inline: "nearest" });
    },
    highlightNext() {
      this.highlightedIndex = this.highlightedIndex == this.filteredOptionsList.length - 1 ? this.filteredOptionsList.length - 1 : this.highlightedIndex + 1;
      this.scrollToIndex(this.highlightedIndex);
    },
    highlightPrevious() {
      this.highlightedIndex = this.highlightedIndex == 0 ? 0 : this.highlightedIndex - 1;
      this.scrollToIndex(this.highlightedIndex);
    },
    getRemoteOptions(refresh) {
      if (!this.searchRemote && this.optionsList.length && !refresh || !this.optionsUrl)
        return;
      let searchQuery = "";
      if (this.query) {
        searchQuery = "?" + this.searchKeys[0] + "=" + this.query;
      }
      let $this = this;
      this.isLoading = true;
      axios({
        method: "get",
        url: this.optionsUrl + searchQuery,
        responseType: "json"
      }).then(function(response) {
        $this.remoteOptions = $this.responseDataPath ? get_1(response.data, $this.responseDataPath) : response.data;
        if ($this.selectFirst && !$this.selectedOptionValue && !$this.lazyLoad) {
          $this.select($this.remoteOptions[0]);
        }
        $this.$emit("remoteSuccess", response);
      }).catch(function(error) {
        $this.$emit("remoteError", error);
      }).then(function() {
        $this.isLoading = false;
        if ($this.popper) {
          $this.popper.scheduleUpdate();
        }
      });
    },
    optionIsDisabled(option) {
      if (this.disabledOptions === null)
        return false;
      if (this.disabledOptions.length && typeof this.disabledOptions[0] === "object") {
        let disabledOptions = JSON.parse(JSON.stringify(this.disabledOptions));
        return typeof find_1(disabledOptions, JSON.parse(JSON.stringify(option))) !== "undefined";
      }
      return this.disabledOptions.includes(option[this.optionKey]);
    }
  }
};
const __cssModules$f = {};
var __component__$f = /* @__PURE__ */ normalizeComponent(__vue2_script$f, render$f, staticRenderFns$f, false, __vue2_injectStyles$f, null, null, null);
function __vue2_injectStyles$f(context) {
  for (let o in __cssModules$f) {
    this[o] = __cssModules$f[o];
  }
}
var FvlSearchSelect = /* @__PURE__ */ function() {
  return __component__$f.exports;
}();
var isArrayLike = isArrayLike_1;
function createBaseEach$1(eachFunc, fromRight) {
  return function(collection, iteratee) {
    if (collection == null) {
      return collection;
    }
    if (!isArrayLike(collection)) {
      return eachFunc(collection, iteratee);
    }
    var length = collection.length, index = fromRight ? length : -1, iterable = Object(collection);
    while (fromRight ? index-- : ++index < length) {
      if (iteratee(iterable[index], index, iterable) === false) {
        break;
      }
    }
    return collection;
  };
}
var _createBaseEach = createBaseEach$1;
var baseForOwn = _baseForOwn, createBaseEach = _createBaseEach;
var baseEach$3 = createBaseEach(baseForOwn);
var _baseEach = baseEach$3;
var baseEach$2 = _baseEach;
function baseFilter$1(collection, predicate) {
  var result = [];
  baseEach$2(collection, function(value, index, collection2) {
    if (predicate(value, index, collection2)) {
      result.push(value);
    }
  });
  return result;
}
var _baseFilter = baseFilter$1;
var arrayFilter = _arrayFilter, baseFilter = _baseFilter, baseIteratee$1 = _baseIteratee, isArray$2 = isArray_1;
function filter(collection, predicate) {
  var func = isArray$2(collection) ? arrayFilter : baseFilter;
  return func(collection, baseIteratee$1(predicate));
}
var filter_1 = filter;
var render$e = function() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("on-click-outside", { on: { "do": function($event) {
    return _vm.close();
  } } }, [_c("div", { staticClass: "fvl-tag-select-wrapper", class: { "fvl-has-error": _vm.hasErrors(_vm.name), "fvl-dropdown-is-open": _vm.isOpen } }, [_vm.label ? _c("label", { staticClass: "fvl-select-label", class: _vm.labelClass, on: { "click": function($event) {
    return _vm.toggle();
  } } }, [_c("span", { domProps: { "innerHTML": _vm._s(_vm.label) } }), _vm._t("label_suffix")], 2) : _vm._e(), _c("div", { staticClass: "fvl-tag-select-input-wrapper", class: { "fvl-tag-select-input-inline": _vm.allowNew } }, [_c("button", { ref: "selectinput", staticClass: "fvl-tag-select", class: [{ "fvl-tag-select-placeholder": !_vm.selectedOptionValues.length }, _vm.fieldClass], attrs: { "disabled": _vm.disabled, "type": "button", "tabindex": "-1" }, on: { "click": function($event) {
    $event.preventDefault();
    _vm.allowNew ? _vm.focusInlineInput() : _vm.toggle(), _vm.allowNew && _vm.openOnClick ? _vm.open() : "";
  }, "keydown": function($event) {
    if (!$event.type.indexOf("key") && _vm._k($event.keyCode, "space", 32, $event.key, [" ", "Spacebar"])) {
      return null;
    }
    return _vm.toggle();
  } } }, [_c("span", { directives: [{ name: "show", rawName: "v-show", value: !_vm.selectedOptionValues.length && _vm.placeholder && !_vm.allowNew, expression: "!selectedOptionValues.length && placeholder && !allowNew" }], domProps: { "textContent": _vm._s(_vm.placeholder) } }), _vm._l(_vm.selectedOptionValues, function(value, index) {
    return _c("span", { key: value + index, staticClass: "fvl-tag-select-item", class: _vm.getErrors(_vm.name) && _vm.getErrors(_vm.name)[index] ? "fvl-tag-select-item-has-error" : "", on: { "click": function($event) {
      $event.preventDefault();
      $event.stopPropagation();
      _vm.max == 1 ? _vm.removeTag($event) : "";
    } } }, [_vm._v(" " + _vm._s(value) + " "), _c("svg", { staticClass: "fvl-tag-select-item-remove", attrs: { "xmlns": "http://www.w3.org/2000/svg", "viewBox": "0 0 24 24", "fill": "none", "stroke-width": "2", "stroke-linecap": "round", "stroke-linejoin": "round" }, on: { "click": function($event) {
      $event.preventDefault();
      $event.stopPropagation();
      return _vm.unselect(value);
    } } }, [_c("line", { attrs: { "x1": "18", "y1": "6", "x2": "6", "y2": "18" } }), _c("line", { attrs: { "x1": "6", "y1": "6", "x2": "18", "y2": "18" } })])]);
  }), _vm.type === "checkbox" && (_vm.allowNew && !(_vm.max !== null && _vm.selected !== null && _vm.selected.length >= _vm.max)) ? _c("input", { directives: [{ name: "model", rawName: "v-model", value: _vm.query, expression: "query" }], ref: "inlineinput", staticClass: "fvl-tag-inline-input", class: { "p-1": _vm.selectedOptionValues.length }, style: {
    width: String(_vm.query).length * 18 + "px",
    maxWidth: "100%",
    minWidth: _vm.selectedOptionValues.length ? "80px" : String(_vm.placeholder).length * 18 + "px"
  }, attrs: { "autocapitalize": "off", "spellcheck": "false", "placeholder": _vm.selectedOptionValues.length ? "" : _vm.placeholder, "autocomplete": "new-" + _vm.name, "type": "checkbox" }, domProps: { "checked": Array.isArray(_vm.query) ? _vm._i(_vm.query, null) > -1 : _vm.query }, on: { "keydown": [function($event) {
    if (!$event.type.indexOf("key") && _vm._k($event.keyCode, "esc", 27, $event.key, ["Esc", "Escape"])) {
      return null;
    }
    return _vm.close();
  }, function($event) {
    return _vm.openOnKeyDown($event);
  }, function($event) {
    if (!$event.type.indexOf("key") && _vm._k($event.keyCode, "down", 40, $event.key, ["Down", "ArrowDown"])) {
      return null;
    }
    return _vm.highlightNext();
  }, function($event) {
    if (!$event.type.indexOf("key") && _vm._k($event.keyCode, "up", 38, $event.key, ["Up", "ArrowUp"])) {
      return null;
    }
    return _vm.highlightPrevious();
  }, function($event) {
    if (!$event.type.indexOf("key") && _vm._k($event.keyCode, "enter", 13, $event.key, "Enter")) {
      return null;
    }
    $event.preventDefault();
    return _vm.checkValidity($event);
  }, function($event) {
    if (!$event.type.indexOf("key") && _vm._k($event.keyCode, "tab", 9, $event.key, "Tab")) {
      return null;
    }
    _vm.checkValidity($event), _vm.close();
  }, function($event) {
    if (!$event.type.indexOf("key") && _vm._k($event.keyCode, "backspace", void 0, $event.key, void 0)) {
      return null;
    }
    return _vm.removeTag($event);
  }], "blur": function($event) {
    _vm.query && !_vm.filteredOptionsList.length ? _vm.checkValidity($event) : "";
  }, "paste": function($event) {
    $event.preventDefault();
    return _vm.checkValidity($event);
  }, "input": function($event) {
    _vm.highlightedIndex = -1, _vm.getRemoteOptions();
  }, "change": function($event) {
    var $$a = _vm.query, $$el = $event.target, $$c = $$el.checked ? true : false;
    if (Array.isArray($$a)) {
      var $$v = null, $$i = _vm._i($$a, $$v);
      if ($$el.checked) {
        $$i < 0 && (_vm.query = $$a.concat([$$v]));
      } else {
        $$i > -1 && (_vm.query = $$a.slice(0, $$i).concat($$a.slice($$i + 1)));
      }
    } else {
      _vm.query = $$c;
    }
  } } }) : _vm.type === "radio" && (_vm.allowNew && !(_vm.max !== null && _vm.selected !== null && _vm.selected.length >= _vm.max)) ? _c("input", { directives: [{ name: "model", rawName: "v-model", value: _vm.query, expression: "query" }], ref: "inlineinput", staticClass: "fvl-tag-inline-input", class: { "p-1": _vm.selectedOptionValues.length }, style: {
    width: String(_vm.query).length * 18 + "px",
    maxWidth: "100%",
    minWidth: _vm.selectedOptionValues.length ? "80px" : String(_vm.placeholder).length * 18 + "px"
  }, attrs: { "autocapitalize": "off", "spellcheck": "false", "placeholder": _vm.selectedOptionValues.length ? "" : _vm.placeholder, "autocomplete": "new-" + _vm.name, "type": "radio" }, domProps: { "checked": _vm._q(_vm.query, null) }, on: { "keydown": [function($event) {
    if (!$event.type.indexOf("key") && _vm._k($event.keyCode, "esc", 27, $event.key, ["Esc", "Escape"])) {
      return null;
    }
    return _vm.close();
  }, function($event) {
    return _vm.openOnKeyDown($event);
  }, function($event) {
    if (!$event.type.indexOf("key") && _vm._k($event.keyCode, "down", 40, $event.key, ["Down", "ArrowDown"])) {
      return null;
    }
    return _vm.highlightNext();
  }, function($event) {
    if (!$event.type.indexOf("key") && _vm._k($event.keyCode, "up", 38, $event.key, ["Up", "ArrowUp"])) {
      return null;
    }
    return _vm.highlightPrevious();
  }, function($event) {
    if (!$event.type.indexOf("key") && _vm._k($event.keyCode, "enter", 13, $event.key, "Enter")) {
      return null;
    }
    $event.preventDefault();
    return _vm.checkValidity($event);
  }, function($event) {
    if (!$event.type.indexOf("key") && _vm._k($event.keyCode, "tab", 9, $event.key, "Tab")) {
      return null;
    }
    _vm.checkValidity($event), _vm.close();
  }, function($event) {
    if (!$event.type.indexOf("key") && _vm._k($event.keyCode, "backspace", void 0, $event.key, void 0)) {
      return null;
    }
    return _vm.removeTag($event);
  }], "blur": function($event) {
    _vm.query && !_vm.filteredOptionsList.length ? _vm.checkValidity($event) : "";
  }, "paste": function($event) {
    $event.preventDefault();
    return _vm.checkValidity($event);
  }, "input": function($event) {
    _vm.highlightedIndex = -1, _vm.getRemoteOptions();
  }, "change": function($event) {
    _vm.query = null;
  } } }) : _vm.allowNew && !(_vm.max !== null && _vm.selected !== null && _vm.selected.length >= _vm.max) ? _c("input", { directives: [{ name: "model", rawName: "v-model", value: _vm.query, expression: "query" }], ref: "inlineinput", staticClass: "fvl-tag-inline-input", class: { "p-1": _vm.selectedOptionValues.length }, style: {
    width: String(_vm.query).length * 18 + "px",
    maxWidth: "100%",
    minWidth: _vm.selectedOptionValues.length ? "80px" : String(_vm.placeholder).length * 18 + "px"
  }, attrs: { "autocapitalize": "off", "spellcheck": "false", "placeholder": _vm.selectedOptionValues.length ? "" : _vm.placeholder, "autocomplete": "new-" + _vm.name, "type": _vm.type }, domProps: { "value": _vm.query }, on: { "keydown": [function($event) {
    if (!$event.type.indexOf("key") && _vm._k($event.keyCode, "esc", 27, $event.key, ["Esc", "Escape"])) {
      return null;
    }
    return _vm.close();
  }, function($event) {
    return _vm.openOnKeyDown($event);
  }, function($event) {
    if (!$event.type.indexOf("key") && _vm._k($event.keyCode, "down", 40, $event.key, ["Down", "ArrowDown"])) {
      return null;
    }
    return _vm.highlightNext();
  }, function($event) {
    if (!$event.type.indexOf("key") && _vm._k($event.keyCode, "up", 38, $event.key, ["Up", "ArrowUp"])) {
      return null;
    }
    return _vm.highlightPrevious();
  }, function($event) {
    if (!$event.type.indexOf("key") && _vm._k($event.keyCode, "enter", 13, $event.key, "Enter")) {
      return null;
    }
    $event.preventDefault();
    return _vm.checkValidity($event);
  }, function($event) {
    if (!$event.type.indexOf("key") && _vm._k($event.keyCode, "tab", 9, $event.key, "Tab")) {
      return null;
    }
    _vm.checkValidity($event), _vm.close();
  }, function($event) {
    if (!$event.type.indexOf("key") && _vm._k($event.keyCode, "backspace", void 0, $event.key, void 0)) {
      return null;
    }
    return _vm.removeTag($event);
  }], "blur": function($event) {
    _vm.query && !_vm.filteredOptionsList.length ? _vm.checkValidity($event) : "";
  }, "paste": function($event) {
    $event.preventDefault();
    return _vm.checkValidity($event);
  }, "input": [function($event) {
    if ($event.target.composing) {
      return;
    }
    _vm.query = $event.target.value;
  }, function($event) {
    _vm.highlightedIndex = -1, _vm.getRemoteOptions();
  }] } }) : _vm._e()], 2), !_vm.allowNew || _vm.allowNew && _vm.openOnClick ? _c("div", { staticClass: "fvl-search-select-carret" }, [_c("svg", { attrs: { "xmlns": "http://www.w3.org/2000/svg", "viewBox": "0 0 20 20" } }, [_c("path", { attrs: { "d": "M9.293 12.95l.707.707L15.657 8l-1.414-1.414L10 10.828 5.757 6.586 4.343 8z" } })])]) : _vm._e(), _c("transition", { attrs: { "name": "fvl-dropdown-transition" } }, [_c("div", { directives: [{ name: "show", rawName: "v-show", value: _vm.isOpen && !_vm.allowNew || _vm.isOpen && _vm.allowNew && _vm.filteredOptionsList.length, expression: "(isOpen && !allowNew) || (isOpen && allowNew && filteredOptionsList.length)" }], ref: "selectdropdown", staticClass: "fvl-search-select-dropdown" }, [!_vm.allowNew ? _c("input", { directives: [{ name: "model", rawName: "v-model", value: _vm.query, expression: "query" }], ref: "search", staticClass: "fvl-search-select-dropdown-input", attrs: { "type": "text" }, domProps: { "value": _vm.query }, on: { "keydown": [function($event) {
    if (!$event.type.indexOf("key") && _vm._k($event.keyCode, "esc", 27, $event.key, ["Esc", "Escape"])) {
      return null;
    }
    return _vm.close();
  }, function($event) {
    if (!$event.type.indexOf("key") && _vm._k($event.keyCode, "down", 40, $event.key, ["Down", "ArrowDown"])) {
      return null;
    }
    return _vm.highlightNext();
  }, function($event) {
    if (!$event.type.indexOf("key") && _vm._k($event.keyCode, "up", 38, $event.key, ["Up", "ArrowUp"])) {
      return null;
    }
    return _vm.highlightPrevious();
  }, function($event) {
    if (!$event.type.indexOf("key") && _vm._k($event.keyCode, "enter", 13, $event.key, "Enter")) {
      return null;
    }
    $event.preventDefault();
    return _vm.selectHighlighted();
  }, function($event) {
    if (!$event.type.indexOf("key") && _vm._k($event.keyCode, "tab", 9, $event.key, "Tab")) {
      return null;
    }
    $event.preventDefault();
  }], "input": [function($event) {
    if ($event.target.composing) {
      return;
    }
    _vm.query = $event.target.value;
  }, function($event) {
    _vm.highlightedIndex = 0, _vm.getRemoteOptions();
  }] } }) : _vm._e(), !_vm.isLoading ? _c("ul", { ref: "options", staticClass: "fvl-search-select-dropdown-options" }, _vm._l(_vm.filteredOptionsList, function(option, index) {
    return _c("li", { key: option[_vm.optionKey] + "-" + index, staticClass: "fvl-search-select-dropdown-option", class: {
      "fvl-search-select-dropdown-option-highlighted": index === _vm.highlightedIndex,
      "fvl-search-dropdown-option-disabled": _vm.optionIsDisabled(option)
    }, on: { "click": function($event) {
      return _vm.select(option);
    } } }, [_vm._t("option", function() {
      return [_vm._v(" " + _vm._s(option[_vm.optionValue]) + " ")];
    }, { "option": option, "disabled": _vm.optionIsDisabled(option) })], 2);
  }), 0) : _vm._e(), !_vm.filteredOptionsList.length && !_vm.isLoading ? _c("div", { staticClass: "search-select-empty" }, [_vm._t("no-results", function() {
    return [!_vm.allowNew ? _c("span", { domProps: { "textContent": _vm._s(_vm.getConfig("noResultsText", "No results found!")) } }) : _vm._e()];
  })], 2) : _vm._e(), _vm.isLoading ? _c("div", { staticClass: "search-select-empty" }, [_vm._t("loading", function() {
    return [_c("span", { domProps: { "textContent": _vm._s(_vm.getConfig("pleaseWaitText", "Please wait...")) } })];
  })], 2) : _vm._e()])])], 1), _vm._t("hint"), _vm._t("errors", function() {
    return [_c("validation-errors", { attrs: { "errors": _vm.getErrors(_vm.name) } })];
  }, { "errors": _vm.getErrors(_vm.name) })], 2)]);
};
var staticRenderFns$e = [];
const __vue2_script$e = {
  components: {
    ValidationErrors,
    OnClickOutside
  },
  mixins: [config],
  props: {
    selected: {
      type: Array,
      default: null
    },
    name: {
      type: String,
      required: true
    },
    id: {
      type: String,
      default: null
    },
    label: {
      type: String,
      default: null
    },
    options: {
      type: Array,
      default: () => []
    },
    disabledOptions: {
      type: Array,
      default: () => []
    },
    optionsUrl: {
      type: String,
      default: null
    },
    responseDataPath: {
      type: String,
      default: null
    },
    lazyLoad: {
      type: Boolean,
      default: false
    },
    optionKey: {
      type: String,
      required: true
    },
    optionValue: {
      type: String,
      required: true
    },
    searchKeys: {
      type: Array,
      required: true,
      default: () => []
    },
    searchRemote: {
      type: Boolean,
      default: false
    },
    allowEmpty: {
      type: Boolean,
      default: true
    },
    allowNew: {
      type: Boolean,
      default: false
    },
    max: {
      type: Number,
      default: null
    },
    min: {
      type: Number,
      default: null
    },
    type: {
      type: String,
      default: "text"
    },
    placeholder: {
      type: String,
      required: false,
      default: "&nbsp;"
    },
    openOnClick: {
      type: Boolean,
      required: false,
      default: false
    },
    autocomplete: {
      type: String,
      required: false,
      default: null
    },
    fieldClass: {
      type: String,
      required: false,
      default: null
    },
    labelClass: {
      type: String,
      required: false,
      default: ""
    },
    required: {
      type: Boolean,
      required: false,
      default: false
    },
    readonly: {
      type: Boolean,
      required: false,
      default: false
    },
    disabled: {
      type: Boolean,
      required: false,
      default: false
    }
  },
  data() {
    return {
      isOpen: false,
      query: null,
      highlightedIndex: 0,
      remoteOptions: [],
      isLoading: false
    };
  },
  computed: {
    optionsList() {
      return this.remoteOptions.length ? this.remoteOptions : this.options;
    },
    filteredOptionsList() {
      let $this = this;
      let options = this.searchRemote ? this.remoteOptions : this.optionsList;
      if (this.selected) {
        options = filter_1(options, function(o) {
          return $this.selected.indexOf(o[$this.optionKey]) === -1;
        });
      }
      if (!this.query || this.searchRemote) {
        return options;
      }
      let fuse = new Fuse(options, {
        threshold: 0.2,
        keys: this.searchKeys
      });
      return fuse.search(this.query).map((a) => a.item);
    },
    selectedOptionValues() {
      let $this = this;
      let options = [];
      if (!this.selected)
        return options;
      this.selected.forEach(function(element) {
        let option = find_1($this.optionsList, function(o) {
          return o[$this.optionKey] == element;
        });
        if (option) {
          options.push(option[$this.optionValue]);
        }
        if (!option && $this.allowNew) {
          options.push(element);
        }
      });
      return options;
    },
    selectedOptionIndex() {
      let $this = this;
      return findKey_1(this.optionsList, function(o) {
        return o[$this.optionKey] == $this.selected;
      });
    }
  },
  watch: {
    optionsUrl() {
      this.getRemoteOptions(true);
    },
    disabledOptions() {
      this.getRemoteOptions(true);
    },
    filteredOptionsList() {
      if (this.popper !== void 0) {
        this.popper.scheduleUpdate();
      }
    }
  },
  mounted() {
    if (!this.optionsUrl)
      return;
    if (!this.lazyLoad)
      this.getRemoteOptions();
  },
  beforeDestroy() {
    if (this.popper !== void 0) {
      this.popper.destroy();
    }
  },
  methods: {
    getErrors(name) {
      var _a;
      let errors = [];
      if (this.selected == "" && this.$parent.getErrors(name).length) {
        errors.push(this.$parent.getErrors(name));
      }
      (_a = this.selected) == null ? void 0 : _a.forEach((item, index) => {
        if (this.$parent.getErrors(name + "." + index).length) {
          errors.push(this.$parent.getErrors(name + "." + index));
        }
      });
      return errors;
    },
    hasErrors(name) {
      var _a;
      let errors = [];
      if (this.selected == "" && this.$parent.getErrors(name).length) {
        return true;
      }
      (_a = this.selected) == null ? void 0 : _a.forEach((item, index) => {
        if (this.$parent.getErrors(name + "." + index).length) {
          errors.push(this.$parent.getErrors(name + "." + index));
        }
      });
      return errors.length;
    },
    select(option) {
      if (this.optionIsDisabled(option))
        return;
      let $this = this;
      let selected = this.selected === null ? [] : this.selected;
      if (this.max !== null && selected.length >= this.max)
        return;
      option = typeof option === "object" ? option[$this.optionKey] : option;
      let elementexists = find_1(selected, function(o) {
        return o == option;
      });
      if (elementexists || !option && !this.filteredOptionsList.length)
        return;
      selected.push(option);
      this.$emit("update:selected", selected);
      this.$emit("changed");
      this.$parent.dirty(this.name);
      if (this.allowNew) {
        this.focusInlineInput();
        this.close();
      }
      if (this.max !== null && this.selectedOptionValues.length == this.max)
        this.close();
      this.reset();
    },
    unselect(option) {
      let selected = this.selected === null ? [] : this.selected;
      selected.splice(this.selectedOptionValues.findIndex((item) => {
        return item == option || item == option[this.optionKey];
      }), 1);
      this.$emit("update:selected", selected);
      this.$emit("changed");
      this.$parent.dirty(this.name);
      this.$nextTick(() => {
        if (this.allowNew)
          this.focusInlineInput();
      });
    },
    removeTag(event) {
      let selected = this.selected === null ? [] : this.selected;
      if (selected && !this.query) {
        let selectedIndex = selected.length - 1;
        let value = selected[selectedIndex];
        this.unselect(value);
        if (this.allowNew) {
          event.preventDefault();
          this.query = value;
        }
        this.$emit("update:selected", selected);
        this.$emit("changed");
        this.$parent.dirty(this.name);
        this.close();
      }
      if (this.query && this.query.length == 1) {
        this.close();
      }
    },
    reset() {
      this.query = "";
    },
    selectHighlighted() {
      if (!this.allowNew && !this.filteredOptionsList.length)
        return;
      if (this.highlightedIndex === null || this.highlightedIndex < 0 || this.highlightedIndex > this.filteredOptionsList.length - 1) {
        if (this.allowNew && this.query !== null && this.query.trimLeft() != "") {
          console.log(this.$refs.inlineinput.checkValidity());
          this.select(this.query);
          return;
        }
      }
      this.select(this.filteredOptionsList[this.highlightedIndex]);
      this.highlightedIndex = -1;
    },
    setupPopper() {
      if (this.popper === void 0) {
        this.popper = new Popper$1(this.$refs.selectinput, this.$refs.selectdropdown, {
          placement: "bottom"
        });
      } else {
        this.popper.scheduleUpdate();
      }
    },
    open() {
      if (this.isOpen)
        return;
      if (this.lazyLoad)
        this.getRemoteOptions();
      if (this.max !== null && this.selected !== null && this.selected.length >= this.max)
        return;
      this.isOpen = true;
      this.$nextTick(() => {
        this.setupPopper();
        this.allowNew ? this.focusInlineInput() : this.focusSearch();
        this.highlightedIndex = this.selectedOptionIndex ? Number(this.selectedOptionIndex) : null;
        this.scrollToIndex(this.highlightedIndex);
      });
    },
    close(reset) {
      reset = typeof reset === "undefined" ? false : reset;
      if (!this.isOpen)
        return;
      this.isOpen = false;
      this.$nextTick(() => {
        if (!this.allowNew) {
          this.focusSelectInput();
        }
        if (reset)
          this.reset();
      });
    },
    focusInlineInput() {
      if (typeof this.$refs.inlineinput !== "undefined") {
        this.$refs.inlineinput.focus();
      }
    },
    focusSelectInput() {
      if (typeof this.$refs.selectinput !== "undefined") {
        this.$refs.selectinput.focus();
      }
    },
    focusSearch() {
      if (typeof this.$refs.search !== "undefined") {
        this.$refs.search.focus();
      }
    },
    preventNative(event) {
      let selected = this.selected === null ? [] : this.selected;
      if (this.max !== null && selected.length < this.max && event.keyCode == 9) {
        event.preventDefault();
      }
    },
    openOnKeyDown(event) {
      let ingoreKeys = [9, 13, 27, 16, 91, 18, 17, 20, 8, 38, 40, 37, 39];
      if (ingoreKeys.includes(event.keyCode)) {
        return;
      }
      this.open();
    },
    toggle() {
      if (this.disabled || this.readonly)
        return;
      this.isOpen ? this.close() : this.open();
    },
    scrollToIndex(index) {
      if (typeof this.$refs.options == "undefined" || typeof this.$refs.options.children[index] == "undefined")
        return;
      this.$refs.options.children[index].scrollIntoView({ block: "nearest", inline: "nearest" });
    },
    highlightNext() {
      this.highlightedIndex = this.highlightedIndex >= this.filteredOptionsList.length - 1 ? this.filteredOptionsList.length - 1 : this.highlightedIndex + 1;
      this.scrollToIndex(this.highlightedIndex);
    },
    highlightPrevious() {
      this.highlightedIndex = this.highlightedIndex <= 0 ? 0 : this.highlightedIndex - 1;
      this.scrollToIndex(this.highlightedIndex);
    },
    checkValidity(event) {
      if (event.clipboardData) {
        this.query = event.clipboardData.getData("text");
        event.target.value = this.query;
      }
      if (this.highlightedIndex !== null && this.highlightedIndex !== -1 || event.target.checkValidity()) {
        this.selectHighlighted();
        return true;
      } else {
        event.target.reportValidity();
        return false;
      }
    },
    getRemoteOptions(refresh) {
      if (!this.searchRemote && this.optionsList.length && !refresh || !this.optionsUrl)
        return;
      let searchQuery = "";
      if (this.query) {
        searchQuery = "?" + this.searchKeys[0] + "=" + this.query;
      }
      let $this = this;
      this.isLoading = true;
      axios({
        method: "get",
        url: this.optionsUrl + searchQuery,
        responseType: "json"
      }).then(function(response) {
        $this.remoteOptions = $this.responseDataPath ? get_1(response.data, $this.responseDataPath) : response.data;
        $this.$emit("remoteSuccess", response);
      }).catch(function(error) {
        $this.$emit("remoteError", error);
      }).then(function() {
        $this.isLoading = false;
        if ($this.popper) {
          $this.popper.scheduleUpdate();
        }
      });
    },
    optionIsDisabled(option) {
      if (this.disabledOptions === null)
        return false;
      if (this.disabledOptions.length && typeof this.disabledOptions[0] === "object") {
        let disabledOptions = JSON.parse(JSON.stringify(this.disabledOptions));
        return typeof find_1(disabledOptions, JSON.parse(JSON.stringify(option))) !== "undefined";
      }
      return this.disabledOptions.includes(option[this.optionKey]);
    }
  }
};
const __cssModules$e = {};
var __component__$e = /* @__PURE__ */ normalizeComponent(__vue2_script$e, render$e, staticRenderFns$e, false, __vue2_injectStyles$e, null, null, null);
function __vue2_injectStyles$e(context) {
  for (let o in __cssModules$e) {
    this[o] = __cssModules$e[o];
  }
}
var FvlTagSelect = /* @__PURE__ */ function() {
  return __component__$e.exports;
}();
var render$d = function() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", { staticClass: "fvl-radio-wrapper", class: { "fvl-has-error": _vm.$parent.hasErrors(_vm.name) } }, [_c("span", { staticClass: "fvl-radio-group-label" }, [_c("span", { domProps: { "innerHTML": _vm._s(_vm.label) } }), _vm._t("label_suffix")], 2), _c("div", { staticClass: "fvl-radio-group-wrapper" }, _vm._l(_vm.options, function(option, key) {
    return _c("div", { key, staticClass: "fvl-radio-group" }, [_c("input", { staticClass: "fvl-radio", class: _vm.fieldClass, attrs: { "id": _vm.name + key, "name": _vm.name, "required": _vm.required, "readonly": _vm.readonly, "disabled": _vm.disabled, "type": "radio" }, domProps: { "value": key, "checked": _vm.checked == key }, on: { "change": function($event) {
      _vm.$emit("update:checked", $event.target.value), _vm.$emit("changed"), _vm.$parent.dirty(_vm.name);
    } } }), _c("label", { staticClass: "fvl-radio-label", class: _vm.labelClass, attrs: { "for": _vm.name + key } }, [_c("span", { staticClass: "fvl-radio-toggle" }), _c("span", { staticClass: "fvl-radio-toggle-text" }, [_vm._v(_vm._s(option))])])]);
  }), 0), _vm._t("hint"), _vm._t("errors", function() {
    return [_c("validation-errors", { attrs: { "errors": _vm.$parent.getErrors(_vm.name) } })];
  }, { "errors": _vm.$parent.getErrors(_vm.name) })], 2);
};
var staticRenderFns$d = [];
const __vue2_script$d = {
  components: {
    ValidationErrors
  },
  props: {
    checked: {
      type: String,
      default: ""
    },
    name: {
      type: String,
      required: true
    },
    label: {
      type: String,
      default: null
    },
    options: {
      type: Object,
      required: true,
      default: () => {
      }
    },
    fieldClass: {
      type: String,
      required: false,
      default: null
    },
    labelClass: {
      type: String,
      required: false,
      default: null
    },
    required: {
      type: Boolean,
      required: false,
      default: false
    },
    readonly: {
      type: Boolean,
      required: false,
      default: false
    },
    disabled: {
      type: Boolean,
      required: false,
      default: false
    }
  },
  computed: {
    errors() {
      return this.$parent.errors[this.name] ? this.$parent.errors[this.name] : false;
    },
    hasError() {
      return this.$parent.errors[this.name] ? "fvl-has-error" : "";
    }
  }
};
const __cssModules$d = {};
var __component__$d = /* @__PURE__ */ normalizeComponent(__vue2_script$d, render$d, staticRenderFns$d, false, __vue2_injectStyles$d, null, null, null);
function __vue2_injectStyles$d(context) {
  for (let o in __cssModules$d) {
    this[o] = __cssModules$d[o];
  }
}
var FvlRadio = /* @__PURE__ */ function() {
  return __component__$d.exports;
}();
var render$c = function() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", { staticClass: "fvl-checkbox-wrapper", class: { "fvl-has-error": _vm.$parent.hasErrors(_vm.name) } }, [_c("input", { staticClass: "fvl-checkbox", class: { checked: _vm.checked, fieldClass: _vm.fieldClass }, attrs: { "id": _vm.id ? _vm.id : _vm.name, "name": _vm.name, "required": _vm.required, "readonly": _vm.readonly, "disabled": _vm.disabled, "type": "checkbox" }, domProps: { "checked": _vm.checked, "value": _vm.value }, on: { "change": function($event) {
    _vm.$emit("update:checked", $event.target.checked), _vm.$emit("changed"), _vm.$parent.dirty(_vm.name);
  } } }), _vm.label ? _c("label", { staticClass: "fvl-checkbox-label", class: _vm.labelClass, attrs: { "for": _vm.id ? _vm.id : _vm.name } }, [_c("span", { staticClass: "fvl-checkbox-outer" }), _vm._t("label_prefix"), _c("span", { domProps: { "innerHTML": _vm._s(_vm.label) } }), _vm._t("label_suffix")], 2) : _vm._e(), _vm._t("hint"), _vm._t("errors", function() {
    return [_c("validation-errors", { attrs: { "errors": _vm.$parent.getErrors(_vm.name) } })];
  }, { "errors": _vm.$parent.getErrors(_vm.name) })], 2);
};
var staticRenderFns$c = [];
const __vue2_script$c = {
  components: {
    ValidationErrors
  },
  props: {
    label: {
      type: String,
      required: false,
      default: null
    },
    name: {
      type: String,
      required: true
    },
    id: {
      type: String,
      required: false,
      default: null
    },
    checked: {
      type: Boolean,
      default: false
    },
    value: {
      type: String,
      required: false,
      default: null
    },
    fieldClass: {
      type: String,
      required: false,
      default: null
    },
    labelClass: {
      type: String,
      required: false,
      default: null
    },
    required: {
      type: Boolean,
      required: false,
      default: false
    },
    readonly: {
      type: Boolean,
      required: false,
      default: false
    },
    disabled: {
      type: Boolean,
      required: false,
      default: false
    }
  }
};
const __cssModules$c = {};
var __component__$c = /* @__PURE__ */ normalizeComponent(__vue2_script$c, render$c, staticRenderFns$c, false, __vue2_injectStyles$c, null, null, null);
function __vue2_injectStyles$c(context) {
  for (let o in __cssModules$c) {
    this[o] = __cssModules$c[o];
  }
}
var FvlCheckbox = /* @__PURE__ */ function() {
  return __component__$c.exports;
}();
var render$b = function() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", { staticClass: "fvl-switch-wrapper", class: { "fvl-has-error": _vm.$parent.hasErrors(_vm.name) } }, [_c("input", { staticClass: "fvl-switch hidden", class: { checked: _vm.checked, fieldClass: _vm.fieldClass }, attrs: { "id": _vm.id ? _vm.id : _vm.name, "name": _vm.name, "required": _vm.required, "readonly": _vm.readonly, "disabled": _vm.disabled, "type": "checkbox" }, domProps: { "checked": _vm.checked }, on: { "change": function($event) {
    _vm.$emit("update:checked", $event.target.checked), _vm.$emit("changed"), _vm.$parent.dirty(_vm.name);
  } } }), _vm.label ? _c("label", { staticClass: "fvl-switch-label", class: _vm.labelClass, attrs: { "for": _vm.id ? _vm.id : _vm.name } }, [_c("span", { staticClass: "fvl-switch-toggle" }), _c("div", { staticClass: "fvl-switch-text", domProps: { "innerHTML": _vm._s(_vm.label) } }), _vm._t("label_suffix")], 2) : _vm._e(), _vm._t("hint"), _vm._t("errors", function() {
    return [_c("validation-errors", { attrs: { "errors": _vm.$parent.getErrors(_vm.name) } })];
  }, { "errors": _vm.$parent.getErrors(_vm.name) })], 2);
};
var staticRenderFns$b = [];
const __vue2_script$b = {
  components: {
    ValidationErrors
  },
  props: {
    label: {
      type: String,
      required: false,
      default: null
    },
    name: {
      type: String,
      required: true
    },
    id: {
      type: String,
      required: false,
      default: null
    },
    checked: {
      default: false,
      validator: function(value) {
        return [0, 1, false, true, "0", "1"].indexOf(value) !== -1;
      }
    },
    fieldClass: {
      type: String,
      required: false,
      default: null
    },
    labelClass: {
      type: String,
      required: false,
      default: null
    },
    required: {
      type: Boolean,
      required: false,
      default: false
    },
    readonly: {
      type: Boolean,
      required: false,
      default: false
    },
    disabled: {
      type: Boolean,
      required: false,
      default: false
    }
  }
};
const __cssModules$b = {};
var __component__$b = /* @__PURE__ */ normalizeComponent(__vue2_script$b, render$b, staticRenderFns$b, false, __vue2_injectStyles$b, null, null, null);
function __vue2_injectStyles$b(context) {
  for (let o in __cssModules$b) {
    this[o] = __cssModules$b[o];
  }
}
var FvlSwitch = /* @__PURE__ */ function() {
  return __component__$b.exports;
}();
var render$a = function() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", { staticClass: "fvl-text-switch-wrapper", class: { "fvl-has-error": _vm.$parent.hasErrors(_vm.name) } }, [_c("input", { ref: "checkbox", staticClass: "fvl-text-switch hidden", class: { checked: _vm.checked, fieldClass: _vm.fieldClass }, attrs: { "id": _vm.id ? _vm.id : _vm.name, "name": _vm.name, "required": _vm.required, "readonly": _vm.readonly, "disabled": _vm.disabled, "type": "checkbox" }, domProps: { "checked": _vm.checked }, on: { "change": function($event) {
    _vm.$emit("update:checked", $event.target.checked), _vm.$emit("changed"), _vm.$parent.dirty(_vm.name);
  } } }), _vm.label ? _c("label", { staticClass: "fvl-text-switch-label" }, [_c("span", { domProps: { "innerHTML": _vm._s(_vm.label) } }), _vm._t("label_suffix")], 2) : _vm._e(), _c("span", { staticClass: "inline-block relative normal-case cursor-pointer" }, [_c("button", { staticClass: "fvl-text-switch-options-wrapper", attrs: { "type": "button" }, on: { "click": function($event) {
    return _vm.$refs.checkbox.click();
  } } }, [_c("div", { staticClass: "fvl-text-switch-option-1", class: !_vm.checked ? "active" : "", domProps: { "innerHTML": _vm._s(_vm.options[0]) } }), _c("div", { staticClass: "fvl-text-switch-option-2", class: { "active text-white": _vm.checked }, domProps: { "innerHTML": _vm._s(_vm.options[1]) } })]), _c("div", { staticClass: "fvl-text-switch-bg", class: { "fvl-text-switch-bg-selected": _vm.checked } })]), _vm._t("hint"), _vm._t("errors", function() {
    return [_c("validation-errors", { attrs: { "errors": _vm.$parent.getErrors(_vm.name) } })];
  }, { "errors": _vm.$parent.getErrors(_vm.name) })], 2);
};
var staticRenderFns$a = [];
const __vue2_script$a = {
  components: {
    ValidationErrors
  },
  props: {
    options: {
      type: Array,
      required: true,
      default: () => ["Off", "On"]
    },
    label: {
      type: String,
      required: false,
      default: ""
    },
    name: {
      type: String,
      required: true
    },
    id: {
      type: String,
      required: false,
      default: null
    },
    checked: {
      default: false,
      validator: function(value) {
        return [0, 1, false, true, "0", "1"].indexOf(value) !== -1;
      }
    },
    fieldClass: {
      type: String,
      required: false,
      default: null
    },
    labelClass: {
      type: String,
      required: false,
      default: null
    },
    required: {
      type: Boolean,
      required: false,
      default: false
    },
    readonly: {
      type: Boolean,
      required: false,
      default: false
    },
    disabled: {
      type: Boolean,
      required: false,
      default: false
    }
  }
};
const __cssModules$a = {};
var __component__$a = /* @__PURE__ */ normalizeComponent(__vue2_script$a, render$a, staticRenderFns$a, false, __vue2_injectStyles$a, null, null, null);
function __vue2_injectStyles$a(context) {
  for (let o in __cssModules$a) {
    this[o] = __cssModules$a[o];
  }
}
var FvlTextSwitch = /* @__PURE__ */ function() {
  return __component__$a.exports;
}();
var render$9 = function() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", { staticClass: "fvl-slider-wrapper", class: { "fvl-has-error": _vm.$parent.hasErrors(_vm.name) } }, [_vm.label ? _c("label", { staticClass: "fvl-slider-label", class: _vm.labelClass, attrs: { "for": _vm.name } }, [_c("span", { domProps: { "innerHTML": _vm._s(_vm.label) } }), _vm._t("label_suffix")], 2) : _vm._e(), _c("div", { staticClass: "fvl-slider-group" }, [_vm._t("prefix", function() {
    return [_vm.valuePosition == "left" ? _c("span", { staticClass: "fvl-slider-value fvl-slider-value-left" }, [_vm._v(_vm._s(_vm.value))]) : _vm._e()];
  }, { "value": _vm.value }), _c("div", { staticClass: "fvl-slider-container" }, [_c("input", { staticClass: "fvl-slider", class: _vm.fieldClass, attrs: { "id": _vm.id, "name": _vm.name, "min": _vm.min, "max": _vm.max, "required": _vm.required, "readonly": _vm.readonly, "disabled": _vm.disabled, "type": "range" }, domProps: { "value": _vm.value }, on: { "change": function($event) {
    _vm.$parent.dirty(_vm.name), _vm.$emit("changed");
  }, "input": function($event) {
    return _vm.$emit("update:value", $event.target.value);
  } } })]), _vm._t("suffix", function() {
    return [_vm.valuePosition == "right" ? _c("span", { staticClass: "fvl-slider-value fvl-slider-value-right" }, [_vm._v(_vm._s(_vm.value))]) : _vm._e()];
  }, { "value": _vm.value })], 2), _vm._t("hint"), _vm._t("errors", function() {
    return [_c("validation-errors", { attrs: { "errors": _vm.$parent.getErrors(_vm.name) } })];
  }, { "errors": _vm.$parent.getErrors(_vm.name) })], 2);
};
var staticRenderFns$9 = [];
const __vue2_script$9 = {
  components: {
    ValidationErrors
  },
  props: {
    label: {
      type: String,
      required: false,
      default: null
    },
    name: {
      type: String,
      required: true
    },
    id: {
      type: String,
      default: null
    },
    valuePosition: {
      type: String,
      default: "left",
      validator: function(value) {
        return ["left", "right", "top", "bottom"].indexOf(value) !== -1;
      }
    },
    value: {
      validator: (prop) => typeof prop === "string" || prop === null,
      default: "0"
    },
    min: {
      type: Number,
      required: false,
      default: null
    },
    max: {
      type: Number,
      required: false,
      default: null
    },
    placeholder: {
      type: String,
      required: false,
      default: null
    },
    fieldClass: {
      type: String,
      required: false,
      default: null
    },
    labelClass: {
      type: String,
      required: false,
      default: null
    },
    readonly: {
      type: Boolean,
      required: false,
      default: false
    },
    required: {
      type: Boolean,
      required: false,
      default: false
    },
    disabled: {
      type: Boolean,
      required: false,
      default: false
    }
  }
};
const __cssModules$9 = {};
var __component__$9 = /* @__PURE__ */ normalizeComponent(__vue2_script$9, render$9, staticRenderFns$9, false, __vue2_injectStyles$9, null, null, null);
function __vue2_injectStyles$9(context) {
  for (let o in __cssModules$9) {
    this[o] = __cssModules$9[o];
  }
}
var FvlSlider = /* @__PURE__ */ function() {
  return __component__$9.exports;
}();
var vueColor_min = { exports: {} };
(function(module, exports) {
  !function(e, t) {
    module.exports = t();
  }(typeof self != "undefined" ? self : commonjsGlobal, function() {
    return function(e) {
      function t(r) {
        if (n[r])
          return n[r].exports;
        var i = n[r] = { i: r, l: false, exports: {} };
        return e[r].call(i.exports, i, i.exports, t), i.l = true, i.exports;
      }
      var n = {};
      return t.m = e, t.c = n, t.d = function(e2, n2, r) {
        t.o(e2, n2) || Object.defineProperty(e2, n2, { configurable: false, enumerable: true, get: r });
      }, t.n = function(e2) {
        var n2 = e2 && e2.__esModule ? function() {
          return e2.default;
        } : function() {
          return e2;
        };
        return t.d(n2, "a", n2), n2;
      }, t.o = function(e2, t2) {
        return Object.prototype.hasOwnProperty.call(e2, t2);
      }, t.p = "", t(t.s = 60);
    }([function(e, t) {
      function n(e2, t2) {
        var n2 = e2[1] || "", i = e2[3];
        if (!i)
          return n2;
        if (t2 && typeof btoa == "function") {
          var o = r(i);
          return [n2].concat(i.sources.map(function(e3) {
            return "/*# sourceURL=" + i.sourceRoot + e3 + " */";
          })).concat([o]).join("\n");
        }
        return [n2].join("\n");
      }
      function r(e2) {
        return "/*# sourceMappingURL=data:application/json;charset=utf-8;base64," + btoa(unescape(encodeURIComponent(JSON.stringify(e2)))) + " */";
      }
      e.exports = function(e2) {
        var t2 = [];
        return t2.toString = function() {
          return this.map(function(t3) {
            var r2 = n(t3, e2);
            return t3[2] ? "@media " + t3[2] + "{" + r2 + "}" : r2;
          }).join("");
        }, t2.i = function(e3, n2) {
          typeof e3 == "string" && (e3 = [[null, e3, ""]]);
          for (var r2 = {}, i = 0; i < this.length; i++) {
            var o = this[i][0];
            typeof o == "number" && (r2[o] = true);
          }
          for (i = 0; i < e3.length; i++) {
            var a = e3[i];
            typeof a[0] == "number" && r2[a[0]] || (n2 && !a[2] ? a[2] = n2 : n2 && (a[2] = "(" + a[2] + ") and (" + n2 + ")"), t2.push(a));
          }
        }, t2;
      };
    }, function(e, t, n) {
      function r(e2) {
        for (var t2 = 0; t2 < e2.length; t2++) {
          var n2 = e2[t2], r2 = u[n2.id];
          if (r2) {
            r2.refs++;
            for (var i2 = 0; i2 < r2.parts.length; i2++)
              r2.parts[i2](n2.parts[i2]);
            for (; i2 < n2.parts.length; i2++)
              r2.parts.push(o(n2.parts[i2]));
            r2.parts.length > n2.parts.length && (r2.parts.length = n2.parts.length);
          } else {
            for (var a2 = [], i2 = 0; i2 < n2.parts.length; i2++)
              a2.push(o(n2.parts[i2]));
            u[n2.id] = { id: n2.id, refs: 1, parts: a2 };
          }
        }
      }
      function i() {
        var e2 = document.createElement("style");
        return e2.type = "text/css", f.appendChild(e2), e2;
      }
      function o(e2) {
        var t2, n2, r2 = document.querySelector("style[" + b + '~="' + e2.id + '"]');
        if (r2) {
          if (p)
            return v;
          r2.parentNode.removeChild(r2);
        }
        if (x) {
          var o2 = h++;
          r2 = d || (d = i()), t2 = a.bind(null, r2, o2, false), n2 = a.bind(null, r2, o2, true);
        } else
          r2 = i(), t2 = s.bind(null, r2), n2 = function() {
            r2.parentNode.removeChild(r2);
          };
        return t2(e2), function(r3) {
          if (r3) {
            if (r3.css === e2.css && r3.media === e2.media && r3.sourceMap === e2.sourceMap)
              return;
            t2(e2 = r3);
          } else
            n2();
        };
      }
      function a(e2, t2, n2, r2) {
        var i2 = n2 ? "" : r2.css;
        if (e2.styleSheet)
          e2.styleSheet.cssText = m(t2, i2);
        else {
          var o2 = document.createTextNode(i2), a2 = e2.childNodes;
          a2[t2] && e2.removeChild(a2[t2]), a2.length ? e2.insertBefore(o2, a2[t2]) : e2.appendChild(o2);
        }
      }
      function s(e2, t2) {
        var n2 = t2.css, r2 = t2.media, i2 = t2.sourceMap;
        if (r2 && e2.setAttribute("media", r2), g.ssrId && e2.setAttribute(b, t2.id), i2 && (n2 += "\n/*# sourceURL=" + i2.sources[0] + " */", n2 += "\n/*# sourceMappingURL=data:application/json;base64," + btoa(unescape(encodeURIComponent(JSON.stringify(i2)))) + " */"), e2.styleSheet)
          e2.styleSheet.cssText = n2;
        else {
          for (; e2.firstChild; )
            e2.removeChild(e2.firstChild);
          e2.appendChild(document.createTextNode(n2));
        }
      }
      var c = typeof document != "undefined";
      if (typeof DEBUG != "undefined" && DEBUG && !c)
        throw new Error("vue-style-loader cannot be used in a non-browser environment. Use { target: 'node' } in your Webpack config to indicate a server-rendering environment.");
      var l = n(64), u = {}, f = c && (document.head || document.getElementsByTagName("head")[0]), d = null, h = 0, p = false, v = function() {
      }, g = null, b = "data-vue-ssr-id", x = typeof navigator != "undefined" && /msie [6-9]\b/.test(navigator.userAgent.toLowerCase());
      e.exports = function(e2, t2, n2, i2) {
        p = n2, g = i2 || {};
        var o2 = l(e2, t2);
        return r(o2), function(t3) {
          for (var n3 = [], i3 = 0; i3 < o2.length; i3++) {
            var a2 = o2[i3], s2 = u[a2.id];
            s2.refs--, n3.push(s2);
          }
          t3 ? (o2 = l(e2, t3), r(o2)) : o2 = [];
          for (var i3 = 0; i3 < n3.length; i3++) {
            var s2 = n3[i3];
            if (s2.refs === 0) {
              for (var c2 = 0; c2 < s2.parts.length; c2++)
                s2.parts[c2]();
              delete u[s2.id];
            }
          }
        };
      };
      var m = function() {
        var e2 = [];
        return function(t2, n2) {
          return e2[t2] = n2, e2.filter(Boolean).join("\n");
        };
      }();
    }, function(e, t) {
      e.exports = function(e2, t2, n, r, i, o) {
        var a, s = e2 = e2 || {}, c = typeof e2.default;
        c !== "object" && c !== "function" || (a = e2, s = e2.default);
        var l = typeof s == "function" ? s.options : s;
        t2 && (l.render = t2.render, l.staticRenderFns = t2.staticRenderFns, l._compiled = true), n && (l.functional = true), i && (l._scopeId = i);
        var u;
        if (o ? (u = function(e3) {
          e3 = e3 || this.$vnode && this.$vnode.ssrContext || this.parent && this.parent.$vnode && this.parent.$vnode.ssrContext, e3 || typeof __VUE_SSR_CONTEXT__ == "undefined" || (e3 = __VUE_SSR_CONTEXT__), r && r.call(this, e3), e3 && e3._registeredComponents && e3._registeredComponents.add(o);
        }, l._ssrRegister = u) : r && (u = r), u) {
          var f = l.functional, d = f ? l.render : l.beforeCreate;
          f ? (l._injectStyles = u, l.render = function(e3, t3) {
            return u.call(t3), d(e3, t3);
          }) : l.beforeCreate = d ? [].concat(d, u) : [u];
        }
        return { esModule: a, exports: s, options: l };
      };
    }, function(e, t, n) {
      function r(e2, t2) {
        var n2, r2 = e2 && e2.a;
        !(n2 = e2 && e2.hsl ? (0, o.default)(e2.hsl) : e2 && e2.hex && e2.hex.length > 0 ? (0, o.default)(e2.hex) : e2 && e2.hsv ? (0, o.default)(e2.hsv) : e2 && e2.rgba ? (0, o.default)(e2.rgba) : e2 && e2.rgb ? (0, o.default)(e2.rgb) : (0, o.default)(e2)) || n2._a !== void 0 && n2._a !== null || n2.setAlpha(r2 || 1);
        var i2 = n2.toHsl(), a = n2.toHsv();
        return i2.s === 0 && (a.h = i2.h = e2.h || e2.hsl && e2.hsl.h || t2 || 0), { hsl: i2, hex: n2.toHexString().toUpperCase(), hex8: n2.toHex8String().toUpperCase(), rgba: n2.toRgb(), hsv: a, oldHue: e2.h || t2 || i2.h, source: e2.source, a: e2.a || n2.getAlpha() };
      }
      Object.defineProperty(t, "__esModule", { value: true });
      var i = n(65), o = function(e2) {
        return e2 && e2.__esModule ? e2 : { default: e2 };
      }(i);
      t.default = { props: ["value"], data: function() {
        return { val: r(this.value) };
      }, computed: { colors: { get: function() {
        return this.val;
      }, set: function(e2) {
        this.val = e2, this.$emit("input", e2);
      } } }, watch: { value: function(e2) {
        this.val = r(e2);
      } }, methods: { colorChange: function(e2, t2) {
        this.oldHue = this.colors.hsl.h, this.colors = r(e2, t2 || this.oldHue);
      }, isValidHex: function(e2) {
        return (0, o.default)(e2).isValid();
      }, simpleCheckForValidColor: function(e2) {
        for (var t2 = ["r", "g", "b", "a", "h", "s", "l", "v"], n2 = 0, r2 = 0, i2 = 0; i2 < t2.length; i2++) {
          var o2 = t2[i2];
          e2[o2] && (n2++, isNaN(e2[o2]) || r2++);
        }
        if (n2 === r2)
          return e2;
      }, paletteUpperCase: function(e2) {
        return e2.map(function(e3) {
          return e3.toUpperCase();
        });
      }, isTransparent: function(e2) {
        return (0, o.default)(e2).getAlpha() === 0;
      } } };
    }, function(e, t) {
      var n = e.exports = typeof window != "undefined" && window.Math == Math ? window : typeof self != "undefined" && self.Math == Math ? self : Function("return this")();
      typeof __g == "number" && (__g = n);
    }, function(e, t, n) {
      function r(e2) {
        n(66);
      }
      Object.defineProperty(t, "__esModule", { value: true });
      var i = n(36), o = n.n(i);
      for (var a in i)
        a !== "default" && function(e2) {
          n.d(t, e2, function() {
            return i[e2];
          });
        }(a);
      var s = n(68), l = n(2), u = r, f = l(o.a, s.a, false, u, null, null);
      f.options.__file = "src/components/common/EditableInput.vue", t.default = f.exports;
    }, function(e, t) {
      var n = {}.hasOwnProperty;
      e.exports = function(e2, t2) {
        return n.call(e2, t2);
      };
    }, function(e, t, n) {
      var r = n(8), i = n(18);
      e.exports = n(9) ? function(e2, t2, n2) {
        return r.f(e2, t2, i(1, n2));
      } : function(e2, t2, n2) {
        return e2[t2] = n2, e2;
      };
    }, function(e, t, n) {
      var r = n(16), i = n(42), o = n(25), a = Object.defineProperty;
      t.f = n(9) ? Object.defineProperty : function(e2, t2, n2) {
        if (r(e2), t2 = o(t2, true), r(n2), i)
          try {
            return a(e2, t2, n2);
          } catch (e3) {
          }
        if ("get" in n2 || "set" in n2)
          throw TypeError("Accessors not supported!");
        return "value" in n2 && (e2[t2] = n2.value), e2;
      };
    }, function(e, t, n) {
      e.exports = !n(17)(function() {
        return Object.defineProperty({}, "a", { get: function() {
          return 7;
        } }).a != 7;
      });
    }, function(e, t, n) {
      var r = n(90), i = n(24);
      e.exports = function(e2) {
        return r(i(e2));
      };
    }, function(e, t, n) {
      var r = n(29)("wks"), i = n(19), o = n(4).Symbol, a = typeof o == "function";
      (e.exports = function(e2) {
        return r[e2] || (r[e2] = a && o[e2] || (a ? o : i)("Symbol." + e2));
      }).store = r;
    }, function(e, t) {
      e.exports = function(e2) {
        return typeof e2 == "object" ? e2 !== null : typeof e2 == "function";
      };
    }, function(e, t, n) {
      function r(e2) {
        n(111);
      }
      Object.defineProperty(t, "__esModule", { value: true });
      var i = n(51), o = n.n(i);
      for (var a in i)
        a !== "default" && function(e2) {
          n.d(t, e2, function() {
            return i[e2];
          });
        }(a);
      var s = n(113), l = n(2), u = r, f = l(o.a, s.a, false, u, null, null);
      f.options.__file = "src/components/common/Hue.vue", t.default = f.exports;
    }, function(e, t) {
      e.exports = true;
    }, function(e, t) {
      var n = e.exports = { version: "2.6.11" };
      typeof __e == "number" && (__e = n);
    }, function(e, t, n) {
      var r = n(12);
      e.exports = function(e2) {
        if (!r(e2))
          throw TypeError(e2 + " is not an object!");
        return e2;
      };
    }, function(e, t) {
      e.exports = function(e2) {
        try {
          return !!e2();
        } catch (e3) {
          return true;
        }
      };
    }, function(e, t) {
      e.exports = function(e2, t2) {
        return { enumerable: !(1 & e2), configurable: !(2 & e2), writable: !(4 & e2), value: t2 };
      };
    }, function(e, t) {
      var n = 0, r = Math.random();
      e.exports = function(e2) {
        return "Symbol(".concat(e2 === void 0 ? "" : e2, ")_", (++n + r).toString(36));
      };
    }, function(e, t, n) {
      function r(e2) {
        n(123);
      }
      Object.defineProperty(t, "__esModule", { value: true });
      var i = n(54), o = n.n(i);
      for (var a in i)
        a !== "default" && function(e2) {
          n.d(t, e2, function() {
            return i[e2];
          });
        }(a);
      var s = n(127), l = n(2), u = r, f = l(o.a, s.a, false, u, null, null);
      f.options.__file = "src/components/common/Saturation.vue", t.default = f.exports;
    }, function(e, t, n) {
      function r(e2) {
        n(128);
      }
      Object.defineProperty(t, "__esModule", { value: true });
      var i = n(55), o = n.n(i);
      for (var a in i)
        a !== "default" && function(e2) {
          n.d(t, e2, function() {
            return i[e2];
          });
        }(a);
      var s = n(133), l = n(2), u = r, f = l(o.a, s.a, false, u, null, null);
      f.options.__file = "src/components/common/Alpha.vue", t.default = f.exports;
    }, function(e, t, n) {
      function r(e2) {
        n(130);
      }
      Object.defineProperty(t, "__esModule", { value: true });
      var i = n(56), o = n.n(i);
      for (var a in i)
        a !== "default" && function(e2) {
          n.d(t, e2, function() {
            return i[e2];
          });
        }(a);
      var s = n(132), l = n(2), u = r, f = l(o.a, s.a, false, u, null, null);
      f.options.__file = "src/components/common/Checkboard.vue", t.default = f.exports;
    }, function(e, t) {
      var n = Math.ceil, r = Math.floor;
      e.exports = function(e2) {
        return isNaN(e2 = +e2) ? 0 : (e2 > 0 ? r : n)(e2);
      };
    }, function(e, t) {
      e.exports = function(e2) {
        if (e2 == void 0)
          throw TypeError("Can't call method on  " + e2);
        return e2;
      };
    }, function(e, t, n) {
      var r = n(12);
      e.exports = function(e2, t2) {
        if (!r(e2))
          return e2;
        var n2, i;
        if (t2 && typeof (n2 = e2.toString) == "function" && !r(i = n2.call(e2)))
          return i;
        if (typeof (n2 = e2.valueOf) == "function" && !r(i = n2.call(e2)))
          return i;
        if (!t2 && typeof (n2 = e2.toString) == "function" && !r(i = n2.call(e2)))
          return i;
        throw TypeError("Can't convert object to primitive value");
      };
    }, function(e, t) {
      e.exports = {};
    }, function(e, t, n) {
      var r = n(46), i = n(30);
      e.exports = Object.keys || function(e2) {
        return r(e2, i);
      };
    }, function(e, t, n) {
      var r = n(29)("keys"), i = n(19);
      e.exports = function(e2) {
        return r[e2] || (r[e2] = i(e2));
      };
    }, function(e, t, n) {
      var r = n(15), i = n(4), o = i["__core-js_shared__"] || (i["__core-js_shared__"] = {});
      (e.exports = function(e2, t2) {
        return o[e2] || (o[e2] = t2 !== void 0 ? t2 : {});
      })("versions", []).push({ version: r.version, mode: n(14) ? "pure" : "global", copyright: "\xA9 2019 Denis Pushkarev (zloirock.ru)" });
    }, function(e, t) {
      e.exports = "constructor,hasOwnProperty,isPrototypeOf,propertyIsEnumerable,toLocaleString,toString,valueOf".split(",");
    }, function(e, t, n) {
      var r = n(8).f, i = n(6), o = n(11)("toStringTag");
      e.exports = function(e2, t2, n2) {
        e2 && !i(e2 = n2 ? e2 : e2.prototype, o) && r(e2, o, { configurable: true, value: t2 });
      };
    }, function(e, t, n) {
      t.f = n(11);
    }, function(e, t, n) {
      var r = n(4), i = n(15), o = n(14), a = n(32), s = n(8).f;
      e.exports = function(e2) {
        var t2 = i.Symbol || (i.Symbol = o ? {} : r.Symbol || {});
        e2.charAt(0) == "_" || e2 in t2 || s(t2, e2, { value: a.f(e2) });
      };
    }, function(e, t) {
      t.f = {}.propertyIsEnumerable;
    }, function(e, t, n) {
      function r(e2) {
        return e2 && e2.__esModule ? e2 : { default: e2 };
      }
      Object.defineProperty(t, "__esModule", { value: true });
      var i = n(3), o = r(i), a = n(5), s = r(a), c = ["#4D4D4D", "#999999", "#FFFFFF", "#F44E3B", "#FE9200", "#FCDC00", "#DBDF00", "#A4DD00", "#68CCCA", "#73D8FF", "#AEA1FF", "#FDA1FF", "#333333", "#808080", "#CCCCCC", "#D33115", "#E27300", "#FCC400", "#B0BC00", "#68BC00", "#16A5A5", "#009CE0", "#7B64FF", "#FA28FF", "#000000", "#666666", "#B3B3B3", "#9F0500", "#C45100", "#FB9E00", "#808900", "#194D33", "#0C797D", "#0062B1", "#653294", "#AB149E"];
      t.default = { name: "Compact", mixins: [o.default], props: { palette: { type: Array, default: function() {
        return c;
      } } }, components: { "ed-in": s.default }, computed: { pick: function() {
        return this.colors.hex.toUpperCase();
      } }, methods: { handlerClick: function(e2) {
        this.colorChange({ hex: e2, source: "hex" });
      } } };
    }, function(e, t, n) {
      Object.defineProperty(t, "__esModule", { value: true }), t.default = { name: "editableInput", props: { label: String, labelText: String, desc: String, value: [String, Number], max: Number, min: Number, arrowOffset: { type: Number, default: 1 } }, computed: { val: { get: function() {
        return this.value;
      }, set: function(e2) {
        if (!(this.max !== void 0 && +e2 > this.max))
          return e2;
        this.$refs.input.value = this.max;
      } }, labelId: function() {
        return "input__label__" + this.label + "__" + Math.random().toString().slice(2, 5);
      }, labelSpanText: function() {
        return this.labelText || this.label;
      } }, methods: { update: function(e2) {
        this.handleChange(e2.target.value);
      }, handleChange: function(e2) {
        var t2 = {};
        t2[this.label] = e2, t2.hex === void 0 && t2["#"] === void 0 ? this.$emit("change", t2) : e2.length > 5 && this.$emit("change", t2);
      }, handleKeyDown: function(e2) {
        var t2 = this.val, n2 = Number(t2);
        if (n2) {
          var r = this.arrowOffset || 1;
          e2.keyCode === 38 && (t2 = n2 + r, this.handleChange(t2), e2.preventDefault()), e2.keyCode === 40 && (t2 = n2 - r, this.handleChange(t2), e2.preventDefault());
        }
      } } };
    }, function(e, t, n) {
      Object.defineProperty(t, "__esModule", { value: true });
      var r = n(3), i = function(e2) {
        return e2 && e2.__esModule ? e2 : { default: e2 };
      }(r), o = ["#FFFFFF", "#F2F2F2", "#E6E6E6", "#D9D9D9", "#CCCCCC", "#BFBFBF", "#B3B3B3", "#A6A6A6", "#999999", "#8C8C8C", "#808080", "#737373", "#666666", "#595959", "#4D4D4D", "#404040", "#333333", "#262626", "#0D0D0D", "#000000"];
      t.default = { name: "Grayscale", mixins: [i.default], props: { palette: { type: Array, default: function() {
        return o;
      } } }, components: {}, computed: { pick: function() {
        return this.colors.hex.toUpperCase();
      } }, methods: { handlerClick: function(e2) {
        this.colorChange({ hex: e2, source: "hex" });
      } } };
    }, function(e, t, n) {
      function r(e2) {
        return e2 && e2.__esModule ? e2 : { default: e2 };
      }
      Object.defineProperty(t, "__esModule", { value: true });
      var i = n(5), o = r(i), a = n(3), s = r(a);
      t.default = { name: "Material", mixins: [s.default], components: { "ed-in": o.default }, methods: { onChange: function(e2) {
        e2 && (e2.hex ? this.isValidHex(e2.hex) && this.colorChange({ hex: e2.hex, source: "hex" }) : (e2.r || e2.g || e2.b) && this.colorChange({ r: e2.r || this.colors.rgba.r, g: e2.g || this.colors.rgba.g, b: e2.b || this.colors.rgba.b, a: e2.a || this.colors.rgba.a, source: "rgba" }));
      } } };
    }, function(e, t, n) {
      function r(e2) {
        return e2 && e2.__esModule ? e2 : { default: e2 };
      }
      Object.defineProperty(t, "__esModule", { value: true });
      var i = n(81), o = r(i), a = n(3), s = r(a), c = n(13), l = r(c);
      t.default = { name: "Slider", mixins: [s.default], props: { swatches: { type: Array, default: function() {
        return [{ s: 0.5, l: 0.8 }, { s: 0.5, l: 0.65 }, { s: 0.5, l: 0.5 }, { s: 0.5, l: 0.35 }, { s: 0.5, l: 0.2 }];
      } } }, components: { hue: l.default }, computed: { normalizedSwatches: function() {
        return this.swatches.map(function(e2) {
          return (e2 === void 0 ? "undefined" : (0, o.default)(e2)) !== "object" ? { s: 0.5, l: e2 } : e2;
        });
      } }, methods: { isActive: function(e2, t2) {
        var n2 = this.colors.hsl;
        return n2.l === 1 && e2.l === 1 || (n2.l === 0 && e2.l === 0 || Math.abs(n2.l - e2.l) < 0.01 && Math.abs(n2.s - e2.s) < 0.01);
      }, hueChange: function(e2) {
        this.colorChange(e2);
      }, handleSwClick: function(e2, t2) {
        this.colorChange({ h: this.colors.hsl.h, s: t2.s, l: t2.l, source: "hsl" });
      } } };
    }, function(e, t, n) {
      var r = n(14), i = n(41), o = n(44), a = n(7), s = n(26), c = n(88), l = n(31), u = n(95), f = n(11)("iterator"), d = !([].keys && "next" in [].keys()), h = function() {
        return this;
      };
      e.exports = function(e2, t2, n2, p, v, g, b) {
        c(n2, t2, p);
        var x, m, _, w = function(e3) {
          if (!d && e3 in F)
            return F[e3];
          switch (e3) {
            case "keys":
            case "values":
              return function() {
                return new n2(this, e3);
              };
          }
          return function() {
            return new n2(this, e3);
          };
        }, y = t2 + " Iterator", C = v == "values", k = false, F = e2.prototype, S = F[f] || F["@@iterator"] || v && F[v], A = S || w(v), O = v ? C ? w("entries") : A : void 0, E = t2 == "Array" ? F.entries || S : S;
        if (E && (_ = u(E.call(new e2()))) !== Object.prototype && _.next && (l(_, y, true), r || typeof _[f] == "function" || a(_, f, h)), C && S && S.name !== "values" && (k = true, A = function() {
          return S.call(this);
        }), r && !b || !d && !k && F[f] || a(F, f, A), s[t2] = A, s[y] = h, v)
          if (x = { values: C ? A : w("values"), keys: g ? A : w("keys"), entries: O }, b)
            for (m in x)
              m in F || o(F, m, x[m]);
          else
            i(i.P + i.F * (d || k), t2, x);
        return x;
      };
    }, function(e, t, n) {
      var r = n(4), i = n(15), o = n(86), a = n(7), s = n(6), c = function(e2, t2, n2) {
        var l, u, f, d = e2 & c.F, h = e2 & c.G, p = e2 & c.S, v = e2 & c.P, g = e2 & c.B, b = e2 & c.W, x = h ? i : i[t2] || (i[t2] = {}), m = x.prototype, _ = h ? r : p ? r[t2] : (r[t2] || {}).prototype;
        h && (n2 = t2);
        for (l in n2)
          (u = !d && _ && _[l] !== void 0) && s(x, l) || (f = u ? _[l] : n2[l], x[l] = h && typeof _[l] != "function" ? n2[l] : g && u ? o(f, r) : b && _[l] == f ? function(e3) {
            var t3 = function(t4, n3, r2) {
              if (this instanceof e3) {
                switch (arguments.length) {
                  case 0:
                    return new e3();
                  case 1:
                    return new e3(t4);
                  case 2:
                    return new e3(t4, n3);
                }
                return new e3(t4, n3, r2);
              }
              return e3.apply(this, arguments);
            };
            return t3.prototype = e3.prototype, t3;
          }(f) : v && typeof f == "function" ? o(Function.call, f) : f, v && ((x.virtual || (x.virtual = {}))[l] = f, e2 & c.R && m && !m[l] && a(m, l, f)));
      };
      c.F = 1, c.G = 2, c.S = 4, c.P = 8, c.B = 16, c.W = 32, c.U = 64, c.R = 128, e.exports = c;
    }, function(e, t, n) {
      e.exports = !n(9) && !n(17)(function() {
        return Object.defineProperty(n(43)("div"), "a", { get: function() {
          return 7;
        } }).a != 7;
      });
    }, function(e, t, n) {
      var r = n(12), i = n(4).document, o = r(i) && r(i.createElement);
      e.exports = function(e2) {
        return o ? i.createElement(e2) : {};
      };
    }, function(e, t, n) {
      e.exports = n(7);
    }, function(e, t, n) {
      var r = n(16), i = n(89), o = n(30), a = n(28)("IE_PROTO"), s = function() {
      }, c = function() {
        var e2, t2 = n(43)("iframe"), r2 = o.length;
        for (t2.style.display = "none", n(94).appendChild(t2), t2.src = "javascript:", e2 = t2.contentWindow.document, e2.open(), e2.write("<script>document.F=Object<\/script>"), e2.close(), c = e2.F; r2--; )
          delete c.prototype[o[r2]];
        return c();
      };
      e.exports = Object.create || function(e2, t2) {
        var n2;
        return e2 !== null ? (s.prototype = r(e2), n2 = new s(), s.prototype = null, n2[a] = e2) : n2 = c(), t2 === void 0 ? n2 : i(n2, t2);
      };
    }, function(e, t, n) {
      var r = n(6), i = n(10), o = n(91)(false), a = n(28)("IE_PROTO");
      e.exports = function(e2, t2) {
        var n2, s = i(e2), c = 0, l = [];
        for (n2 in s)
          n2 != a && r(s, n2) && l.push(n2);
        for (; t2.length > c; )
          r(s, n2 = t2[c++]) && (~o(l, n2) || l.push(n2));
        return l;
      };
    }, function(e, t) {
      var n = {}.toString;
      e.exports = function(e2) {
        return n.call(e2).slice(8, -1);
      };
    }, function(e, t, n) {
      var r = n(24);
      e.exports = function(e2) {
        return Object(r(e2));
      };
    }, function(e, t) {
      t.f = Object.getOwnPropertySymbols;
    }, function(e, t, n) {
      var r = n(46), i = n(30).concat("length", "prototype");
      t.f = Object.getOwnPropertyNames || function(e2) {
        return r(e2, i);
      };
    }, function(e, t, n) {
      Object.defineProperty(t, "__esModule", { value: true }), t.default = { name: "Hue", props: { value: Object, direction: { type: String, default: "horizontal" } }, data: function() {
        return { oldHue: 0, pullDirection: "" };
      }, computed: { colors: function() {
        var e2 = this.value.hsl.h;
        return e2 !== 0 && e2 - this.oldHue > 0 && (this.pullDirection = "right"), e2 !== 0 && e2 - this.oldHue < 0 && (this.pullDirection = "left"), this.oldHue = e2, this.value;
      }, directionClass: function() {
        return { "vc-hue--horizontal": this.direction === "horizontal", "vc-hue--vertical": this.direction === "vertical" };
      }, pointerTop: function() {
        return this.direction === "vertical" ? this.colors.hsl.h === 0 && this.pullDirection === "right" ? 0 : -100 * this.colors.hsl.h / 360 + 100 + "%" : 0;
      }, pointerLeft: function() {
        return this.direction === "vertical" ? 0 : this.colors.hsl.h === 0 && this.pullDirection === "right" ? "100%" : 100 * this.colors.hsl.h / 360 + "%";
      } }, methods: { handleChange: function(e2, t2) {
        !t2 && e2.preventDefault();
        var n2 = this.$refs.container;
        if (n2) {
          var r, i, o = n2.clientWidth, a = n2.clientHeight, s = n2.getBoundingClientRect().left + window.pageXOffset, c = n2.getBoundingClientRect().top + window.pageYOffset, l = e2.pageX || (e2.touches ? e2.touches[0].pageX : 0), u = e2.pageY || (e2.touches ? e2.touches[0].pageY : 0), f = l - s, d = u - c;
          this.direction === "vertical" ? (d < 0 ? r = 360 : d > a ? r = 0 : (i = -100 * d / a + 100, r = 360 * i / 100), this.colors.hsl.h !== r && this.$emit("change", { h: r, s: this.colors.hsl.s, l: this.colors.hsl.l, a: this.colors.hsl.a, source: "hsl" })) : (f < 0 ? r = 0 : f > o ? r = 360 : (i = 100 * f / o, r = 360 * i / 100), this.colors.hsl.h !== r && this.$emit("change", { h: r, s: this.colors.hsl.s, l: this.colors.hsl.l, a: this.colors.hsl.a, source: "hsl" }));
        }
      }, handleMouseDown: function(e2) {
        this.handleChange(e2, true), window.addEventListener("mousemove", this.handleChange), window.addEventListener("mouseup", this.handleMouseUp);
      }, handleMouseUp: function(e2) {
        this.unbindEventListeners();
      }, unbindEventListeners: function() {
        window.removeEventListener("mousemove", this.handleChange), window.removeEventListener("mouseup", this.handleMouseUp);
      } } };
    }, function(e, t, n) {
      function r(e2) {
        return e2 && e2.__esModule ? e2 : { default: e2 };
      }
      Object.defineProperty(t, "__esModule", { value: true });
      var i = n(118), o = r(i), a = n(3), s = r(a), c = ["red", "pink", "purple", "deepPurple", "indigo", "blue", "lightBlue", "cyan", "teal", "green", "lightGreen", "lime", "yellow", "amber", "orange", "deepOrange", "brown", "blueGrey", "black"], l = ["900", "700", "500", "300", "100"], u = function() {
        var e2 = [];
        return c.forEach(function(t2) {
          var n2 = [];
          t2.toLowerCase() === "black" || t2.toLowerCase() === "white" ? n2 = n2.concat(["#000000", "#FFFFFF"]) : l.forEach(function(e3) {
            var r2 = o.default[t2][e3];
            n2.push(r2.toUpperCase());
          }), e2.push(n2);
        }), e2;
      }();
      t.default = { name: "Swatches", mixins: [s.default], props: { palette: { type: Array, default: function() {
        return u;
      } } }, computed: { pick: function() {
        return this.colors.hex;
      } }, methods: { equal: function(e2) {
        return e2.toLowerCase() === this.colors.hex.toLowerCase();
      }, handlerClick: function(e2) {
        this.colorChange({ hex: e2, source: "hex" });
      } } };
    }, function(e, t, n) {
      function r(e2) {
        return e2 && e2.__esModule ? e2 : { default: e2 };
      }
      Object.defineProperty(t, "__esModule", { value: true });
      var i = n(3), o = r(i), a = n(5), s = r(a), c = n(20), l = r(c), u = n(13), f = r(u), d = n(21), h = r(d);
      t.default = { name: "Photoshop", mixins: [o.default], props: { head: { type: String, default: "Color Picker" }, disableFields: { type: Boolean, default: false }, hasResetButton: { type: Boolean, default: false }, acceptLabel: { type: String, default: "OK" }, cancelLabel: { type: String, default: "Cancel" }, resetLabel: { type: String, default: "Reset" }, newLabel: { type: String, default: "new" }, currentLabel: { type: String, default: "current" } }, components: { saturation: l.default, hue: f.default, alpha: h.default, "ed-in": s.default }, data: function() {
        return { currentColor: "#FFF" };
      }, computed: { hsv: function() {
        var e2 = this.colors.hsv;
        return { h: e2.h.toFixed(), s: (100 * e2.s).toFixed(), v: (100 * e2.v).toFixed() };
      }, hex: function() {
        var e2 = this.colors.hex;
        return e2 && e2.replace("#", "");
      } }, created: function() {
        this.currentColor = this.colors.hex;
      }, methods: { childChange: function(e2) {
        this.colorChange(e2);
      }, inputChange: function(e2) {
        e2 && (e2["#"] ? this.isValidHex(e2["#"]) && this.colorChange({ hex: e2["#"], source: "hex" }) : e2.r || e2.g || e2.b || e2.a ? this.colorChange({ r: e2.r || this.colors.rgba.r, g: e2.g || this.colors.rgba.g, b: e2.b || this.colors.rgba.b, a: e2.a || this.colors.rgba.a, source: "rgba" }) : (e2.h || e2.s || e2.v) && this.colorChange({ h: e2.h || this.colors.hsv.h, s: e2.s / 100 || this.colors.hsv.s, v: e2.v / 100 || this.colors.hsv.v, source: "hsv" }));
      }, clickCurrentColor: function() {
        this.colorChange({ hex: this.currentColor, source: "hex" });
      }, handleAccept: function() {
        this.$emit("ok");
      }, handleCancel: function() {
        this.$emit("cancel");
      }, handleReset: function() {
        this.$emit("reset");
      } } };
    }, function(e, t, n) {
      function r(e2) {
        return e2 && e2.__esModule ? e2 : { default: e2 };
      }
      Object.defineProperty(t, "__esModule", { value: true });
      var i = n(125), o = r(i), a = n(126), s = r(a);
      t.default = { name: "Saturation", props: { value: Object }, computed: { colors: function() {
        return this.value;
      }, bgColor: function() {
        return "hsl(" + this.colors.hsv.h + ", 100%, 50%)";
      }, pointerTop: function() {
        return -100 * this.colors.hsv.v + 1 + 100 + "%";
      }, pointerLeft: function() {
        return 100 * this.colors.hsv.s + "%";
      } }, methods: { throttle: (0, s.default)(function(e2, t2) {
        e2(t2);
      }, 20, { leading: true, trailing: false }), handleChange: function(e2, t2) {
        !t2 && e2.preventDefault();
        var n2 = this.$refs.container;
        if (n2) {
          var r2 = n2.clientWidth, i2 = n2.clientHeight, a2 = n2.getBoundingClientRect().left + window.pageXOffset, s2 = n2.getBoundingClientRect().top + window.pageYOffset, c = e2.pageX || (e2.touches ? e2.touches[0].pageX : 0), l = e2.pageY || (e2.touches ? e2.touches[0].pageY : 0), u = (0, o.default)(c - a2, 0, r2), f = (0, o.default)(l - s2, 0, i2), d = u / r2, h = (0, o.default)(-f / i2 + 1, 0, 1);
          this.throttle(this.onChange, { h: this.colors.hsv.h, s: d, v: h, a: this.colors.hsv.a, source: "hsva" });
        }
      }, onChange: function(e2) {
        this.$emit("change", e2);
      }, handleMouseDown: function(e2) {
        window.addEventListener("mousemove", this.handleChange), window.addEventListener("mouseup", this.handleChange), window.addEventListener("mouseup", this.handleMouseUp);
      }, handleMouseUp: function(e2) {
        this.unbindEventListeners();
      }, unbindEventListeners: function() {
        window.removeEventListener("mousemove", this.handleChange), window.removeEventListener("mouseup", this.handleChange), window.removeEventListener("mouseup", this.handleMouseUp);
      } } };
    }, function(e, t, n) {
      Object.defineProperty(t, "__esModule", { value: true });
      var r = n(22), i = function(e2) {
        return e2 && e2.__esModule ? e2 : { default: e2 };
      }(r);
      t.default = { name: "Alpha", props: { value: Object, onChange: Function }, components: { checkboard: i.default }, computed: { colors: function() {
        return this.value;
      }, gradientColor: function() {
        var e2 = this.colors.rgba, t2 = [e2.r, e2.g, e2.b].join(",");
        return "linear-gradient(to right, rgba(" + t2 + ", 0) 0%, rgba(" + t2 + ", 1) 100%)";
      } }, methods: { handleChange: function(e2, t2) {
        !t2 && e2.preventDefault();
        var n2 = this.$refs.container;
        if (n2) {
          var r2, i2 = n2.clientWidth, o = n2.getBoundingClientRect().left + window.pageXOffset, a = e2.pageX || (e2.touches ? e2.touches[0].pageX : 0), s = a - o;
          r2 = s < 0 ? 0 : s > i2 ? 1 : Math.round(100 * s / i2) / 100, this.colors.a !== r2 && this.$emit("change", { h: this.colors.hsl.h, s: this.colors.hsl.s, l: this.colors.hsl.l, a: r2, source: "rgba" });
        }
      }, handleMouseDown: function(e2) {
        this.handleChange(e2, true), window.addEventListener("mousemove", this.handleChange), window.addEventListener("mouseup", this.handleMouseUp);
      }, handleMouseUp: function() {
        this.unbindEventListeners();
      }, unbindEventListeners: function() {
        window.removeEventListener("mousemove", this.handleChange), window.removeEventListener("mouseup", this.handleMouseUp);
      } } };
    }, function(e, t, n) {
      function r(e2, t2, n2) {
        if (typeof document == "undefined")
          return null;
        var r2 = document.createElement("canvas");
        r2.width = r2.height = 2 * n2;
        var i2 = r2.getContext("2d");
        return i2 ? (i2.fillStyle = e2, i2.fillRect(0, 0, r2.width, r2.height), i2.fillStyle = t2, i2.fillRect(0, 0, n2, n2), i2.translate(n2, n2), i2.fillRect(0, 0, n2, n2), r2.toDataURL()) : null;
      }
      function i(e2, t2, n2) {
        var i2 = e2 + "," + t2 + "," + n2;
        if (o[i2])
          return o[i2];
        var a = r(e2, t2, n2);
        return o[i2] = a, a;
      }
      Object.defineProperty(t, "__esModule", { value: true });
      var o = {};
      t.default = { name: "Checkboard", props: { size: { type: [Number, String], default: 8 }, white: { type: String, default: "#fff" }, grey: { type: String, default: "#e6e6e6" } }, computed: { bgStyle: function() {
        return { "background-image": "url(" + i(this.white, this.grey, this.size) + ")" };
      } } };
    }, function(e, t, n) {
      function r(e2) {
        return e2 && e2.__esModule ? e2 : { default: e2 };
      }
      Object.defineProperty(t, "__esModule", { value: true });
      var i = n(3), o = r(i), a = n(5), s = r(a), c = n(20), l = r(c), u = n(13), f = r(u), d = n(21), h = r(d), p = n(22), v = r(p), g = ["#D0021B", "#F5A623", "#F8E71C", "#8B572A", "#7ED321", "#417505", "#BD10E0", "#9013FE", "#4A90E2", "#50E3C2", "#B8E986", "#000000", "#4A4A4A", "#9B9B9B", "#FFFFFF", "rgba(0,0,0,0)"];
      t.default = { name: "Sketch", mixins: [o.default], components: { saturation: l.default, hue: f.default, alpha: h.default, "ed-in": s.default, checkboard: v.default }, props: { presetColors: { type: Array, default: function() {
        return g;
      } }, disableAlpha: { type: Boolean, default: false }, disableFields: { type: Boolean, default: false } }, computed: { hex: function() {
        var e2 = void 0;
        return e2 = this.colors.a < 1 ? this.colors.hex8 : this.colors.hex, e2.replace("#", "");
      }, activeColor: function() {
        var e2 = this.colors.rgba;
        return "rgba(" + [e2.r, e2.g, e2.b, e2.a].join(",") + ")";
      } }, methods: { handlePreset: function(e2) {
        this.colorChange({ hex: e2, source: "hex" });
      }, childChange: function(e2) {
        this.colorChange(e2);
      }, inputChange: function(e2) {
        e2 && (e2.hex ? this.isValidHex(e2.hex) && this.colorChange({ hex: e2.hex, source: "hex" }) : (e2.r || e2.g || e2.b || e2.a) && this.colorChange({ r: e2.r || this.colors.rgba.r, g: e2.g || this.colors.rgba.g, b: e2.b || this.colors.rgba.b, a: e2.a || this.colors.rgba.a, source: "rgba" }));
      } } };
    }, function(e, t, n) {
      function r(e2) {
        return e2 && e2.__esModule ? e2 : { default: e2 };
      }
      Object.defineProperty(t, "__esModule", { value: true });
      var i = n(3), o = r(i), a = n(5), s = r(a), c = n(20), l = r(c), u = n(13), f = r(u), d = n(21), h = r(d), p = n(22), v = r(p);
      t.default = { name: "Chrome", mixins: [o.default], props: { disableAlpha: { type: Boolean, default: false }, disableFields: { type: Boolean, default: false } }, components: { saturation: l.default, hue: f.default, alpha: h.default, "ed-in": s.default, checkboard: v.default }, data: function() {
        return { fieldsIndex: 0, highlight: false };
      }, computed: { hsl: function() {
        var e2 = this.colors.hsl, t2 = e2.h, n2 = e2.s, r2 = e2.l;
        return { h: t2.toFixed(), s: (100 * n2).toFixed() + "%", l: (100 * r2).toFixed() + "%" };
      }, activeColor: function() {
        var e2 = this.colors.rgba;
        return "rgba(" + [e2.r, e2.g, e2.b, e2.a].join(",") + ")";
      }, hasAlpha: function() {
        return this.colors.a < 1;
      } }, methods: { childChange: function(e2) {
        this.colorChange(e2);
      }, inputChange: function(e2) {
        if (e2) {
          if (e2.hex)
            this.isValidHex(e2.hex) && this.colorChange({ hex: e2.hex, source: "hex" });
          else if (e2.r || e2.g || e2.b || e2.a)
            this.colorChange({ r: e2.r || this.colors.rgba.r, g: e2.g || this.colors.rgba.g, b: e2.b || this.colors.rgba.b, a: e2.a || this.colors.rgba.a, source: "rgba" });
          else if (e2.h || e2.s || e2.l) {
            var t2 = e2.s ? e2.s.replace("%", "") / 100 : this.colors.hsl.s, n2 = e2.l ? e2.l.replace("%", "") / 100 : this.colors.hsl.l;
            this.colorChange({ h: e2.h || this.colors.hsl.h, s: t2, l: n2, source: "hsl" });
          }
        }
      }, toggleViews: function() {
        if (this.fieldsIndex >= 2)
          return void (this.fieldsIndex = 0);
        this.fieldsIndex++;
      }, showHighlight: function() {
        this.highlight = true;
      }, hideHighlight: function() {
        this.highlight = false;
      } } };
    }, function(e, t, n) {
      function r(e2) {
        return e2 && e2.__esModule ? e2 : { default: e2 };
      }
      Object.defineProperty(t, "__esModule", { value: true });
      var i = n(5), o = r(i), a = n(3), s = r(a), c = ["#FF6900", "#FCB900", "#7BDCB5", "#00D084", "#8ED1FC", "#0693E3", "#ABB8C3", "#EB144C", "#F78DA7", "#9900EF"];
      t.default = { name: "Twitter", mixins: [s.default], components: { editableInput: o.default }, props: { width: { type: [String, Number], default: 276 }, defaultColors: { type: Array, default: function() {
        return c;
      } }, triangle: { default: "top-left", validator: function(e2) {
        return ["hide", "top-left", "top-right"].includes(e2);
      } } }, computed: { hsv: function() {
        var e2 = this.colors.hsv;
        return { h: e2.h.toFixed(), s: (100 * e2.s).toFixed(), v: (100 * e2.v).toFixed() };
      }, hex: function() {
        var e2 = this.colors.hex;
        return e2 && e2.replace("#", "");
      } }, methods: { equal: function(e2) {
        return e2.toLowerCase() === this.colors.hex.toLowerCase();
      }, handlerClick: function(e2) {
        this.colorChange({ hex: e2, source: "hex" });
      }, inputChange: function(e2) {
        e2 && (e2["#"] ? this.isValidHex(e2["#"]) && this.colorChange({ hex: e2["#"], source: "hex" }) : e2.r || e2.g || e2.b || e2.a ? this.colorChange({ r: e2.r || this.colors.rgba.r, g: e2.g || this.colors.rgba.g, b: e2.b || this.colors.rgba.b, a: e2.a || this.colors.rgba.a, source: "rgba" }) : (e2.h || e2.s || e2.v) && this.colorChange({ h: e2.h || this.colors.hsv.h, s: e2.s / 100 || this.colors.hsv.s, v: e2.v / 100 || this.colors.hsv.v, source: "hsv" }));
      } } };
    }, function(e, t, n) {
      function r(e2) {
        return e2 && e2.__esModule ? e2 : { default: e2 };
      }
      var i = n(61), o = r(i), a = n(70), s = r(a), c = n(74), l = r(c), u = n(78), f = r(u), d = n(115), h = r(d), p = n(120), v = r(p), g = n(135), b = r(g), x = n(139), m = r(x), _ = n(143), w = r(_), y = n(21), C = r(y), k = n(22), F = r(k), S = n(5), A = r(S), O = n(13), E = r(O), M = n(20), j = r(M), L = n(3), P = r(L), R = { version: "2.8.1", Compact: o.default, Grayscale: s.default, Twitter: w.default, Material: l.default, Slider: f.default, Swatches: h.default, Photoshop: v.default, Sketch: b.default, Chrome: m.default, Alpha: C.default, Checkboard: F.default, EditableInput: A.default, Hue: E.default, Saturation: j.default, ColorMixin: P.default };
      e.exports = R;
    }, function(e, t, n) {
      function r(e2) {
        n(62);
      }
      Object.defineProperty(t, "__esModule", { value: true });
      var i = n(35), o = n.n(i);
      for (var a in i)
        a !== "default" && function(e2) {
          n.d(t, e2, function() {
            return i[e2];
          });
        }(a);
      var s = n(69), l = n(2), u = r, f = l(o.a, s.a, false, u, null, null);
      f.options.__file = "src/components/Compact.vue", t.default = f.exports;
    }, function(e, t, n) {
      var r = n(63);
      typeof r == "string" && (r = [[e.i, r, ""]]), r.locals && (e.exports = r.locals);
      n(1)("6ce8a5a8", r, false, {});
    }, function(e, t, n) {
      t = e.exports = n(0)(false), t.push([e.i, "\n.vc-compact {\n  padding-top: 5px;\n  padding-left: 5px;\n  width: 245px;\n  border-radius: 2px;\n  box-sizing: border-box;\n  box-shadow: 0 2px 10px rgba(0,0,0,.12), 0 2px 5px rgba(0,0,0,.16);\n  background-color: #fff;\n}\n.vc-compact-colors {\n  overflow: hidden;\n  padding: 0;\n  margin: 0;\n}\n.vc-compact-color-item {\n  list-style: none;\n  width: 15px;\n  height: 15px;\n  float: left;\n  margin-right: 5px;\n  margin-bottom: 5px;\n  position: relative;\n  cursor: pointer;\n}\n.vc-compact-color-item--white {\n  box-shadow: inset 0 0 0 1px #ddd;\n}\n.vc-compact-color-item--white .vc-compact-dot {\n  background: #000;\n}\n.vc-compact-dot {\n  position: absolute;\n  top: 5px;\n  right: 5px;\n  bottom: 5px;\n  left: 5px;\n  border-radius: 50%;\n  opacity: 1;\n  background: #fff;\n}\n", ""]);
    }, function(e, t) {
      e.exports = function(e2, t2) {
        for (var n = [], r = {}, i = 0; i < t2.length; i++) {
          var o = t2[i], a = o[0], s = o[1], c = o[2], l = o[3], u = { id: e2 + ":" + i, css: s, media: c, sourceMap: l };
          r[a] ? r[a].parts.push(u) : n.push(r[a] = { id: a, parts: [u] });
        }
        return n;
      };
    }, function(e, t, n) {
      var r;
      !function(i) {
        function o(e2, t2) {
          if (e2 = e2 || "", t2 = t2 || {}, e2 instanceof o)
            return e2;
          if (!(this instanceof o))
            return new o(e2, t2);
          var n2 = a(e2);
          this._originalInput = e2, this._r = n2.r, this._g = n2.g, this._b = n2.b, this._a = n2.a, this._roundA = G(100 * this._a) / 100, this._format = t2.format || n2.format, this._gradientType = t2.gradientType, this._r < 1 && (this._r = G(this._r)), this._g < 1 && (this._g = G(this._g)), this._b < 1 && (this._b = G(this._b)), this._ok = n2.ok, this._tc_id = U++;
        }
        function a(e2) {
          var t2 = { r: 0, g: 0, b: 0 }, n2 = 1, r2 = null, i2 = null, o2 = null, a2 = false, c2 = false;
          return typeof e2 == "string" && (e2 = N(e2)), typeof e2 == "object" && (H(e2.r) && H(e2.g) && H(e2.b) ? (t2 = s(e2.r, e2.g, e2.b), a2 = true, c2 = String(e2.r).substr(-1) === "%" ? "prgb" : "rgb") : H(e2.h) && H(e2.s) && H(e2.v) ? (r2 = D(e2.s), i2 = D(e2.v), t2 = f(e2.h, r2, i2), a2 = true, c2 = "hsv") : H(e2.h) && H(e2.s) && H(e2.l) && (r2 = D(e2.s), o2 = D(e2.l), t2 = l(e2.h, r2, o2), a2 = true, c2 = "hsl"), e2.hasOwnProperty("a") && (n2 = e2.a)), n2 = O(n2), { ok: a2, format: e2.format || c2, r: V(255, q(t2.r, 0)), g: V(255, q(t2.g, 0)), b: V(255, q(t2.b, 0)), a: n2 };
        }
        function s(e2, t2, n2) {
          return { r: 255 * E(e2, 255), g: 255 * E(t2, 255), b: 255 * E(n2, 255) };
        }
        function c(e2, t2, n2) {
          e2 = E(e2, 255), t2 = E(t2, 255), n2 = E(n2, 255);
          var r2, i2, o2 = q(e2, t2, n2), a2 = V(e2, t2, n2), s2 = (o2 + a2) / 2;
          if (o2 == a2)
            r2 = i2 = 0;
          else {
            var c2 = o2 - a2;
            switch (i2 = s2 > 0.5 ? c2 / (2 - o2 - a2) : c2 / (o2 + a2), o2) {
              case e2:
                r2 = (t2 - n2) / c2 + (t2 < n2 ? 6 : 0);
                break;
              case t2:
                r2 = (n2 - e2) / c2 + 2;
                break;
              case n2:
                r2 = (e2 - t2) / c2 + 4;
            }
            r2 /= 6;
          }
          return { h: r2, s: i2, l: s2 };
        }
        function l(e2, t2, n2) {
          function r2(e3, t3, n3) {
            return n3 < 0 && (n3 += 1), n3 > 1 && (n3 -= 1), n3 < 1 / 6 ? e3 + 6 * (t3 - e3) * n3 : n3 < 0.5 ? t3 : n3 < 2 / 3 ? e3 + (t3 - e3) * (2 / 3 - n3) * 6 : e3;
          }
          var i2, o2, a2;
          if (e2 = E(e2, 360), t2 = E(t2, 100), n2 = E(n2, 100), t2 === 0)
            i2 = o2 = a2 = n2;
          else {
            var s2 = n2 < 0.5 ? n2 * (1 + t2) : n2 + t2 - n2 * t2, c2 = 2 * n2 - s2;
            i2 = r2(c2, s2, e2 + 1 / 3), o2 = r2(c2, s2, e2), a2 = r2(c2, s2, e2 - 1 / 3);
          }
          return { r: 255 * i2, g: 255 * o2, b: 255 * a2 };
        }
        function u(e2, t2, n2) {
          e2 = E(e2, 255), t2 = E(t2, 255), n2 = E(n2, 255);
          var r2, i2, o2 = q(e2, t2, n2), a2 = V(e2, t2, n2), s2 = o2, c2 = o2 - a2;
          if (i2 = o2 === 0 ? 0 : c2 / o2, o2 == a2)
            r2 = 0;
          else {
            switch (o2) {
              case e2:
                r2 = (t2 - n2) / c2 + (t2 < n2 ? 6 : 0);
                break;
              case t2:
                r2 = (n2 - e2) / c2 + 2;
                break;
              case n2:
                r2 = (e2 - t2) / c2 + 4;
            }
            r2 /= 6;
          }
          return { h: r2, s: i2, v: s2 };
        }
        function f(e2, t2, n2) {
          e2 = 6 * E(e2, 360), t2 = E(t2, 100), n2 = E(n2, 100);
          var r2 = i.floor(e2), o2 = e2 - r2, a2 = n2 * (1 - t2), s2 = n2 * (1 - o2 * t2), c2 = n2 * (1 - (1 - o2) * t2), l2 = r2 % 6;
          return { r: 255 * [n2, s2, a2, a2, c2, n2][l2], g: 255 * [c2, n2, n2, s2, a2, a2][l2], b: 255 * [a2, a2, c2, n2, n2, s2][l2] };
        }
        function d(e2, t2, n2, r2) {
          var i2 = [R(G(e2).toString(16)), R(G(t2).toString(16)), R(G(n2).toString(16))];
          return r2 && i2[0].charAt(0) == i2[0].charAt(1) && i2[1].charAt(0) == i2[1].charAt(1) && i2[2].charAt(0) == i2[2].charAt(1) ? i2[0].charAt(0) + i2[1].charAt(0) + i2[2].charAt(0) : i2.join("");
        }
        function h(e2, t2, n2, r2, i2) {
          var o2 = [R(G(e2).toString(16)), R(G(t2).toString(16)), R(G(n2).toString(16)), R(B(r2))];
          return i2 && o2[0].charAt(0) == o2[0].charAt(1) && o2[1].charAt(0) == o2[1].charAt(1) && o2[2].charAt(0) == o2[2].charAt(1) && o2[3].charAt(0) == o2[3].charAt(1) ? o2[0].charAt(0) + o2[1].charAt(0) + o2[2].charAt(0) + o2[3].charAt(0) : o2.join("");
        }
        function p(e2, t2, n2, r2) {
          return [R(B(r2)), R(G(e2).toString(16)), R(G(t2).toString(16)), R(G(n2).toString(16))].join("");
        }
        function v(e2, t2) {
          t2 = t2 === 0 ? 0 : t2 || 10;
          var n2 = o(e2).toHsl();
          return n2.s -= t2 / 100, n2.s = M(n2.s), o(n2);
        }
        function g(e2, t2) {
          t2 = t2 === 0 ? 0 : t2 || 10;
          var n2 = o(e2).toHsl();
          return n2.s += t2 / 100, n2.s = M(n2.s), o(n2);
        }
        function b(e2) {
          return o(e2).desaturate(100);
        }
        function x(e2, t2) {
          t2 = t2 === 0 ? 0 : t2 || 10;
          var n2 = o(e2).toHsl();
          return n2.l += t2 / 100, n2.l = M(n2.l), o(n2);
        }
        function m(e2, t2) {
          t2 = t2 === 0 ? 0 : t2 || 10;
          var n2 = o(e2).toRgb();
          return n2.r = q(0, V(255, n2.r - G(-t2 / 100 * 255))), n2.g = q(0, V(255, n2.g - G(-t2 / 100 * 255))), n2.b = q(0, V(255, n2.b - G(-t2 / 100 * 255))), o(n2);
        }
        function _(e2, t2) {
          t2 = t2 === 0 ? 0 : t2 || 10;
          var n2 = o(e2).toHsl();
          return n2.l -= t2 / 100, n2.l = M(n2.l), o(n2);
        }
        function w(e2, t2) {
          var n2 = o(e2).toHsl(), r2 = (n2.h + t2) % 360;
          return n2.h = r2 < 0 ? 360 + r2 : r2, o(n2);
        }
        function y(e2) {
          var t2 = o(e2).toHsl();
          return t2.h = (t2.h + 180) % 360, o(t2);
        }
        function C(e2) {
          var t2 = o(e2).toHsl(), n2 = t2.h;
          return [o(e2), o({ h: (n2 + 120) % 360, s: t2.s, l: t2.l }), o({ h: (n2 + 240) % 360, s: t2.s, l: t2.l })];
        }
        function k(e2) {
          var t2 = o(e2).toHsl(), n2 = t2.h;
          return [o(e2), o({ h: (n2 + 90) % 360, s: t2.s, l: t2.l }), o({ h: (n2 + 180) % 360, s: t2.s, l: t2.l }), o({ h: (n2 + 270) % 360, s: t2.s, l: t2.l })];
        }
        function F(e2) {
          var t2 = o(e2).toHsl(), n2 = t2.h;
          return [o(e2), o({ h: (n2 + 72) % 360, s: t2.s, l: t2.l }), o({ h: (n2 + 216) % 360, s: t2.s, l: t2.l })];
        }
        function S(e2, t2, n2) {
          t2 = t2 || 6, n2 = n2 || 30;
          var r2 = o(e2).toHsl(), i2 = 360 / n2, a2 = [o(e2)];
          for (r2.h = (r2.h - (i2 * t2 >> 1) + 720) % 360; --t2; )
            r2.h = (r2.h + i2) % 360, a2.push(o(r2));
          return a2;
        }
        function A(e2, t2) {
          t2 = t2 || 6;
          for (var n2 = o(e2).toHsv(), r2 = n2.h, i2 = n2.s, a2 = n2.v, s2 = [], c2 = 1 / t2; t2--; )
            s2.push(o({ h: r2, s: i2, v: a2 })), a2 = (a2 + c2) % 1;
          return s2;
        }
        function O(e2) {
          return e2 = parseFloat(e2), (isNaN(e2) || e2 < 0 || e2 > 1) && (e2 = 1), e2;
        }
        function E(e2, t2) {
          L(e2) && (e2 = "100%");
          var n2 = P(e2);
          return e2 = V(t2, q(0, parseFloat(e2))), n2 && (e2 = parseInt(e2 * t2, 10) / 100), i.abs(e2 - t2) < 1e-6 ? 1 : e2 % t2 / parseFloat(t2);
        }
        function M(e2) {
          return V(1, q(0, e2));
        }
        function j(e2) {
          return parseInt(e2, 16);
        }
        function L(e2) {
          return typeof e2 == "string" && e2.indexOf(".") != -1 && parseFloat(e2) === 1;
        }
        function P(e2) {
          return typeof e2 == "string" && e2.indexOf("%") != -1;
        }
        function R(e2) {
          return e2.length == 1 ? "0" + e2 : "" + e2;
        }
        function D(e2) {
          return e2 <= 1 && (e2 = 100 * e2 + "%"), e2;
        }
        function B(e2) {
          return i.round(255 * parseFloat(e2)).toString(16);
        }
        function T(e2) {
          return j(e2) / 255;
        }
        function H(e2) {
          return !!J.CSS_UNIT.exec(e2);
        }
        function N(e2) {
          e2 = e2.replace(I, "").replace($, "").toLowerCase();
          var t2 = false;
          if (W[e2])
            e2 = W[e2], t2 = true;
          else if (e2 == "transparent")
            return { r: 0, g: 0, b: 0, a: 0, format: "name" };
          var n2;
          return (n2 = J.rgb.exec(e2)) ? { r: n2[1], g: n2[2], b: n2[3] } : (n2 = J.rgba.exec(e2)) ? { r: n2[1], g: n2[2], b: n2[3], a: n2[4] } : (n2 = J.hsl.exec(e2)) ? { h: n2[1], s: n2[2], l: n2[3] } : (n2 = J.hsla.exec(e2)) ? { h: n2[1], s: n2[2], l: n2[3], a: n2[4] } : (n2 = J.hsv.exec(e2)) ? { h: n2[1], s: n2[2], v: n2[3] } : (n2 = J.hsva.exec(e2)) ? { h: n2[1], s: n2[2], v: n2[3], a: n2[4] } : (n2 = J.hex8.exec(e2)) ? { r: j(n2[1]), g: j(n2[2]), b: j(n2[3]), a: T(n2[4]), format: t2 ? "name" : "hex8" } : (n2 = J.hex6.exec(e2)) ? { r: j(n2[1]), g: j(n2[2]), b: j(n2[3]), format: t2 ? "name" : "hex" } : (n2 = J.hex4.exec(e2)) ? { r: j(n2[1] + "" + n2[1]), g: j(n2[2] + "" + n2[2]), b: j(n2[3] + "" + n2[3]), a: T(n2[4] + "" + n2[4]), format: t2 ? "name" : "hex8" } : !!(n2 = J.hex3.exec(e2)) && { r: j(n2[1] + "" + n2[1]), g: j(n2[2] + "" + n2[2]), b: j(n2[3] + "" + n2[3]), format: t2 ? "name" : "hex" };
        }
        function z(e2) {
          var t2, n2;
          return e2 = e2 || { level: "AA", size: "small" }, t2 = (e2.level || "AA").toUpperCase(), n2 = (e2.size || "small").toLowerCase(), t2 !== "AA" && t2 !== "AAA" && (t2 = "AA"), n2 !== "small" && n2 !== "large" && (n2 = "small"), { level: t2, size: n2 };
        }
        var I = /^\s+/, $ = /\s+$/, U = 0, G = i.round, V = i.min, q = i.max, X = i.random;
        o.prototype = { isDark: function() {
          return this.getBrightness() < 128;
        }, isLight: function() {
          return !this.isDark();
        }, isValid: function() {
          return this._ok;
        }, getOriginalInput: function() {
          return this._originalInput;
        }, getFormat: function() {
          return this._format;
        }, getAlpha: function() {
          return this._a;
        }, getBrightness: function() {
          var e2 = this.toRgb();
          return (299 * e2.r + 587 * e2.g + 114 * e2.b) / 1e3;
        }, getLuminance: function() {
          var e2, t2, n2, r2, o2, a2, s2 = this.toRgb();
          return e2 = s2.r / 255, t2 = s2.g / 255, n2 = s2.b / 255, r2 = e2 <= 0.03928 ? e2 / 12.92 : i.pow((e2 + 0.055) / 1.055, 2.4), o2 = t2 <= 0.03928 ? t2 / 12.92 : i.pow((t2 + 0.055) / 1.055, 2.4), a2 = n2 <= 0.03928 ? n2 / 12.92 : i.pow((n2 + 0.055) / 1.055, 2.4), 0.2126 * r2 + 0.7152 * o2 + 0.0722 * a2;
        }, setAlpha: function(e2) {
          return this._a = O(e2), this._roundA = G(100 * this._a) / 100, this;
        }, toHsv: function() {
          var e2 = u(this._r, this._g, this._b);
          return { h: 360 * e2.h, s: e2.s, v: e2.v, a: this._a };
        }, toHsvString: function() {
          var e2 = u(this._r, this._g, this._b), t2 = G(360 * e2.h), n2 = G(100 * e2.s), r2 = G(100 * e2.v);
          return this._a == 1 ? "hsv(" + t2 + ", " + n2 + "%, " + r2 + "%)" : "hsva(" + t2 + ", " + n2 + "%, " + r2 + "%, " + this._roundA + ")";
        }, toHsl: function() {
          var e2 = c(this._r, this._g, this._b);
          return { h: 360 * e2.h, s: e2.s, l: e2.l, a: this._a };
        }, toHslString: function() {
          var e2 = c(this._r, this._g, this._b), t2 = G(360 * e2.h), n2 = G(100 * e2.s), r2 = G(100 * e2.l);
          return this._a == 1 ? "hsl(" + t2 + ", " + n2 + "%, " + r2 + "%)" : "hsla(" + t2 + ", " + n2 + "%, " + r2 + "%, " + this._roundA + ")";
        }, toHex: function(e2) {
          return d(this._r, this._g, this._b, e2);
        }, toHexString: function(e2) {
          return "#" + this.toHex(e2);
        }, toHex8: function(e2) {
          return h(this._r, this._g, this._b, this._a, e2);
        }, toHex8String: function(e2) {
          return "#" + this.toHex8(e2);
        }, toRgb: function() {
          return { r: G(this._r), g: G(this._g), b: G(this._b), a: this._a };
        }, toRgbString: function() {
          return this._a == 1 ? "rgb(" + G(this._r) + ", " + G(this._g) + ", " + G(this._b) + ")" : "rgba(" + G(this._r) + ", " + G(this._g) + ", " + G(this._b) + ", " + this._roundA + ")";
        }, toPercentageRgb: function() {
          return { r: G(100 * E(this._r, 255)) + "%", g: G(100 * E(this._g, 255)) + "%", b: G(100 * E(this._b, 255)) + "%", a: this._a };
        }, toPercentageRgbString: function() {
          return this._a == 1 ? "rgb(" + G(100 * E(this._r, 255)) + "%, " + G(100 * E(this._g, 255)) + "%, " + G(100 * E(this._b, 255)) + "%)" : "rgba(" + G(100 * E(this._r, 255)) + "%, " + G(100 * E(this._g, 255)) + "%, " + G(100 * E(this._b, 255)) + "%, " + this._roundA + ")";
        }, toName: function() {
          return this._a === 0 ? "transparent" : !(this._a < 1) && (Y[d(this._r, this._g, this._b, true)] || false);
        }, toFilter: function(e2) {
          var t2 = "#" + p(this._r, this._g, this._b, this._a), n2 = t2, r2 = this._gradientType ? "GradientType = 1, " : "";
          if (e2) {
            var i2 = o(e2);
            n2 = "#" + p(i2._r, i2._g, i2._b, i2._a);
          }
          return "progid:DXImageTransform.Microsoft.gradient(" + r2 + "startColorstr=" + t2 + ",endColorstr=" + n2 + ")";
        }, toString: function(e2) {
          var t2 = !!e2;
          e2 = e2 || this._format;
          var n2 = false, r2 = this._a < 1 && this._a >= 0;
          return t2 || !r2 || e2 !== "hex" && e2 !== "hex6" && e2 !== "hex3" && e2 !== "hex4" && e2 !== "hex8" && e2 !== "name" ? (e2 === "rgb" && (n2 = this.toRgbString()), e2 === "prgb" && (n2 = this.toPercentageRgbString()), e2 !== "hex" && e2 !== "hex6" || (n2 = this.toHexString()), e2 === "hex3" && (n2 = this.toHexString(true)), e2 === "hex4" && (n2 = this.toHex8String(true)), e2 === "hex8" && (n2 = this.toHex8String()), e2 === "name" && (n2 = this.toName()), e2 === "hsl" && (n2 = this.toHslString()), e2 === "hsv" && (n2 = this.toHsvString()), n2 || this.toHexString()) : e2 === "name" && this._a === 0 ? this.toName() : this.toRgbString();
        }, clone: function() {
          return o(this.toString());
        }, _applyModification: function(e2, t2) {
          var n2 = e2.apply(null, [this].concat([].slice.call(t2)));
          return this._r = n2._r, this._g = n2._g, this._b = n2._b, this.setAlpha(n2._a), this;
        }, lighten: function() {
          return this._applyModification(x, arguments);
        }, brighten: function() {
          return this._applyModification(m, arguments);
        }, darken: function() {
          return this._applyModification(_, arguments);
        }, desaturate: function() {
          return this._applyModification(v, arguments);
        }, saturate: function() {
          return this._applyModification(g, arguments);
        }, greyscale: function() {
          return this._applyModification(b, arguments);
        }, spin: function() {
          return this._applyModification(w, arguments);
        }, _applyCombination: function(e2, t2) {
          return e2.apply(null, [this].concat([].slice.call(t2)));
        }, analogous: function() {
          return this._applyCombination(S, arguments);
        }, complement: function() {
          return this._applyCombination(y, arguments);
        }, monochromatic: function() {
          return this._applyCombination(A, arguments);
        }, splitcomplement: function() {
          return this._applyCombination(F, arguments);
        }, triad: function() {
          return this._applyCombination(C, arguments);
        }, tetrad: function() {
          return this._applyCombination(k, arguments);
        } }, o.fromRatio = function(e2, t2) {
          if (typeof e2 == "object") {
            var n2 = {};
            for (var r2 in e2)
              e2.hasOwnProperty(r2) && (n2[r2] = r2 === "a" ? e2[r2] : D(e2[r2]));
            e2 = n2;
          }
          return o(e2, t2);
        }, o.equals = function(e2, t2) {
          return !(!e2 || !t2) && o(e2).toRgbString() == o(t2).toRgbString();
        }, o.random = function() {
          return o.fromRatio({ r: X(), g: X(), b: X() });
        }, o.mix = function(e2, t2, n2) {
          n2 = n2 === 0 ? 0 : n2 || 50;
          var r2 = o(e2).toRgb(), i2 = o(t2).toRgb(), a2 = n2 / 100;
          return o({ r: (i2.r - r2.r) * a2 + r2.r, g: (i2.g - r2.g) * a2 + r2.g, b: (i2.b - r2.b) * a2 + r2.b, a: (i2.a - r2.a) * a2 + r2.a });
        }, o.readability = function(e2, t2) {
          var n2 = o(e2), r2 = o(t2);
          return (i.max(n2.getLuminance(), r2.getLuminance()) + 0.05) / (i.min(n2.getLuminance(), r2.getLuminance()) + 0.05);
        }, o.isReadable = function(e2, t2, n2) {
          var r2, i2, a2 = o.readability(e2, t2);
          switch (i2 = false, r2 = z(n2), r2.level + r2.size) {
            case "AAsmall":
            case "AAAlarge":
              i2 = a2 >= 4.5;
              break;
            case "AAlarge":
              i2 = a2 >= 3;
              break;
            case "AAAsmall":
              i2 = a2 >= 7;
          }
          return i2;
        }, o.mostReadable = function(e2, t2, n2) {
          var r2, i2, a2, s2, c2 = null, l2 = 0;
          n2 = n2 || {}, i2 = n2.includeFallbackColors, a2 = n2.level, s2 = n2.size;
          for (var u2 = 0; u2 < t2.length; u2++)
            (r2 = o.readability(e2, t2[u2])) > l2 && (l2 = r2, c2 = o(t2[u2]));
          return o.isReadable(e2, c2, { level: a2, size: s2 }) || !i2 ? c2 : (n2.includeFallbackColors = false, o.mostReadable(e2, ["#fff", "#000"], n2));
        };
        var W = o.names = { aliceblue: "f0f8ff", antiquewhite: "faebd7", aqua: "0ff", aquamarine: "7fffd4", azure: "f0ffff", beige: "f5f5dc", bisque: "ffe4c4", black: "000", blanchedalmond: "ffebcd", blue: "00f", blueviolet: "8a2be2", brown: "a52a2a", burlywood: "deb887", burntsienna: "ea7e5d", cadetblue: "5f9ea0", chartreuse: "7fff00", chocolate: "d2691e", coral: "ff7f50", cornflowerblue: "6495ed", cornsilk: "fff8dc", crimson: "dc143c", cyan: "0ff", darkblue: "00008b", darkcyan: "008b8b", darkgoldenrod: "b8860b", darkgray: "a9a9a9", darkgreen: "006400", darkgrey: "a9a9a9", darkkhaki: "bdb76b", darkmagenta: "8b008b", darkolivegreen: "556b2f", darkorange: "ff8c00", darkorchid: "9932cc", darkred: "8b0000", darksalmon: "e9967a", darkseagreen: "8fbc8f", darkslateblue: "483d8b", darkslategray: "2f4f4f", darkslategrey: "2f4f4f", darkturquoise: "00ced1", darkviolet: "9400d3", deeppink: "ff1493", deepskyblue: "00bfff", dimgray: "696969", dimgrey: "696969", dodgerblue: "1e90ff", firebrick: "b22222", floralwhite: "fffaf0", forestgreen: "228b22", fuchsia: "f0f", gainsboro: "dcdcdc", ghostwhite: "f8f8ff", gold: "ffd700", goldenrod: "daa520", gray: "808080", green: "008000", greenyellow: "adff2f", grey: "808080", honeydew: "f0fff0", hotpink: "ff69b4", indianred: "cd5c5c", indigo: "4b0082", ivory: "fffff0", khaki: "f0e68c", lavender: "e6e6fa", lavenderblush: "fff0f5", lawngreen: "7cfc00", lemonchiffon: "fffacd", lightblue: "add8e6", lightcoral: "f08080", lightcyan: "e0ffff", lightgoldenrodyellow: "fafad2", lightgray: "d3d3d3", lightgreen: "90ee90", lightgrey: "d3d3d3", lightpink: "ffb6c1", lightsalmon: "ffa07a", lightseagreen: "20b2aa", lightskyblue: "87cefa", lightslategray: "789", lightslategrey: "789", lightsteelblue: "b0c4de", lightyellow: "ffffe0", lime: "0f0", limegreen: "32cd32", linen: "faf0e6", magenta: "f0f", maroon: "800000", mediumaquamarine: "66cdaa", mediumblue: "0000cd", mediumorchid: "ba55d3", mediumpurple: "9370db", mediumseagreen: "3cb371", mediumslateblue: "7b68ee", mediumspringgreen: "00fa9a", mediumturquoise: "48d1cc", mediumvioletred: "c71585", midnightblue: "191970", mintcream: "f5fffa", mistyrose: "ffe4e1", moccasin: "ffe4b5", navajowhite: "ffdead", navy: "000080", oldlace: "fdf5e6", olive: "808000", olivedrab: "6b8e23", orange: "ffa500", orangered: "ff4500", orchid: "da70d6", palegoldenrod: "eee8aa", palegreen: "98fb98", paleturquoise: "afeeee", palevioletred: "db7093", papayawhip: "ffefd5", peachpuff: "ffdab9", peru: "cd853f", pink: "ffc0cb", plum: "dda0dd", powderblue: "b0e0e6", purple: "800080", rebeccapurple: "663399", red: "f00", rosybrown: "bc8f8f", royalblue: "4169e1", saddlebrown: "8b4513", salmon: "fa8072", sandybrown: "f4a460", seagreen: "2e8b57", seashell: "fff5ee", sienna: "a0522d", silver: "c0c0c0", skyblue: "87ceeb", slateblue: "6a5acd", slategray: "708090", slategrey: "708090", snow: "fffafa", springgreen: "00ff7f", steelblue: "4682b4", tan: "d2b48c", teal: "008080", thistle: "d8bfd8", tomato: "ff6347", turquoise: "40e0d0", violet: "ee82ee", wheat: "f5deb3", white: "fff", whitesmoke: "f5f5f5", yellow: "ff0", yellowgreen: "9acd32" }, Y = o.hexNames = function(e2) {
          var t2 = {};
          for (var n2 in e2)
            e2.hasOwnProperty(n2) && (t2[e2[n2]] = n2);
          return t2;
        }(W), J = function() {
          var e2 = "(?:[-\\+]?\\d*\\.\\d+%?)|(?:[-\\+]?\\d+%?)", t2 = "[\\s|\\(]+(" + e2 + ")[,|\\s]+(" + e2 + ")[,|\\s]+(" + e2 + ")\\s*\\)?", n2 = "[\\s|\\(]+(" + e2 + ")[,|\\s]+(" + e2 + ")[,|\\s]+(" + e2 + ")[,|\\s]+(" + e2 + ")\\s*\\)?";
          return { CSS_UNIT: new RegExp(e2), rgb: new RegExp("rgb" + t2), rgba: new RegExp("rgba" + n2), hsl: new RegExp("hsl" + t2), hsla: new RegExp("hsla" + n2), hsv: new RegExp("hsv" + t2), hsva: new RegExp("hsva" + n2), hex3: /^#?([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})$/, hex6: /^#?([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})$/, hex4: /^#?([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})$/, hex8: /^#?([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})$/ };
        }();
        e !== void 0 && e.exports ? e.exports = o : (r = function() {
          return o;
        }.call(t, n, t, e)) !== void 0 && (e.exports = r);
      }(Math);
    }, function(e, t, n) {
      var r = n(67);
      typeof r == "string" && (r = [[e.i, r, ""]]), r.locals && (e.exports = r.locals);
      n(1)("0f73e73c", r, false, {});
    }, function(e, t, n) {
      t = e.exports = n(0)(false), t.push([e.i, "\n.vc-editable-input {\n  position: relative;\n}\n.vc-input__input {\n  padding: 0;\n  border: 0;\n  outline: none;\n}\n.vc-input__label {\n  text-transform: capitalize;\n}\n", ""]);
    }, function(e, t, n) {
      var r = function() {
        var e2 = this, t2 = e2.$createElement, n2 = e2._self._c || t2;
        return n2("div", { staticClass: "vc-editable-input" }, [n2("input", { directives: [{ name: "model", rawName: "v-model", value: e2.val, expression: "val" }], ref: "input", staticClass: "vc-input__input", attrs: { "aria-labelledby": e2.labelId }, domProps: { value: e2.val }, on: { keydown: e2.handleKeyDown, input: [function(t3) {
          t3.target.composing || (e2.val = t3.target.value);
        }, e2.update] } }), e2._v(" "), n2("span", { staticClass: "vc-input__label", attrs: { for: e2.label, id: e2.labelId } }, [e2._v(e2._s(e2.labelSpanText))]), e2._v(" "), n2("span", { staticClass: "vc-input__desc" }, [e2._v(e2._s(e2.desc))])]);
      }, i = [];
      r._withStripped = true;
      var o = { render: r, staticRenderFns: i };
      t.a = o;
    }, function(e, t, n) {
      var r = function() {
        var e2 = this, t2 = e2.$createElement, n2 = e2._self._c || t2;
        return n2("div", { staticClass: "vc-compact", attrs: { role: "application", "aria-label": "Compact color picker" } }, [n2("ul", { staticClass: "vc-compact-colors", attrs: { role: "listbox" } }, e2._l(e2.paletteUpperCase(e2.palette), function(t3) {
          return n2("li", { key: t3, staticClass: "vc-compact-color-item", class: { "vc-compact-color-item--white": t3 === "#FFFFFF" }, style: { background: t3 }, attrs: { role: "option", "aria-label": "color:" + t3, "aria-selected": t3 === e2.pick }, on: { click: function(n3) {
            return e2.handlerClick(t3);
          } } }, [n2("div", { directives: [{ name: "show", rawName: "v-show", value: t3 === e2.pick, expression: "c === pick" }], staticClass: "vc-compact-dot" })]);
        }), 0)]);
      }, i = [];
      r._withStripped = true;
      var o = { render: r, staticRenderFns: i };
      t.a = o;
    }, function(e, t, n) {
      function r(e2) {
        n(71);
      }
      Object.defineProperty(t, "__esModule", { value: true });
      var i = n(37), o = n.n(i);
      for (var a in i)
        a !== "default" && function(e2) {
          n.d(t, e2, function() {
            return i[e2];
          });
        }(a);
      var s = n(73), l = n(2), u = r, f = l(o.a, s.a, false, u, null, null);
      f.options.__file = "src/components/Grayscale.vue", t.default = f.exports;
    }, function(e, t, n) {
      var r = n(72);
      typeof r == "string" && (r = [[e.i, r, ""]]), r.locals && (e.exports = r.locals);
      n(1)("21ddbb74", r, false, {});
    }, function(e, t, n) {
      t = e.exports = n(0)(false), t.push([e.i, "\n.vc-grayscale {\n  width: 125px;\n  border-radius: 2px;\n  box-shadow: 0 2px 15px rgba(0,0,0,.12), 0 2px 10px rgba(0,0,0,.16);\n  background-color: #fff;\n}\n.vc-grayscale-colors {\n  border-radius: 2px;\n  overflow: hidden;\n  padding: 0;\n  margin: 0;\n}\n.vc-grayscale-color-item {\n  list-style: none;\n  width: 25px;\n  height: 25px;\n  float: left;\n  position: relative;\n  cursor: pointer;\n}\n.vc-grayscale-color-item--white .vc-grayscale-dot {\n  background: #000;\n}\n.vc-grayscale-dot {\n  position: absolute;\n  top: 50%;\n  left: 50%;\n  width: 6px;\n  height: 6px;\n  margin: -3px 0 0 -2px;\n  border-radius: 50%;\n  opacity: 1;\n  background: #fff;\n}\n", ""]);
    }, function(e, t, n) {
      var r = function() {
        var e2 = this, t2 = e2.$createElement, n2 = e2._self._c || t2;
        return n2("div", { staticClass: "vc-grayscale", attrs: { role: "application", "aria-label": "Grayscale color picker" } }, [n2("ul", { staticClass: "vc-grayscale-colors", attrs: { role: "listbox" } }, e2._l(e2.paletteUpperCase(e2.palette), function(t3) {
          return n2("li", { key: t3, staticClass: "vc-grayscale-color-item", class: { "vc-grayscale-color-item--white": t3 == "#FFFFFF" }, style: { background: t3 }, attrs: { role: "option", "aria-label": "Color:" + t3, "aria-selected": t3 === e2.pick }, on: { click: function(n3) {
            return e2.handlerClick(t3);
          } } }, [n2("div", { directives: [{ name: "show", rawName: "v-show", value: t3 === e2.pick, expression: "c === pick" }], staticClass: "vc-grayscale-dot" })]);
        }), 0)]);
      }, i = [];
      r._withStripped = true;
      var o = { render: r, staticRenderFns: i };
      t.a = o;
    }, function(e, t, n) {
      function r(e2) {
        n(75);
      }
      Object.defineProperty(t, "__esModule", { value: true });
      var i = n(38), o = n.n(i);
      for (var a in i)
        a !== "default" && function(e2) {
          n.d(t, e2, function() {
            return i[e2];
          });
        }(a);
      var s = n(77), l = n(2), u = r, f = l(o.a, s.a, false, u, null, null);
      f.options.__file = "src/components/Material.vue", t.default = f.exports;
    }, function(e, t, n) {
      var r = n(76);
      typeof r == "string" && (r = [[e.i, r, ""]]), r.locals && (e.exports = r.locals);
      n(1)("1ff3af73", r, false, {});
    }, function(e, t, n) {
      t = e.exports = n(0)(false), t.push([e.i, '\n.vc-material {\n  width: 98px;\n  height: 98px;\n  padding: 16px;\n  font-family: "Roboto";\n  position: relative;\n  border-radius: 2px;\n  box-shadow: 0 2px 10px rgba(0,0,0,.12), 0 2px 5px rgba(0,0,0,.16);\n  background-color: #fff;\n}\n.vc-material .vc-input__input {\n  width: 100%;\n  margin-top: 12px;\n  font-size: 15px;\n  color: #333;\n  height: 30px;\n}\n.vc-material .vc-input__label {\n  position: absolute;\n  top: 0;\n  left: 0;\n  font-size: 11px;\n  color: #999;\n  text-transform: capitalize;\n}\n.vc-material-hex {\n  border-bottom-width: 2px;\n  border-bottom-style: solid;\n}\n.vc-material-split {\n  display: flex;\n  margin-right: -10px;\n  padding-top: 11px;\n}\n.vc-material-third {\n  flex: 1;\n  padding-right: 10px;\n}\n', ""]);
    }, function(e, t, n) {
      var r = function() {
        var e2 = this, t2 = e2.$createElement, n2 = e2._self._c || t2;
        return n2("div", { staticClass: "vc-material", attrs: { role: "application", "aria-label": "Material color picker" } }, [n2("ed-in", { staticClass: "vc-material-hex", style: { borderColor: e2.colors.hex }, attrs: { label: "hex" }, on: { change: e2.onChange }, model: { value: e2.colors.hex, callback: function(t3) {
          e2.$set(e2.colors, "hex", t3);
        }, expression: "colors.hex" } }), e2._v(" "), n2("div", { staticClass: "vc-material-split" }, [n2("div", { staticClass: "vc-material-third" }, [n2("ed-in", { attrs: { label: "r" }, on: { change: e2.onChange }, model: { value: e2.colors.rgba.r, callback: function(t3) {
          e2.$set(e2.colors.rgba, "r", t3);
        }, expression: "colors.rgba.r" } })], 1), e2._v(" "), n2("div", { staticClass: "vc-material-third" }, [n2("ed-in", { attrs: { label: "g" }, on: { change: e2.onChange }, model: { value: e2.colors.rgba.g, callback: function(t3) {
          e2.$set(e2.colors.rgba, "g", t3);
        }, expression: "colors.rgba.g" } })], 1), e2._v(" "), n2("div", { staticClass: "vc-material-third" }, [n2("ed-in", { attrs: { label: "b" }, on: { change: e2.onChange }, model: { value: e2.colors.rgba.b, callback: function(t3) {
          e2.$set(e2.colors.rgba, "b", t3);
        }, expression: "colors.rgba.b" } })], 1)])], 1);
      }, i = [];
      r._withStripped = true;
      var o = { render: r, staticRenderFns: i };
      t.a = o;
    }, function(e, t, n) {
      function r(e2) {
        n(79);
      }
      Object.defineProperty(t, "__esModule", { value: true });
      var i = n(39), o = n.n(i);
      for (var a in i)
        a !== "default" && function(e2) {
          n.d(t, e2, function() {
            return i[e2];
          });
        }(a);
      var s = n(114), l = n(2), u = r, f = l(o.a, s.a, false, u, null, null);
      f.options.__file = "src/components/Slider.vue", t.default = f.exports;
    }, function(e, t, n) {
      var r = n(80);
      typeof r == "string" && (r = [[e.i, r, ""]]), r.locals && (e.exports = r.locals);
      n(1)("7982aa43", r, false, {});
    }, function(e, t, n) {
      t = e.exports = n(0)(false), t.push([e.i, "\n.vc-slider {\n  position: relative;\n  width: 410px;\n}\n.vc-slider-hue-warp {\n  height: 12px;\n  position: relative;\n}\n.vc-slider-hue-warp .vc-hue-picker {\n  width: 14px;\n  height: 14px;\n  border-radius: 6px;\n  transform: translate(-7px, -2px);\n  background-color: rgb(248, 248, 248);\n  box-shadow: 0 1px 4px 0 rgba(0, 0, 0, 0.37);\n}\n.vc-slider-swatches {\n  display: flex;\n  margin-top: 20px;\n}\n.vc-slider-swatch {\n  margin-right: 1px;\n  flex: 1;\n  width: 20%;\n}\n.vc-slider-swatch:first-child {\n  margin-right: 1px;\n}\n.vc-slider-swatch:first-child .vc-slider-swatch-picker {\n  border-radius: 2px 0px 0px 2px;\n}\n.vc-slider-swatch:last-child {\n  margin-right: 0;\n}\n.vc-slider-swatch:last-child .vc-slider-swatch-picker {\n  border-radius: 0px 2px 2px 0px;\n}\n.vc-slider-swatch-picker {\n  cursor: pointer;\n  height: 12px;\n}\n.vc-slider-swatch:nth-child(n) .vc-slider-swatch-picker.vc-slider-swatch-picker--active {\n  transform: scaleY(1.8);\n  border-radius: 3.6px/2px;\n}\n.vc-slider-swatch-picker--white {\n  box-shadow: inset 0 0 0 1px #ddd;\n}\n.vc-slider-swatch-picker--active.vc-slider-swatch-picker--white {\n  box-shadow: inset 0 0 0 0.6px #ddd;\n}\n", ""]);
    }, function(e, t, n) {
      function r(e2) {
        return e2 && e2.__esModule ? e2 : { default: e2 };
      }
      t.__esModule = true;
      var i = n(82), o = r(i), a = n(100), s = r(a), c = typeof s.default == "function" && typeof o.default == "symbol" ? function(e2) {
        return typeof e2;
      } : function(e2) {
        return e2 && typeof s.default == "function" && e2.constructor === s.default && e2 !== s.default.prototype ? "symbol" : typeof e2;
      };
      t.default = typeof s.default == "function" && c(o.default) === "symbol" ? function(e2) {
        return e2 === void 0 ? "undefined" : c(e2);
      } : function(e2) {
        return e2 && typeof s.default == "function" && e2.constructor === s.default && e2 !== s.default.prototype ? "symbol" : e2 === void 0 ? "undefined" : c(e2);
      };
    }, function(e, t, n) {
      e.exports = { default: n(83), __esModule: true };
    }, function(e, t, n) {
      n(84), n(96), e.exports = n(32).f("iterator");
    }, function(e, t, n) {
      var r = n(85)(true);
      n(40)(String, "String", function(e2) {
        this._t = String(e2), this._i = 0;
      }, function() {
        var e2, t2 = this._t, n2 = this._i;
        return n2 >= t2.length ? { value: void 0, done: true } : (e2 = r(t2, n2), this._i += e2.length, { value: e2, done: false });
      });
    }, function(e, t, n) {
      var r = n(23), i = n(24);
      e.exports = function(e2) {
        return function(t2, n2) {
          var o, a, s = String(i(t2)), c = r(n2), l = s.length;
          return c < 0 || c >= l ? e2 ? "" : void 0 : (o = s.charCodeAt(c), o < 55296 || o > 56319 || c + 1 === l || (a = s.charCodeAt(c + 1)) < 56320 || a > 57343 ? e2 ? s.charAt(c) : o : e2 ? s.slice(c, c + 2) : a - 56320 + (o - 55296 << 10) + 65536);
        };
      };
    }, function(e, t, n) {
      var r = n(87);
      e.exports = function(e2, t2, n2) {
        if (r(e2), t2 === void 0)
          return e2;
        switch (n2) {
          case 1:
            return function(n3) {
              return e2.call(t2, n3);
            };
          case 2:
            return function(n3, r2) {
              return e2.call(t2, n3, r2);
            };
          case 3:
            return function(n3, r2, i) {
              return e2.call(t2, n3, r2, i);
            };
        }
        return function() {
          return e2.apply(t2, arguments);
        };
      };
    }, function(e, t) {
      e.exports = function(e2) {
        if (typeof e2 != "function")
          throw TypeError(e2 + " is not a function!");
        return e2;
      };
    }, function(e, t, n) {
      var r = n(45), i = n(18), o = n(31), a = {};
      n(7)(a, n(11)("iterator"), function() {
        return this;
      }), e.exports = function(e2, t2, n2) {
        e2.prototype = r(a, { next: i(1, n2) }), o(e2, t2 + " Iterator");
      };
    }, function(e, t, n) {
      var r = n(8), i = n(16), o = n(27);
      e.exports = n(9) ? Object.defineProperties : function(e2, t2) {
        i(e2);
        for (var n2, a = o(t2), s = a.length, c = 0; s > c; )
          r.f(e2, n2 = a[c++], t2[n2]);
        return e2;
      };
    }, function(e, t, n) {
      var r = n(47);
      e.exports = Object("z").propertyIsEnumerable(0) ? Object : function(e2) {
        return r(e2) == "String" ? e2.split("") : Object(e2);
      };
    }, function(e, t, n) {
      var r = n(10), i = n(92), o = n(93);
      e.exports = function(e2) {
        return function(t2, n2, a) {
          var s, c = r(t2), l = i(c.length), u = o(a, l);
          if (e2 && n2 != n2) {
            for (; l > u; )
              if ((s = c[u++]) != s)
                return true;
          } else
            for (; l > u; u++)
              if ((e2 || u in c) && c[u] === n2)
                return e2 || u || 0;
          return !e2 && -1;
        };
      };
    }, function(e, t, n) {
      var r = n(23), i = Math.min;
      e.exports = function(e2) {
        return e2 > 0 ? i(r(e2), 9007199254740991) : 0;
      };
    }, function(e, t, n) {
      var r = n(23), i = Math.max, o = Math.min;
      e.exports = function(e2, t2) {
        return e2 = r(e2), e2 < 0 ? i(e2 + t2, 0) : o(e2, t2);
      };
    }, function(e, t, n) {
      var r = n(4).document;
      e.exports = r && r.documentElement;
    }, function(e, t, n) {
      var r = n(6), i = n(48), o = n(28)("IE_PROTO"), a = Object.prototype;
      e.exports = Object.getPrototypeOf || function(e2) {
        return e2 = i(e2), r(e2, o) ? e2[o] : typeof e2.constructor == "function" && e2 instanceof e2.constructor ? e2.constructor.prototype : e2 instanceof Object ? a : null;
      };
    }, function(e, t, n) {
      n(97);
      for (var r = n(4), i = n(7), o = n(26), a = n(11)("toStringTag"), s = "CSSRuleList,CSSStyleDeclaration,CSSValueList,ClientRectList,DOMRectList,DOMStringList,DOMTokenList,DataTransferItemList,FileList,HTMLAllCollection,HTMLCollection,HTMLFormElement,HTMLSelectElement,MediaList,MimeTypeArray,NamedNodeMap,NodeList,PaintRequestList,Plugin,PluginArray,SVGLengthList,SVGNumberList,SVGPathSegList,SVGPointList,SVGStringList,SVGTransformList,SourceBufferList,StyleSheetList,TextTrackCueList,TextTrackList,TouchList".split(","), c = 0; c < s.length; c++) {
        var l = s[c], u = r[l], f = u && u.prototype;
        f && !f[a] && i(f, a, l), o[l] = o.Array;
      }
    }, function(e, t, n) {
      var r = n(98), i = n(99), o = n(26), a = n(10);
      e.exports = n(40)(Array, "Array", function(e2, t2) {
        this._t = a(e2), this._i = 0, this._k = t2;
      }, function() {
        var e2 = this._t, t2 = this._k, n2 = this._i++;
        return !e2 || n2 >= e2.length ? (this._t = void 0, i(1)) : t2 == "keys" ? i(0, n2) : t2 == "values" ? i(0, e2[n2]) : i(0, [n2, e2[n2]]);
      }, "values"), o.Arguments = o.Array, r("keys"), r("values"), r("entries");
    }, function(e, t) {
      e.exports = function() {
      };
    }, function(e, t) {
      e.exports = function(e2, t2) {
        return { value: t2, done: !!e2 };
      };
    }, function(e, t, n) {
      e.exports = { default: n(101), __esModule: true };
    }, function(e, t, n) {
      n(102), n(108), n(109), n(110), e.exports = n(15).Symbol;
    }, function(e, t, n) {
      var r = n(4), i = n(6), o = n(9), a = n(41), s = n(44), c = n(103).KEY, l = n(17), u = n(29), f = n(31), d = n(19), h = n(11), p = n(32), v = n(33), g = n(104), b = n(105), x = n(16), m = n(12), _ = n(48), w = n(10), y = n(25), C = n(18), k = n(45), F = n(106), S = n(107), A = n(49), O = n(8), E = n(27), M = S.f, j = O.f, L = F.f, P = r.Symbol, R = r.JSON, D = R && R.stringify, B = h("_hidden"), T = h("toPrimitive"), H = {}.propertyIsEnumerable, N = u("symbol-registry"), z = u("symbols"), I = u("op-symbols"), $ = Object.prototype, U = typeof P == "function" && !!A.f, G = r.QObject, V = !G || !G.prototype || !G.prototype.findChild, q = o && l(function() {
        return k(j({}, "a", { get: function() {
          return j(this, "a", { value: 7 }).a;
        } })).a != 7;
      }) ? function(e2, t2, n2) {
        var r2 = M($, t2);
        r2 && delete $[t2], j(e2, t2, n2), r2 && e2 !== $ && j($, t2, r2);
      } : j, X = function(e2) {
        var t2 = z[e2] = k(P.prototype);
        return t2._k = e2, t2;
      }, W = U && typeof P.iterator == "symbol" ? function(e2) {
        return typeof e2 == "symbol";
      } : function(e2) {
        return e2 instanceof P;
      }, Y = function(e2, t2, n2) {
        return e2 === $ && Y(I, t2, n2), x(e2), t2 = y(t2, true), x(n2), i(z, t2) ? (n2.enumerable ? (i(e2, B) && e2[B][t2] && (e2[B][t2] = false), n2 = k(n2, { enumerable: C(0, false) })) : (i(e2, B) || j(e2, B, C(1, {})), e2[B][t2] = true), q(e2, t2, n2)) : j(e2, t2, n2);
      }, J = function(e2, t2) {
        x(e2);
        for (var n2, r2 = g(t2 = w(t2)), i2 = 0, o2 = r2.length; o2 > i2; )
          Y(e2, n2 = r2[i2++], t2[n2]);
        return e2;
      }, K = function(e2, t2) {
        return t2 === void 0 ? k(e2) : J(k(e2), t2);
      }, Z = function(e2) {
        var t2 = H.call(this, e2 = y(e2, true));
        return !(this === $ && i(z, e2) && !i(I, e2)) && (!(t2 || !i(this, e2) || !i(z, e2) || i(this, B) && this[B][e2]) || t2);
      }, Q = function(e2, t2) {
        if (e2 = w(e2), t2 = y(t2, true), e2 !== $ || !i(z, t2) || i(I, t2)) {
          var n2 = M(e2, t2);
          return !n2 || !i(z, t2) || i(e2, B) && e2[B][t2] || (n2.enumerable = true), n2;
        }
      }, ee = function(e2) {
        for (var t2, n2 = L(w(e2)), r2 = [], o2 = 0; n2.length > o2; )
          i(z, t2 = n2[o2++]) || t2 == B || t2 == c || r2.push(t2);
        return r2;
      }, te = function(e2) {
        for (var t2, n2 = e2 === $, r2 = L(n2 ? I : w(e2)), o2 = [], a2 = 0; r2.length > a2; )
          !i(z, t2 = r2[a2++]) || n2 && !i($, t2) || o2.push(z[t2]);
        return o2;
      };
      U || (P = function() {
        if (this instanceof P)
          throw TypeError("Symbol is not a constructor!");
        var e2 = d(arguments.length > 0 ? arguments[0] : void 0), t2 = function(n2) {
          this === $ && t2.call(I, n2), i(this, B) && i(this[B], e2) && (this[B][e2] = false), q(this, e2, C(1, n2));
        };
        return o && V && q($, e2, { configurable: true, set: t2 }), X(e2);
      }, s(P.prototype, "toString", function() {
        return this._k;
      }), S.f = Q, O.f = Y, n(50).f = F.f = ee, n(34).f = Z, A.f = te, o && !n(14) && s($, "propertyIsEnumerable", Z, true), p.f = function(e2) {
        return X(h(e2));
      }), a(a.G + a.W + a.F * !U, { Symbol: P });
      for (var ne = "hasInstance,isConcatSpreadable,iterator,match,replace,search,species,split,toPrimitive,toStringTag,unscopables".split(","), re = 0; ne.length > re; )
        h(ne[re++]);
      for (var ie = E(h.store), oe = 0; ie.length > oe; )
        v(ie[oe++]);
      a(a.S + a.F * !U, "Symbol", { for: function(e2) {
        return i(N, e2 += "") ? N[e2] : N[e2] = P(e2);
      }, keyFor: function(e2) {
        if (!W(e2))
          throw TypeError(e2 + " is not a symbol!");
        for (var t2 in N)
          if (N[t2] === e2)
            return t2;
      }, useSetter: function() {
        V = true;
      }, useSimple: function() {
        V = false;
      } }), a(a.S + a.F * !U, "Object", { create: K, defineProperty: Y, defineProperties: J, getOwnPropertyDescriptor: Q, getOwnPropertyNames: ee, getOwnPropertySymbols: te });
      var ae = l(function() {
        A.f(1);
      });
      a(a.S + a.F * ae, "Object", { getOwnPropertySymbols: function(e2) {
        return A.f(_(e2));
      } }), R && a(a.S + a.F * (!U || l(function() {
        var e2 = P();
        return D([e2]) != "[null]" || D({ a: e2 }) != "{}" || D(Object(e2)) != "{}";
      })), "JSON", { stringify: function(e2) {
        for (var t2, n2, r2 = [e2], i2 = 1; arguments.length > i2; )
          r2.push(arguments[i2++]);
        if (n2 = t2 = r2[1], (m(t2) || e2 !== void 0) && !W(e2))
          return b(t2) || (t2 = function(e3, t3) {
            if (typeof n2 == "function" && (t3 = n2.call(this, e3, t3)), !W(t3))
              return t3;
          }), r2[1] = t2, D.apply(R, r2);
      } }), P.prototype[T] || n(7)(P.prototype, T, P.prototype.valueOf), f(P, "Symbol"), f(Math, "Math", true), f(r.JSON, "JSON", true);
    }, function(e, t, n) {
      var r = n(19)("meta"), i = n(12), o = n(6), a = n(8).f, s = 0, c = Object.isExtensible || function() {
        return true;
      }, l = !n(17)(function() {
        return c(Object.preventExtensions({}));
      }), u = function(e2) {
        a(e2, r, { value: { i: "O" + ++s, w: {} } });
      }, f = function(e2, t2) {
        if (!i(e2))
          return typeof e2 == "symbol" ? e2 : (typeof e2 == "string" ? "S" : "P") + e2;
        if (!o(e2, r)) {
          if (!c(e2))
            return "F";
          if (!t2)
            return "E";
          u(e2);
        }
        return e2[r].i;
      }, d = function(e2, t2) {
        if (!o(e2, r)) {
          if (!c(e2))
            return true;
          if (!t2)
            return false;
          u(e2);
        }
        return e2[r].w;
      }, h = function(e2) {
        return l && p.NEED && c(e2) && !o(e2, r) && u(e2), e2;
      }, p = e.exports = { KEY: r, NEED: false, fastKey: f, getWeak: d, onFreeze: h };
    }, function(e, t, n) {
      var r = n(27), i = n(49), o = n(34);
      e.exports = function(e2) {
        var t2 = r(e2), n2 = i.f;
        if (n2)
          for (var a, s = n2(e2), c = o.f, l = 0; s.length > l; )
            c.call(e2, a = s[l++]) && t2.push(a);
        return t2;
      };
    }, function(e, t, n) {
      var r = n(47);
      e.exports = Array.isArray || function(e2) {
        return r(e2) == "Array";
      };
    }, function(e, t, n) {
      var r = n(10), i = n(50).f, o = {}.toString, a = typeof window == "object" && window && Object.getOwnPropertyNames ? Object.getOwnPropertyNames(window) : [], s = function(e2) {
        try {
          return i(e2);
        } catch (e3) {
          return a.slice();
        }
      };
      e.exports.f = function(e2) {
        return a && o.call(e2) == "[object Window]" ? s(e2) : i(r(e2));
      };
    }, function(e, t, n) {
      var r = n(34), i = n(18), o = n(10), a = n(25), s = n(6), c = n(42), l = Object.getOwnPropertyDescriptor;
      t.f = n(9) ? l : function(e2, t2) {
        if (e2 = o(e2), t2 = a(t2, true), c)
          try {
            return l(e2, t2);
          } catch (e3) {
          }
        if (s(e2, t2))
          return i(!r.f.call(e2, t2), e2[t2]);
      };
    }, function(e, t) {
    }, function(e, t, n) {
      n(33)("asyncIterator");
    }, function(e, t, n) {
      n(33)("observable");
    }, function(e, t, n) {
      var r = n(112);
      typeof r == "string" && (r = [[e.i, r, ""]]), r.locals && (e.exports = r.locals);
      n(1)("7c5f1a1c", r, false, {});
    }, function(e, t, n) {
      t = e.exports = n(0)(false), t.push([e.i, "\n.vc-hue {\n  position: absolute;\n  top: 0px;\n  right: 0px;\n  bottom: 0px;\n  left: 0px;\n  border-radius: 2px;\n}\n.vc-hue--horizontal {\n  background: linear-gradient(to right, #f00 0%, #ff0 17%, #0f0 33%, #0ff 50%, #00f 67%, #f0f 83%, #f00 100%);\n}\n.vc-hue--vertical {\n  background: linear-gradient(to top, #f00 0%, #ff0 17%, #0f0 33%, #0ff 50%, #00f 67%, #f0f 83%, #f00 100%);\n}\n.vc-hue-container {\n  cursor: pointer;\n  margin: 0 2px;\n  position: relative;\n  height: 100%;\n}\n.vc-hue-pointer {\n  z-index: 2;\n  position: absolute;\n}\n.vc-hue-picker {\n  cursor: pointer;\n  margin-top: 1px;\n  width: 4px;\n  border-radius: 1px;\n  height: 8px;\n  box-shadow: 0 0 2px rgba(0, 0, 0, .6);\n  background: #fff;\n  transform: translateX(-2px) ;\n}\n", ""]);
    }, function(e, t, n) {
      var r = function() {
        var e2 = this, t2 = e2.$createElement, n2 = e2._self._c || t2;
        return n2("div", { class: ["vc-hue", e2.directionClass] }, [n2("div", { ref: "container", staticClass: "vc-hue-container", attrs: { role: "slider", "aria-valuenow": e2.colors.hsl.h, "aria-valuemin": "0", "aria-valuemax": "360" }, on: { mousedown: e2.handleMouseDown, touchmove: e2.handleChange, touchstart: e2.handleChange } }, [n2("div", { staticClass: "vc-hue-pointer", style: { top: e2.pointerTop, left: e2.pointerLeft }, attrs: { role: "presentation" } }, [n2("div", { staticClass: "vc-hue-picker" })])])]);
      }, i = [];
      r._withStripped = true;
      var o = { render: r, staticRenderFns: i };
      t.a = o;
    }, function(e, t, n) {
      var r = function() {
        var e2 = this, t2 = e2.$createElement, n2 = e2._self._c || t2;
        return n2("div", { staticClass: "vc-slider", attrs: { role: "application", "aria-label": "Slider color picker" } }, [n2("div", { staticClass: "vc-slider-hue-warp" }, [n2("hue", { on: { change: e2.hueChange }, model: { value: e2.colors, callback: function(t3) {
          e2.colors = t3;
        }, expression: "colors" } })], 1), e2._v(" "), n2("div", { staticClass: "vc-slider-swatches", attrs: { role: "group" } }, e2._l(e2.normalizedSwatches, function(t3, r2) {
          return n2("div", { key: r2, staticClass: "vc-slider-swatch", attrs: { "data-index": r2, "aria-label": "color:" + e2.colors.hex, role: "button" }, on: { click: function(n3) {
            return e2.handleSwClick(r2, t3);
          } } }, [n2("div", { staticClass: "vc-slider-swatch-picker", class: { "vc-slider-swatch-picker--active": e2.isActive(t3, r2), "vc-slider-swatch-picker--white": t3.l === 1 }, style: { background: "hsl(" + e2.colors.hsl.h + ", " + 100 * t3.s + "%, " + 100 * t3.l + "%)" } })]);
        }), 0)]);
      }, i = [];
      r._withStripped = true;
      var o = { render: r, staticRenderFns: i };
      t.a = o;
    }, function(e, t, n) {
      function r(e2) {
        n(116);
      }
      Object.defineProperty(t, "__esModule", { value: true });
      var i = n(52), o = n.n(i);
      for (var a in i)
        a !== "default" && function(e2) {
          n.d(t, e2, function() {
            return i[e2];
          });
        }(a);
      var s = n(119), l = n(2), u = r, f = l(o.a, s.a, false, u, null, null);
      f.options.__file = "src/components/Swatches.vue", t.default = f.exports;
    }, function(e, t, n) {
      var r = n(117);
      typeof r == "string" && (r = [[e.i, r, ""]]), r.locals && (e.exports = r.locals);
      n(1)("10f839a2", r, false, {});
    }, function(e, t, n) {
      t = e.exports = n(0)(false), t.push([e.i, "\n.vc-swatches {\n  width: 320px;\n  height: 240px;\n  overflow-y: scroll;\n  background-color: #fff;\n  box-shadow: 0 2px 10px rgba(0,0,0,.12), 0 2px 5px rgba(0,0,0,.16);\n}\n.vc-swatches-box {\n  padding: 16px 0 6px 16px;\n  overflow: hidden;\n}\n.vc-swatches-color-group {\n  padding-bottom: 10px;\n  width: 40px;\n  float: left;\n  margin-right: 10px;\n}\n.vc-swatches-color-it {\n  box-sizing: border-box;\n  width: 40px;\n  height: 24px;\n  cursor: pointer;\n  background: #880e4f;\n  margin-bottom: 1px;\n  overflow: hidden;\n  -ms-border-radius: 2px 2px 0 0;\n  -moz-border-radius: 2px 2px 0 0;\n  -o-border-radius: 2px 2px 0 0;\n  -webkit-border-radius: 2px 2px 0 0;\n  border-radius: 2px 2px 0 0;\n}\n.vc-swatches-color--white {\n  border: 1px solid #DDD;\n}\n.vc-swatches-pick {\n  fill: rgb(255, 255, 255);\n  margin-left: 8px;\n  display: block;\n}\n.vc-swatches-color--white .vc-swatches-pick {\n  fill: rgb(51, 51, 51);\n}\n", ""]);
    }, function(e, t, n) {
      Object.defineProperty(t, "__esModule", { value: true }), n.d(t, "red", function() {
        return r;
      }), n.d(t, "pink", function() {
        return i;
      }), n.d(t, "purple", function() {
        return o;
      }), n.d(t, "deepPurple", function() {
        return a;
      }), n.d(t, "indigo", function() {
        return s;
      }), n.d(t, "blue", function() {
        return c;
      }), n.d(t, "lightBlue", function() {
        return l;
      }), n.d(t, "cyan", function() {
        return u;
      }), n.d(t, "teal", function() {
        return f;
      }), n.d(t, "green", function() {
        return d;
      }), n.d(t, "lightGreen", function() {
        return h;
      }), n.d(t, "lime", function() {
        return p;
      }), n.d(t, "yellow", function() {
        return v;
      }), n.d(t, "amber", function() {
        return g;
      }), n.d(t, "orange", function() {
        return b;
      }), n.d(t, "deepOrange", function() {
        return x;
      }), n.d(t, "brown", function() {
        return m;
      }), n.d(t, "grey", function() {
        return _;
      }), n.d(t, "blueGrey", function() {
        return w;
      }), n.d(t, "darkText", function() {
        return y;
      }), n.d(t, "lightText", function() {
        return C;
      }), n.d(t, "darkIcons", function() {
        return k;
      }), n.d(t, "lightIcons", function() {
        return F;
      }), n.d(t, "white", function() {
        return S;
      }), n.d(t, "black", function() {
        return A;
      });
      var r = { 50: "#ffebee", 100: "#ffcdd2", 200: "#ef9a9a", 300: "#e57373", 400: "#ef5350", 500: "#f44336", 600: "#e53935", 700: "#d32f2f", 800: "#c62828", 900: "#b71c1c", a100: "#ff8a80", a200: "#ff5252", a400: "#ff1744", a700: "#d50000" }, i = { 50: "#fce4ec", 100: "#f8bbd0", 200: "#f48fb1", 300: "#f06292", 400: "#ec407a", 500: "#e91e63", 600: "#d81b60", 700: "#c2185b", 800: "#ad1457", 900: "#880e4f", a100: "#ff80ab", a200: "#ff4081", a400: "#f50057", a700: "#c51162" }, o = { 50: "#f3e5f5", 100: "#e1bee7", 200: "#ce93d8", 300: "#ba68c8", 400: "#ab47bc", 500: "#9c27b0", 600: "#8e24aa", 700: "#7b1fa2", 800: "#6a1b9a", 900: "#4a148c", a100: "#ea80fc", a200: "#e040fb", a400: "#d500f9", a700: "#aa00ff" }, a = { 50: "#ede7f6", 100: "#d1c4e9", 200: "#b39ddb", 300: "#9575cd", 400: "#7e57c2", 500: "#673ab7", 600: "#5e35b1", 700: "#512da8", 800: "#4527a0", 900: "#311b92", a100: "#b388ff", a200: "#7c4dff", a400: "#651fff", a700: "#6200ea" }, s = { 50: "#e8eaf6", 100: "#c5cae9", 200: "#9fa8da", 300: "#7986cb", 400: "#5c6bc0", 500: "#3f51b5", 600: "#3949ab", 700: "#303f9f", 800: "#283593", 900: "#1a237e", a100: "#8c9eff", a200: "#536dfe", a400: "#3d5afe", a700: "#304ffe" }, c = { 50: "#e3f2fd", 100: "#bbdefb", 200: "#90caf9", 300: "#64b5f6", 400: "#42a5f5", 500: "#2196f3", 600: "#1e88e5", 700: "#1976d2", 800: "#1565c0", 900: "#0d47a1", a100: "#82b1ff", a200: "#448aff", a400: "#2979ff", a700: "#2962ff" }, l = { 50: "#e1f5fe", 100: "#b3e5fc", 200: "#81d4fa", 300: "#4fc3f7", 400: "#29b6f6", 500: "#03a9f4", 600: "#039be5", 700: "#0288d1", 800: "#0277bd", 900: "#01579b", a100: "#80d8ff", a200: "#40c4ff", a400: "#00b0ff", a700: "#0091ea" }, u = { 50: "#e0f7fa", 100: "#b2ebf2", 200: "#80deea", 300: "#4dd0e1", 400: "#26c6da", 500: "#00bcd4", 600: "#00acc1", 700: "#0097a7", 800: "#00838f", 900: "#006064", a100: "#84ffff", a200: "#18ffff", a400: "#00e5ff", a700: "#00b8d4" }, f = { 50: "#e0f2f1", 100: "#b2dfdb", 200: "#80cbc4", 300: "#4db6ac", 400: "#26a69a", 500: "#009688", 600: "#00897b", 700: "#00796b", 800: "#00695c", 900: "#004d40", a100: "#a7ffeb", a200: "#64ffda", a400: "#1de9b6", a700: "#00bfa5" }, d = { 50: "#e8f5e9", 100: "#c8e6c9", 200: "#a5d6a7", 300: "#81c784", 400: "#66bb6a", 500: "#4caf50", 600: "#43a047", 700: "#388e3c", 800: "#2e7d32", 900: "#1b5e20", a100: "#b9f6ca", a200: "#69f0ae", a400: "#00e676", a700: "#00c853" }, h = { 50: "#f1f8e9", 100: "#dcedc8", 200: "#c5e1a5", 300: "#aed581", 400: "#9ccc65", 500: "#8bc34a", 600: "#7cb342", 700: "#689f38", 800: "#558b2f", 900: "#33691e", a100: "#ccff90", a200: "#b2ff59", a400: "#76ff03", a700: "#64dd17" }, p = { 50: "#f9fbe7", 100: "#f0f4c3", 200: "#e6ee9c", 300: "#dce775", 400: "#d4e157", 500: "#cddc39", 600: "#c0ca33", 700: "#afb42b", 800: "#9e9d24", 900: "#827717", a100: "#f4ff81", a200: "#eeff41", a400: "#c6ff00", a700: "#aeea00" }, v = { 50: "#fffde7", 100: "#fff9c4", 200: "#fff59d", 300: "#fff176", 400: "#ffee58", 500: "#ffeb3b", 600: "#fdd835", 700: "#fbc02d", 800: "#f9a825", 900: "#f57f17", a100: "#ffff8d", a200: "#ffff00", a400: "#ffea00", a700: "#ffd600" }, g = { 50: "#fff8e1", 100: "#ffecb3", 200: "#ffe082", 300: "#ffd54f", 400: "#ffca28", 500: "#ffc107", 600: "#ffb300", 700: "#ffa000", 800: "#ff8f00", 900: "#ff6f00", a100: "#ffe57f", a200: "#ffd740", a400: "#ffc400", a700: "#ffab00" }, b = { 50: "#fff3e0", 100: "#ffe0b2", 200: "#ffcc80", 300: "#ffb74d", 400: "#ffa726", 500: "#ff9800", 600: "#fb8c00", 700: "#f57c00", 800: "#ef6c00", 900: "#e65100", a100: "#ffd180", a200: "#ffab40", a400: "#ff9100", a700: "#ff6d00" }, x = { 50: "#fbe9e7", 100: "#ffccbc", 200: "#ffab91", 300: "#ff8a65", 400: "#ff7043", 500: "#ff5722", 600: "#f4511e", 700: "#e64a19", 800: "#d84315", 900: "#bf360c", a100: "#ff9e80", a200: "#ff6e40", a400: "#ff3d00", a700: "#dd2c00" }, m = { 50: "#efebe9", 100: "#d7ccc8", 200: "#bcaaa4", 300: "#a1887f", 400: "#8d6e63", 500: "#795548", 600: "#6d4c41", 700: "#5d4037", 800: "#4e342e", 900: "#3e2723" }, _ = { 50: "#fafafa", 100: "#f5f5f5", 200: "#eeeeee", 300: "#e0e0e0", 400: "#bdbdbd", 500: "#9e9e9e", 600: "#757575", 700: "#616161", 800: "#424242", 900: "#212121" }, w = { 50: "#eceff1", 100: "#cfd8dc", 200: "#b0bec5", 300: "#90a4ae", 400: "#78909c", 500: "#607d8b", 600: "#546e7a", 700: "#455a64", 800: "#37474f", 900: "#263238" }, y = { primary: "rgba(0, 0, 0, 0.87)", secondary: "rgba(0, 0, 0, 0.54)", disabled: "rgba(0, 0, 0, 0.38)", dividers: "rgba(0, 0, 0, 0.12)" }, C = { primary: "rgba(255, 255, 255, 1)", secondary: "rgba(255, 255, 255, 0.7)", disabled: "rgba(255, 255, 255, 0.5)", dividers: "rgba(255, 255, 255, 0.12)" }, k = { active: "rgba(0, 0, 0, 0.54)", inactive: "rgba(0, 0, 0, 0.38)" }, F = { active: "rgba(255, 255, 255, 1)", inactive: "rgba(255, 255, 255, 0.5)" }, S = "#ffffff", A = "#000000";
      t.default = { red: r, pink: i, purple: o, deepPurple: a, indigo: s, blue: c, lightBlue: l, cyan: u, teal: f, green: d, lightGreen: h, lime: p, yellow: v, amber: g, orange: b, deepOrange: x, brown: m, grey: _, blueGrey: w, darkText: y, lightText: C, darkIcons: k, lightIcons: F, white: S, black: A };
    }, function(e, t, n) {
      var r = function() {
        var e2 = this, t2 = e2.$createElement, n2 = e2._self._c || t2;
        return n2("div", { staticClass: "vc-swatches", attrs: { role: "application", "aria-label": "Swatches color picker", "data-pick": e2.pick } }, [n2("div", { staticClass: "vc-swatches-box", attrs: { role: "listbox" } }, e2._l(e2.palette, function(t3, r2) {
          return n2("div", { key: r2, staticClass: "vc-swatches-color-group" }, e2._l(t3, function(t4) {
            return n2("div", { key: t4, class: ["vc-swatches-color-it", { "vc-swatches-color--white": t4 === "#FFFFFF" }], style: { background: t4 }, attrs: { role: "option", "aria-label": "Color:" + t4, "aria-selected": e2.equal(t4), "data-color": t4 }, on: { click: function(n3) {
              return e2.handlerClick(t4);
            } } }, [n2("div", { directives: [{ name: "show", rawName: "v-show", value: e2.equal(t4), expression: "equal(c)" }], staticClass: "vc-swatches-pick" }, [n2("svg", { staticStyle: { width: "24px", height: "24px" }, attrs: { viewBox: "0 0 24 24" } }, [n2("path", { attrs: { d: "M21,7L9,19L3.5,13.5L4.91,12.09L9,16.17L19.59,5.59L21,7Z" } })])])]);
          }), 0);
        }), 0)]);
      }, i = [];
      r._withStripped = true;
      var o = { render: r, staticRenderFns: i };
      t.a = o;
    }, function(e, t, n) {
      function r(e2) {
        n(121);
      }
      Object.defineProperty(t, "__esModule", { value: true });
      var i = n(53), o = n.n(i);
      for (var a in i)
        a !== "default" && function(e2) {
          n.d(t, e2, function() {
            return i[e2];
          });
        }(a);
      var s = n(134), l = n(2), u = r, f = l(o.a, s.a, false, u, null, null);
      f.options.__file = "src/components/Photoshop.vue", t.default = f.exports;
    }, function(e, t, n) {
      var r = n(122);
      typeof r == "string" && (r = [[e.i, r, ""]]), r.locals && (e.exports = r.locals);
      n(1)("080365d4", r, false, {});
    }, function(e, t, n) {
      t = e.exports = n(0)(false), t.push([e.i, '\n.vc-photoshop {\n  background: #DCDCDC;\n  border-radius: 4px;\n  box-shadow: 0 0 0 1px rgba(0,0,0,.25), 0 8px 16px rgba(0,0,0,.15);\n  box-sizing: initial;\n  width: 513px;\n  font-family: Roboto;\n}\n.vc-photoshop__disable-fields {\n  width: 390px;\n}\n.vc-ps-head {\n  background-image: linear-gradient(-180deg, #F0F0F0 0%, #D4D4D4 100%);\n  border-bottom: 1px solid #B1B1B1;\n  box-shadow: inset 0 1px 0 0 rgba(255,255,255,.2), inset 0 -1px 0 0 rgba(0,0,0,.02);\n  height: 23px;\n  line-height: 24px;\n  border-radius: 4px 4px 0 0;\n  font-size: 13px;\n  color: #4D4D4D;\n  text-align: center;\n}\n.vc-ps-body {\n  padding: 15px;\n  display: flex;\n}\n.vc-ps-saturation-wrap {\n  width: 256px;\n  height: 256px;\n  position: relative;\n  border: 2px solid #B3B3B3;\n  border-bottom: 2px solid #F0F0F0;\n  overflow: hidden;\n}\n.vc-ps-saturation-wrap .vc-saturation-circle {\n  width: 12px;\n  height: 12px;\n}\n.vc-ps-hue-wrap {\n  position: relative;\n  height: 256px;\n  width: 19px;\n  margin-left: 10px;\n  border: 2px solid #B3B3B3;\n  border-bottom: 2px solid #F0F0F0;\n}\n.vc-ps-hue-pointer {\n  position: relative;\n}\n.vc-ps-hue-pointer--left,\n.vc-ps-hue-pointer--right {\n  position: absolute;\n  width: 0;\n  height: 0;\n  border-style: solid;\n  border-width: 5px 0 5px 8px;\n  border-color: transparent transparent transparent #555;\n}\n.vc-ps-hue-pointer--left:after,\n.vc-ps-hue-pointer--right:after {\n  content: "";\n  width: 0;\n  height: 0;\n  border-style: solid;\n  border-width: 4px 0 4px 6px;\n  border-color: transparent transparent transparent #fff;\n  position: absolute;\n  top: 1px;\n  left: 1px;\n  transform: translate(-8px, -5px);\n}\n.vc-ps-hue-pointer--left {\n  transform: translate(-13px, -4px);\n}\n.vc-ps-hue-pointer--right {\n  transform: translate(20px, -4px) rotate(180deg);\n}\n.vc-ps-controls {\n  width: 180px;\n  margin-left: 10px;\n  display: flex;\n}\n.vc-ps-controls__disable-fields {\n  width: auto;\n}\n.vc-ps-actions {\n  margin-left: 20px;\n  flex: 1;\n}\n.vc-ps-ac-btn {\n  cursor: pointer;\n  background-image: linear-gradient(-180deg, #FFFFFF 0%, #E6E6E6 100%);\n  border: 1px solid #878787;\n  border-radius: 2px;\n  height: 20px;\n  box-shadow: 0 1px 0 0 #EAEAEA;\n  font-size: 14px;\n  color: #000;\n  line-height: 20px;\n  text-align: center;\n  margin-bottom: 10px;\n}\n.vc-ps-previews {\n  width: 60px;\n}\n.vc-ps-previews__swatches {\n  border: 1px solid #B3B3B3;\n  border-bottom: 1px solid #F0F0F0;\n  margin-bottom: 2px;\n  margin-top: 1px;\n}\n.vc-ps-previews__pr-color {\n  height: 34px;\n  box-shadow: inset 1px 0 0 #000, inset -1px 0 0 #000, inset 0 1px 0 #000;\n}\n.vc-ps-previews__label {\n  font-size: 14px;\n  color: #000;\n  text-align: center;\n}\n.vc-ps-fields {\n  padding-top: 5px;\n  padding-bottom: 9px;\n  width: 80px;\n  position: relative;\n}\n.vc-ps-fields .vc-input__input {\n  margin-left: 40%;\n  width: 40%;\n  height: 18px;\n  border: 1px solid #888888;\n  box-shadow: inset 0 1px 1px rgba(0,0,0,.1), 0 1px 0 0 #ECECEC;\n  margin-bottom: 5px;\n  font-size: 13px;\n  padding-left: 3px;\n  margin-right: 10px;\n}\n.vc-ps-fields .vc-input__label, .vc-ps-fields .vc-input__desc {\n  top: 0;\n  text-transform: uppercase;\n  font-size: 13px;\n  height: 18px;\n  line-height: 22px;\n  position: absolute;\n}\n.vc-ps-fields .vc-input__label {\n  left: 0;\n  width: 34px;\n}\n.vc-ps-fields .vc-input__desc {\n  right: 0;\n  width: 0;\n}\n.vc-ps-fields__divider {\n  height: 5px;\n}\n.vc-ps-fields__hex .vc-input__input {\n  margin-left: 20%;\n  width: 80%;\n  height: 18px;\n  border: 1px solid #888888;\n  box-shadow: inset 0 1px 1px rgba(0,0,0,.1), 0 1px 0 0 #ECECEC;\n  margin-bottom: 6px;\n  font-size: 13px;\n  padding-left: 3px;\n}\n.vc-ps-fields__hex .vc-input__label {\n  position: absolute;\n  top: 0;\n  left: 0;\n  width: 14px;\n  text-transform: uppercase;\n  font-size: 13px;\n  height: 18px;\n  line-height: 22px;\n}\n', ""]);
    }, function(e, t, n) {
      var r = n(124);
      typeof r == "string" && (r = [[e.i, r, ""]]), r.locals && (e.exports = r.locals);
      n(1)("b5380e52", r, false, {});
    }, function(e, t, n) {
      t = e.exports = n(0)(false), t.push([e.i, "\n.vc-saturation,\n.vc-saturation--white,\n.vc-saturation--black {\n  cursor: pointer;\n  position: absolute;\n  top: 0;\n  left: 0;\n  right: 0;\n  bottom: 0;\n}\n.vc-saturation--white {\n  background: linear-gradient(to right, #fff, rgba(255,255,255,0));\n}\n.vc-saturation--black {\n  background: linear-gradient(to top, #000, rgba(0,0,0,0));\n}\n.vc-saturation-pointer {\n  cursor: pointer;\n  position: absolute;\n}\n.vc-saturation-circle {\n  cursor: head;\n  width: 4px;\n  height: 4px;\n  box-shadow: 0 0 0 1.5px #fff, inset 0 0 1px 1px rgba(0,0,0,.3), 0 0 1px 2px rgba(0,0,0,.4);\n  border-radius: 50%;\n  transform: translate(-2px, -2px);\n}\n", ""]);
    }, function(e, t) {
      function n(e2, t2, n2) {
        return t2 < n2 ? e2 < t2 ? t2 : e2 > n2 ? n2 : e2 : e2 < n2 ? n2 : e2 > t2 ? t2 : e2;
      }
      e.exports = n;
    }, function(e, t) {
      function n(e2, t2, n2) {
        function r2(t3) {
          var n3 = v2, r3 = g2;
          return v2 = g2 = void 0, k = t3, x2 = e2.apply(r3, n3);
        }
        function o2(e3) {
          return k = e3, m2 = setTimeout(u2, t2), F ? r2(e3) : x2;
        }
        function a2(e3) {
          var n3 = e3 - _2, r3 = e3 - k, i2 = t2 - n3;
          return S ? y(i2, b2 - r3) : i2;
        }
        function l2(e3) {
          var n3 = e3 - _2, r3 = e3 - k;
          return _2 === void 0 || n3 >= t2 || n3 < 0 || S && r3 >= b2;
        }
        function u2() {
          var e3 = C();
          if (l2(e3))
            return f2(e3);
          m2 = setTimeout(u2, a2(e3));
        }
        function f2(e3) {
          return m2 = void 0, A && v2 ? r2(e3) : (v2 = g2 = void 0, x2);
        }
        function d2() {
          m2 !== void 0 && clearTimeout(m2), k = 0, v2 = _2 = g2 = m2 = void 0;
        }
        function h2() {
          return m2 === void 0 ? x2 : f2(C());
        }
        function p2() {
          var e3 = C(), n3 = l2(e3);
          if (v2 = arguments, g2 = this, _2 = e3, n3) {
            if (m2 === void 0)
              return o2(_2);
            if (S)
              return m2 = setTimeout(u2, t2), r2(_2);
          }
          return m2 === void 0 && (m2 = setTimeout(u2, t2)), x2;
        }
        var v2, g2, b2, x2, m2, _2, k = 0, F = false, S = false, A = true;
        if (typeof e2 != "function")
          throw new TypeError(c);
        return t2 = s(t2) || 0, i(n2) && (F = !!n2.leading, S = "maxWait" in n2, b2 = S ? w(s(n2.maxWait) || 0, t2) : b2, A = "trailing" in n2 ? !!n2.trailing : A), p2.cancel = d2, p2.flush = h2, p2;
      }
      function r(e2, t2, r2) {
        var o2 = true, a2 = true;
        if (typeof e2 != "function")
          throw new TypeError(c);
        return i(r2) && (o2 = "leading" in r2 ? !!r2.leading : o2, a2 = "trailing" in r2 ? !!r2.trailing : a2), n(e2, t2, { leading: o2, maxWait: t2, trailing: a2 });
      }
      function i(e2) {
        var t2 = typeof e2;
        return !!e2 && (t2 == "object" || t2 == "function");
      }
      function o(e2) {
        return !!e2 && typeof e2 == "object";
      }
      function a(e2) {
        return typeof e2 == "symbol" || o(e2) && _.call(e2) == u;
      }
      function s(e2) {
        if (typeof e2 == "number")
          return e2;
        if (a(e2))
          return l;
        if (i(e2)) {
          var t2 = typeof e2.valueOf == "function" ? e2.valueOf() : e2;
          e2 = i(t2) ? t2 + "" : t2;
        }
        if (typeof e2 != "string")
          return e2 === 0 ? e2 : +e2;
        e2 = e2.replace(f, "");
        var n2 = h.test(e2);
        return n2 || p.test(e2) ? v(e2.slice(2), n2 ? 2 : 8) : d.test(e2) ? l : +e2;
      }
      var c = "Expected a function", l = NaN, u = "[object Symbol]", f = /^\s+|\s+$/g, d = /^[-+]0x[0-9a-f]+$/i, h = /^0b[01]+$/i, p = /^0o[0-7]+$/i, v = parseInt, g = typeof commonjsGlobal == "object" && commonjsGlobal && commonjsGlobal.Object === Object && commonjsGlobal, b = typeof self == "object" && self && self.Object === Object && self, x = g || b || Function("return this")(), m = Object.prototype, _ = m.toString, w = Math.max, y = Math.min, C = function() {
        return x.Date.now();
      };
      e.exports = r;
    }, function(e, t, n) {
      var r = function() {
        var e2 = this, t2 = e2.$createElement, n2 = e2._self._c || t2;
        return n2("div", { ref: "container", staticClass: "vc-saturation", style: { background: e2.bgColor }, on: { mousedown: e2.handleMouseDown, touchmove: e2.handleChange, touchstart: e2.handleChange } }, [n2("div", { staticClass: "vc-saturation--white" }), e2._v(" "), n2("div", { staticClass: "vc-saturation--black" }), e2._v(" "), n2("div", { staticClass: "vc-saturation-pointer", style: { top: e2.pointerTop, left: e2.pointerLeft } }, [n2("div", { staticClass: "vc-saturation-circle" })])]);
      }, i = [];
      r._withStripped = true;
      var o = { render: r, staticRenderFns: i };
      t.a = o;
    }, function(e, t, n) {
      var r = n(129);
      typeof r == "string" && (r = [[e.i, r, ""]]), r.locals && (e.exports = r.locals);
      n(1)("4dc1b086", r, false, {});
    }, function(e, t, n) {
      t = e.exports = n(0)(false), t.push([e.i, "\n.vc-alpha {\n  position: absolute;\n  top: 0px;\n  right: 0px;\n  bottom: 0px;\n  left: 0px;\n}\n.vc-alpha-checkboard-wrap {\n  position: absolute;\n  top: 0px;\n  right: 0px;\n  bottom: 0px;\n  left: 0px;\n  overflow: hidden;\n}\n.vc-alpha-gradient {\n  position: absolute;\n  top: 0px;\n  right: 0px;\n  bottom: 0px;\n  left: 0px;\n}\n.vc-alpha-container {\n  cursor: pointer;\n  position: relative;\n  z-index: 2;\n  height: 100%;\n  margin: 0 3px;\n}\n.vc-alpha-pointer {\n  z-index: 2;\n  position: absolute;\n}\n.vc-alpha-picker {\n  cursor: pointer;\n  width: 4px;\n  border-radius: 1px;\n  height: 8px;\n  box-shadow: 0 0 2px rgba(0, 0, 0, .6);\n  background: #fff;\n  margin-top: 1px;\n  transform: translateX(-2px);\n}\n", ""]);
    }, function(e, t, n) {
      var r = n(131);
      typeof r == "string" && (r = [[e.i, r, ""]]), r.locals && (e.exports = r.locals);
      n(1)("7e15c05b", r, false, {});
    }, function(e, t, n) {
      t = e.exports = n(0)(false), t.push([e.i, "\n.vc-checkerboard {\n  position: absolute;\n  top: 0px;\n  right: 0px;\n  bottom: 0px;\n  left: 0px;\n  background-size: contain;\n}\n", ""]);
    }, function(e, t, n) {
      var r = function() {
        var e2 = this, t2 = e2.$createElement;
        return (e2._self._c || t2)("div", { staticClass: "vc-checkerboard", style: e2.bgStyle });
      }, i = [];
      r._withStripped = true;
      var o = { render: r, staticRenderFns: i };
      t.a = o;
    }, function(e, t, n) {
      var r = function() {
        var e2 = this, t2 = e2.$createElement, n2 = e2._self._c || t2;
        return n2("div", { staticClass: "vc-alpha" }, [n2("div", { staticClass: "vc-alpha-checkboard-wrap" }, [n2("checkboard")], 1), e2._v(" "), n2("div", { staticClass: "vc-alpha-gradient", style: { background: e2.gradientColor } }), e2._v(" "), n2("div", { ref: "container", staticClass: "vc-alpha-container", on: { mousedown: e2.handleMouseDown, touchmove: e2.handleChange, touchstart: e2.handleChange } }, [n2("div", { staticClass: "vc-alpha-pointer", style: { left: 100 * e2.colors.a + "%" } }, [n2("div", { staticClass: "vc-alpha-picker" })])])]);
      }, i = [];
      r._withStripped = true;
      var o = { render: r, staticRenderFns: i };
      t.a = o;
    }, function(e, t, n) {
      var r = function() {
        var e2 = this, t2 = e2.$createElement, n2 = e2._self._c || t2;
        return n2("div", { class: ["vc-photoshop", e2.disableFields ? "vc-photoshop__disable-fields" : ""], attrs: { role: "application", "aria-label": "PhotoShop color picker" } }, [n2("div", { staticClass: "vc-ps-head", attrs: { role: "heading" } }, [e2._v(e2._s(e2.head))]), e2._v(" "), n2("div", { staticClass: "vc-ps-body" }, [n2("div", { staticClass: "vc-ps-saturation-wrap" }, [n2("saturation", { on: { change: e2.childChange }, model: { value: e2.colors, callback: function(t3) {
          e2.colors = t3;
        }, expression: "colors" } })], 1), e2._v(" "), n2("div", { staticClass: "vc-ps-hue-wrap" }, [n2("hue", { attrs: { direction: "vertical" }, on: { change: e2.childChange }, model: { value: e2.colors, callback: function(t3) {
          e2.colors = t3;
        }, expression: "colors" } }, [n2("div", { staticClass: "vc-ps-hue-pointer" }, [n2("i", { staticClass: "vc-ps-hue-pointer--left" }), n2("i", { staticClass: "vc-ps-hue-pointer--right" })])])], 1), e2._v(" "), n2("div", { class: ["vc-ps-controls", e2.disableFields ? "vc-ps-controls__disable-fields" : ""] }, [n2("div", { staticClass: "vc-ps-previews" }, [n2("div", { staticClass: "vc-ps-previews__label" }, [e2._v(e2._s(e2.newLabel))]), e2._v(" "), n2("div", { staticClass: "vc-ps-previews__swatches" }, [n2("div", { staticClass: "vc-ps-previews__pr-color", style: { background: e2.colors.hex }, attrs: { "aria-label": "New color is " + e2.colors.hex } }), e2._v(" "), n2("div", { staticClass: "vc-ps-previews__pr-color", style: { background: e2.currentColor }, attrs: { "aria-label": "Current color is " + e2.currentColor }, on: { click: e2.clickCurrentColor } })]), e2._v(" "), n2("div", { staticClass: "vc-ps-previews__label" }, [e2._v(e2._s(e2.currentLabel))])]), e2._v(" "), e2.disableFields ? e2._e() : n2("div", { staticClass: "vc-ps-actions" }, [n2("div", { staticClass: "vc-ps-ac-btn", attrs: { role: "button", "aria-label": e2.acceptLabel }, on: { click: e2.handleAccept } }, [e2._v(e2._s(e2.acceptLabel))]), e2._v(" "), n2("div", { staticClass: "vc-ps-ac-btn", attrs: { role: "button", "aria-label": e2.cancelLabel }, on: { click: e2.handleCancel } }, [e2._v(e2._s(e2.cancelLabel))]), e2._v(" "), n2("div", { staticClass: "vc-ps-fields" }, [n2("ed-in", { attrs: { label: "h", desc: "\xB0", value: e2.hsv.h }, on: { change: e2.inputChange } }), e2._v(" "), n2("ed-in", { attrs: { label: "s", desc: "%", value: e2.hsv.s, max: 100 }, on: { change: e2.inputChange } }), e2._v(" "), n2("ed-in", { attrs: { label: "v", desc: "%", value: e2.hsv.v, max: 100 }, on: { change: e2.inputChange } }), e2._v(" "), n2("div", { staticClass: "vc-ps-fields__divider" }), e2._v(" "), n2("ed-in", { attrs: { label: "r", value: e2.colors.rgba.r }, on: { change: e2.inputChange } }), e2._v(" "), n2("ed-in", { attrs: { label: "g", value: e2.colors.rgba.g }, on: { change: e2.inputChange } }), e2._v(" "), n2("ed-in", { attrs: { label: "b", value: e2.colors.rgba.b }, on: { change: e2.inputChange } }), e2._v(" "), n2("div", { staticClass: "vc-ps-fields__divider" }), e2._v(" "), n2("ed-in", { staticClass: "vc-ps-fields__hex", attrs: { label: "#", value: e2.hex }, on: { change: e2.inputChange } })], 1), e2._v(" "), e2.hasResetButton ? n2("div", { staticClass: "vc-ps-ac-btn", attrs: { "aria-label": "reset" }, on: { click: e2.handleReset } }, [e2._v(e2._s(e2.resetLabel))]) : e2._e()])])])]);
      }, i = [];
      r._withStripped = true;
      var o = { render: r, staticRenderFns: i };
      t.a = o;
    }, function(e, t, n) {
      function r(e2) {
        n(136);
      }
      Object.defineProperty(t, "__esModule", { value: true });
      var i = n(57), o = n.n(i);
      for (var a in i)
        a !== "default" && function(e2) {
          n.d(t, e2, function() {
            return i[e2];
          });
        }(a);
      var s = n(138), l = n(2), u = r, f = l(o.a, s.a, false, u, null, null);
      f.options.__file = "src/components/Sketch.vue", t.default = f.exports;
    }, function(e, t, n) {
      var r = n(137);
      typeof r == "string" && (r = [[e.i, r, ""]]), r.locals && (e.exports = r.locals);
      n(1)("612c6604", r, false, {});
    }, function(e, t, n) {
      t = e.exports = n(0)(false), t.push([e.i, "\n.vc-sketch {\n  position: relative;\n  width: 200px;\n  padding: 10px 10px 0;\n  box-sizing: initial;\n  background: #fff;\n  border-radius: 4px;\n  box-shadow: 0 0 0 1px rgba(0, 0, 0, .15), 0 8px 16px rgba(0, 0, 0, .15);\n}\n.vc-sketch-saturation-wrap {\n  width: 100%;\n  padding-bottom: 75%;\n  position: relative;\n  overflow: hidden;\n}\n.vc-sketch-controls {\n  display: flex;\n}\n.vc-sketch-sliders {\n  padding: 4px 0;\n  flex: 1;\n}\n.vc-sketch-sliders .vc-hue,\n.vc-sketch-sliders .vc-alpha-gradient {\n  border-radius: 2px;\n}\n.vc-sketch-hue-wrap {\n  position: relative;\n  height: 10px;\n}\n.vc-sketch-alpha-wrap {\n  position: relative;\n  height: 10px;\n  margin-top: 4px;\n  overflow: hidden;\n}\n.vc-sketch-color-wrap {\n  width: 24px;\n  height: 24px;\n  position: relative;\n  margin-top: 4px;\n  margin-left: 4px;\n  border-radius: 3px;\n}\n.vc-sketch-active-color {\n  position: absolute;\n  top: 0;\n  left: 0;\n  right: 0;\n  bottom: 0;\n  border-radius: 2px;\n  box-shadow: inset 0 0 0 1px rgba(0, 0, 0, .15), inset 0 0 4px rgba(0, 0, 0, .25);\n  z-index: 2;\n}\n.vc-sketch-color-wrap .vc-checkerboard {\n  background-size: auto;\n}\n.vc-sketch-field {\n  display: flex;\n  padding-top: 4px;\n}\n.vc-sketch-field .vc-input__input {\n  width: 90%;\n  padding: 4px 0 3px 10%;\n  border: none;\n  box-shadow: inset 0 0 0 1px #ccc;\n  font-size: 10px;\n}\n.vc-sketch-field .vc-input__label {\n  display: block;\n  text-align: center;\n  font-size: 11px;\n  color: #222;\n  padding-top: 3px;\n  padding-bottom: 4px;\n  text-transform: capitalize;\n}\n.vc-sketch-field--single {\n  flex: 1;\n  padding-left: 6px;\n}\n.vc-sketch-field--double {\n  flex: 2;\n}\n.vc-sketch-presets {\n  margin-right: -10px;\n  margin-left: -10px;\n  padding-left: 10px;\n  padding-top: 10px;\n  border-top: 1px solid #eee;\n}\n.vc-sketch-presets-color {\n  border-radius: 3px;\n  overflow: hidden;\n  position: relative;\n  display: inline-block;\n  margin: 0 10px 10px 0;\n  vertical-align: top;\n  cursor: pointer;\n  width: 16px;\n  height: 16px;\n  box-shadow: inset 0 0 0 1px rgba(0, 0, 0, .15);\n}\n.vc-sketch-presets-color .vc-checkerboard {\n  box-shadow: inset 0 0 0 1px rgba(0, 0, 0, .15);\n  border-radius: 3px;\n}\n.vc-sketch__disable-alpha .vc-sketch-color-wrap {\n  height: 10px;\n}\n", ""]);
    }, function(e, t, n) {
      var r = function() {
        var e2 = this, t2 = e2.$createElement, n2 = e2._self._c || t2;
        return n2("div", { class: ["vc-sketch", e2.disableAlpha ? "vc-sketch__disable-alpha" : ""], attrs: { role: "application", "aria-label": "Sketch color picker" } }, [n2("div", { staticClass: "vc-sketch-saturation-wrap" }, [n2("saturation", { on: { change: e2.childChange }, model: { value: e2.colors, callback: function(t3) {
          e2.colors = t3;
        }, expression: "colors" } })], 1), e2._v(" "), n2("div", { staticClass: "vc-sketch-controls" }, [n2("div", { staticClass: "vc-sketch-sliders" }, [n2("div", { staticClass: "vc-sketch-hue-wrap" }, [n2("hue", { on: { change: e2.childChange }, model: { value: e2.colors, callback: function(t3) {
          e2.colors = t3;
        }, expression: "colors" } })], 1), e2._v(" "), e2.disableAlpha ? e2._e() : n2("div", { staticClass: "vc-sketch-alpha-wrap" }, [n2("alpha", { on: { change: e2.childChange }, model: { value: e2.colors, callback: function(t3) {
          e2.colors = t3;
        }, expression: "colors" } })], 1)]), e2._v(" "), n2("div", { staticClass: "vc-sketch-color-wrap" }, [n2("div", { staticClass: "vc-sketch-active-color", style: { background: e2.activeColor }, attrs: { "aria-label": "Current color is " + e2.activeColor } }), e2._v(" "), n2("checkboard")], 1)]), e2._v(" "), e2.disableFields ? e2._e() : n2("div", { staticClass: "vc-sketch-field" }, [n2("div", { staticClass: "vc-sketch-field--double" }, [n2("ed-in", { attrs: { label: "hex", value: e2.hex }, on: { change: e2.inputChange } })], 1), e2._v(" "), n2("div", { staticClass: "vc-sketch-field--single" }, [n2("ed-in", { attrs: { label: "r", value: e2.colors.rgba.r }, on: { change: e2.inputChange } })], 1), e2._v(" "), n2("div", { staticClass: "vc-sketch-field--single" }, [n2("ed-in", { attrs: { label: "g", value: e2.colors.rgba.g }, on: { change: e2.inputChange } })], 1), e2._v(" "), n2("div", { staticClass: "vc-sketch-field--single" }, [n2("ed-in", { attrs: { label: "b", value: e2.colors.rgba.b }, on: { change: e2.inputChange } })], 1), e2._v(" "), e2.disableAlpha ? e2._e() : n2("div", { staticClass: "vc-sketch-field--single" }, [n2("ed-in", { attrs: { label: "a", value: e2.colors.a, "arrow-offset": 0.01, max: 1 }, on: { change: e2.inputChange } })], 1)]), e2._v(" "), n2("div", { staticClass: "vc-sketch-presets", attrs: { role: "group", "aria-label": "A color preset, pick one to set as current color" } }, [e2._l(e2.presetColors, function(t3) {
          return [e2.isTransparent(t3) ? n2("div", { key: t3, staticClass: "vc-sketch-presets-color", attrs: { "aria-label": "Color:" + t3 }, on: { click: function(n3) {
            return e2.handlePreset(t3);
          } } }, [n2("checkboard")], 1) : n2("div", { key: t3, staticClass: "vc-sketch-presets-color", style: { background: t3 }, attrs: { "aria-label": "Color:" + t3 }, on: { click: function(n3) {
            return e2.handlePreset(t3);
          } } })];
        })], 2)]);
      }, i = [];
      r._withStripped = true;
      var o = { render: r, staticRenderFns: i };
      t.a = o;
    }, function(e, t, n) {
      function r(e2) {
        n(140);
      }
      Object.defineProperty(t, "__esModule", { value: true });
      var i = n(58), o = n.n(i);
      for (var a in i)
        a !== "default" && function(e2) {
          n.d(t, e2, function() {
            return i[e2];
          });
        }(a);
      var s = n(142), l = n(2), u = r, f = l(o.a, s.a, false, u, null, null);
      f.options.__file = "src/components/Chrome.vue", t.default = f.exports;
    }, function(e, t, n) {
      var r = n(141);
      typeof r == "string" && (r = [[e.i, r, ""]]), r.locals && (e.exports = r.locals);
      n(1)("1cd16048", r, false, {});
    }, function(e, t, n) {
      t = e.exports = n(0)(false), t.push([e.i, "\n.vc-chrome {\n  background: #fff;\n  border-radius: 2px;\n  box-shadow: 0 0 2px rgba(0,0,0,.3), 0 4px 8px rgba(0,0,0,.3);\n  box-sizing: initial;\n  width: 225px;\n  font-family: Menlo;\n  background-color: #fff;\n}\n.vc-chrome-controls {\n  display: flex;\n}\n.vc-chrome-color-wrap {\n  position: relative;\n  width: 36px;\n}\n.vc-chrome-active-color {\n  position: relative;\n  width: 30px;\n  height: 30px;\n  border-radius: 15px;\n  overflow: hidden;\n  z-index: 1;\n}\n.vc-chrome-color-wrap .vc-checkerboard {\n  width: 30px;\n  height: 30px;\n  border-radius: 15px;\n  background-size: auto;\n}\n.vc-chrome-sliders {\n  flex: 1;\n}\n.vc-chrome-fields-wrap {\n  display: flex;\n  padding-top: 16px;\n}\n.vc-chrome-fields {\n  display: flex;\n  margin-left: -6px;\n  flex: 1;\n}\n.vc-chrome-field {\n  padding-left: 6px;\n  width: 100%;\n}\n.vc-chrome-toggle-btn {\n  width: 32px;\n  text-align: right;\n  position: relative;\n}\n.vc-chrome-toggle-icon {\n  margin-right: -4px;\n  margin-top: 12px;\n  cursor: pointer;\n  position: relative;\n  z-index: 2;\n}\n.vc-chrome-toggle-icon-highlight {\n  position: absolute;\n  width: 24px;\n  height: 28px;\n  background: #eee;\n  border-radius: 4px;\n  top: 10px;\n  left: 12px;\n}\n.vc-chrome-hue-wrap {\n  position: relative;\n  height: 10px;\n  margin-bottom: 8px;\n}\n.vc-chrome-alpha-wrap {\n  position: relative;\n  height: 10px;\n}\n.vc-chrome-hue-wrap .vc-hue {\n  border-radius: 2px;\n}\n.vc-chrome-alpha-wrap .vc-alpha-gradient {\n  border-radius: 2px;\n}\n.vc-chrome-hue-wrap .vc-hue-picker, .vc-chrome-alpha-wrap .vc-alpha-picker {\n  width: 12px;\n  height: 12px;\n  border-radius: 6px;\n  transform: translate(-6px, -2px);\n  background-color: rgb(248, 248, 248);\n  box-shadow: 0 1px 4px 0 rgba(0, 0, 0, 0.37);\n}\n.vc-chrome-body {\n  padding: 16px 16px 12px;\n  background-color: #fff;\n}\n.vc-chrome-saturation-wrap {\n  width: 100%;\n  padding-bottom: 55%;\n  position: relative;\n  border-radius: 2px 2px 0 0;\n  overflow: hidden;\n}\n.vc-chrome-saturation-wrap .vc-saturation-circle {\n  width: 12px;\n  height: 12px;\n}\n.vc-chrome-fields .vc-input__input {\n  font-size: 11px;\n  color: #333;\n  width: 100%;\n  border-radius: 2px;\n  border: none;\n  box-shadow: inset 0 0 0 1px #dadada;\n  height: 21px;\n  text-align: center;\n}\n.vc-chrome-fields .vc-input__label {\n  text-transform: uppercase;\n  font-size: 11px;\n  line-height: 11px;\n  color: #969696;\n  text-align: center;\n  display: block;\n  margin-top: 12px;\n}\n.vc-chrome__disable-alpha .vc-chrome-active-color {\n  width: 18px;\n  height: 18px;\n}\n.vc-chrome__disable-alpha .vc-chrome-color-wrap {\n  width: 30px;\n}\n.vc-chrome__disable-alpha .vc-chrome-hue-wrap {\n  margin-top: 4px;\n  margin-bottom: 4px;\n}\n", ""]);
    }, function(e, t, n) {
      var r = function() {
        var e2 = this, t2 = e2.$createElement, n2 = e2._self._c || t2;
        return n2("div", { class: ["vc-chrome", e2.disableAlpha ? "vc-chrome__disable-alpha" : ""], attrs: { role: "application", "aria-label": "Chrome color picker" } }, [n2("div", { staticClass: "vc-chrome-saturation-wrap" }, [n2("saturation", { on: { change: e2.childChange }, model: { value: e2.colors, callback: function(t3) {
          e2.colors = t3;
        }, expression: "colors" } })], 1), e2._v(" "), n2("div", { staticClass: "vc-chrome-body" }, [n2("div", { staticClass: "vc-chrome-controls" }, [n2("div", { staticClass: "vc-chrome-color-wrap" }, [n2("div", { staticClass: "vc-chrome-active-color", style: { background: e2.activeColor }, attrs: { "aria-label": "current color is " + e2.colors.hex } }), e2._v(" "), e2.disableAlpha ? e2._e() : n2("checkboard")], 1), e2._v(" "), n2("div", { staticClass: "vc-chrome-sliders" }, [n2("div", { staticClass: "vc-chrome-hue-wrap" }, [n2("hue", { on: { change: e2.childChange }, model: { value: e2.colors, callback: function(t3) {
          e2.colors = t3;
        }, expression: "colors" } })], 1), e2._v(" "), e2.disableAlpha ? e2._e() : n2("div", { staticClass: "vc-chrome-alpha-wrap" }, [n2("alpha", { on: { change: e2.childChange }, model: { value: e2.colors, callback: function(t3) {
          e2.colors = t3;
        }, expression: "colors" } })], 1)])]), e2._v(" "), e2.disableFields ? e2._e() : n2("div", { staticClass: "vc-chrome-fields-wrap" }, [n2("div", { directives: [{ name: "show", rawName: "v-show", value: e2.fieldsIndex === 0, expression: "fieldsIndex === 0" }], staticClass: "vc-chrome-fields" }, [n2("div", { staticClass: "vc-chrome-field" }, [e2.hasAlpha ? e2._e() : n2("ed-in", { attrs: { label: "hex", value: e2.colors.hex }, on: { change: e2.inputChange } }), e2._v(" "), e2.hasAlpha ? n2("ed-in", { attrs: { label: "hex", value: e2.colors.hex8 }, on: { change: e2.inputChange } }) : e2._e()], 1)]), e2._v(" "), n2("div", { directives: [{ name: "show", rawName: "v-show", value: e2.fieldsIndex === 1, expression: "fieldsIndex === 1" }], staticClass: "vc-chrome-fields" }, [n2("div", { staticClass: "vc-chrome-field" }, [n2("ed-in", { attrs: { label: "r", value: e2.colors.rgba.r }, on: { change: e2.inputChange } })], 1), e2._v(" "), n2("div", { staticClass: "vc-chrome-field" }, [n2("ed-in", { attrs: { label: "g", value: e2.colors.rgba.g }, on: { change: e2.inputChange } })], 1), e2._v(" "), n2("div", { staticClass: "vc-chrome-field" }, [n2("ed-in", { attrs: { label: "b", value: e2.colors.rgba.b }, on: { change: e2.inputChange } })], 1), e2._v(" "), e2.disableAlpha ? e2._e() : n2("div", { staticClass: "vc-chrome-field" }, [n2("ed-in", { attrs: { label: "a", value: e2.colors.a, "arrow-offset": 0.01, max: 1 }, on: { change: e2.inputChange } })], 1)]), e2._v(" "), n2("div", { directives: [{ name: "show", rawName: "v-show", value: e2.fieldsIndex === 2, expression: "fieldsIndex === 2" }], staticClass: "vc-chrome-fields" }, [n2("div", { staticClass: "vc-chrome-field" }, [n2("ed-in", { attrs: { label: "h", value: e2.hsl.h }, on: { change: e2.inputChange } })], 1), e2._v(" "), n2("div", { staticClass: "vc-chrome-field" }, [n2("ed-in", { attrs: { label: "s", value: e2.hsl.s }, on: { change: e2.inputChange } })], 1), e2._v(" "), n2("div", { staticClass: "vc-chrome-field" }, [n2("ed-in", { attrs: { label: "l", value: e2.hsl.l }, on: { change: e2.inputChange } })], 1), e2._v(" "), e2.disableAlpha ? e2._e() : n2("div", { staticClass: "vc-chrome-field" }, [n2("ed-in", { attrs: { label: "a", value: e2.colors.a, "arrow-offset": 0.01, max: 1 }, on: { change: e2.inputChange } })], 1)]), e2._v(" "), n2("div", { staticClass: "vc-chrome-toggle-btn", attrs: { role: "button", "aria-label": "Change another color definition" }, on: { click: e2.toggleViews } }, [n2("div", { staticClass: "vc-chrome-toggle-icon" }, [n2("svg", { staticStyle: { width: "24px", height: "24px" }, attrs: { viewBox: "0 0 24 24" }, on: { mouseover: e2.showHighlight, mouseenter: e2.showHighlight, mouseout: e2.hideHighlight } }, [n2("path", { attrs: { fill: "#333", d: "M12,18.17L8.83,15L7.42,16.41L12,21L16.59,16.41L15.17,15M12,5.83L15.17,9L16.58,7.59L12,3L7.41,7.59L8.83,9L12,5.83Z" } })])]), e2._v(" "), n2("div", { directives: [{ name: "show", rawName: "v-show", value: e2.highlight, expression: "highlight" }], staticClass: "vc-chrome-toggle-icon-highlight" })])])])]);
      }, i = [];
      r._withStripped = true;
      var o = { render: r, staticRenderFns: i };
      t.a = o;
    }, function(e, t, n) {
      function r(e2) {
        n(144);
      }
      Object.defineProperty(t, "__esModule", { value: true });
      var i = n(59), o = n.n(i);
      for (var a in i)
        a !== "default" && function(e2) {
          n.d(t, e2, function() {
            return i[e2];
          });
        }(a);
      var s = n(146), l = n(2), u = r, f = l(o.a, s.a, false, u, null, null);
      f.options.__file = "src/components/Twitter.vue", t.default = f.exports;
    }, function(e, t, n) {
      var r = n(145);
      typeof r == "string" && (r = [[e.i, r, ""]]), r.locals && (e.exports = r.locals);
      n(1)("669a48a5", r, false, {});
    }, function(e, t, n) {
      t = e.exports = n(0)(false), t.push([e.i, "\n.vc-twitter {\n  background: #fff;\n  border: 0 solid rgba(0,0,0,0.25);\n  box-shadow: 0 1px 4px rgba(0,0,0,0.25);\n  border-radius: 4px;\n  position: relative;\n}\n.vc-twitter-triangle {\n  width: 0px;\n  height: 0px;\n  border-style: solid;\n  border-width: 0 9px 10px 9px;\n  border-color: transparent transparent #fff transparent;\n  position: absolute;\n}\n.vc-twitter-triangle-shadow {\n  width: 0px;\n  height: 0px;\n  border-style: solid;\n  border-width: 0 9px 10px 9px;\n  border-color: transparent transparent rgba(0, 0, 0, .1) transparent;\n  position: absolute;\n}\n.vc-twitter-body {\n  padding: 15px 9px 9px 15px;\n}\n.vc-twitter .vc-editable-input {\n  position: relative;\n}\n.vc-twitter .vc-editable-input input {\n  width: 100px;\n  font-size: 14px;\n  color: #666;\n  border: 0px;\n  outline: none;\n  height: 28px;\n  box-shadow: inset 0 0 0 1px #F0F0F0;\n  box-sizing: content-box;\n  border-radius: 0 4px 4px 0;\n  float: left;\n  padding: 1px;\n  padding-left: 8px;\n}\n.vc-twitter .vc-editable-input span {\n  display: none;\n}\n.vc-twitter-hash {\n  background: #F0F0F0;\n  height: 30px;\n  width: 30px;\n  border-radius: 4px 0 0 4px;\n  float: left;\n  color: #98A1A4;\n  display: flex;\n  align-items: center;\n  justify-content: center;\n}\n.vc-twitter-swatch {\n  width: 30px;\n  height: 30px;\n  float: left;\n  border-radius: 4px;\n  margin: 0 6px 6px 0;\n  cursor: pointer;\n  position: relative;\n  outline: none;\n}\n.vc-twitter-clear {\n  clear: both;\n}\n.vc-twitter-hide-triangle .vc-twitter-triangle {\n  display: none;\n}\n.vc-twitter-hide-triangle .vc-twitter-triangle-shadow {\n  display: none;\n}\n.vc-twitter-top-left-triangle .vc-twitter-triangle{\n  top: -10px;\n  left: 12px;\n}\n.vc-twitter-top-left-triangle .vc-twitter-triangle-shadow{\n  top: -11px;\n  left: 12px;\n}\n.vc-twitter-top-right-triangle .vc-twitter-triangle{\n  top: -10px;\n  right: 12px;\n}\n.vc-twitter-top-right-triangle .vc-twitter-triangle-shadow{\n  top: -11px;\n  right: 12px;\n}\n", ""]);
    }, function(e, t, n) {
      var r = function() {
        var e2 = this, t2 = e2.$createElement, n2 = e2._self._c || t2;
        return n2("div", { staticClass: "vc-twitter", class: { "vc-twitter-hide-triangle ": e2.triangle === "hide", "vc-twitter-top-left-triangle ": e2.triangle === "top-left", "vc-twitter-top-right-triangle ": e2.triangle === "top-right" }, style: { width: typeof e2.width == "number" ? e2.width + "px" : e2.width } }, [n2("div", { staticClass: "vc-twitter-triangle-shadow" }), e2._v(" "), n2("div", { staticClass: "vc-twitter-triangle" }), e2._v(" "), n2("div", { staticClass: "vc-twitter-body" }, [e2._l(e2.defaultColors, function(t3, r2) {
          return n2("span", { key: r2, staticClass: "vc-twitter-swatch", style: { background: t3, boxShadow: "0 0 4px " + (e2.equal(t3) ? t3 : "transparent") }, on: { click: function(n3) {
            return e2.handlerClick(t3);
          } } });
        }), e2._v(" "), n2("div", { staticClass: "vc-twitter-hash" }, [e2._v("#")]), e2._v(" "), n2("editable-input", { attrs: { label: "#", value: e2.hex }, on: { change: e2.inputChange } }), e2._v(" "), n2("div", { staticClass: "vc-twitter-clear" })], 2)]);
      }, i = [];
      r._withStripped = true;
      var o = { render: r, staticRenderFns: i };
      t.a = o;
    }]);
  });
})(vueColor_min);
var render$8 = function() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", { staticClass: "fvl-color-picker-wrapper", class: { "fvl-has-error": _vm.$parent.hasErrors(_vm.name) } }, [_vm.label ? _c("label", { staticClass: "fvl-color-picker-label", class: _vm.labelClass, attrs: { "for": _vm.name } }, [_c("span", { domProps: { "innerHTML": _vm._s(_vm.label) } }), _vm._t("label_suffix")], 2) : _vm._e(), _c("on-click-outside", { on: { "do": function($event) {
    return _vm.close();
  } } }, [_c("div", { staticClass: "fvl-color-picker-group", class: _vm.fieldClass }, [_vm._t("prefix"), _c("div", { staticClass: "fvl-color-picker-container" }, [_c("input", { ref: "colorinput", staticClass: "fvl-color-picker", attrs: { "id": _vm.id, "autocapitalize": "off", "spellcheck": "false", "name": _vm.name, "required": _vm.required, "disabled": _vm.disabled, "readonly": _vm.readonly, "type": "text", "pattern": _vm.validateFormat ? _vm.pattern : null }, domProps: { "value": _vm.value }, on: { "keyup": function($event) {
    if (!$event.type.indexOf("key") && _vm._k($event.keyCode, "space", 32, $event.key, [" ", "Spacebar"])) {
      return null;
    }
    return _vm.toggle();
  }, "change": function($event) {
    return _vm.updateValueManually($event.target.value);
  }, "input": function($event) {
    return _vm.$parent.dirty(_vm.name);
  } } }), _c("div", { ref: "colorpicker", staticClass: "fvl-color-preview", on: { "click": function($event) {
    return _vm.toggle();
  } } }, [_c("span", { staticClass: "inline-block rounded-full border border-white h-4 w-4", style: { background: _vm.value } })])]), _vm._t("suffix"), _c("div", { directives: [{ name: "show", rawName: "v-show", value: _vm.isOpen, expression: "isOpen" }], ref: "picker", staticClass: "fvl-color-picker-dropdown" }, [_c("chrome-picker", { ref: "picker", attrs: { "disable-alpha": _vm.format == "hex", "value": _vm.value, "disable-fields": "" }, on: { "input": _vm.updateValue } })], 1)], 2), _vm._t("hint"), _vm._t("errors", function() {
    return [_c("validation-errors", { attrs: { "errors": _vm.$parent.getErrors(_vm.name) } })];
  }, { "errors": _vm.$parent.getErrors(_vm.name) })], 2)], 1);
};
var staticRenderFns$8 = [];
const __vue2_script$8 = {
  components: {
    OnClickOutside,
    ValidationErrors,
    "chrome-picker": vueColor_min.exports.Chrome
  },
  props: {
    label: {
      type: String,
      required: false,
      default: null
    },
    name: {
      type: String,
      required: true
    },
    id: {
      type: String,
      default: null
    },
    value: {
      validator: (prop) => typeof prop === "string" || prop === null,
      default: null
    },
    format: {
      type: String,
      validator: function(value) {
        return ["hex", "hex8", "hsl", "hsv", "rgba", "linearGradient", "radialGradient"].indexOf(value) !== -1;
      },
      default: "hex"
    },
    placeholder: {
      type: String,
      required: false,
      default: null
    },
    fieldClass: {
      type: String,
      required: false,
      default: null
    },
    labelClass: {
      type: String,
      required: false,
      default: null
    },
    readonly: {
      type: Boolean,
      required: false,
      default: false
    },
    required: {
      type: Boolean,
      required: false,
      default: false
    },
    disabled: {
      type: Boolean,
      required: false,
      default: false
    },
    validateFormat: {
      type: Boolean,
      required: false,
      default: true
    }
  },
  data() {
    return {
      isOpen: false,
      patterns: {
        hex: `([#]([a-fA-F\\d]{6}|[a-fA-F\\d]{3}|[a-fA-F\\d]{8})|(linear|radial)-gradient\\([^(]*(\\([^)]*\\)[^(]*)*[^)]*\\))`,
        linearGradient: `linear-gradient\\([^(]*(\\([^)]*\\)[^(]*)*[^)]*\\)`,
        radialGradient: `radial-gradient\\([^(]*(\\([^)]*\\)[^(]*)*[^)]*\\)`,
        hex8: `[#]([a-fA-F\\d]{8}`,
        hsl: `[Hh][Ss][Ll][\\(](((([\\d]{1,3}|[\\d\\%]{2,4})[\\,]{0,1})[\\s]*){3})[\\)]`,
        hsla: `[Hh][Ss][Ll][Aa][\\(](((([\\d]{1,3}|[\\d\\%]{2,4}|[\\d\\.]{1,3})[\\,]{0,1})[\\s]*){4})[\\)]`,
        hsv: ``,
        rgb: `[Rr][Gg][Bb][\\(](((([\\d]{1,3})[\\,]{0,1})[\\s]*){3})[\\)]`,
        rgba: `[Rr][Gg][Bb][Aa][\\(](((([\\d]{1,3}|[\\d\\.]{1,3})[\\,]{0,1})[\\s]*){4})[\\)]`
      }
    };
  },
  computed: {
    pattern() {
      return this.patterns[this.format];
    }
  },
  methods: {
    updateValue(e) {
      this.$emit("update:value", e[this.format]);
      this.$emit("changed");
      this.$parent.dirty(this.name);
    },
    updateValueManually(e) {
      this.$emit("update:value", e);
      this.$emit("changed");
      this.$parent.dirty(this.name);
    },
    setupPopper() {
      if (this.popper === void 0) {
        this.popper = new Popper$1(this.$refs.colorpicker, this.$refs.picker, {
          placement: "bottom-end"
        });
      } else {
        this.popper.scheduleUpdate();
      }
    },
    open() {
      if (this.isOpen)
        return;
      this.isOpen = true;
      this.$nextTick(() => {
        this.setupPopper();
      });
    },
    close() {
      if (!this.isOpen)
        return;
      this.isOpen = false;
      this.$nextTick(() => {
        this.$refs.colorinput.focus();
      });
    },
    toggle() {
      if (this.disabled)
        return;
      this.isOpen ? this.close() : this.open();
    }
  }
};
const __cssModules$8 = {};
var __component__$8 = /* @__PURE__ */ normalizeComponent(__vue2_script$8, render$8, staticRenderFns$8, false, __vue2_injectStyles$8, null, null, null);
function __vue2_injectStyles$8(context) {
  for (let o in __cssModules$8) {
    this[o] = __cssModules$8[o];
  }
}
var FvlColorPicker = /* @__PURE__ */ function() {
  return __component__$8.exports;
}();
function arrayEvery$1(array, predicate) {
  var index = -1, length = array == null ? 0 : array.length;
  while (++index < length) {
    if (!predicate(array[index], index, array)) {
      return false;
    }
  }
  return true;
}
var _arrayEvery = arrayEvery$1;
var baseEach$1 = _baseEach;
function baseEvery$1(collection, predicate) {
  var result = true;
  baseEach$1(collection, function(value, index, collection2) {
    result = !!predicate(value, index, collection2);
    return result;
  });
  return result;
}
var _baseEvery = baseEvery$1;
var arrayEvery = _arrayEvery, baseEvery = _baseEvery, baseIteratee = _baseIteratee, isArray$1 = isArray_1, isIterateeCall = _isIterateeCall;
function every(collection, predicate, guard) {
  var func = isArray$1(collection) ? arrayEvery : baseEvery;
  if (guard && isIterateeCall(collection, predicate, guard)) {
    predicate = void 0;
  }
  return func(collection, baseIteratee(predicate));
}
var every_1 = every;
function arrayEach$1(array, iteratee) {
  var index = -1, length = array == null ? 0 : array.length;
  while (++index < length) {
    if (iteratee(array[index], index, array) === false) {
      break;
    }
  }
  return array;
}
var _arrayEach = arrayEach$1;
var identity = identity_1;
function castFunction$1(value) {
  return typeof value == "function" ? value : identity;
}
var _castFunction = castFunction$1;
var arrayEach = _arrayEach, baseEach = _baseEach, castFunction = _castFunction, isArray = isArray_1;
function forEach2(collection, iteratee) {
  var func = isArray(collection) ? arrayEach : baseEach;
  return func(collection, castFunction(iteratee));
}
var forEach_1 = forEach2;
var render$7 = function() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", { staticClass: "fvl-multi-checkbox-wrapper", class: { "fvl-has-error": _vm.$parent.hasErrors(_vm.name) } }, [_vm.label ? _c("label", { staticClass: "fvl-multi-checkbox-label", class: _vm.labelClass, attrs: { "for": _vm.id ? _vm.id : _vm.name } }, [_c("span", { domProps: { "innerHTML": _vm._s(_vm.label) } }), _vm._t("label_suffix")], 2) : _vm._e(), _vm._l(_vm.allgroups, function(group) {
    return _c("div", { key: group.name }, [_c("fvl-checkbox", { staticClass: "fvl-multi-checkbox", class: {
      "fvl-multi-checkbox-all-checked": _vm.groupAllChecked(group),
      "fvl-multi-checkbox-any-checked": _vm.groupAnyChecked(group)
    }, attrs: { "label": group.label, "name": group.name }, nativeOn: { "click": function($event) {
      $event.preventDefault();
      return _vm.toggleChildren(group);
    } } }), _vm._l(group.options, function(nestedOption) {
      return _c("div", { key: nestedOption.name, staticClass: "fvl-multi-checkbox-group" }, [_c("fvl-checkbox", { staticClass: "fvl-multi-checkbox-nested", attrs: { "checked": nestedOption.checked, "label": nestedOption.label, "name": nestedOption.name }, on: { "update:checked": function($event) {
        return _vm.$set(nestedOption, "checked", $event);
      } } })], 1);
    })], 2);
  }), _vm._t("hint"), _vm._t("errors", function() {
    return [_c("validation-errors", { attrs: { "errors": _vm.$parent.getErrors(_vm.name) } })];
  }, { "errors": _vm.$parent.getErrors(_vm.name) })], 2);
};
var staticRenderFns$7 = [];
const __vue2_script$7 = {
  components: {
    ValidationErrors,
    FvlCheckbox
  },
  props: {
    label: {
      type: String,
      required: false,
      default: null
    },
    name: {
      type: String,
      required: true
    },
    id: {
      type: String,
      required: false,
      default: null
    },
    groups: {
      type: Array,
      default: () => []
    },
    fieldClass: {
      type: String,
      required: false,
      default: null
    },
    labelClass: {
      type: String,
      required: false,
      default: null
    },
    required: {
      type: Boolean,
      required: false,
      default: false
    },
    readonly: {
      type: Boolean,
      required: false,
      default: false
    },
    disabled: {
      type: Boolean,
      required: false,
      default: false
    }
  },
  data() {
    return {};
  },
  computed: {
    allgroups() {
      return this.groups;
    },
    values() {
      let values = [];
      forEach_1(this.allgroups, function(group) {
        forEach_1(group.options, function(field) {
          values.push({ [field.name]: field.checked });
        });
      });
      return values;
    }
  },
  methods: {
    toggleChildren(group) {
      let state = !every_1(group.options, "checked");
      forEach_1(group.options, function(value) {
        value.checked = state;
      });
    },
    groupAllChecked(group) {
      let allChecked = every_1(group.options, "checked");
      group.checked = allChecked;
      return allChecked;
    },
    groupAnyChecked(group) {
      this.$emit("update:checked", this.values);
      return filter_1(group.options, "checked").length;
    },
    dirty(name) {
      this.$parent.errors[name] = false;
    },
    getErrors(name) {
      return this.$parent.errors[name] ? this.$parent.errors[name] : [];
    },
    hasErrors(name) {
      return this.$parent.errors[name] && this.$parent.errors[name] !== [] ? true : false;
    }
  }
};
const __cssModules$7 = {};
var __component__$7 = /* @__PURE__ */ normalizeComponent(__vue2_script$7, render$7, staticRenderFns$7, false, __vue2_injectStyles$7, null, null, null);
function __vue2_injectStyles$7(context) {
  for (let o in __cssModules$7) {
    this[o] = __cssModules$7[o];
  }
}
var FvlMultiCheckbox = /* @__PURE__ */ function() {
  return __component__$7.exports;
}();
var render$6 = function() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", { staticClass: "fvl-file-wrapper", class: { "fvl-has-error": _vm.$parent.hasErrors(_vm.name) } }, [_vm.label ? _c("label", { staticClass: "fvl-file-label", class: _vm.labelClass, attrs: { "for": _vm.name } }, [_c("span", { domProps: { "innerHTML": _vm._s(_vm.label) } }), _vm._t("label_suffix")], 2) : _vm._e(), _c("div", { staticClass: "fvl-file-button-wrapper" }, [_c("button", { staticClass: "fvl-file-button", attrs: { "tabindex": "-1", "type": "button" }, on: { "click": function($event) {
    $event.preventDefault();
  } } }, [_vm._t("button", function() {
    return [_c("span", { domProps: { "textContent": _vm._s(_vm.getConfig("selectFileText", "Select File")) } })];
  })], 2), _c("span", { staticClass: "fvl-file-name", domProps: { "textContent": _vm._s(_vm.fileName) } }), _c("input", { ref: _vm.name, staticClass: "fvl-file", class: _vm.fieldClass, attrs: { "id": _vm.id, "name": _vm.name, "placeholder": _vm.placeholder, "required": _vm.required, "readonly": _vm.readonly, "accept": _vm.accept, "disabled": _vm.disabled || _vm.$parent.isLoading, "type": "file" }, on: { "change": function($event) {
    _vm.handleFileChange(), _vm.$emit("changed"), _vm.$parent.dirty(_vm.name);
  } } })]), _vm._t("hint"), _vm._t("errors", function() {
    return [_c("validation-errors", { attrs: { "errors": _vm.$parent.getErrors(_vm.name) } })];
  }, { "errors": _vm.$parent.getErrors(_vm.name) })], 2);
};
var staticRenderFns$6 = [];
const __vue2_script$6 = {
  components: {
    ValidationErrors
  },
  mixins: [config],
  props: {
    file: {
      type: File | String,
      default: null
    },
    label: {
      type: String,
      required: false,
      default: null
    },
    name: {
      type: String,
      required: true
    },
    id: {
      type: String,
      default: null
    },
    accept: {
      type: String,
      required: false,
      default: null
    },
    placeholder: {
      type: String,
      required: false,
      default: null
    },
    fieldClass: {
      type: String,
      required: false,
      default: null
    },
    labelClass: {
      type: String,
      required: false,
      default: null
    },
    required: {
      type: Boolean,
      required: false,
      default: false
    },
    readonly: {
      type: Boolean,
      required: false,
      default: false
    },
    disabled: {
      type: Boolean,
      required: false,
      default: false
    }
  },
  data() {
    return {
      fileName: ""
    };
  },
  watch: {
    file(newValue) {
      if (!(newValue instanceof File))
        this.$emit("update:file", "");
    }
  },
  mounted() {
    if (!(this.file instanceof File)) {
      this.$emit("update:file", "");
    }
  },
  methods: {
    handleFileChange() {
      let file = this.$refs[this.name].files[0];
      this.fileName = file.name;
      this.$emit("update:file", file);
    }
  }
};
const __cssModules$6 = {};
var __component__$6 = /* @__PURE__ */ normalizeComponent(__vue2_script$6, render$6, staticRenderFns$6, false, __vue2_injectStyles$6, null, null, null);
function __vue2_injectStyles$6(context) {
  for (let o in __cssModules$6) {
    this[o] = __cssModules$6[o];
  }
}
var FvlFile = /* @__PURE__ */ function() {
  return __component__$6.exports;
}();
var render$5 = function() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", { staticClass: "fvl-image-wrapper", class: { "fvl-has-error": _vm.$parent.hasErrors(_vm.name) } }, [_vm.label ? _c("label", { staticClass: "fvl-image-label", class: _vm.labelClass, attrs: { "for": _vm.name } }, [_c("span", { domProps: { "innerHTML": _vm._s(_vm.label) } }), _vm._t("label_suffix")], 2) : _vm._e(), _c("div", { staticClass: "fvl-image-group", class: _vm.fieldClass }, [_vm._t("preview", function() {
    return [_c("div", { staticClass: "fvl-image-preview" }, [_vm.preview.src ? _c("img", { attrs: { "src": _vm.preview.src, "alt": _vm.fileName } }) : _vm._e()])];
  }, { "preview": _vm.preview, "selectImage": function() {
    return _vm.$refs[_vm.name].click();
  } }), _vm._t("button-wrapper", function() {
    return [_c("div", { staticClass: "fvl-image-button-wrapper", class: { "fvl-image-hide-file-name": !_vm.showFileName } }, [_c("button", { staticClass: "fvl-image-button", attrs: { "type": "button" }, on: { "click": function($event) {
      $event.preventDefault();
      return _vm.$refs[_vm.name].click();
    } } }, [_vm._t("button", function() {
      return [_c("span", { domProps: { "textContent": _vm._s(_vm.getConfig("selectImageText", "Select Image")) } })];
    })], 2), _vm.showFileName ? _c("span", { staticClass: "fvl-image-name", domProps: { "textContent": _vm._s(_vm.fileName) } }) : _vm._e()])];
  }, { "preview": _vm.preview, "selectImage": function() {
    return _vm.$refs[_vm.name].click();
  } }), _c("input", { ref: _vm.name, staticClass: "fvl-image", class: _vm.fieldClass, attrs: { "id": _vm.id, "name": _vm.name, "placeholder": _vm.placeholder, "required": _vm.required, "readonly": _vm.readonly, "accept": _vm.accept, "disabled": _vm.disabled || _vm.$parent.isLoading, "type": "file" }, on: { "change": function($event) {
    _vm.handleFileChange(), _vm.$emit("changed"), _vm.$parent.dirty(_vm.name);
  } } })], 2), _vm._t("hint"), _vm._t("errors", function() {
    return [_c("validation-errors", { attrs: { "errors": _vm.$parent.getErrors(_vm.name) } })];
  }, { "errors": _vm.$parent.getErrors(_vm.name) })], 2);
};
var staticRenderFns$5 = [];
const __vue2_script$5 = {
  components: {
    ValidationErrors
  },
  mixins: [config],
  props: {
    file: {
      type: File | String,
      default: null
    },
    label: {
      type: String,
      required: false,
      default: null
    },
    name: {
      type: String,
      required: true
    },
    id: {
      type: String,
      default: null
    },
    accept: {
      type: String,
      required: false,
      default: "image/*"
    },
    placeholder: {
      type: String,
      required: false,
      default: null
    },
    fieldClass: {
      type: String,
      required: false,
      default: null
    },
    labelClass: {
      type: String,
      required: false,
      default: null
    },
    required: {
      type: Boolean,
      required: false,
      default: false
    },
    readonly: {
      type: Boolean,
      required: false,
      default: false
    },
    disabled: {
      type: Boolean,
      required: false,
      default: false
    },
    showFileName: {
      type: Boolean,
      required: false,
      default: true
    }
  },
  data() {
    return {
      fileName: "",
      preview: {
        isimage: false,
        size: 0,
        loaded: false,
        percent: 0,
        status: "initial",
        src: this.file,
        ratioHeight: 0
      }
    };
  },
  watch: {
    file(newValue) {
      if (!(newValue instanceof File)) {
        if (typeof newValue == "string" && newValue != "" && this.isValidURL(newValue)) {
          this.preview.src = newValue;
        }
        if (newValue === null) {
          this.preview.src = "";
        }
        this.$emit("update:file", "");
      }
    }
  },
  mounted() {
    if (!(this.file instanceof File)) {
      this.$emit("update:file", "");
    }
  },
  methods: {
    handleFileChange() {
      this.$emit("processstarted");
      let file = this.$refs[this.name].files[0];
      this.fileName = file.name;
      let mime = file.type;
      mime = mime.split("/");
      let reader = this.getFileReader(mime);
      reader.readAsDataURL(file);
      this.$emit("update:file", file);
      this.$emit("processfinished");
    },
    getFileReader(mime) {
      let $this = this;
      let reader = new FileReader();
      reader.onloadstart = (event) => {
        let percent = Math.round(event.loaded / event.total * 100);
        $this.preview = {
          isimage: mime[0] == "image",
          size: event.total,
          loaded: event.loaded,
          percent,
          status: "loading",
          src: "",
          ratioHeight: 0
        };
      };
      reader.onprogress = (event) => {
        let percent = Math.round(event.loaded / event.total * 100);
        $this.preview.loaded = event.loaded;
        $this.preview.percent = percent;
      };
      reader.onabort = () => {
        $this.preview.status = "failed";
        alert($this.file.name + " could not be loaded!");
      };
      reader.onerror = () => {
        $this.preview.status = "failed";
        alert($this.file.name + " could not be loaded!");
        reader.abort();
      };
      reader.onload = () => {
        $this.preview.status = "loaded";
        $this.preview.percent = 100;
        if ($this.preview.isimage) {
          $this.getImagesize();
        }
      };
      return reader;
    },
    getImagesize() {
      let _URL = window.URL || window.webkitURL;
      let $this = this;
      let image = new Image();
      image.onload = function() {
        $this.preview.src = $this.resizeImageForPreview(this);
        let minRatio = 19;
        let maxRatio = 70;
        $this.preview.height = this.height;
        $this.preview.width = this.width;
        let percent = this.height > 60 ? this.height / this.width * 100 : minRatio;
        $this.preview.ratioHeight = percent < maxRatio ? percent : maxRatio;
        $this.$emit("previewchanged", $this.preview);
      };
      image.src = _URL.createObjectURL(this.file);
      return image.src;
    },
    resizeImageForPreview(img) {
      let canvas = document.createElement("canvas");
      let ctx = canvas.getContext("2d");
      let canvasCopy = document.createElement("canvas");
      let copyContext = canvasCopy.getContext("2d");
      let ratio = 1;
      if (img.width > this.maxPreviewImageWidth)
        ratio = this.maxPreviewImageWidth / img.width;
      else if (img.height > this.maxPreviewImageHeight)
        ratio = this.maxPreviewImageHeight / img.height;
      canvasCopy.width = img.width;
      canvasCopy.height = img.height;
      copyContext.drawImage(img, 0, 0);
      canvas.width = img.width * ratio;
      canvas.height = img.height * ratio;
      ctx.drawImage(canvasCopy, 0, 0, canvasCopy.width, canvasCopy.height, 0, 0, canvas.width, canvas.height);
      return canvas.toDataURL();
    },
    isValidURL(string) {
      var res = string.match(/(http(s)?:\/\/.)?(www\.)?[-a-zA-Z0-9@:%._+~#=]{2,256}\.[a-z]{2,6}\b([-a-zA-Z0-9@:%_+.~#?&//=]*)/g);
      return res !== null;
    }
  }
};
const __cssModules$5 = {};
var __component__$5 = /* @__PURE__ */ normalizeComponent(__vue2_script$5, render$5, staticRenderFns$5, false, __vue2_injectStyles$5, null, null, null);
function __vue2_injectStyles$5(context) {
  for (let o in __cssModules$5) {
    this[o] = __cssModules$5[o];
  }
}
var FvlImage = /* @__PURE__ */ function() {
  return __component__$5.exports;
}();
var render$4 = function() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", { staticClass: "fvl-multi-file-wrapper", class: { "fvl-has-error": _vm.$parent.hasErrors(_vm.name) } }, [_vm.label ? _c("label", { staticClass: "fvl-multi-file-label", class: _vm.labelClass, attrs: { "for": _vm.name } }, [_c("span", { domProps: { "innerHTML": _vm._s(_vm.label) } }), _vm._t("label_suffix")], 2) : _vm._e(), _c("div", { staticClass: "fvl-multi-file-button-wrapper" }, [_c("button", { staticClass: "fvl-multi-file-button", attrs: { "tabindex": "-1", "type": "button" }, on: { "click": function($event) {
    $event.preventDefault();
  } } }, [_vm._t("button", function() {
    return [_c("span", { domProps: { "textContent": _vm._s(_vm.getConfig("addFilesText", "Add Files")) } })];
  })], 2), _c("span", { staticClass: "fvl-multi-file-name" }, [_vm._t("selected-text", function() {
    return [_vm._v(" " + _vm._s(_vm.filesList ? _vm.filesList.length : 0) + " "), _c("span", { domProps: { "textContent": _vm._s(_vm.getConfig("filesSelectedText", "Files Selected")) } })];
  }, { "files": _vm.filesList })], 2), _c("input", { ref: _vm.name, staticClass: "fvl-multi-file", class: _vm.fieldClass, attrs: { "id": _vm.id, "name": _vm.name, "placeholder": _vm.placeholder, "required": _vm.required, "readonly": _vm.readonly, "accept": _vm.accept, "disabled": _vm.disabled || _vm.$parent.isLoading, "multiple": "", "type": "file" }, on: { "change": function($event) {
    _vm.handleFileChange(), _vm.$emit("changed"), _vm.$parent.dirty(_vm.name);
  } } })]), _vm._l(_vm.filesList, function(file, key) {
    return _c("div", { key, staticClass: "fvl-multi-file-list" }, [_vm._v(" " + _vm._s(file.name) + " "), _c("span", { staticClass: "fvl-multi-file-remove", on: { "click": function($event) {
      return _vm.removeFile(key);
    } } }, [_vm._t("remove", function() {
      return [_c("svg", { attrs: { "viewBox": "0 0 40 40" } }, [_c("path", { attrs: { "stroke": "current", "stroke-linecap": "round", "stroke-width": "4", "d": "M 10,10 L 30,30 M 30,10 L 10,30" } })])];
    })], 2)]);
  }), _vm._t("hint"), _vm._t("errors", function() {
    return [_c("validation-errors", { attrs: { "errors": _vm.$parent.getErrors(_vm.name) } })];
  }, { "errors": _vm.$parent.getErrors(_vm.name) })], 2);
};
var staticRenderFns$4 = [];
const __vue2_script$4 = {
  components: {
    ValidationErrors
  },
  mixins: [config],
  props: {
    files: {
      type: Array,
      default: () => []
    },
    label: {
      type: String,
      required: false,
      default: null
    },
    name: {
      type: String,
      required: true
    },
    id: {
      type: String,
      default: null
    },
    accept: {
      type: String,
      required: false,
      default: null
    },
    placeholder: {
      type: String,
      required: false,
      default: null
    },
    fieldClass: {
      type: String,
      required: false,
      default: null
    },
    labelClass: {
      type: String,
      required: false,
      default: null
    },
    required: {
      type: Boolean,
      required: false,
      default: false
    },
    readonly: {
      type: Boolean,
      required: false,
      default: false
    },
    disabled: {
      type: Boolean,
      required: false,
      default: false
    }
  },
  data() {
    return {
      filesList: []
    };
  },
  watch: {
    files(newValue) {
      if (!(newValue instanceof Array) || !(newValue instanceof File))
        this.$emit("update:file", []);
    }
  },
  methods: {
    handleFileChange() {
      var uploadedFiles = this.$refs[this.name].files;
      for (var i = 0; i < uploadedFiles.length; i++) {
        this.filesList.push(uploadedFiles[i]);
      }
      this.$emit("update:files", this.filesList);
    },
    removeFile(key) {
      this.filesList.splice(key, 1);
    }
  }
};
const __cssModules$4 = {};
var __component__$4 = /* @__PURE__ */ normalizeComponent(__vue2_script$4, render$4, staticRenderFns$4, false, __vue2_injectStyles$4, null, null, null);
function __vue2_injectStyles$4(context) {
  for (let o in __cssModules$4) {
    this[o] = __cssModules$4[o];
  }
}
var FvlMultiFile = /* @__PURE__ */ function() {
  return __component__$4.exports;
}();
var render$3 = function() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", { staticClass: "fvl-dropzone-wrapper", class: { "fvl-has-error": _vm.$parent.hasErrors(_vm.name) } }, [_vm.label ? _c("label", { staticClass: "fvl-dropzone-label", class: _vm.labelClass, attrs: { "for": _vm.name } }, [_c("span", { domProps: { "innerHTML": _vm._s(_vm.label) } }), _vm._t("label_suffix")], 2) : _vm._e(), _vm.filesCount ? _vm._t("summary", function() {
    return [_vm._v(" " + _vm._s(_vm.filesCount) + " "), _c("span", { domProps: { "textContent": _vm._s(_vm.getConfig("filesSelectedAndSizeText", "files selected with a combined size of")) } }), _vm._v(" " + _vm._s(_vm.filesSizeSum) + " ")];
  }, { "filesCount": _vm.filesCount, "filesSizeSum": _vm.filesSizeSum }) : _vm._e(), _c("div", { staticClass: "fvl-dropzone-area-wrapper" }, [_c("div", { staticClass: "fvl-dropzone-area" }, [!_vm.filesCount ? _c("span", { staticClass: "fvl-dropzone-area-placeholder" }, [_vm._t("placeholder", function() {
    return [_c("span", { domProps: { "textContent": _vm._s(_vm.getConfig("dropFilesHereText", "Drop files here or click to upload.")) } })];
  })], 2) : _vm._l(_vm.files, function(file, key) {
    return _c("div", { key, staticClass: "fvl-dropzone-file-preview", class: _vm.previews[key] && _vm.previews[key].status == "failed" ? "fvl-dropzone-file-has-error" : "" }, [_vm.previews[key] && _vm.previews[key].status == "loading" ? _c("div", { staticClass: "fvl-dropzone-file-preview-loader" }, [_c("div", { style: "width:" + _vm.previews[key].percent + "%" })]) : _vm._e(), _vm.previews[key] ? _c("div", { staticClass: "fvl-dropzone-file-preview-name", class: { "fvl-dropzone-file-preview-name-background": _vm.previews[key].isimage } }, [_vm._v(" " + _vm._s(file.name) + " "), _c("div", { staticClass: "fvl-dropzone-file-preview-size" }, [_vm._v(" " + _vm._s(_vm.formatBytes(_vm.previews[key].size)) + " ")])]) : _vm._e(), _c("transition", { attrs: { "name": "fvl-dropzone-fade" } }, [_vm.previews[key] && _vm.previews[key].isimage && _vm.previews[key].src ? _c("div", { staticClass: "fvl-dropzone-file-image", style: {
      backgroundImage: "url(" + _vm.previews[key].src + ")",
      paddingTop: _vm.previews[key].ratioHeight + "%"
    } }) : _vm._e()]), _c("span", { staticClass: "fvl-dropzone-remove", on: { "click": function($event) {
      return _vm.removeFile(key);
    } } }, [_vm._t("remove", function() {
      return [_c("svg", { attrs: { "viewBox": "0 0 40 40" } }, [_c("path", { attrs: { "stroke": "current", "stroke-linecap": "round", "stroke-width": "4", "d": "M 10,10 L 30,30 M 30,10 L 10,30" } })])];
    })], 2)], 1);
  })], 2), _c("input", { ref: _vm.name, staticClass: "fvl-dropzone", class: _vm.fieldClass, attrs: { "id": _vm.id, "name": _vm.name, "placeholder": _vm.placeholder, "required": _vm.required, "readonly": _vm.readonly, "accept": _vm.accept, "disabled": _vm.disabled || _vm.$parent.isLoading, "multiple": "", "type": "file" }, on: { "change": function($event) {
    _vm.handleFileChange(), _vm.$emit("changed"), _vm.$parent.dirty(_vm.name);
  } } })]), _vm._t("hint"), _vm._t("errors", function() {
    return [_c("validation-errors", { attrs: { "errors": _vm.$parent.getErrors(_vm.name) } })];
  }, { "errors": _vm.$parent.getErrors(_vm.name) })], 2);
};
var staticRenderFns$3 = [];
const __vue2_script$3 = {
  components: {
    ValidationErrors
  },
  mixins: [config],
  props: {
    label: {
      type: String,
      required: false,
      default: null
    },
    name: {
      type: String,
      required: true
    },
    id: {
      type: String,
      default: null
    },
    accept: {
      type: String,
      required: false,
      default: null
    },
    placeholder: {
      type: String,
      required: false,
      default: null
    },
    fieldClass: {
      type: String,
      required: false,
      default: null
    },
    labelClass: {
      type: String,
      required: false,
      default: null
    },
    required: {
      type: Boolean,
      required: false,
      default: false
    },
    readonly: {
      type: Boolean,
      required: false,
      default: false
    },
    disabled: {
      type: Boolean,
      required: false,
      default: false
    },
    maxSizePerFile: {
      type: Number,
      required: false,
      default: 20 * (1024 * 1024)
    },
    maxFiles: {
      type: Number,
      required: false,
      default: 50
    },
    maxSizeOfAllFiles: {
      type: Number,
      required: false,
      default: null
    },
    maxPreviewImageWidth: {
      type: Number,
      required: false,
      default: 400
    },
    maxPreviewImageHeight: {
      type: Number,
      required: false,
      default: 200
    }
  },
  data() {
    return {
      files: [],
      previews: [],
      loaded: 0
    };
  },
  computed: {
    filesCount() {
      return this.files.length;
    },
    filesSizeSum() {
      let size = 0;
      this.previews.forEach(function(e) {
        size = size + e.size;
      });
      return this.formatBytes(size);
    }
  },
  methods: {
    handleFileChange() {
      var uploadedFiles = this.$refs[this.name].files;
      for (var i = 0; i < uploadedFiles.length; i++) {
        let mime = uploadedFiles[i].type;
        mime = mime.split("/");
        let reader = this.getFileReader(mime, uploadedFiles[i]);
        reader.readAsDataURL(uploadedFiles[i]);
      }
      this.$emit("update:files", this.files);
    },
    removeFile(key) {
      this.files.splice(key, 1);
      this.previews.splice(key, 1);
    },
    formatBytes(a, b) {
      if (a == 0)
        return "0 Bytes";
      var c = 1024, d = b || 2, e = ["Bytes", "KB", "MB", "GB", "TB", "PB", "EB", "ZB", "YB"], f = Math.floor(Math.log(a) / Math.log(c));
      return parseFloat((a / Math.pow(c, f)).toFixed(d)) + " " + e[f];
    },
    getFileReader(mime, file) {
      let $this = this;
      let reader = new FileReader();
      let index = 0;
      reader.onloadstart = (event) => {
        index = $this.files.push(file) - 1;
        let percent = Math.round(event.loaded / event.total * 100);
        $this.previews.push({
          isimage: mime[0] == "image",
          size: event.total,
          loaded: event.loaded,
          percent,
          status: "loading",
          src: "",
          ratioHeight: 0
        });
      };
      reader.onprogress = (event) => {
        let percent = Math.round(event.loaded / event.total * 100);
        $this.previews[index].loaded = event.loaded;
        $this.previews[index].percent = percent;
      };
      reader.onabort = () => {
        $this.previews[index].status = "failed";
        alert($this.files[index].name + " could not be loaded!");
      };
      reader.onerror = () => {
        $this.previews[index].status = "failed";
        alert($this.files[index].name + " could not be loaded!");
        reader.abort();
      };
      reader.onload = () => {
        $this.previews[index].status = "loaded";
        $this.previews[index].percent = 100;
        if ($this.previews[index].isimage) {
          $this.getImagesize(index);
        }
      };
      return reader;
    },
    getImagesize(index) {
      let _URL = window.URL || window.webkitURL;
      let $this = this;
      let image = new Image();
      image.onload = function() {
        $this.previews[index].src = $this.resizeImageForPreview(this);
        let minRatio = 19;
        let maxRatio = 70;
        $this.previews[index].height = this.height;
        $this.previews[index].width = this.width;
        let percent = this.height > 60 ? this.height / this.width * 100 : minRatio;
        $this.previews[index].ratioHeight = percent < maxRatio ? percent : maxRatio;
      };
      image.src = _URL.createObjectURL(this.files[index]);
      return image.src;
    },
    resizeImageForPreview(img) {
      let canvas = document.createElement("canvas");
      let ctx = canvas.getContext("2d");
      let canvasCopy = document.createElement("canvas");
      let copyContext = canvasCopy.getContext("2d");
      let ratio = 1;
      if (img.width > this.maxPreviewImageWidth)
        ratio = this.maxPreviewImageWidth / img.width;
      else if (img.height > this.maxPreviewImageHeight)
        ratio = this.maxPreviewImageHeight / img.height;
      canvasCopy.width = img.width;
      canvasCopy.height = img.height;
      copyContext.drawImage(img, 0, 0);
      canvas.width = img.width * ratio;
      canvas.height = img.height * ratio;
      ctx.drawImage(canvasCopy, 0, 0, canvasCopy.width, canvasCopy.height, 0, 0, canvas.width, canvas.height);
      return canvas.toDataURL();
    }
  }
};
const __cssModules$3 = {};
var __component__$3 = /* @__PURE__ */ normalizeComponent(__vue2_script$3, render$3, staticRenderFns$3, false, __vue2_injectStyles$3, null, null, null);
function __vue2_injectStyles$3(context) {
  for (let o in __cssModules$3) {
    this[o] = __cssModules$3[o];
  }
}
var FvlDropzone = /* @__PURE__ */ function() {
  return __component__$3.exports;
}();
var render$2 = function() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", { staticClass: "fvl-submit-wrapper" }, [_c("button", { staticClass: "fvl-submit-button", class: _vm.buttonClass, attrs: { "disabled": _vm.disabled || _vm.$parent.isLoading }, on: { "click": function($event) {
    return _vm.$emit("submit");
  } } }, [_c("span", { staticClass: "fvl-submit-text" }, [_vm._t("default")], 2), _vm.loader && _vm.$parent.isLoading ? _vm._t("loader", function() {
    return [_c("div", { staticClass: "fvl-submit-button-loader" }, [_c("div", { staticClass: "fvl-submit-button-loader-progress", style: { width: _vm.$parent.uploadPercentage + "%" } })])];
  }, { "isLoading": _vm.$parent.isLoading, "uploadPercentage": _vm.$parent.uploadPercentage }) : _vm._e()], 2)]);
};
var staticRenderFns$2 = [];
const __vue2_script$2 = {
  props: {
    loader: {
      type: Boolean,
      default: false
    },
    disabled: {
      type: Boolean,
      required: false,
      default: false
    },
    buttonClass: {
      type: String,
      default: null
    }
  }
};
const __cssModules$2 = {};
var __component__$2 = /* @__PURE__ */ normalizeComponent(__vue2_script$2, render$2, staticRenderFns$2, false, __vue2_injectStyles$2, null, null, null);
function __vue2_injectStyles$2(context) {
  for (let o in __cssModules$2) {
    this[o] = __cssModules$2[o];
  }
}
var FvlSubmit = /* @__PURE__ */ function() {
  return __component__$2.exports;
}();
var vueFlatpickr_min = { exports: {} };
var HOOKS = [
  "onChange",
  "onClose",
  "onDayCreate",
  "onDestroy",
  "onKeyDown",
  "onMonthChange",
  "onOpen",
  "onParseConfig",
  "onReady",
  "onValueUpdate",
  "onYearChange",
  "onPreCalendarPosition"
];
var defaults = {
  _disable: [],
  allowInput: false,
  allowInvalidPreload: false,
  altFormat: "F j, Y",
  altInput: false,
  altInputClass: "form-control input",
  animate: typeof window === "object" && window.navigator.userAgent.indexOf("MSIE") === -1,
  ariaDateFormat: "F j, Y",
  autoFillDefaultTime: true,
  clickOpens: true,
  closeOnSelect: true,
  conjunction: ", ",
  dateFormat: "Y-m-d",
  defaultHour: 12,
  defaultMinute: 0,
  defaultSeconds: 0,
  disable: [],
  disableMobile: false,
  enableSeconds: false,
  enableTime: false,
  errorHandler: function(err) {
    return typeof console !== "undefined" && console.warn(err);
  },
  getWeek: function(givenDate) {
    var date = new Date(givenDate.getTime());
    date.setHours(0, 0, 0, 0);
    date.setDate(date.getDate() + 3 - (date.getDay() + 6) % 7);
    var week1 = new Date(date.getFullYear(), 0, 4);
    return 1 + Math.round(((date.getTime() - week1.getTime()) / 864e5 - 3 + (week1.getDay() + 6) % 7) / 7);
  },
  hourIncrement: 1,
  ignoredFocusElements: [],
  inline: false,
  locale: "default",
  minuteIncrement: 5,
  mode: "single",
  monthSelectorType: "dropdown",
  nextArrow: "<svg version='1.1' xmlns='http://www.w3.org/2000/svg' xmlns:xlink='http://www.w3.org/1999/xlink' viewBox='0 0 17 17'><g></g><path d='M13.207 8.472l-7.854 7.854-0.707-0.707 7.146-7.146-7.146-7.148 0.707-0.707 7.854 7.854z' /></svg>",
  noCalendar: false,
  now: new Date(),
  onChange: [],
  onClose: [],
  onDayCreate: [],
  onDestroy: [],
  onKeyDown: [],
  onMonthChange: [],
  onOpen: [],
  onParseConfig: [],
  onReady: [],
  onValueUpdate: [],
  onYearChange: [],
  onPreCalendarPosition: [],
  plugins: [],
  position: "auto",
  positionElement: void 0,
  prevArrow: "<svg version='1.1' xmlns='http://www.w3.org/2000/svg' xmlns:xlink='http://www.w3.org/1999/xlink' viewBox='0 0 17 17'><g></g><path d='M5.207 8.471l7.146 7.147-0.707 0.707-7.853-7.854 7.854-7.853 0.707 0.707-7.147 7.146z' /></svg>",
  shorthandCurrentMonth: false,
  showMonths: 1,
  static: false,
  time_24hr: false,
  weekNumbers: false,
  wrap: false
};
var english = {
  weekdays: {
    shorthand: ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"],
    longhand: [
      "Sunday",
      "Monday",
      "Tuesday",
      "Wednesday",
      "Thursday",
      "Friday",
      "Saturday"
    ]
  },
  months: {
    shorthand: [
      "Jan",
      "Feb",
      "Mar",
      "Apr",
      "May",
      "Jun",
      "Jul",
      "Aug",
      "Sep",
      "Oct",
      "Nov",
      "Dec"
    ],
    longhand: [
      "January",
      "February",
      "March",
      "April",
      "May",
      "June",
      "July",
      "August",
      "September",
      "October",
      "November",
      "December"
    ]
  },
  daysInMonth: [31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31],
  firstDayOfWeek: 0,
  ordinal: function(nth) {
    var s = nth % 100;
    if (s > 3 && s < 21)
      return "th";
    switch (s % 10) {
      case 1:
        return "st";
      case 2:
        return "nd";
      case 3:
        return "rd";
      default:
        return "th";
    }
  },
  rangeSeparator: " to ",
  weekAbbreviation: "Wk",
  scrollTitle: "Scroll to increment",
  toggleTitle: "Click to toggle",
  amPM: ["AM", "PM"],
  yearAriaLabel: "Year",
  monthAriaLabel: "Month",
  hourAriaLabel: "Hour",
  minuteAriaLabel: "Minute",
  time_24hr: false
};
var pad = function(number, length) {
  if (length === void 0) {
    length = 2;
  }
  return ("000" + number).slice(length * -1);
};
var int = function(bool) {
  return bool === true ? 1 : 0;
};
function debounce(fn, wait) {
  var t;
  return function() {
    var _this = this;
    var args = arguments;
    clearTimeout(t);
    t = setTimeout(function() {
      return fn.apply(_this, args);
    }, wait);
  };
}
var arrayify = function(obj) {
  return obj instanceof Array ? obj : [obj];
};
function toggleClass(elem, className, bool) {
  if (bool === true)
    return elem.classList.add(className);
  elem.classList.remove(className);
}
function createElement(tag, className, content) {
  var e = window.document.createElement(tag);
  className = className || "";
  content = content || "";
  e.className = className;
  if (content !== void 0)
    e.textContent = content;
  return e;
}
function clearNode(node) {
  while (node.firstChild)
    node.removeChild(node.firstChild);
}
function findParent(node, condition) {
  if (condition(node))
    return node;
  else if (node.parentNode)
    return findParent(node.parentNode, condition);
  return void 0;
}
function createNumberInput(inputClassName, opts) {
  var wrapper = createElement("div", "numInputWrapper"), numInput = createElement("input", "numInput " + inputClassName), arrowUp = createElement("span", "arrowUp"), arrowDown = createElement("span", "arrowDown");
  if (navigator.userAgent.indexOf("MSIE 9.0") === -1) {
    numInput.type = "number";
  } else {
    numInput.type = "text";
    numInput.pattern = "\\d*";
  }
  if (opts !== void 0)
    for (var key in opts)
      numInput.setAttribute(key, opts[key]);
  wrapper.appendChild(numInput);
  wrapper.appendChild(arrowUp);
  wrapper.appendChild(arrowDown);
  return wrapper;
}
function getEventTarget(event) {
  try {
    if (typeof event.composedPath === "function") {
      var path = event.composedPath();
      return path[0];
    }
    return event.target;
  } catch (error) {
    return event.target;
  }
}
var doNothing = function() {
  return void 0;
};
var monthToStr = function(monthNumber, shorthand, locale) {
  return locale.months[shorthand ? "shorthand" : "longhand"][monthNumber];
};
var revFormat = {
  D: doNothing,
  F: function(dateObj, monthName, locale) {
    dateObj.setMonth(locale.months.longhand.indexOf(monthName));
  },
  G: function(dateObj, hour) {
    dateObj.setHours((dateObj.getHours() >= 12 ? 12 : 0) + parseFloat(hour));
  },
  H: function(dateObj, hour) {
    dateObj.setHours(parseFloat(hour));
  },
  J: function(dateObj, day) {
    dateObj.setDate(parseFloat(day));
  },
  K: function(dateObj, amPM, locale) {
    dateObj.setHours(dateObj.getHours() % 12 + 12 * int(new RegExp(locale.amPM[1], "i").test(amPM)));
  },
  M: function(dateObj, shortMonth, locale) {
    dateObj.setMonth(locale.months.shorthand.indexOf(shortMonth));
  },
  S: function(dateObj, seconds) {
    dateObj.setSeconds(parseFloat(seconds));
  },
  U: function(_, unixSeconds) {
    return new Date(parseFloat(unixSeconds) * 1e3);
  },
  W: function(dateObj, weekNum, locale) {
    var weekNumber = parseInt(weekNum);
    var date = new Date(dateObj.getFullYear(), 0, 2 + (weekNumber - 1) * 7, 0, 0, 0, 0);
    date.setDate(date.getDate() - date.getDay() + locale.firstDayOfWeek);
    return date;
  },
  Y: function(dateObj, year) {
    dateObj.setFullYear(parseFloat(year));
  },
  Z: function(_, ISODate) {
    return new Date(ISODate);
  },
  d: function(dateObj, day) {
    dateObj.setDate(parseFloat(day));
  },
  h: function(dateObj, hour) {
    dateObj.setHours((dateObj.getHours() >= 12 ? 12 : 0) + parseFloat(hour));
  },
  i: function(dateObj, minutes) {
    dateObj.setMinutes(parseFloat(minutes));
  },
  j: function(dateObj, day) {
    dateObj.setDate(parseFloat(day));
  },
  l: doNothing,
  m: function(dateObj, month) {
    dateObj.setMonth(parseFloat(month) - 1);
  },
  n: function(dateObj, month) {
    dateObj.setMonth(parseFloat(month) - 1);
  },
  s: function(dateObj, seconds) {
    dateObj.setSeconds(parseFloat(seconds));
  },
  u: function(_, unixMillSeconds) {
    return new Date(parseFloat(unixMillSeconds));
  },
  w: doNothing,
  y: function(dateObj, year) {
    dateObj.setFullYear(2e3 + parseFloat(year));
  }
};
var tokenRegex = {
  D: "",
  F: "",
  G: "(\\d\\d|\\d)",
  H: "(\\d\\d|\\d)",
  J: "(\\d\\d|\\d)\\w+",
  K: "",
  M: "",
  S: "(\\d\\d|\\d)",
  U: "(.+)",
  W: "(\\d\\d|\\d)",
  Y: "(\\d{4})",
  Z: "(.+)",
  d: "(\\d\\d|\\d)",
  h: "(\\d\\d|\\d)",
  i: "(\\d\\d|\\d)",
  j: "(\\d\\d|\\d)",
  l: "",
  m: "(\\d\\d|\\d)",
  n: "(\\d\\d|\\d)",
  s: "(\\d\\d|\\d)",
  u: "(.+)",
  w: "(\\d\\d|\\d)",
  y: "(\\d{2})"
};
var formats = {
  Z: function(date) {
    return date.toISOString();
  },
  D: function(date, locale, options) {
    return locale.weekdays.shorthand[formats.w(date, locale, options)];
  },
  F: function(date, locale, options) {
    return monthToStr(formats.n(date, locale, options) - 1, false, locale);
  },
  G: function(date, locale, options) {
    return pad(formats.h(date, locale, options));
  },
  H: function(date) {
    return pad(date.getHours());
  },
  J: function(date, locale) {
    return locale.ordinal !== void 0 ? date.getDate() + locale.ordinal(date.getDate()) : date.getDate();
  },
  K: function(date, locale) {
    return locale.amPM[int(date.getHours() > 11)];
  },
  M: function(date, locale) {
    return monthToStr(date.getMonth(), true, locale);
  },
  S: function(date) {
    return pad(date.getSeconds());
  },
  U: function(date) {
    return date.getTime() / 1e3;
  },
  W: function(date, _, options) {
    return options.getWeek(date);
  },
  Y: function(date) {
    return pad(date.getFullYear(), 4);
  },
  d: function(date) {
    return pad(date.getDate());
  },
  h: function(date) {
    return date.getHours() % 12 ? date.getHours() % 12 : 12;
  },
  i: function(date) {
    return pad(date.getMinutes());
  },
  j: function(date) {
    return date.getDate();
  },
  l: function(date, locale) {
    return locale.weekdays.longhand[date.getDay()];
  },
  m: function(date) {
    return pad(date.getMonth() + 1);
  },
  n: function(date) {
    return date.getMonth() + 1;
  },
  s: function(date) {
    return date.getSeconds();
  },
  u: function(date) {
    return date.getTime();
  },
  w: function(date) {
    return date.getDay();
  },
  y: function(date) {
    return String(date.getFullYear()).substring(2);
  }
};
var createDateFormatter = function(_a) {
  var _b = _a.config, config2 = _b === void 0 ? defaults : _b, _c = _a.l10n, l10n = _c === void 0 ? english : _c, _d = _a.isMobile, isMobile = _d === void 0 ? false : _d;
  return function(dateObj, frmt, overrideLocale) {
    var locale = overrideLocale || l10n;
    if (config2.formatDate !== void 0 && !isMobile) {
      return config2.formatDate(dateObj, frmt, locale);
    }
    return frmt.split("").map(function(c, i, arr) {
      return formats[c] && arr[i - 1] !== "\\" ? formats[c](dateObj, locale, config2) : c !== "\\" ? c : "";
    }).join("");
  };
};
var createDateParser = function(_a) {
  var _b = _a.config, config2 = _b === void 0 ? defaults : _b, _c = _a.l10n, l10n = _c === void 0 ? english : _c;
  return function(date, givenFormat, timeless, customLocale) {
    if (date !== 0 && !date)
      return void 0;
    var locale = customLocale || l10n;
    var parsedDate;
    var dateOrig = date;
    if (date instanceof Date)
      parsedDate = new Date(date.getTime());
    else if (typeof date !== "string" && date.toFixed !== void 0)
      parsedDate = new Date(date);
    else if (typeof date === "string") {
      var format2 = givenFormat || (config2 || defaults).dateFormat;
      var datestr = String(date).trim();
      if (datestr === "today") {
        parsedDate = new Date();
        timeless = true;
      } else if (config2 && config2.parseDate) {
        parsedDate = config2.parseDate(date, format2);
      } else if (/Z$/.test(datestr) || /GMT$/.test(datestr)) {
        parsedDate = new Date(date);
      } else {
        var matched = void 0, ops = [];
        for (var i = 0, matchIndex = 0, regexStr = ""; i < format2.length; i++) {
          var token = format2[i];
          var isBackSlash = token === "\\";
          var escaped = format2[i - 1] === "\\" || isBackSlash;
          if (tokenRegex[token] && !escaped) {
            regexStr += tokenRegex[token];
            var match = new RegExp(regexStr).exec(date);
            if (match && (matched = true)) {
              ops[token !== "Y" ? "push" : "unshift"]({
                fn: revFormat[token],
                val: match[++matchIndex]
              });
            }
          } else if (!isBackSlash)
            regexStr += ".";
        }
        parsedDate = !config2 || !config2.noCalendar ? new Date(new Date().getFullYear(), 0, 1, 0, 0, 0, 0) : new Date(new Date().setHours(0, 0, 0, 0));
        ops.forEach(function(_a2) {
          var fn = _a2.fn, val = _a2.val;
          return parsedDate = fn(parsedDate, val, locale) || parsedDate;
        });
        parsedDate = matched ? parsedDate : void 0;
      }
    }
    if (!(parsedDate instanceof Date && !isNaN(parsedDate.getTime()))) {
      config2.errorHandler(new Error("Invalid date provided: " + dateOrig));
      return void 0;
    }
    if (timeless === true)
      parsedDate.setHours(0, 0, 0, 0);
    return parsedDate;
  };
};
function compareDates(date1, date2, timeless) {
  if (timeless === void 0) {
    timeless = true;
  }
  if (timeless !== false) {
    return new Date(date1.getTime()).setHours(0, 0, 0, 0) - new Date(date2.getTime()).setHours(0, 0, 0, 0);
  }
  return date1.getTime() - date2.getTime();
}
var isBetween = function(ts, ts1, ts2) {
  return ts > Math.min(ts1, ts2) && ts < Math.max(ts1, ts2);
};
var calculateSecondsSinceMidnight = function(hours, minutes, seconds) {
  return hours * 3600 + minutes * 60 + seconds;
};
var parseSeconds = function(secondsSinceMidnight) {
  var hours = Math.floor(secondsSinceMidnight / 3600), minutes = (secondsSinceMidnight - hours * 3600) / 60;
  return [hours, minutes, secondsSinceMidnight - hours * 3600 - minutes * 60];
};
var duration = {
  DAY: 864e5
};
function getDefaultHours(config2) {
  var hours = config2.defaultHour;
  var minutes = config2.defaultMinute;
  var seconds = config2.defaultSeconds;
  if (config2.minDate !== void 0) {
    var minHour = config2.minDate.getHours();
    var minMinutes = config2.minDate.getMinutes();
    var minSeconds = config2.minDate.getSeconds();
    if (hours < minHour) {
      hours = minHour;
    }
    if (hours === minHour && minutes < minMinutes) {
      minutes = minMinutes;
    }
    if (hours === minHour && minutes === minMinutes && seconds < minSeconds)
      seconds = config2.minDate.getSeconds();
  }
  if (config2.maxDate !== void 0) {
    var maxHr = config2.maxDate.getHours();
    var maxMinutes = config2.maxDate.getMinutes();
    hours = Math.min(hours, maxHr);
    if (hours === maxHr)
      minutes = Math.min(maxMinutes, minutes);
    if (hours === maxHr && minutes === maxMinutes)
      seconds = config2.maxDate.getSeconds();
  }
  return { hours, minutes, seconds };
}
if (typeof Object.assign !== "function") {
  Object.assign = function(target) {
    var args = [];
    for (var _i = 1; _i < arguments.length; _i++) {
      args[_i - 1] = arguments[_i];
    }
    if (!target) {
      throw TypeError("Cannot convert undefined or null to object");
    }
    var _loop_1 = function(source3) {
      if (source3) {
        Object.keys(source3).forEach(function(key) {
          return target[key] = source3[key];
        });
      }
    };
    for (var _a = 0, args_1 = args; _a < args_1.length; _a++) {
      var source2 = args_1[_a];
      _loop_1(source2);
    }
    return target;
  };
}
var __assign = globalThis && globalThis.__assign || function() {
  __assign = Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s)
        if (Object.prototype.hasOwnProperty.call(s, p))
          t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
var __spreadArrays = globalThis && globalThis.__spreadArrays || function() {
  for (var s = 0, i = 0, il = arguments.length; i < il; i++)
    s += arguments[i].length;
  for (var r = Array(s), k = 0, i = 0; i < il; i++)
    for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
      r[k] = a[j];
  return r;
};
var DEBOUNCED_CHANGE_MS = 300;
function FlatpickrInstance(element, instanceConfig) {
  var self2 = {
    config: __assign(__assign({}, defaults), flatpickr.defaultConfig),
    l10n: english
  };
  self2.parseDate = createDateParser({ config: self2.config, l10n: self2.l10n });
  self2._handlers = [];
  self2.pluginElements = [];
  self2.loadedPlugins = [];
  self2._bind = bind3;
  self2._setHoursFromDate = setHoursFromDate;
  self2._positionCalendar = positionCalendar;
  self2.changeMonth = changeMonth;
  self2.changeYear = changeYear;
  self2.clear = clear;
  self2.close = close;
  self2.onMouseOver = onMouseOver;
  self2._createElement = createElement;
  self2.createDay = createDay;
  self2.destroy = destroy2;
  self2.isEnabled = isEnabled;
  self2.jumpToDate = jumpToDate;
  self2.updateValue = updateValue;
  self2.open = open;
  self2.redraw = redraw;
  self2.set = set;
  self2.setDate = setDate;
  self2.toggle = toggle;
  function setupHelperFunctions() {
    self2.utils = {
      getDaysInMonth: function(month, yr) {
        if (month === void 0) {
          month = self2.currentMonth;
        }
        if (yr === void 0) {
          yr = self2.currentYear;
        }
        if (month === 1 && (yr % 4 === 0 && yr % 100 !== 0 || yr % 400 === 0))
          return 29;
        return self2.l10n.daysInMonth[month];
      }
    };
  }
  function init() {
    self2.element = self2.input = element;
    self2.isOpen = false;
    parseConfig();
    setupLocale();
    setupInputs();
    setupDates();
    setupHelperFunctions();
    if (!self2.isMobile)
      build();
    bindEvents();
    if (self2.selectedDates.length || self2.config.noCalendar) {
      if (self2.config.enableTime) {
        setHoursFromDate(self2.config.noCalendar ? self2.latestSelectedDateObj : void 0);
      }
      updateValue(false);
    }
    setCalendarWidth();
    var isSafari = /^((?!chrome|android).)*safari/i.test(navigator.userAgent);
    if (!self2.isMobile && isSafari) {
      positionCalendar();
    }
    triggerEvent("onReady");
  }
  function getClosestActiveElement() {
    var _a;
    return ((_a = self2.calendarContainer) === null || _a === void 0 ? void 0 : _a.getRootNode()).activeElement || document.activeElement;
  }
  function bindToInstance(fn) {
    return fn.bind(self2);
  }
  function setCalendarWidth() {
    var config2 = self2.config;
    if (config2.weekNumbers === false && config2.showMonths === 1) {
      return;
    } else if (config2.noCalendar !== true) {
      window.requestAnimationFrame(function() {
        if (self2.calendarContainer !== void 0) {
          self2.calendarContainer.style.visibility = "hidden";
          self2.calendarContainer.style.display = "block";
        }
        if (self2.daysContainer !== void 0) {
          var daysWidth = (self2.days.offsetWidth + 1) * config2.showMonths;
          self2.daysContainer.style.width = daysWidth + "px";
          self2.calendarContainer.style.width = daysWidth + (self2.weekWrapper !== void 0 ? self2.weekWrapper.offsetWidth : 0) + "px";
          self2.calendarContainer.style.removeProperty("visibility");
          self2.calendarContainer.style.removeProperty("display");
        }
      });
    }
  }
  function updateTime(e) {
    if (self2.selectedDates.length === 0) {
      var defaultDate = self2.config.minDate === void 0 || compareDates(new Date(), self2.config.minDate) >= 0 ? new Date() : new Date(self2.config.minDate.getTime());
      var defaults2 = getDefaultHours(self2.config);
      defaultDate.setHours(defaults2.hours, defaults2.minutes, defaults2.seconds, defaultDate.getMilliseconds());
      self2.selectedDates = [defaultDate];
      self2.latestSelectedDateObj = defaultDate;
    }
    if (e !== void 0 && e.type !== "blur") {
      timeWrapper(e);
    }
    var prevValue = self2._input.value;
    setHoursFromInputs();
    updateValue();
    if (self2._input.value !== prevValue) {
      self2._debouncedChange();
    }
  }
  function ampm2military(hour, amPM) {
    return hour % 12 + 12 * int(amPM === self2.l10n.amPM[1]);
  }
  function military2ampm(hour) {
    switch (hour % 24) {
      case 0:
      case 12:
        return 12;
      default:
        return hour % 12;
    }
  }
  function setHoursFromInputs() {
    if (self2.hourElement === void 0 || self2.minuteElement === void 0)
      return;
    var hours = (parseInt(self2.hourElement.value.slice(-2), 10) || 0) % 24, minutes = (parseInt(self2.minuteElement.value, 10) || 0) % 60, seconds = self2.secondElement !== void 0 ? (parseInt(self2.secondElement.value, 10) || 0) % 60 : 0;
    if (self2.amPM !== void 0) {
      hours = ampm2military(hours, self2.amPM.textContent);
    }
    var limitMinHours = self2.config.minTime !== void 0 || self2.config.minDate && self2.minDateHasTime && self2.latestSelectedDateObj && compareDates(self2.latestSelectedDateObj, self2.config.minDate, true) === 0;
    var limitMaxHours = self2.config.maxTime !== void 0 || self2.config.maxDate && self2.maxDateHasTime && self2.latestSelectedDateObj && compareDates(self2.latestSelectedDateObj, self2.config.maxDate, true) === 0;
    if (self2.config.maxTime !== void 0 && self2.config.minTime !== void 0 && self2.config.minTime > self2.config.maxTime) {
      var minBound = calculateSecondsSinceMidnight(self2.config.minTime.getHours(), self2.config.minTime.getMinutes(), self2.config.minTime.getSeconds());
      var maxBound = calculateSecondsSinceMidnight(self2.config.maxTime.getHours(), self2.config.maxTime.getMinutes(), self2.config.maxTime.getSeconds());
      var currentTime = calculateSecondsSinceMidnight(hours, minutes, seconds);
      if (currentTime > maxBound && currentTime < minBound) {
        var result = parseSeconds(minBound);
        hours = result[0];
        minutes = result[1];
        seconds = result[2];
      }
    } else {
      if (limitMaxHours) {
        var maxTime = self2.config.maxTime !== void 0 ? self2.config.maxTime : self2.config.maxDate;
        hours = Math.min(hours, maxTime.getHours());
        if (hours === maxTime.getHours())
          minutes = Math.min(minutes, maxTime.getMinutes());
        if (minutes === maxTime.getMinutes())
          seconds = Math.min(seconds, maxTime.getSeconds());
      }
      if (limitMinHours) {
        var minTime = self2.config.minTime !== void 0 ? self2.config.minTime : self2.config.minDate;
        hours = Math.max(hours, minTime.getHours());
        if (hours === minTime.getHours() && minutes < minTime.getMinutes())
          minutes = minTime.getMinutes();
        if (minutes === minTime.getMinutes())
          seconds = Math.max(seconds, minTime.getSeconds());
      }
    }
    setHours(hours, minutes, seconds);
  }
  function setHoursFromDate(dateObj) {
    var date = dateObj || self2.latestSelectedDateObj;
    if (date && date instanceof Date) {
      setHours(date.getHours(), date.getMinutes(), date.getSeconds());
    }
  }
  function setHours(hours, minutes, seconds) {
    if (self2.latestSelectedDateObj !== void 0) {
      self2.latestSelectedDateObj.setHours(hours % 24, minutes, seconds || 0, 0);
    }
    if (!self2.hourElement || !self2.minuteElement || self2.isMobile)
      return;
    self2.hourElement.value = pad(!self2.config.time_24hr ? (12 + hours) % 12 + 12 * int(hours % 12 === 0) : hours);
    self2.minuteElement.value = pad(minutes);
    if (self2.amPM !== void 0)
      self2.amPM.textContent = self2.l10n.amPM[int(hours >= 12)];
    if (self2.secondElement !== void 0)
      self2.secondElement.value = pad(seconds);
  }
  function onYearInput(event) {
    var eventTarget = getEventTarget(event);
    var year = parseInt(eventTarget.value) + (event.delta || 0);
    if (year / 1e3 > 1 || event.key === "Enter" && !/[^\d]/.test(year.toString())) {
      changeYear(year);
    }
  }
  function bind3(element2, event, handler, options) {
    if (event instanceof Array)
      return event.forEach(function(ev) {
        return bind3(element2, ev, handler, options);
      });
    if (element2 instanceof Array)
      return element2.forEach(function(el) {
        return bind3(el, event, handler, options);
      });
    element2.addEventListener(event, handler, options);
    self2._handlers.push({
      remove: function() {
        return element2.removeEventListener(event, handler, options);
      }
    });
  }
  function triggerChange() {
    triggerEvent("onChange");
  }
  function bindEvents() {
    if (self2.config.wrap) {
      ["open", "close", "toggle", "clear"].forEach(function(evt) {
        Array.prototype.forEach.call(self2.element.querySelectorAll("[data-" + evt + "]"), function(el) {
          return bind3(el, "click", self2[evt]);
        });
      });
    }
    if (self2.isMobile) {
      setupMobile();
      return;
    }
    var debouncedResize = debounce(onResize, 50);
    self2._debouncedChange = debounce(triggerChange, DEBOUNCED_CHANGE_MS);
    if (self2.daysContainer && !/iPhone|iPad|iPod/i.test(navigator.userAgent))
      bind3(self2.daysContainer, "mouseover", function(e) {
        if (self2.config.mode === "range")
          onMouseOver(getEventTarget(e));
      });
    bind3(self2._input, "keydown", onKeyDown);
    if (self2.calendarContainer !== void 0) {
      bind3(self2.calendarContainer, "keydown", onKeyDown);
    }
    if (!self2.config.inline && !self2.config.static)
      bind3(window, "resize", debouncedResize);
    if (window.ontouchstart !== void 0)
      bind3(window.document, "touchstart", documentClick);
    else
      bind3(window.document, "mousedown", documentClick);
    bind3(window.document, "focus", documentClick, { capture: true });
    if (self2.config.clickOpens === true) {
      bind3(self2._input, "focus", self2.open);
      bind3(self2._input, "click", self2.open);
    }
    if (self2.daysContainer !== void 0) {
      bind3(self2.monthNav, "click", onMonthNavClick);
      bind3(self2.monthNav, ["keyup", "increment"], onYearInput);
      bind3(self2.daysContainer, "click", selectDate);
    }
    if (self2.timeContainer !== void 0 && self2.minuteElement !== void 0 && self2.hourElement !== void 0) {
      var selText = function(e) {
        return getEventTarget(e).select();
      };
      bind3(self2.timeContainer, ["increment"], updateTime);
      bind3(self2.timeContainer, "blur", updateTime, { capture: true });
      bind3(self2.timeContainer, "click", timeIncrement);
      bind3([self2.hourElement, self2.minuteElement], ["focus", "click"], selText);
      if (self2.secondElement !== void 0)
        bind3(self2.secondElement, "focus", function() {
          return self2.secondElement && self2.secondElement.select();
        });
      if (self2.amPM !== void 0) {
        bind3(self2.amPM, "click", function(e) {
          updateTime(e);
        });
      }
    }
    if (self2.config.allowInput) {
      bind3(self2._input, "blur", onBlur);
    }
  }
  function jumpToDate(jumpDate, triggerChange2) {
    var jumpTo = jumpDate !== void 0 ? self2.parseDate(jumpDate) : self2.latestSelectedDateObj || (self2.config.minDate && self2.config.minDate > self2.now ? self2.config.minDate : self2.config.maxDate && self2.config.maxDate < self2.now ? self2.config.maxDate : self2.now);
    var oldYear = self2.currentYear;
    var oldMonth = self2.currentMonth;
    try {
      if (jumpTo !== void 0) {
        self2.currentYear = jumpTo.getFullYear();
        self2.currentMonth = jumpTo.getMonth();
      }
    } catch (e) {
      e.message = "Invalid date supplied: " + jumpTo;
      self2.config.errorHandler(e);
    }
    if (triggerChange2 && self2.currentYear !== oldYear) {
      triggerEvent("onYearChange");
      buildMonthSwitch();
    }
    if (triggerChange2 && (self2.currentYear !== oldYear || self2.currentMonth !== oldMonth)) {
      triggerEvent("onMonthChange");
    }
    self2.redraw();
  }
  function timeIncrement(e) {
    var eventTarget = getEventTarget(e);
    if (~eventTarget.className.indexOf("arrow"))
      incrementNumInput(e, eventTarget.classList.contains("arrowUp") ? 1 : -1);
  }
  function incrementNumInput(e, delta, inputElem) {
    var target = e && getEventTarget(e);
    var input = inputElem || target && target.parentNode && target.parentNode.firstChild;
    var event = createEvent("increment");
    event.delta = delta;
    input && input.dispatchEvent(event);
  }
  function build() {
    var fragment = window.document.createDocumentFragment();
    self2.calendarContainer = createElement("div", "flatpickr-calendar");
    self2.calendarContainer.tabIndex = -1;
    if (!self2.config.noCalendar) {
      fragment.appendChild(buildMonthNav());
      self2.innerContainer = createElement("div", "flatpickr-innerContainer");
      if (self2.config.weekNumbers) {
        var _a = buildWeeks(), weekWrapper = _a.weekWrapper, weekNumbers = _a.weekNumbers;
        self2.innerContainer.appendChild(weekWrapper);
        self2.weekNumbers = weekNumbers;
        self2.weekWrapper = weekWrapper;
      }
      self2.rContainer = createElement("div", "flatpickr-rContainer");
      self2.rContainer.appendChild(buildWeekdays());
      if (!self2.daysContainer) {
        self2.daysContainer = createElement("div", "flatpickr-days");
        self2.daysContainer.tabIndex = -1;
      }
      buildDays();
      self2.rContainer.appendChild(self2.daysContainer);
      self2.innerContainer.appendChild(self2.rContainer);
      fragment.appendChild(self2.innerContainer);
    }
    if (self2.config.enableTime) {
      fragment.appendChild(buildTime());
    }
    toggleClass(self2.calendarContainer, "rangeMode", self2.config.mode === "range");
    toggleClass(self2.calendarContainer, "animate", self2.config.animate === true);
    toggleClass(self2.calendarContainer, "multiMonth", self2.config.showMonths > 1);
    self2.calendarContainer.appendChild(fragment);
    var customAppend = self2.config.appendTo !== void 0 && self2.config.appendTo.nodeType !== void 0;
    if (self2.config.inline || self2.config.static) {
      self2.calendarContainer.classList.add(self2.config.inline ? "inline" : "static");
      if (self2.config.inline) {
        if (!customAppend && self2.element.parentNode)
          self2.element.parentNode.insertBefore(self2.calendarContainer, self2._input.nextSibling);
        else if (self2.config.appendTo !== void 0)
          self2.config.appendTo.appendChild(self2.calendarContainer);
      }
      if (self2.config.static) {
        var wrapper = createElement("div", "flatpickr-wrapper");
        if (self2.element.parentNode)
          self2.element.parentNode.insertBefore(wrapper, self2.element);
        wrapper.appendChild(self2.element);
        if (self2.altInput)
          wrapper.appendChild(self2.altInput);
        wrapper.appendChild(self2.calendarContainer);
      }
    }
    if (!self2.config.static && !self2.config.inline)
      (self2.config.appendTo !== void 0 ? self2.config.appendTo : window.document.body).appendChild(self2.calendarContainer);
  }
  function createDay(className, date, _dayNumber, i) {
    var dateIsEnabled = isEnabled(date, true), dayElement = createElement("span", className, date.getDate().toString());
    dayElement.dateObj = date;
    dayElement.$i = i;
    dayElement.setAttribute("aria-label", self2.formatDate(date, self2.config.ariaDateFormat));
    if (className.indexOf("hidden") === -1 && compareDates(date, self2.now) === 0) {
      self2.todayDateElem = dayElement;
      dayElement.classList.add("today");
      dayElement.setAttribute("aria-current", "date");
    }
    if (dateIsEnabled) {
      dayElement.tabIndex = -1;
      if (isDateSelected(date)) {
        dayElement.classList.add("selected");
        self2.selectedDateElem = dayElement;
        if (self2.config.mode === "range") {
          toggleClass(dayElement, "startRange", self2.selectedDates[0] && compareDates(date, self2.selectedDates[0], true) === 0);
          toggleClass(dayElement, "endRange", self2.selectedDates[1] && compareDates(date, self2.selectedDates[1], true) === 0);
          if (className === "nextMonthDay")
            dayElement.classList.add("inRange");
        }
      }
    } else {
      dayElement.classList.add("flatpickr-disabled");
    }
    if (self2.config.mode === "range") {
      if (isDateInRange(date) && !isDateSelected(date))
        dayElement.classList.add("inRange");
    }
    if (self2.weekNumbers && self2.config.showMonths === 1 && className !== "prevMonthDay" && i % 7 === 6) {
      self2.weekNumbers.insertAdjacentHTML("beforeend", "<span class='flatpickr-day'>" + self2.config.getWeek(date) + "</span>");
    }
    triggerEvent("onDayCreate", dayElement);
    return dayElement;
  }
  function focusOnDayElem(targetNode) {
    targetNode.focus();
    if (self2.config.mode === "range")
      onMouseOver(targetNode);
  }
  function getFirstAvailableDay(delta) {
    var startMonth = delta > 0 ? 0 : self2.config.showMonths - 1;
    var endMonth = delta > 0 ? self2.config.showMonths : -1;
    for (var m = startMonth; m != endMonth; m += delta) {
      var month = self2.daysContainer.children[m];
      var startIndex = delta > 0 ? 0 : month.children.length - 1;
      var endIndex = delta > 0 ? month.children.length : -1;
      for (var i = startIndex; i != endIndex; i += delta) {
        var c = month.children[i];
        if (c.className.indexOf("hidden") === -1 && isEnabled(c.dateObj))
          return c;
      }
    }
    return void 0;
  }
  function getNextAvailableDay(current, delta) {
    var givenMonth = current.className.indexOf("Month") === -1 ? current.dateObj.getMonth() : self2.currentMonth;
    var endMonth = delta > 0 ? self2.config.showMonths : -1;
    var loopDelta = delta > 0 ? 1 : -1;
    for (var m = givenMonth - self2.currentMonth; m != endMonth; m += loopDelta) {
      var month = self2.daysContainer.children[m];
      var startIndex = givenMonth - self2.currentMonth === m ? current.$i + delta : delta < 0 ? month.children.length - 1 : 0;
      var numMonthDays = month.children.length;
      for (var i = startIndex; i >= 0 && i < numMonthDays && i != (delta > 0 ? numMonthDays : -1); i += loopDelta) {
        var c = month.children[i];
        if (c.className.indexOf("hidden") === -1 && isEnabled(c.dateObj) && Math.abs(current.$i - i) >= Math.abs(delta))
          return focusOnDayElem(c);
      }
    }
    self2.changeMonth(loopDelta);
    focusOnDay(getFirstAvailableDay(loopDelta), 0);
    return void 0;
  }
  function focusOnDay(current, offset2) {
    var activeElement = getClosestActiveElement();
    var dayFocused = isInView(activeElement || document.body);
    var startElem = current !== void 0 ? current : dayFocused ? activeElement : self2.selectedDateElem !== void 0 && isInView(self2.selectedDateElem) ? self2.selectedDateElem : self2.todayDateElem !== void 0 && isInView(self2.todayDateElem) ? self2.todayDateElem : getFirstAvailableDay(offset2 > 0 ? 1 : -1);
    if (startElem === void 0) {
      self2._input.focus();
    } else if (!dayFocused) {
      focusOnDayElem(startElem);
    } else {
      getNextAvailableDay(startElem, offset2);
    }
  }
  function buildMonthDays(year, month) {
    var firstOfMonth = (new Date(year, month, 1).getDay() - self2.l10n.firstDayOfWeek + 7) % 7;
    var prevMonthDays = self2.utils.getDaysInMonth((month - 1 + 12) % 12, year);
    var daysInMonth = self2.utils.getDaysInMonth(month, year), days = window.document.createDocumentFragment(), isMultiMonth = self2.config.showMonths > 1, prevMonthDayClass = isMultiMonth ? "prevMonthDay hidden" : "prevMonthDay", nextMonthDayClass = isMultiMonth ? "nextMonthDay hidden" : "nextMonthDay";
    var dayNumber = prevMonthDays + 1 - firstOfMonth, dayIndex = 0;
    for (; dayNumber <= prevMonthDays; dayNumber++, dayIndex++) {
      days.appendChild(createDay("flatpickr-day " + prevMonthDayClass, new Date(year, month - 1, dayNumber), dayNumber, dayIndex));
    }
    for (dayNumber = 1; dayNumber <= daysInMonth; dayNumber++, dayIndex++) {
      days.appendChild(createDay("flatpickr-day", new Date(year, month, dayNumber), dayNumber, dayIndex));
    }
    for (var dayNum = daysInMonth + 1; dayNum <= 42 - firstOfMonth && (self2.config.showMonths === 1 || dayIndex % 7 !== 0); dayNum++, dayIndex++) {
      days.appendChild(createDay("flatpickr-day " + nextMonthDayClass, new Date(year, month + 1, dayNum % daysInMonth), dayNum, dayIndex));
    }
    var dayContainer = createElement("div", "dayContainer");
    dayContainer.appendChild(days);
    return dayContainer;
  }
  function buildDays() {
    if (self2.daysContainer === void 0) {
      return;
    }
    clearNode(self2.daysContainer);
    if (self2.weekNumbers)
      clearNode(self2.weekNumbers);
    var frag = document.createDocumentFragment();
    for (var i = 0; i < self2.config.showMonths; i++) {
      var d = new Date(self2.currentYear, self2.currentMonth, 1);
      d.setMonth(self2.currentMonth + i);
      frag.appendChild(buildMonthDays(d.getFullYear(), d.getMonth()));
    }
    self2.daysContainer.appendChild(frag);
    self2.days = self2.daysContainer.firstChild;
    if (self2.config.mode === "range" && self2.selectedDates.length === 1) {
      onMouseOver();
    }
  }
  function buildMonthSwitch() {
    if (self2.config.showMonths > 1 || self2.config.monthSelectorType !== "dropdown")
      return;
    var shouldBuildMonth = function(month2) {
      if (self2.config.minDate !== void 0 && self2.currentYear === self2.config.minDate.getFullYear() && month2 < self2.config.minDate.getMonth()) {
        return false;
      }
      return !(self2.config.maxDate !== void 0 && self2.currentYear === self2.config.maxDate.getFullYear() && month2 > self2.config.maxDate.getMonth());
    };
    self2.monthsDropdownContainer.tabIndex = -1;
    self2.monthsDropdownContainer.innerHTML = "";
    for (var i = 0; i < 12; i++) {
      if (!shouldBuildMonth(i))
        continue;
      var month = createElement("option", "flatpickr-monthDropdown-month");
      month.value = new Date(self2.currentYear, i).getMonth().toString();
      month.textContent = monthToStr(i, self2.config.shorthandCurrentMonth, self2.l10n);
      month.tabIndex = -1;
      if (self2.currentMonth === i) {
        month.selected = true;
      }
      self2.monthsDropdownContainer.appendChild(month);
    }
  }
  function buildMonth() {
    var container = createElement("div", "flatpickr-month");
    var monthNavFragment = window.document.createDocumentFragment();
    var monthElement;
    if (self2.config.showMonths > 1 || self2.config.monthSelectorType === "static") {
      monthElement = createElement("span", "cur-month");
    } else {
      self2.monthsDropdownContainer = createElement("select", "flatpickr-monthDropdown-months");
      self2.monthsDropdownContainer.setAttribute("aria-label", self2.l10n.monthAriaLabel);
      bind3(self2.monthsDropdownContainer, "change", function(e) {
        var target = getEventTarget(e);
        var selectedMonth = parseInt(target.value, 10);
        self2.changeMonth(selectedMonth - self2.currentMonth);
        triggerEvent("onMonthChange");
      });
      buildMonthSwitch();
      monthElement = self2.monthsDropdownContainer;
    }
    var yearInput = createNumberInput("cur-year", { tabindex: "-1" });
    var yearElement = yearInput.getElementsByTagName("input")[0];
    yearElement.setAttribute("aria-label", self2.l10n.yearAriaLabel);
    if (self2.config.minDate) {
      yearElement.setAttribute("min", self2.config.minDate.getFullYear().toString());
    }
    if (self2.config.maxDate) {
      yearElement.setAttribute("max", self2.config.maxDate.getFullYear().toString());
      yearElement.disabled = !!self2.config.minDate && self2.config.minDate.getFullYear() === self2.config.maxDate.getFullYear();
    }
    var currentMonth = createElement("div", "flatpickr-current-month");
    currentMonth.appendChild(monthElement);
    currentMonth.appendChild(yearInput);
    monthNavFragment.appendChild(currentMonth);
    container.appendChild(monthNavFragment);
    return {
      container,
      yearElement,
      monthElement
    };
  }
  function buildMonths() {
    clearNode(self2.monthNav);
    self2.monthNav.appendChild(self2.prevMonthNav);
    if (self2.config.showMonths) {
      self2.yearElements = [];
      self2.monthElements = [];
    }
    for (var m = self2.config.showMonths; m--; ) {
      var month = buildMonth();
      self2.yearElements.push(month.yearElement);
      self2.monthElements.push(month.monthElement);
      self2.monthNav.appendChild(month.container);
    }
    self2.monthNav.appendChild(self2.nextMonthNav);
  }
  function buildMonthNav() {
    self2.monthNav = createElement("div", "flatpickr-months");
    self2.yearElements = [];
    self2.monthElements = [];
    self2.prevMonthNav = createElement("span", "flatpickr-prev-month");
    self2.prevMonthNav.innerHTML = self2.config.prevArrow;
    self2.nextMonthNav = createElement("span", "flatpickr-next-month");
    self2.nextMonthNav.innerHTML = self2.config.nextArrow;
    buildMonths();
    Object.defineProperty(self2, "_hidePrevMonthArrow", {
      get: function() {
        return self2.__hidePrevMonthArrow;
      },
      set: function(bool) {
        if (self2.__hidePrevMonthArrow !== bool) {
          toggleClass(self2.prevMonthNav, "flatpickr-disabled", bool);
          self2.__hidePrevMonthArrow = bool;
        }
      }
    });
    Object.defineProperty(self2, "_hideNextMonthArrow", {
      get: function() {
        return self2.__hideNextMonthArrow;
      },
      set: function(bool) {
        if (self2.__hideNextMonthArrow !== bool) {
          toggleClass(self2.nextMonthNav, "flatpickr-disabled", bool);
          self2.__hideNextMonthArrow = bool;
        }
      }
    });
    self2.currentYearElement = self2.yearElements[0];
    updateNavigationCurrentMonth();
    return self2.monthNav;
  }
  function buildTime() {
    self2.calendarContainer.classList.add("hasTime");
    if (self2.config.noCalendar)
      self2.calendarContainer.classList.add("noCalendar");
    var defaults2 = getDefaultHours(self2.config);
    self2.timeContainer = createElement("div", "flatpickr-time");
    self2.timeContainer.tabIndex = -1;
    var separator = createElement("span", "flatpickr-time-separator", ":");
    var hourInput = createNumberInput("flatpickr-hour", {
      "aria-label": self2.l10n.hourAriaLabel
    });
    self2.hourElement = hourInput.getElementsByTagName("input")[0];
    var minuteInput = createNumberInput("flatpickr-minute", {
      "aria-label": self2.l10n.minuteAriaLabel
    });
    self2.minuteElement = minuteInput.getElementsByTagName("input")[0];
    self2.hourElement.tabIndex = self2.minuteElement.tabIndex = -1;
    self2.hourElement.value = pad(self2.latestSelectedDateObj ? self2.latestSelectedDateObj.getHours() : self2.config.time_24hr ? defaults2.hours : military2ampm(defaults2.hours));
    self2.minuteElement.value = pad(self2.latestSelectedDateObj ? self2.latestSelectedDateObj.getMinutes() : defaults2.minutes);
    self2.hourElement.setAttribute("step", self2.config.hourIncrement.toString());
    self2.minuteElement.setAttribute("step", self2.config.minuteIncrement.toString());
    self2.hourElement.setAttribute("min", self2.config.time_24hr ? "0" : "1");
    self2.hourElement.setAttribute("max", self2.config.time_24hr ? "23" : "12");
    self2.hourElement.setAttribute("maxlength", "2");
    self2.minuteElement.setAttribute("min", "0");
    self2.minuteElement.setAttribute("max", "59");
    self2.minuteElement.setAttribute("maxlength", "2");
    self2.timeContainer.appendChild(hourInput);
    self2.timeContainer.appendChild(separator);
    self2.timeContainer.appendChild(minuteInput);
    if (self2.config.time_24hr)
      self2.timeContainer.classList.add("time24hr");
    if (self2.config.enableSeconds) {
      self2.timeContainer.classList.add("hasSeconds");
      var secondInput = createNumberInput("flatpickr-second");
      self2.secondElement = secondInput.getElementsByTagName("input")[0];
      self2.secondElement.value = pad(self2.latestSelectedDateObj ? self2.latestSelectedDateObj.getSeconds() : defaults2.seconds);
      self2.secondElement.setAttribute("step", self2.minuteElement.getAttribute("step"));
      self2.secondElement.setAttribute("min", "0");
      self2.secondElement.setAttribute("max", "59");
      self2.secondElement.setAttribute("maxlength", "2");
      self2.timeContainer.appendChild(createElement("span", "flatpickr-time-separator", ":"));
      self2.timeContainer.appendChild(secondInput);
    }
    if (!self2.config.time_24hr) {
      self2.amPM = createElement("span", "flatpickr-am-pm", self2.l10n.amPM[int((self2.latestSelectedDateObj ? self2.hourElement.value : self2.config.defaultHour) > 11)]);
      self2.amPM.title = self2.l10n.toggleTitle;
      self2.amPM.tabIndex = -1;
      self2.timeContainer.appendChild(self2.amPM);
    }
    return self2.timeContainer;
  }
  function buildWeekdays() {
    if (!self2.weekdayContainer)
      self2.weekdayContainer = createElement("div", "flatpickr-weekdays");
    else
      clearNode(self2.weekdayContainer);
    for (var i = self2.config.showMonths; i--; ) {
      var container = createElement("div", "flatpickr-weekdaycontainer");
      self2.weekdayContainer.appendChild(container);
    }
    updateWeekdays();
    return self2.weekdayContainer;
  }
  function updateWeekdays() {
    if (!self2.weekdayContainer) {
      return;
    }
    var firstDayOfWeek = self2.l10n.firstDayOfWeek;
    var weekdays = __spreadArrays(self2.l10n.weekdays.shorthand);
    if (firstDayOfWeek > 0 && firstDayOfWeek < weekdays.length) {
      weekdays = __spreadArrays(weekdays.splice(firstDayOfWeek, weekdays.length), weekdays.splice(0, firstDayOfWeek));
    }
    for (var i = self2.config.showMonths; i--; ) {
      self2.weekdayContainer.children[i].innerHTML = "\n      <span class='flatpickr-weekday'>\n        " + weekdays.join("</span><span class='flatpickr-weekday'>") + "\n      </span>\n      ";
    }
  }
  function buildWeeks() {
    self2.calendarContainer.classList.add("hasWeeks");
    var weekWrapper = createElement("div", "flatpickr-weekwrapper");
    weekWrapper.appendChild(createElement("span", "flatpickr-weekday", self2.l10n.weekAbbreviation));
    var weekNumbers = createElement("div", "flatpickr-weeks");
    weekWrapper.appendChild(weekNumbers);
    return {
      weekWrapper,
      weekNumbers
    };
  }
  function changeMonth(value, isOffset) {
    if (isOffset === void 0) {
      isOffset = true;
    }
    var delta = isOffset ? value : value - self2.currentMonth;
    if (delta < 0 && self2._hidePrevMonthArrow === true || delta > 0 && self2._hideNextMonthArrow === true)
      return;
    self2.currentMonth += delta;
    if (self2.currentMonth < 0 || self2.currentMonth > 11) {
      self2.currentYear += self2.currentMonth > 11 ? 1 : -1;
      self2.currentMonth = (self2.currentMonth + 12) % 12;
      triggerEvent("onYearChange");
      buildMonthSwitch();
    }
    buildDays();
    triggerEvent("onMonthChange");
    updateNavigationCurrentMonth();
  }
  function clear(triggerChangeEvent, toInitial) {
    if (triggerChangeEvent === void 0) {
      triggerChangeEvent = true;
    }
    if (toInitial === void 0) {
      toInitial = true;
    }
    self2.input.value = "";
    if (self2.altInput !== void 0)
      self2.altInput.value = "";
    if (self2.mobileInput !== void 0)
      self2.mobileInput.value = "";
    self2.selectedDates = [];
    self2.latestSelectedDateObj = void 0;
    if (toInitial === true) {
      self2.currentYear = self2._initialDate.getFullYear();
      self2.currentMonth = self2._initialDate.getMonth();
    }
    if (self2.config.enableTime === true) {
      var _a = getDefaultHours(self2.config), hours = _a.hours, minutes = _a.minutes, seconds = _a.seconds;
      setHours(hours, minutes, seconds);
    }
    self2.redraw();
    if (triggerChangeEvent)
      triggerEvent("onChange");
  }
  function close() {
    self2.isOpen = false;
    if (!self2.isMobile) {
      if (self2.calendarContainer !== void 0) {
        self2.calendarContainer.classList.remove("open");
      }
      if (self2._input !== void 0) {
        self2._input.classList.remove("active");
      }
    }
    triggerEvent("onClose");
  }
  function destroy2() {
    if (self2.config !== void 0)
      triggerEvent("onDestroy");
    for (var i = self2._handlers.length; i--; ) {
      self2._handlers[i].remove();
    }
    self2._handlers = [];
    if (self2.mobileInput) {
      if (self2.mobileInput.parentNode)
        self2.mobileInput.parentNode.removeChild(self2.mobileInput);
      self2.mobileInput = void 0;
    } else if (self2.calendarContainer && self2.calendarContainer.parentNode) {
      if (self2.config.static && self2.calendarContainer.parentNode) {
        var wrapper = self2.calendarContainer.parentNode;
        wrapper.lastChild && wrapper.removeChild(wrapper.lastChild);
        if (wrapper.parentNode) {
          while (wrapper.firstChild)
            wrapper.parentNode.insertBefore(wrapper.firstChild, wrapper);
          wrapper.parentNode.removeChild(wrapper);
        }
      } else
        self2.calendarContainer.parentNode.removeChild(self2.calendarContainer);
    }
    if (self2.altInput) {
      self2.input.type = "text";
      if (self2.altInput.parentNode)
        self2.altInput.parentNode.removeChild(self2.altInput);
      delete self2.altInput;
    }
    if (self2.input) {
      self2.input.type = self2.input._type;
      self2.input.classList.remove("flatpickr-input");
      self2.input.removeAttribute("readonly");
    }
    [
      "_showTimeInput",
      "latestSelectedDateObj",
      "_hideNextMonthArrow",
      "_hidePrevMonthArrow",
      "__hideNextMonthArrow",
      "__hidePrevMonthArrow",
      "isMobile",
      "isOpen",
      "selectedDateElem",
      "minDateHasTime",
      "maxDateHasTime",
      "days",
      "daysContainer",
      "_input",
      "_positionElement",
      "innerContainer",
      "rContainer",
      "monthNav",
      "todayDateElem",
      "calendarContainer",
      "weekdayContainer",
      "prevMonthNav",
      "nextMonthNav",
      "monthsDropdownContainer",
      "currentMonthElement",
      "currentYearElement",
      "navigationCurrentMonth",
      "selectedDateElem",
      "config"
    ].forEach(function(k) {
      try {
        delete self2[k];
      } catch (_) {
      }
    });
  }
  function isCalendarElem(elem) {
    return self2.calendarContainer.contains(elem);
  }
  function documentClick(e) {
    if (self2.isOpen && !self2.config.inline) {
      var eventTarget_1 = getEventTarget(e);
      var isCalendarElement = isCalendarElem(eventTarget_1);
      var isInput = eventTarget_1 === self2.input || eventTarget_1 === self2.altInput || self2.element.contains(eventTarget_1) || e.path && e.path.indexOf && (~e.path.indexOf(self2.input) || ~e.path.indexOf(self2.altInput));
      var lostFocus = !isInput && !isCalendarElement && !isCalendarElem(e.relatedTarget);
      var isIgnored = !self2.config.ignoredFocusElements.some(function(elem) {
        return elem.contains(eventTarget_1);
      });
      if (lostFocus && isIgnored) {
        if (self2.config.allowInput) {
          self2.setDate(self2._input.value, false, self2.config.altInput ? self2.config.altFormat : self2.config.dateFormat);
        }
        if (self2.timeContainer !== void 0 && self2.minuteElement !== void 0 && self2.hourElement !== void 0 && self2.input.value !== "" && self2.input.value !== void 0) {
          updateTime();
        }
        self2.close();
        if (self2.config && self2.config.mode === "range" && self2.selectedDates.length === 1)
          self2.clear(false);
      }
    }
  }
  function changeYear(newYear) {
    if (!newYear || self2.config.minDate && newYear < self2.config.minDate.getFullYear() || self2.config.maxDate && newYear > self2.config.maxDate.getFullYear())
      return;
    var newYearNum = newYear, isNewYear = self2.currentYear !== newYearNum;
    self2.currentYear = newYearNum || self2.currentYear;
    if (self2.config.maxDate && self2.currentYear === self2.config.maxDate.getFullYear()) {
      self2.currentMonth = Math.min(self2.config.maxDate.getMonth(), self2.currentMonth);
    } else if (self2.config.minDate && self2.currentYear === self2.config.minDate.getFullYear()) {
      self2.currentMonth = Math.max(self2.config.minDate.getMonth(), self2.currentMonth);
    }
    if (isNewYear) {
      self2.redraw();
      triggerEvent("onYearChange");
      buildMonthSwitch();
    }
  }
  function isEnabled(date, timeless) {
    var _a;
    if (timeless === void 0) {
      timeless = true;
    }
    var dateToCheck = self2.parseDate(date, void 0, timeless);
    if (self2.config.minDate && dateToCheck && compareDates(dateToCheck, self2.config.minDate, timeless !== void 0 ? timeless : !self2.minDateHasTime) < 0 || self2.config.maxDate && dateToCheck && compareDates(dateToCheck, self2.config.maxDate, timeless !== void 0 ? timeless : !self2.maxDateHasTime) > 0)
      return false;
    if (!self2.config.enable && self2.config.disable.length === 0)
      return true;
    if (dateToCheck === void 0)
      return false;
    var bool = !!self2.config.enable, array = (_a = self2.config.enable) !== null && _a !== void 0 ? _a : self2.config.disable;
    for (var i = 0, d = void 0; i < array.length; i++) {
      d = array[i];
      if (typeof d === "function" && d(dateToCheck))
        return bool;
      else if (d instanceof Date && dateToCheck !== void 0 && d.getTime() === dateToCheck.getTime())
        return bool;
      else if (typeof d === "string") {
        var parsed = self2.parseDate(d, void 0, true);
        return parsed && parsed.getTime() === dateToCheck.getTime() ? bool : !bool;
      } else if (typeof d === "object" && dateToCheck !== void 0 && d.from && d.to && dateToCheck.getTime() >= d.from.getTime() && dateToCheck.getTime() <= d.to.getTime())
        return bool;
    }
    return !bool;
  }
  function isInView(elem) {
    if (self2.daysContainer !== void 0)
      return elem.className.indexOf("hidden") === -1 && elem.className.indexOf("flatpickr-disabled") === -1 && self2.daysContainer.contains(elem);
    return false;
  }
  function onBlur(e) {
    var isInput = e.target === self2._input;
    var valueChanged = self2._input.value.trimEnd() !== getDateStr();
    if (isInput && valueChanged && !(e.relatedTarget && isCalendarElem(e.relatedTarget))) {
      self2.setDate(self2._input.value, true, e.target === self2.altInput ? self2.config.altFormat : self2.config.dateFormat);
    }
  }
  function onKeyDown(e) {
    var eventTarget = getEventTarget(e);
    var isInput = self2.config.wrap ? element.contains(eventTarget) : eventTarget === self2._input;
    var allowInput = self2.config.allowInput;
    var allowKeydown = self2.isOpen && (!allowInput || !isInput);
    var allowInlineKeydown = self2.config.inline && isInput && !allowInput;
    if (e.keyCode === 13 && isInput) {
      if (allowInput) {
        self2.setDate(self2._input.value, true, eventTarget === self2.altInput ? self2.config.altFormat : self2.config.dateFormat);
        self2.close();
        return eventTarget.blur();
      } else {
        self2.open();
      }
    } else if (isCalendarElem(eventTarget) || allowKeydown || allowInlineKeydown) {
      var isTimeObj = !!self2.timeContainer && self2.timeContainer.contains(eventTarget);
      switch (e.keyCode) {
        case 13:
          if (isTimeObj) {
            e.preventDefault();
            updateTime();
            focusAndClose();
          } else
            selectDate(e);
          break;
        case 27:
          e.preventDefault();
          focusAndClose();
          break;
        case 8:
        case 46:
          if (isInput && !self2.config.allowInput) {
            e.preventDefault();
            self2.clear();
          }
          break;
        case 37:
        case 39:
          if (!isTimeObj && !isInput) {
            e.preventDefault();
            var activeElement = getClosestActiveElement();
            if (self2.daysContainer !== void 0 && (allowInput === false || activeElement && isInView(activeElement))) {
              var delta_1 = e.keyCode === 39 ? 1 : -1;
              if (!e.ctrlKey)
                focusOnDay(void 0, delta_1);
              else {
                e.stopPropagation();
                changeMonth(delta_1);
                focusOnDay(getFirstAvailableDay(1), 0);
              }
            }
          } else if (self2.hourElement)
            self2.hourElement.focus();
          break;
        case 38:
        case 40:
          e.preventDefault();
          var delta = e.keyCode === 40 ? 1 : -1;
          if (self2.daysContainer && eventTarget.$i !== void 0 || eventTarget === self2.input || eventTarget === self2.altInput) {
            if (e.ctrlKey) {
              e.stopPropagation();
              changeYear(self2.currentYear - delta);
              focusOnDay(getFirstAvailableDay(1), 0);
            } else if (!isTimeObj)
              focusOnDay(void 0, delta * 7);
          } else if (eventTarget === self2.currentYearElement) {
            changeYear(self2.currentYear - delta);
          } else if (self2.config.enableTime) {
            if (!isTimeObj && self2.hourElement)
              self2.hourElement.focus();
            updateTime(e);
            self2._debouncedChange();
          }
          break;
        case 9:
          if (isTimeObj) {
            var elems = [
              self2.hourElement,
              self2.minuteElement,
              self2.secondElement,
              self2.amPM
            ].concat(self2.pluginElements).filter(function(x) {
              return x;
            });
            var i = elems.indexOf(eventTarget);
            if (i !== -1) {
              var target = elems[i + (e.shiftKey ? -1 : 1)];
              e.preventDefault();
              (target || self2._input).focus();
            }
          } else if (!self2.config.noCalendar && self2.daysContainer && self2.daysContainer.contains(eventTarget) && e.shiftKey) {
            e.preventDefault();
            self2._input.focus();
          }
          break;
      }
    }
    if (self2.amPM !== void 0 && eventTarget === self2.amPM) {
      switch (e.key) {
        case self2.l10n.amPM[0].charAt(0):
        case self2.l10n.amPM[0].charAt(0).toLowerCase():
          self2.amPM.textContent = self2.l10n.amPM[0];
          setHoursFromInputs();
          updateValue();
          break;
        case self2.l10n.amPM[1].charAt(0):
        case self2.l10n.amPM[1].charAt(0).toLowerCase():
          self2.amPM.textContent = self2.l10n.amPM[1];
          setHoursFromInputs();
          updateValue();
          break;
      }
    }
    if (isInput || isCalendarElem(eventTarget)) {
      triggerEvent("onKeyDown", e);
    }
  }
  function onMouseOver(elem, cellClass) {
    if (cellClass === void 0) {
      cellClass = "flatpickr-day";
    }
    if (self2.selectedDates.length !== 1 || elem && (!elem.classList.contains(cellClass) || elem.classList.contains("flatpickr-disabled")))
      return;
    var hoverDate = elem ? elem.dateObj.getTime() : self2.days.firstElementChild.dateObj.getTime(), initialDate = self2.parseDate(self2.selectedDates[0], void 0, true).getTime(), rangeStartDate = Math.min(hoverDate, self2.selectedDates[0].getTime()), rangeEndDate = Math.max(hoverDate, self2.selectedDates[0].getTime());
    var containsDisabled = false;
    var minRange = 0, maxRange = 0;
    for (var t = rangeStartDate; t < rangeEndDate; t += duration.DAY) {
      if (!isEnabled(new Date(t), true)) {
        containsDisabled = containsDisabled || t > rangeStartDate && t < rangeEndDate;
        if (t < initialDate && (!minRange || t > minRange))
          minRange = t;
        else if (t > initialDate && (!maxRange || t < maxRange))
          maxRange = t;
      }
    }
    var hoverableCells = Array.from(self2.rContainer.querySelectorAll("*:nth-child(-n+" + self2.config.showMonths + ") > ." + cellClass));
    hoverableCells.forEach(function(dayElem) {
      var date = dayElem.dateObj;
      var timestamp = date.getTime();
      var outOfRange = minRange > 0 && timestamp < minRange || maxRange > 0 && timestamp > maxRange;
      if (outOfRange) {
        dayElem.classList.add("notAllowed");
        ["inRange", "startRange", "endRange"].forEach(function(c) {
          dayElem.classList.remove(c);
        });
        return;
      } else if (containsDisabled && !outOfRange)
        return;
      ["startRange", "inRange", "endRange", "notAllowed"].forEach(function(c) {
        dayElem.classList.remove(c);
      });
      if (elem !== void 0) {
        elem.classList.add(hoverDate <= self2.selectedDates[0].getTime() ? "startRange" : "endRange");
        if (initialDate < hoverDate && timestamp === initialDate)
          dayElem.classList.add("startRange");
        else if (initialDate > hoverDate && timestamp === initialDate)
          dayElem.classList.add("endRange");
        if (timestamp >= minRange && (maxRange === 0 || timestamp <= maxRange) && isBetween(timestamp, initialDate, hoverDate))
          dayElem.classList.add("inRange");
      }
    });
  }
  function onResize() {
    if (self2.isOpen && !self2.config.static && !self2.config.inline)
      positionCalendar();
  }
  function open(e, positionElement) {
    if (positionElement === void 0) {
      positionElement = self2._positionElement;
    }
    if (self2.isMobile === true) {
      if (e) {
        e.preventDefault();
        var eventTarget = getEventTarget(e);
        if (eventTarget) {
          eventTarget.blur();
        }
      }
      if (self2.mobileInput !== void 0) {
        self2.mobileInput.focus();
        self2.mobileInput.click();
      }
      triggerEvent("onOpen");
      return;
    } else if (self2._input.disabled || self2.config.inline) {
      return;
    }
    var wasOpen = self2.isOpen;
    self2.isOpen = true;
    if (!wasOpen) {
      self2.calendarContainer.classList.add("open");
      self2._input.classList.add("active");
      triggerEvent("onOpen");
      positionCalendar(positionElement);
    }
    if (self2.config.enableTime === true && self2.config.noCalendar === true) {
      if (self2.config.allowInput === false && (e === void 0 || !self2.timeContainer.contains(e.relatedTarget))) {
        setTimeout(function() {
          return self2.hourElement.select();
        }, 50);
      }
    }
  }
  function minMaxDateSetter(type) {
    return function(date) {
      var dateObj = self2.config["_" + type + "Date"] = self2.parseDate(date, self2.config.dateFormat);
      var inverseDateObj = self2.config["_" + (type === "min" ? "max" : "min") + "Date"];
      if (dateObj !== void 0) {
        self2[type === "min" ? "minDateHasTime" : "maxDateHasTime"] = dateObj.getHours() > 0 || dateObj.getMinutes() > 0 || dateObj.getSeconds() > 0;
      }
      if (self2.selectedDates) {
        self2.selectedDates = self2.selectedDates.filter(function(d) {
          return isEnabled(d);
        });
        if (!self2.selectedDates.length && type === "min")
          setHoursFromDate(dateObj);
        updateValue();
      }
      if (self2.daysContainer) {
        redraw();
        if (dateObj !== void 0)
          self2.currentYearElement[type] = dateObj.getFullYear().toString();
        else
          self2.currentYearElement.removeAttribute(type);
        self2.currentYearElement.disabled = !!inverseDateObj && dateObj !== void 0 && inverseDateObj.getFullYear() === dateObj.getFullYear();
      }
    };
  }
  function parseConfig() {
    var boolOpts = [
      "wrap",
      "weekNumbers",
      "allowInput",
      "allowInvalidPreload",
      "clickOpens",
      "time_24hr",
      "enableTime",
      "noCalendar",
      "altInput",
      "shorthandCurrentMonth",
      "inline",
      "static",
      "enableSeconds",
      "disableMobile"
    ];
    var userConfig = __assign(__assign({}, JSON.parse(JSON.stringify(element.dataset || {}))), instanceConfig);
    var formats2 = {};
    self2.config.parseDate = userConfig.parseDate;
    self2.config.formatDate = userConfig.formatDate;
    Object.defineProperty(self2.config, "enable", {
      get: function() {
        return self2.config._enable;
      },
      set: function(dates) {
        self2.config._enable = parseDateRules(dates);
      }
    });
    Object.defineProperty(self2.config, "disable", {
      get: function() {
        return self2.config._disable;
      },
      set: function(dates) {
        self2.config._disable = parseDateRules(dates);
      }
    });
    var timeMode = userConfig.mode === "time";
    if (!userConfig.dateFormat && (userConfig.enableTime || timeMode)) {
      var defaultDateFormat = flatpickr.defaultConfig.dateFormat || defaults.dateFormat;
      formats2.dateFormat = userConfig.noCalendar || timeMode ? "H:i" + (userConfig.enableSeconds ? ":S" : "") : defaultDateFormat + " H:i" + (userConfig.enableSeconds ? ":S" : "");
    }
    if (userConfig.altInput && (userConfig.enableTime || timeMode) && !userConfig.altFormat) {
      var defaultAltFormat = flatpickr.defaultConfig.altFormat || defaults.altFormat;
      formats2.altFormat = userConfig.noCalendar || timeMode ? "h:i" + (userConfig.enableSeconds ? ":S K" : " K") : defaultAltFormat + (" h:i" + (userConfig.enableSeconds ? ":S" : "") + " K");
    }
    Object.defineProperty(self2.config, "minDate", {
      get: function() {
        return self2.config._minDate;
      },
      set: minMaxDateSetter("min")
    });
    Object.defineProperty(self2.config, "maxDate", {
      get: function() {
        return self2.config._maxDate;
      },
      set: minMaxDateSetter("max")
    });
    var minMaxTimeSetter = function(type) {
      return function(val) {
        self2.config[type === "min" ? "_minTime" : "_maxTime"] = self2.parseDate(val, "H:i:S");
      };
    };
    Object.defineProperty(self2.config, "minTime", {
      get: function() {
        return self2.config._minTime;
      },
      set: minMaxTimeSetter("min")
    });
    Object.defineProperty(self2.config, "maxTime", {
      get: function() {
        return self2.config._maxTime;
      },
      set: minMaxTimeSetter("max")
    });
    if (userConfig.mode === "time") {
      self2.config.noCalendar = true;
      self2.config.enableTime = true;
    }
    Object.assign(self2.config, formats2, userConfig);
    for (var i = 0; i < boolOpts.length; i++)
      self2.config[boolOpts[i]] = self2.config[boolOpts[i]] === true || self2.config[boolOpts[i]] === "true";
    HOOKS.filter(function(hook) {
      return self2.config[hook] !== void 0;
    }).forEach(function(hook) {
      self2.config[hook] = arrayify(self2.config[hook] || []).map(bindToInstance);
    });
    self2.isMobile = !self2.config.disableMobile && !self2.config.inline && self2.config.mode === "single" && !self2.config.disable.length && !self2.config.enable && !self2.config.weekNumbers && /Android|webOS|iPhone|iPad|iPod|BlackBerry|IEMobile|Opera Mini/i.test(navigator.userAgent);
    for (var i = 0; i < self2.config.plugins.length; i++) {
      var pluginConf = self2.config.plugins[i](self2) || {};
      for (var key in pluginConf) {
        if (HOOKS.indexOf(key) > -1) {
          self2.config[key] = arrayify(pluginConf[key]).map(bindToInstance).concat(self2.config[key]);
        } else if (typeof userConfig[key] === "undefined")
          self2.config[key] = pluginConf[key];
      }
    }
    if (!userConfig.altInputClass) {
      self2.config.altInputClass = getInputElem().className + " " + self2.config.altInputClass;
    }
    triggerEvent("onParseConfig");
  }
  function getInputElem() {
    return self2.config.wrap ? element.querySelector("[data-input]") : element;
  }
  function setupLocale() {
    if (typeof self2.config.locale !== "object" && typeof flatpickr.l10ns[self2.config.locale] === "undefined")
      self2.config.errorHandler(new Error("flatpickr: invalid locale " + self2.config.locale));
    self2.l10n = __assign(__assign({}, flatpickr.l10ns.default), typeof self2.config.locale === "object" ? self2.config.locale : self2.config.locale !== "default" ? flatpickr.l10ns[self2.config.locale] : void 0);
    tokenRegex.D = "(" + self2.l10n.weekdays.shorthand.join("|") + ")";
    tokenRegex.l = "(" + self2.l10n.weekdays.longhand.join("|") + ")";
    tokenRegex.M = "(" + self2.l10n.months.shorthand.join("|") + ")";
    tokenRegex.F = "(" + self2.l10n.months.longhand.join("|") + ")";
    tokenRegex.K = "(" + self2.l10n.amPM[0] + "|" + self2.l10n.amPM[1] + "|" + self2.l10n.amPM[0].toLowerCase() + "|" + self2.l10n.amPM[1].toLowerCase() + ")";
    var userConfig = __assign(__assign({}, instanceConfig), JSON.parse(JSON.stringify(element.dataset || {})));
    if (userConfig.time_24hr === void 0 && flatpickr.defaultConfig.time_24hr === void 0) {
      self2.config.time_24hr = self2.l10n.time_24hr;
    }
    self2.formatDate = createDateFormatter(self2);
    self2.parseDate = createDateParser({ config: self2.config, l10n: self2.l10n });
  }
  function positionCalendar(customPositionElement) {
    if (typeof self2.config.position === "function") {
      return void self2.config.position(self2, customPositionElement);
    }
    if (self2.calendarContainer === void 0)
      return;
    triggerEvent("onPreCalendarPosition");
    var positionElement = customPositionElement || self2._positionElement;
    var calendarHeight = Array.prototype.reduce.call(self2.calendarContainer.children, function(acc, child) {
      return acc + child.offsetHeight;
    }, 0), calendarWidth = self2.calendarContainer.offsetWidth, configPos = self2.config.position.split(" "), configPosVertical = configPos[0], configPosHorizontal = configPos.length > 1 ? configPos[1] : null, inputBounds = positionElement.getBoundingClientRect(), distanceFromBottom = window.innerHeight - inputBounds.bottom, showOnTop = configPosVertical === "above" || configPosVertical !== "below" && distanceFromBottom < calendarHeight && inputBounds.top > calendarHeight;
    var top = window.pageYOffset + inputBounds.top + (!showOnTop ? positionElement.offsetHeight + 2 : -calendarHeight - 2);
    toggleClass(self2.calendarContainer, "arrowTop", !showOnTop);
    toggleClass(self2.calendarContainer, "arrowBottom", showOnTop);
    if (self2.config.inline)
      return;
    var left = window.pageXOffset + inputBounds.left;
    var isCenter = false;
    var isRight = false;
    if (configPosHorizontal === "center") {
      left -= (calendarWidth - inputBounds.width) / 2;
      isCenter = true;
    } else if (configPosHorizontal === "right") {
      left -= calendarWidth - inputBounds.width;
      isRight = true;
    }
    toggleClass(self2.calendarContainer, "arrowLeft", !isCenter && !isRight);
    toggleClass(self2.calendarContainer, "arrowCenter", isCenter);
    toggleClass(self2.calendarContainer, "arrowRight", isRight);
    var right = window.document.body.offsetWidth - (window.pageXOffset + inputBounds.right);
    var rightMost = left + calendarWidth > window.document.body.offsetWidth;
    var centerMost = right + calendarWidth > window.document.body.offsetWidth;
    toggleClass(self2.calendarContainer, "rightMost", rightMost);
    if (self2.config.static)
      return;
    self2.calendarContainer.style.top = top + "px";
    if (!rightMost) {
      self2.calendarContainer.style.left = left + "px";
      self2.calendarContainer.style.right = "auto";
    } else if (!centerMost) {
      self2.calendarContainer.style.left = "auto";
      self2.calendarContainer.style.right = right + "px";
    } else {
      var doc = getDocumentStyleSheet();
      if (doc === void 0)
        return;
      var bodyWidth = window.document.body.offsetWidth;
      var centerLeft = Math.max(0, bodyWidth / 2 - calendarWidth / 2);
      var centerBefore = ".flatpickr-calendar.centerMost:before";
      var centerAfter = ".flatpickr-calendar.centerMost:after";
      var centerIndex = doc.cssRules.length;
      var centerStyle = "{left:" + inputBounds.left + "px;right:auto;}";
      toggleClass(self2.calendarContainer, "rightMost", false);
      toggleClass(self2.calendarContainer, "centerMost", true);
      doc.insertRule(centerBefore + "," + centerAfter + centerStyle, centerIndex);
      self2.calendarContainer.style.left = centerLeft + "px";
      self2.calendarContainer.style.right = "auto";
    }
  }
  function getDocumentStyleSheet() {
    var editableSheet = null;
    for (var i = 0; i < document.styleSheets.length; i++) {
      var sheet = document.styleSheets[i];
      if (!sheet.cssRules)
        continue;
      try {
        sheet.cssRules;
      } catch (err) {
        continue;
      }
      editableSheet = sheet;
      break;
    }
    return editableSheet != null ? editableSheet : createStyleSheet();
  }
  function createStyleSheet() {
    var style = document.createElement("style");
    document.head.appendChild(style);
    return style.sheet;
  }
  function redraw() {
    if (self2.config.noCalendar || self2.isMobile)
      return;
    buildMonthSwitch();
    updateNavigationCurrentMonth();
    buildDays();
  }
  function focusAndClose() {
    self2._input.focus();
    if (window.navigator.userAgent.indexOf("MSIE") !== -1 || navigator.msMaxTouchPoints !== void 0) {
      setTimeout(self2.close, 0);
    } else {
      self2.close();
    }
  }
  function selectDate(e) {
    e.preventDefault();
    e.stopPropagation();
    var isSelectable = function(day) {
      return day.classList && day.classList.contains("flatpickr-day") && !day.classList.contains("flatpickr-disabled") && !day.classList.contains("notAllowed");
    };
    var t = findParent(getEventTarget(e), isSelectable);
    if (t === void 0)
      return;
    var target = t;
    var selectedDate = self2.latestSelectedDateObj = new Date(target.dateObj.getTime());
    var shouldChangeMonth = (selectedDate.getMonth() < self2.currentMonth || selectedDate.getMonth() > self2.currentMonth + self2.config.showMonths - 1) && self2.config.mode !== "range";
    self2.selectedDateElem = target;
    if (self2.config.mode === "single")
      self2.selectedDates = [selectedDate];
    else if (self2.config.mode === "multiple") {
      var selectedIndex = isDateSelected(selectedDate);
      if (selectedIndex)
        self2.selectedDates.splice(parseInt(selectedIndex), 1);
      else
        self2.selectedDates.push(selectedDate);
    } else if (self2.config.mode === "range") {
      if (self2.selectedDates.length === 2) {
        self2.clear(false, false);
      }
      self2.latestSelectedDateObj = selectedDate;
      self2.selectedDates.push(selectedDate);
      if (compareDates(selectedDate, self2.selectedDates[0], true) !== 0)
        self2.selectedDates.sort(function(a, b) {
          return a.getTime() - b.getTime();
        });
    }
    setHoursFromInputs();
    if (shouldChangeMonth) {
      var isNewYear = self2.currentYear !== selectedDate.getFullYear();
      self2.currentYear = selectedDate.getFullYear();
      self2.currentMonth = selectedDate.getMonth();
      if (isNewYear) {
        triggerEvent("onYearChange");
        buildMonthSwitch();
      }
      triggerEvent("onMonthChange");
    }
    updateNavigationCurrentMonth();
    buildDays();
    updateValue();
    if (!shouldChangeMonth && self2.config.mode !== "range" && self2.config.showMonths === 1)
      focusOnDayElem(target);
    else if (self2.selectedDateElem !== void 0 && self2.hourElement === void 0) {
      self2.selectedDateElem && self2.selectedDateElem.focus();
    }
    if (self2.hourElement !== void 0)
      self2.hourElement !== void 0 && self2.hourElement.focus();
    if (self2.config.closeOnSelect) {
      var single = self2.config.mode === "single" && !self2.config.enableTime;
      var range = self2.config.mode === "range" && self2.selectedDates.length === 2 && !self2.config.enableTime;
      if (single || range) {
        focusAndClose();
      }
    }
    triggerChange();
  }
  var CALLBACKS = {
    locale: [setupLocale, updateWeekdays],
    showMonths: [buildMonths, setCalendarWidth, buildWeekdays],
    minDate: [jumpToDate],
    maxDate: [jumpToDate],
    positionElement: [updatePositionElement],
    clickOpens: [
      function() {
        if (self2.config.clickOpens === true) {
          bind3(self2._input, "focus", self2.open);
          bind3(self2._input, "click", self2.open);
        } else {
          self2._input.removeEventListener("focus", self2.open);
          self2._input.removeEventListener("click", self2.open);
        }
      }
    ]
  };
  function set(option, value) {
    if (option !== null && typeof option === "object") {
      Object.assign(self2.config, option);
      for (var key in option) {
        if (CALLBACKS[key] !== void 0)
          CALLBACKS[key].forEach(function(x) {
            return x();
          });
      }
    } else {
      self2.config[option] = value;
      if (CALLBACKS[option] !== void 0)
        CALLBACKS[option].forEach(function(x) {
          return x();
        });
      else if (HOOKS.indexOf(option) > -1)
        self2.config[option] = arrayify(value);
    }
    self2.redraw();
    updateValue(true);
  }
  function setSelectedDate(inputDate, format2) {
    var dates = [];
    if (inputDate instanceof Array)
      dates = inputDate.map(function(d) {
        return self2.parseDate(d, format2);
      });
    else if (inputDate instanceof Date || typeof inputDate === "number")
      dates = [self2.parseDate(inputDate, format2)];
    else if (typeof inputDate === "string") {
      switch (self2.config.mode) {
        case "single":
        case "time":
          dates = [self2.parseDate(inputDate, format2)];
          break;
        case "multiple":
          dates = inputDate.split(self2.config.conjunction).map(function(date) {
            return self2.parseDate(date, format2);
          });
          break;
        case "range":
          dates = inputDate.split(self2.l10n.rangeSeparator).map(function(date) {
            return self2.parseDate(date, format2);
          });
          break;
      }
    } else
      self2.config.errorHandler(new Error("Invalid date supplied: " + JSON.stringify(inputDate)));
    self2.selectedDates = self2.config.allowInvalidPreload ? dates : dates.filter(function(d) {
      return d instanceof Date && isEnabled(d, false);
    });
    if (self2.config.mode === "range")
      self2.selectedDates.sort(function(a, b) {
        return a.getTime() - b.getTime();
      });
  }
  function setDate(date, triggerChange2, format2) {
    if (triggerChange2 === void 0) {
      triggerChange2 = false;
    }
    if (format2 === void 0) {
      format2 = self2.config.dateFormat;
    }
    if (date !== 0 && !date || date instanceof Array && date.length === 0)
      return self2.clear(triggerChange2);
    setSelectedDate(date, format2);
    self2.latestSelectedDateObj = self2.selectedDates[self2.selectedDates.length - 1];
    self2.redraw();
    jumpToDate(void 0, triggerChange2);
    setHoursFromDate();
    if (self2.selectedDates.length === 0) {
      self2.clear(false);
    }
    updateValue(triggerChange2);
    if (triggerChange2)
      triggerEvent("onChange");
  }
  function parseDateRules(arr) {
    return arr.slice().map(function(rule) {
      if (typeof rule === "string" || typeof rule === "number" || rule instanceof Date) {
        return self2.parseDate(rule, void 0, true);
      } else if (rule && typeof rule === "object" && rule.from && rule.to)
        return {
          from: self2.parseDate(rule.from, void 0),
          to: self2.parseDate(rule.to, void 0)
        };
      return rule;
    }).filter(function(x) {
      return x;
    });
  }
  function setupDates() {
    self2.selectedDates = [];
    self2.now = self2.parseDate(self2.config.now) || new Date();
    var preloadedDate = self2.config.defaultDate || ((self2.input.nodeName === "INPUT" || self2.input.nodeName === "TEXTAREA") && self2.input.placeholder && self2.input.value === self2.input.placeholder ? null : self2.input.value);
    if (preloadedDate)
      setSelectedDate(preloadedDate, self2.config.dateFormat);
    self2._initialDate = self2.selectedDates.length > 0 ? self2.selectedDates[0] : self2.config.minDate && self2.config.minDate.getTime() > self2.now.getTime() ? self2.config.minDate : self2.config.maxDate && self2.config.maxDate.getTime() < self2.now.getTime() ? self2.config.maxDate : self2.now;
    self2.currentYear = self2._initialDate.getFullYear();
    self2.currentMonth = self2._initialDate.getMonth();
    if (self2.selectedDates.length > 0)
      self2.latestSelectedDateObj = self2.selectedDates[0];
    if (self2.config.minTime !== void 0)
      self2.config.minTime = self2.parseDate(self2.config.minTime, "H:i");
    if (self2.config.maxTime !== void 0)
      self2.config.maxTime = self2.parseDate(self2.config.maxTime, "H:i");
    self2.minDateHasTime = !!self2.config.minDate && (self2.config.minDate.getHours() > 0 || self2.config.minDate.getMinutes() > 0 || self2.config.minDate.getSeconds() > 0);
    self2.maxDateHasTime = !!self2.config.maxDate && (self2.config.maxDate.getHours() > 0 || self2.config.maxDate.getMinutes() > 0 || self2.config.maxDate.getSeconds() > 0);
  }
  function setupInputs() {
    self2.input = getInputElem();
    if (!self2.input) {
      self2.config.errorHandler(new Error("Invalid input element specified"));
      return;
    }
    self2.input._type = self2.input.type;
    self2.input.type = "text";
    self2.input.classList.add("flatpickr-input");
    self2._input = self2.input;
    if (self2.config.altInput) {
      self2.altInput = createElement(self2.input.nodeName, self2.config.altInputClass);
      self2._input = self2.altInput;
      self2.altInput.placeholder = self2.input.placeholder;
      self2.altInput.disabled = self2.input.disabled;
      self2.altInput.required = self2.input.required;
      self2.altInput.tabIndex = self2.input.tabIndex;
      self2.altInput.type = "text";
      self2.input.setAttribute("type", "hidden");
      if (!self2.config.static && self2.input.parentNode)
        self2.input.parentNode.insertBefore(self2.altInput, self2.input.nextSibling);
    }
    if (!self2.config.allowInput)
      self2._input.setAttribute("readonly", "readonly");
    updatePositionElement();
  }
  function updatePositionElement() {
    self2._positionElement = self2.config.positionElement || self2._input;
  }
  function setupMobile() {
    var inputType = self2.config.enableTime ? self2.config.noCalendar ? "time" : "datetime-local" : "date";
    self2.mobileInput = createElement("input", self2.input.className + " flatpickr-mobile");
    self2.mobileInput.tabIndex = 1;
    self2.mobileInput.type = inputType;
    self2.mobileInput.disabled = self2.input.disabled;
    self2.mobileInput.required = self2.input.required;
    self2.mobileInput.placeholder = self2.input.placeholder;
    self2.mobileFormatStr = inputType === "datetime-local" ? "Y-m-d\\TH:i:S" : inputType === "date" ? "Y-m-d" : "H:i:S";
    if (self2.selectedDates.length > 0) {
      self2.mobileInput.defaultValue = self2.mobileInput.value = self2.formatDate(self2.selectedDates[0], self2.mobileFormatStr);
    }
    if (self2.config.minDate)
      self2.mobileInput.min = self2.formatDate(self2.config.minDate, "Y-m-d");
    if (self2.config.maxDate)
      self2.mobileInput.max = self2.formatDate(self2.config.maxDate, "Y-m-d");
    if (self2.input.getAttribute("step"))
      self2.mobileInput.step = String(self2.input.getAttribute("step"));
    self2.input.type = "hidden";
    if (self2.altInput !== void 0)
      self2.altInput.type = "hidden";
    try {
      if (self2.input.parentNode)
        self2.input.parentNode.insertBefore(self2.mobileInput, self2.input.nextSibling);
    } catch (_a) {
    }
    bind3(self2.mobileInput, "change", function(e) {
      self2.setDate(getEventTarget(e).value, false, self2.mobileFormatStr);
      triggerEvent("onChange");
      triggerEvent("onClose");
    });
  }
  function toggle(e) {
    if (self2.isOpen === true)
      return self2.close();
    self2.open(e);
  }
  function triggerEvent(event, data2) {
    if (self2.config === void 0)
      return;
    var hooks = self2.config[event];
    if (hooks !== void 0 && hooks.length > 0) {
      for (var i = 0; hooks[i] && i < hooks.length; i++)
        hooks[i](self2.selectedDates, self2.input.value, self2, data2);
    }
    if (event === "onChange") {
      self2.input.dispatchEvent(createEvent("change"));
      self2.input.dispatchEvent(createEvent("input"));
    }
  }
  function createEvent(name) {
    var e = document.createEvent("Event");
    e.initEvent(name, true, true);
    return e;
  }
  function isDateSelected(date) {
    for (var i = 0; i < self2.selectedDates.length; i++) {
      var selectedDate = self2.selectedDates[i];
      if (selectedDate instanceof Date && compareDates(selectedDate, date) === 0)
        return "" + i;
    }
    return false;
  }
  function isDateInRange(date) {
    if (self2.config.mode !== "range" || self2.selectedDates.length < 2)
      return false;
    return compareDates(date, self2.selectedDates[0]) >= 0 && compareDates(date, self2.selectedDates[1]) <= 0;
  }
  function updateNavigationCurrentMonth() {
    if (self2.config.noCalendar || self2.isMobile || !self2.monthNav)
      return;
    self2.yearElements.forEach(function(yearElement, i) {
      var d = new Date(self2.currentYear, self2.currentMonth, 1);
      d.setMonth(self2.currentMonth + i);
      if (self2.config.showMonths > 1 || self2.config.monthSelectorType === "static") {
        self2.monthElements[i].textContent = monthToStr(d.getMonth(), self2.config.shorthandCurrentMonth, self2.l10n) + " ";
      } else {
        self2.monthsDropdownContainer.value = d.getMonth().toString();
      }
      yearElement.value = d.getFullYear().toString();
    });
    self2._hidePrevMonthArrow = self2.config.minDate !== void 0 && (self2.currentYear === self2.config.minDate.getFullYear() ? self2.currentMonth <= self2.config.minDate.getMonth() : self2.currentYear < self2.config.minDate.getFullYear());
    self2._hideNextMonthArrow = self2.config.maxDate !== void 0 && (self2.currentYear === self2.config.maxDate.getFullYear() ? self2.currentMonth + 1 > self2.config.maxDate.getMonth() : self2.currentYear > self2.config.maxDate.getFullYear());
  }
  function getDateStr(specificFormat) {
    var format2 = specificFormat || (self2.config.altInput ? self2.config.altFormat : self2.config.dateFormat);
    return self2.selectedDates.map(function(dObj) {
      return self2.formatDate(dObj, format2);
    }).filter(function(d, i, arr) {
      return self2.config.mode !== "range" || self2.config.enableTime || arr.indexOf(d) === i;
    }).join(self2.config.mode !== "range" ? self2.config.conjunction : self2.l10n.rangeSeparator);
  }
  function updateValue(triggerChange2) {
    if (triggerChange2 === void 0) {
      triggerChange2 = true;
    }
    if (self2.mobileInput !== void 0 && self2.mobileFormatStr) {
      self2.mobileInput.value = self2.latestSelectedDateObj !== void 0 ? self2.formatDate(self2.latestSelectedDateObj, self2.mobileFormatStr) : "";
    }
    self2.input.value = getDateStr(self2.config.dateFormat);
    if (self2.altInput !== void 0) {
      self2.altInput.value = getDateStr(self2.config.altFormat);
    }
    if (triggerChange2 !== false)
      triggerEvent("onValueUpdate");
  }
  function onMonthNavClick(e) {
    var eventTarget = getEventTarget(e);
    var isPrevMonth = self2.prevMonthNav.contains(eventTarget);
    var isNextMonth = self2.nextMonthNav.contains(eventTarget);
    if (isPrevMonth || isNextMonth) {
      changeMonth(isPrevMonth ? -1 : 1);
    } else if (self2.yearElements.indexOf(eventTarget) >= 0) {
      eventTarget.select();
    } else if (eventTarget.classList.contains("arrowUp")) {
      self2.changeYear(self2.currentYear + 1);
    } else if (eventTarget.classList.contains("arrowDown")) {
      self2.changeYear(self2.currentYear - 1);
    }
  }
  function timeWrapper(e) {
    e.preventDefault();
    var isKeyDown = e.type === "keydown", eventTarget = getEventTarget(e), input = eventTarget;
    if (self2.amPM !== void 0 && eventTarget === self2.amPM) {
      self2.amPM.textContent = self2.l10n.amPM[int(self2.amPM.textContent === self2.l10n.amPM[0])];
    }
    var min = parseFloat(input.getAttribute("min")), max = parseFloat(input.getAttribute("max")), step = parseFloat(input.getAttribute("step")), curValue = parseInt(input.value, 10), delta = e.delta || (isKeyDown ? e.which === 38 ? 1 : -1 : 0);
    var newValue = curValue + step * delta;
    if (typeof input.value !== "undefined" && input.value.length === 2) {
      var isHourElem = input === self2.hourElement, isMinuteElem = input === self2.minuteElement;
      if (newValue < min) {
        newValue = max + newValue + int(!isHourElem) + (int(isHourElem) && int(!self2.amPM));
        if (isMinuteElem)
          incrementNumInput(void 0, -1, self2.hourElement);
      } else if (newValue > max) {
        newValue = input === self2.hourElement ? newValue - max - int(!self2.amPM) : min;
        if (isMinuteElem)
          incrementNumInput(void 0, 1, self2.hourElement);
      }
      if (self2.amPM && isHourElem && (step === 1 ? newValue + curValue === 23 : Math.abs(newValue - curValue) > step)) {
        self2.amPM.textContent = self2.l10n.amPM[int(self2.amPM.textContent === self2.l10n.amPM[0])];
      }
      input.value = pad(newValue);
    }
  }
  init();
  return self2;
}
function _flatpickr(nodeList, config2) {
  var nodes = Array.prototype.slice.call(nodeList).filter(function(x) {
    return x instanceof HTMLElement;
  });
  var instances = [];
  for (var i = 0; i < nodes.length; i++) {
    var node = nodes[i];
    try {
      if (node.getAttribute("data-fp-omit") !== null)
        continue;
      if (node._flatpickr !== void 0) {
        node._flatpickr.destroy();
        node._flatpickr = void 0;
      }
      node._flatpickr = FlatpickrInstance(node, config2 || {});
      instances.push(node._flatpickr);
    } catch (e) {
      console.error(e);
    }
  }
  return instances.length === 1 ? instances[0] : instances;
}
if (typeof HTMLElement !== "undefined" && typeof HTMLCollection !== "undefined" && typeof NodeList !== "undefined") {
  HTMLCollection.prototype.flatpickr = NodeList.prototype.flatpickr = function(config2) {
    return _flatpickr(this, config2);
  };
  HTMLElement.prototype.flatpickr = function(config2) {
    return _flatpickr([this], config2);
  };
}
var flatpickr = function(selector, config2) {
  if (typeof selector === "string") {
    return _flatpickr(window.document.querySelectorAll(selector), config2);
  } else if (selector instanceof Node) {
    return _flatpickr([selector], config2);
  } else {
    return _flatpickr(selector, config2);
  }
};
flatpickr.defaultConfig = {};
flatpickr.l10ns = {
  en: __assign({}, english),
  default: __assign({}, english)
};
flatpickr.localize = function(l10n) {
  flatpickr.l10ns.default = __assign(__assign({}, flatpickr.l10ns.default), l10n);
};
flatpickr.setDefaults = function(config2) {
  flatpickr.defaultConfig = __assign(__assign({}, flatpickr.defaultConfig), config2);
};
flatpickr.parseDate = createDateParser({});
flatpickr.formatDate = createDateFormatter({});
flatpickr.compareDates = compareDates;
if (typeof jQuery !== "undefined" && typeof jQuery.fn !== "undefined") {
  jQuery.fn.flatpickr = function(config2) {
    return _flatpickr(this, config2);
  };
}
Date.prototype.fp_incr = function(days) {
  return new Date(this.getFullYear(), this.getMonth(), this.getDate() + (typeof days === "string" ? parseInt(days, 10) : days));
};
if (typeof window !== "undefined") {
  window.flatpickr = flatpickr;
}
var esm = /* @__PURE__ */ Object.freeze(/* @__PURE__ */ Object.defineProperty({
  __proto__: null,
  "default": flatpickr
}, Symbol.toStringTag, { value: "Module" }));
var require$$0 = /* @__PURE__ */ getAugmentedNamespace(esm);
(function(module, exports) {
  !function(t, e) {
    module.exports = e(require$$0);
  }(typeof self != "undefined" ? self : commonjsGlobal, function(t) {
    return function(t2) {
      var e = {};
      function n(r) {
        if (e[r])
          return e[r].exports;
        var o = e[r] = { i: r, l: false, exports: {} };
        return t2[r].call(o.exports, o, o.exports, n), o.l = true, o.exports;
      }
      return n.m = t2, n.c = e, n.d = function(t3, e2, r) {
        n.o(t3, e2) || Object.defineProperty(t3, e2, { enumerable: true, get: r });
      }, n.r = function(t3) {
        typeof Symbol != "undefined" && Symbol.toStringTag && Object.defineProperty(t3, Symbol.toStringTag, { value: "Module" }), Object.defineProperty(t3, "__esModule", { value: true });
      }, n.t = function(t3, e2) {
        if (1 & e2 && (t3 = n(t3)), 8 & e2)
          return t3;
        if (4 & e2 && typeof t3 == "object" && t3 && t3.__esModule)
          return t3;
        var r = /* @__PURE__ */ Object.create(null);
        if (n.r(r), Object.defineProperty(r, "default", { enumerable: true, value: t3 }), 2 & e2 && typeof t3 != "string")
          for (var o in t3)
            n.d(r, o, function(e3) {
              return t3[e3];
            }.bind(null, o));
        return r;
      }, n.n = function(t3) {
        var e2 = t3 && t3.__esModule ? function() {
          return t3.default;
        } : function() {
          return t3;
        };
        return n.d(e2, "a", e2), e2;
      }, n.o = function(t3, e2) {
        return Object.prototype.hasOwnProperty.call(t3, e2);
      }, n.p = "", n(n.s = 1);
    }([function(e, n) {
      e.exports = t;
    }, function(t2, e, n) {
      n.r(e), n.d(e, "Component", function() {
        return p;
      }), n.d(e, "Plugin", function() {
        return d;
      });
      var r = n(0), o = n.n(r), i = ["onChange", "onClose", "onDestroy", "onMonthChange", "onOpen", "onYearChange"];
      function u() {
        return (u = Object.assign || function(t3) {
          for (var e2 = 1; e2 < arguments.length; e2++) {
            var n2 = arguments[e2];
            for (var r2 in n2)
              Object.prototype.hasOwnProperty.call(n2, r2) && (t3[r2] = n2[r2]);
          }
          return t3;
        }).apply(this, arguments);
      }
      var a = function(t3) {
        return t3.replace(/([a-z])([A-Z])/g, "$1-$2").toLowerCase();
      }, f = function(t3) {
        return t3 && t3.length ? t3 : null;
      }, l = function(t3) {
        return u({}, t3);
      }, s = i.concat(["onValueUpdate", "onDayCreate", "onParseConfig", "onReady", "onPreCalendarPosition", "onKeyDown"]), c = ["locale", "showMonths"], p = { name: "flat-pickr", render: function(t3) {
        return t3("input", { attrs: { type: "text", "data-input": true }, props: { disabled: this.disabled }, on: { input: this.onInput } });
      }, props: { value: { default: null, required: true, validator: function(t3) {
        return t3 === null || t3 instanceof Date || typeof t3 == "string" || t3 instanceof String || t3 instanceof Array || typeof t3 == "number";
      } }, config: { type: Object, default: function() {
        return { wrap: false, defaultDate: null };
      } }, events: { type: Array, default: function() {
        return i;
      } }, disabled: { type: Boolean, default: false } }, data: function() {
        return { fp: null };
      }, mounted: function() {
        var t3 = this;
        if (!this.fp) {
          var e2 = l(this.config);
          this.events.forEach(function(n2) {
            var r2, i2 = o.a.defaultConfig[n2] || [];
            e2[n2] = (r2 = e2[n2] || [], r2 instanceof Array ? r2 : [r2]).concat(i2, function() {
              for (var e3 = arguments.length, r3 = new Array(e3), o2 = 0; o2 < e3; o2++)
                r3[o2] = arguments[o2];
              t3.$emit.apply(t3, [a(n2)].concat(r3));
            });
          }), e2.defaultDate = this.value || e2.defaultDate, this.fp = new o.a(this.getElem(), e2), this.fpInput().addEventListener("blur", this.onBlur), this.$on("on-close", this.onClose), this.$watch("disabled", this.watchDisabled, { immediate: true });
        }
      }, methods: { getElem: function() {
        return this.config.wrap ? this.$el.parentNode : this.$el;
      }, onInput: function(t3) {
        var e2 = this, n2 = t3.target;
        this.$nextTick(function() {
          e2.$emit("input", f(n2.value));
        });
      }, fpInput: function() {
        return this.fp.altInput || this.fp.input;
      }, onBlur: function(t3) {
        this.$emit("blur", f(t3.target.value));
      }, onClose: function(t3, e2) {
        this.$emit("input", f(e2));
      }, watchDisabled: function(t3) {
        t3 ? this.fpInput().setAttribute("disabled", t3) : this.fpInput().removeAttribute("disabled");
      } }, watch: { config: { deep: true, handler: function(t3) {
        var e2 = this, n2 = l(t3);
        s.forEach(function(t4) {
          delete n2[t4];
        }), this.fp.set(n2), c.forEach(function(t4) {
          n2[t4] !== void 0 && e2.fp.set(t4, n2[t4]);
        });
      } }, value: function(t3) {
        t3 !== f(this.$el.value) && this.fp && this.fp.setDate(t3, true);
      } }, beforeDestroy: function() {
        this.fp && (this.fpInput().removeEventListener("blur", this.onBlur), this.fp.destroy(), this.fp = null);
      } }, d = function(t3, e2) {
        var n2 = "flat-pickr";
        typeof e2 == "string" && (n2 = e2), t3.component(n2, p);
      };
      p.install = d;
      e.default = p;
    }]).default;
  });
})(vueFlatpickr_min);
var flatPickr = /* @__PURE__ */ getDefaultExportFromCjs(vueFlatpickr_min.exports);
var render$1 = function() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", { staticClass: "fvl-input-wrapper", class: { "fvl-has-error": _vm.$parent.hasErrors(_vm.name) } }, [_vm.label ? _c("label", { staticClass: "fvl-input-label", class: _vm.labelClass, attrs: { "for": _vm.name } }, [_c("span", { domProps: { "innerHTML": _vm._s(_vm.label) } }), _vm._t("label_suffix")], 2) : _vm._e(), _c("div", { staticClass: "fvl-input-group fvl-date-picker" }, [_vm._t("prefix"), _c("flat-pickr", { class: ["fvl-input", _vm.fieldClass], attrs: { "name": _vm.name, "placeholder": _vm.placeholder, "config": _vm.flatpickrConfig, "required": _vm.required, "readonly": _vm.readonly, "disabled": _vm.disabled }, on: { "on-change": function($event) {
    _vm.$parent.dirty(_vm.name), _vm.$emit("changed");
  }, "on-close": function($event) {
    return _vm.$emit("closed");
  } }, model: { value: _vm.inputvalue, callback: function($$v) {
    _vm.inputvalue = $$v;
  }, expression: "inputvalue" } }), _vm._t("suffix")], 2), _vm._t("hint"), _vm._t("errors", function() {
    return [_c("validation-errors", { attrs: { "errors": _vm.$parent.getErrors(_vm.name) } })];
  }, { "errors": _vm.$parent.getErrors(_vm.name) })], 2);
};
var staticRenderFns$1 = [];
const __vue2_script$1 = {
  components: {
    ValidationErrors,
    flatPickr
  },
  props: {
    label: {
      type: String,
      required: false,
      default: null
    },
    name: {
      type: String,
      required: true
    },
    id: {
      type: String,
      default: null
    },
    value: {
      type: String | Array,
      default: ""
    },
    start: {
      type: String,
      required: false,
      default: null
    },
    end: {
      type: String,
      required: false,
      default: null
    },
    type: {
      type: String,
      default: "text"
    },
    placeholder: {
      type: String,
      required: false,
      default: null
    },
    autocomplete: {
      type: String,
      required: false,
      default: null
    },
    fieldClass: {
      type: String,
      required: false,
      default: null
    },
    labelClass: {
      type: String,
      required: false,
      default: null
    },
    readonly: {
      type: Boolean,
      required: false,
      default: false
    },
    required: {
      type: Boolean,
      required: false,
      default: false
    },
    disabled: {
      type: Boolean,
      required: false,
      default: false
    },
    config: {
      type: Object,
      required: false,
      default: () => {
        return {
          dateFormat: "Y-m-d"
        };
      }
    }
  },
  data() {
    return {
      inputvalue: this.config.mode == "range" && this.start && this.end ? this.start + " - " + this.end : this.value
    };
  },
  computed: {
    flatpickrConfig() {
      let config2 = this.config;
      if (this.config.mode == "range" && config2.locale) {
        config2.locale.rangeSeparator = " - ";
      }
      if (this.config.mode == "range" && !config2.locale) {
        config2.locale = { rangeSeparator: " - " };
      }
      return config2;
    }
  },
  watch: {
    value(newValue, oldValue) {
      if (this.config.mode != "range" && oldValue != newValue) {
        this.inputvalue = newValue;
      }
    },
    inputvalue(newValue, oldValue) {
      let formatedValue;
      if (this.config.mode == "range") {
        let newValueParts = typeof newValue == "string" ? newValue.split(" - ") : newValue;
        formatedValue = { start: newValueParts[0], end: newValueParts[1] };
        this.$emit("update:start", formatedValue.start);
        this.$emit("update:end", formatedValue.end);
        if (oldValue != formatedValue) {
          this.$emit("update:value", formatedValue);
        }
      } else {
        formatedValue = newValue;
        this.$emit("update:value", formatedValue);
      }
    }
  }
};
const __cssModules$1 = {};
var __component__$1 = /* @__PURE__ */ normalizeComponent(__vue2_script$1, render$1, staticRenderFns$1, false, __vue2_injectStyles$1, null, null, null);
function __vue2_injectStyles$1(context) {
  for (let o in __cssModules$1) {
    this[o] = __cssModules$1[o];
  }
}
var FvlDatePicker = /* @__PURE__ */ function() {
  return __component__$1.exports;
}();
var render = function() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("on-click-outside", { on: { "do": function($event) {
    return _vm.close();
  } } }, [_c("div", { staticClass: "fvl-input-wrapper", class: { "fvl-has-error": _vm.$parent.hasErrors(_vm.name) } }, [_vm.label ? _c("label", { staticClass: "fvl-input-label", class: _vm.labelClass, attrs: { "for": _vm.name } }, [_c("span", { domProps: { "innerHTML": _vm._s(_vm.label) } }), _vm._t("label_suffix")], 2) : _vm._e(), _c("div", { staticClass: "fvl-input-group", on: { "click": function($event) {
    _vm.isOpen = true;
  } } }, [_vm._t("prefix"), _c("input", { ref: "dateinput", class: ["fvl-input cursor-pointer", _vm.fieldClass], attrs: { "required": _vm.required, "readonly": "readonly", "disabled": _vm.disabled, "placeholder": _vm.placeholder }, domProps: { "value": _vm.inputvalue }, on: { "click": function($event) {
    $event.preventDefault();
    return _vm.toggle();
  }, "keydown": [function($event) {
    if (!$event.type.indexOf("key") && _vm._k($event.keyCode, "space", 32, $event.key, [" ", "Spacebar"])) {
      return null;
    }
    return _vm.toggle();
  }, function($event) {
    if (!$event.type.indexOf("key") && _vm._k($event.keyCode, "esc", 27, $event.key, ["Esc", "Escape"])) {
      return null;
    }
    return _vm.close();
  }] } }), _vm._t("suffix")], 2), _c("transition", { attrs: { "name": "fvl-dropdown-transition" } }, [_c("div", { directives: [{ name: "show", rawName: "v-show", value: _vm.isOpen, expression: "isOpen" }], ref: "datedropdown", staticClass: "fvl-date-picker", style: { "max-width": _vm.width } }, [_c("div", { staticClass: "fvl-date-picker-extended-wrapper" }, [_c("div", { staticClass: "flex-grow pr-3" }, _vm._l(_vm.datePresets, function(preset) {
    return _c("button", { key: preset.name, staticClass: "fvl-date-picker-extended-preset-item", class: {
      "fvl-date-picker-extended-preset-item-active": _vm.inputvalue == preset.start + " - " + preset.end
    }, attrs: { "type": "button" }, on: { "click": function($event) {
      _vm.inputvalue = preset.start + " - " + preset.end;
    }, "keydown": function($event) {
      if (!$event.type.indexOf("key") && _vm._k($event.keyCode, "esc", 27, $event.key, ["Esc", "Escape"])) {
        return null;
      }
      return _vm.close();
    } } }, [_vm._v(" " + _vm._s(preset.name) + " ")]);
  }), 0), _c("div", { staticClass: "fvl-date-picker-extended-flatpickr-wrapper" }, [_c("flat-pickr", { ref: "flatpickr", class: ["hidden", _vm.fieldClass], attrs: { "name": _vm.name, "placeholder": _vm.placeholder, "config": _vm.flatpickrConfig }, on: { "on-change": function($event) {
    _vm.$parent.dirty(_vm.name), _vm.$emit("changed");
  } }, model: { value: _vm.inputvalue, callback: function($$v) {
    _vm.inputvalue = $$v;
  }, expression: "inputvalue" } })], 1)])])]), _vm._t("hint"), _vm._t("errors", function() {
    return [_c("validation-errors", { attrs: { "errors": _vm.$parent.getErrors(_vm.name) } })];
  }, { "errors": _vm.$parent.getErrors(_vm.name) })], 2)]);
};
var staticRenderFns = [];
const __vue2_script = {
  components: {
    ValidationErrors,
    flatPickr,
    OnClickOutside
  },
  props: {
    label: {
      type: String,
      required: false,
      default: null
    },
    name: {
      type: String,
      required: true
    },
    id: {
      type: String,
      default: null
    },
    value: {
      type: String | Array | Object,
      default: ""
    },
    start: {
      type: String,
      required: false,
      default: null
    },
    end: {
      type: String,
      required: false,
      default: null
    },
    type: {
      type: String,
      default: "text"
    },
    placeholder: {
      type: String,
      required: false,
      default: null
    },
    autocomplete: {
      type: String,
      required: false,
      default: null
    },
    fieldClass: {
      type: String,
      required: false,
      default: null
    },
    labelClass: {
      type: String,
      required: false,
      default: null
    },
    readonly: {
      type: Boolean,
      required: false,
      default: false
    },
    required: {
      type: Boolean,
      required: false,
      default: false
    },
    disabled: {
      type: Boolean,
      required: false,
      default: false
    },
    config: {
      type: Object,
      required: false,
      default: () => {
        return {
          dateFormat: "Y-m-d",
          mode: "range",
          inline: true
        };
      }
    },
    presets: {
      type: Array,
      required: false,
      default: () => []
    },
    width: {
      type: String,
      required: false,
      default: null
    }
  },
  data() {
    return {
      isOpen: false,
      inputvalue: this.start && this.end ? this.start + " - " + this.end : this.value
    };
  },
  computed: {
    flatpickrConfig() {
      let config2 = this.config;
      if (this.config.mode == "range" && config2.locale) {
        config2.locale.rangeSeparator = " - ";
      }
      if (this.config.mode == "range" && !config2.locale) {
        config2.locale = { rangeSeparator: " - " };
      }
      return config2;
    },
    datePresets() {
      if (this.presets.length) {
        return this.presets;
      }
      return [
        { name: "Last 30 Days", start: this.getRange(30).start, end: this.getRange(30).end },
        { name: "Last 60 Days", start: this.getRange(60).start, end: this.getRange(60).end },
        { name: "Last 90 Days", start: this.getRange(90).start, end: this.getRange(90).end },
        { name: "Last 365 Days", start: this.getRange(365).start, end: this.getRange(365).end }
      ];
    }
  },
  watch: {
    value(newValue) {
      if (this.config.mode != "range") {
        this.inputvalue = newValue;
      }
    },
    inputvalue(newValue) {
      let formatedValue;
      if (this.config.mode == "range" && typeof newValue == "string") {
        newValue = newValue.split(" - ");
        formatedValue = { start: newValue[0], end: newValue[1] };
        this.$emit("update:start", newValue[0]);
        this.$emit("update:end", newValue[1]);
      } else {
        formatedValue = newValue;
      }
      this.$emit("update:value", formatedValue);
    }
  },
  beforeDestroy() {
    if (this.popper !== void 0) {
      this.popper.destroy();
    }
  },
  methods: {
    setupPopper() {
      if (this.popper === void 0) {
        this.popper = new Popper$1(this.$refs.dateinput, this.$refs.datedropdown, {
          placement: "bottom"
        });
      } else {
        this.popper.scheduleUpdate();
      }
    },
    open() {
      if (this.isOpen)
        return;
      this.isOpen = true;
      this.$nextTick(() => {
        this.setupPopper();
      });
    },
    close() {
      if (!this.isOpen)
        return;
      this.isOpen = false;
      if (this.value && typeof this.value.end == "undefined") {
        this.inputvalue = "";
        this.$emit("update:value", "");
        this.$emit("update:start", "");
        this.$emit("update:end", "");
      }
      this.$nextTick(() => {
        this.$emit("closed");
        this.$refs.dateinput.focus();
      });
    },
    toggle() {
      if (this.disabled)
        return;
      this.isOpen ? this.close() : this.open();
    },
    getRange(days) {
      let now = new Date();
      let end = `${now.getFullYear()}-${(now.getMonth() + 1).toString().padStart(2, "0")}-${now.getDate()}`;
      let d = new Date(now.setDate(now.getDate() - days));
      let start = `${d.getFullYear()}-${(d.getMonth() + 1).toString().padStart(2, "0")}-${d.getDate()}`;
      return { start, end };
    }
  }
};
const __cssModules = {};
var __component__ = /* @__PURE__ */ normalizeComponent(__vue2_script, render, staticRenderFns, false, __vue2_injectStyles, null, null, null);
function __vue2_injectStyles(context) {
  for (let o in __cssModules) {
    this[o] = __cssModules[o];
  }
}
var FvlDatePickerExtended = /* @__PURE__ */ function() {
  return __component__.exports;
}();
export { FvlCheckbox, FvlColorPicker, FvlDatePicker, FvlDatePickerExtended, FvlDropzone, FvlFile, FvlForm, FvlImage, FvlInput, FvlMultiCheckbox, FvlMultiFile, FvlRadio, FvlSearchSelect, FvlSelect, FvlSlider, FvlSubmit, FvlSwitch, FvlTagSelect, FvlTextSwitch, FvlTextarea };
